
var Module;
if (typeof Module === 'undefined') Module = eval('(function() { try { return Module || {} } catch(e) { return {} } })()');
if (!Module.expectedDataFileDownloads) {
  Module.expectedDataFileDownloads = 0;
  Module.finishedDataFileDownloads = 0;
}
Module.expectedDataFileDownloads++;
(function() {

    var PACKAGE_PATH;
    if (typeof window === 'object') {
      PACKAGE_PATH = window['encodeURIComponent'](window.location.pathname.toString().substring(0, window.location.pathname.toString().lastIndexOf('/')) + '/');
    } else {
      // worker
      PACKAGE_PATH = encodeURIComponent(location.pathname.toString().substring(0, location.pathname.toString().lastIndexOf('/')) + '/');
    }
    var PACKAGE_NAME = 'emscript.data';
    var REMOTE_PACKAGE_NAME = (Module['filePackagePrefixURL'] || '') + 'emscript.data';
    var REMOTE_PACKAGE_SIZE = 10029056;
    var PACKAGE_UUID = 'b57f2b53-057a-48d7-925e-3c39dad706f8';
  
    function fetchRemotePackage(packageName, packageSize, callback, errback) {
      var xhr = new XMLHttpRequest();
      xhr.open('GET', packageName, true);
      xhr.responseType = 'arraybuffer';
      xhr.onprogress = function(event) {
        var url = packageName;
        var size = packageSize;
        if (event.total) size = event.total;
        if (event.loaded) {
          if (!xhr.addedTotal) {
            xhr.addedTotal = true;
            if (!Module.dataFileDownloads) Module.dataFileDownloads = {};
            Module.dataFileDownloads[url] = {
              loaded: event.loaded,
              total: size
            };
          } else {
            Module.dataFileDownloads[url].loaded = event.loaded;
          }
          var total = 0;
          var loaded = 0;
          var num = 0;
          for (var download in Module.dataFileDownloads) {
          var data = Module.dataFileDownloads[download];
            total += data.total;
            loaded += data.loaded;
            num++;
          }
          total = Math.ceil(total * Module.expectedDataFileDownloads/num);
          if (Module['setStatus']) Module['setStatus']('Downloading data... (' + loaded + '/' + total + ')');
        } else if (!Module.dataFileDownloads) {
          if (Module['setStatus']) Module['setStatus']('Downloading data...');
        }
      };
      xhr.onload = function(event) {
        var packageData = xhr.response;
        callback(packageData);
      };
      xhr.send(null);
    };

    function handleError(error) {
      console.error('package error:', error);
    };
  
      var fetched = null, fetchedCallback = null;
      fetchRemotePackage(REMOTE_PACKAGE_NAME, REMOTE_PACKAGE_SIZE, function(data) {
        if (fetchedCallback) {
          fetchedCallback(data);
          fetchedCallback = null;
        } else {
          fetched = data;
        }
      }, handleError);
    
  function runWithFS() {

function assert(check, msg) {
  if (!check) throw msg + new Error().stack;
}

    function DataRequest(start, end, crunched, audio) {
      this.start = start;
      this.end = end;
      this.crunched = crunched;
      this.audio = audio;
    }
    DataRequest.prototype = {
      requests: {},
      open: function(mode, name) {
        this.name = name;
        this.requests[name] = this;
        Module['addRunDependency']('fp ' + this.name);
      },
      send: function() {},
      onload: function() {
        var byteArray = this.byteArray.subarray(this.start, this.end);

          this.finish(byteArray);

      },
      finish: function(byteArray) {
        var that = this;
        Module['FS_createPreloadedFile'](this.name, null, byteArray, true, true, function() {
          Module['removeRunDependency']('fp ' + that.name);
        }, function() {
          if (that.audio) {
            Module['removeRunDependency']('fp ' + that.name); // workaround for chromium bug 124926 (still no audio with this, but at least we don't hang)
          } else {
            Module.printErr('Preloading file ' + that.name + ' failed');
          }
        }, false, true); // canOwn this data in the filesystem, it is a slide into the heap that will never change
        this.requests[this.name] = null;
      },
    };
      new DataRequest(0, 10027008, 0, 0).open('GET', '/TrdiDisk.img');
    new DataRequest(10027008, 10029056, 0, 0).open('GET', '/ROM.img');

    function processPackageData(arrayBuffer) {
      Module.finishedDataFileDownloads++;
      assert(arrayBuffer, 'Loading data file failed.');
      var byteArray = new Uint8Array(arrayBuffer);
      var curr;
      
      // copy the entire loaded file into a spot in the heap. Files will refer to slices in that. They cannot be freed though.
      var ptr = Module['_malloc'](byteArray.length);
      Module['HEAPU8'].set(byteArray, ptr);
      DataRequest.prototype.byteArray = Module['HEAPU8'].subarray(ptr, ptr+byteArray.length);
          DataRequest.prototype.requests["/TrdiDisk.img"].onload();
          DataRequest.prototype.requests["/ROM.img"].onload();
          Module['removeRunDependency']('datafile_emscript.data');

    };
    Module['addRunDependency']('datafile_emscript.data');
  
    if (!Module.preloadResults) Module.preloadResults = {};
  
      Module.preloadResults[PACKAGE_NAME] = {fromCache: false};
      if (fetched) {
        processPackageData(fetched);
        fetched = null;
      } else {
        fetchedCallback = processPackageData;
      }
    
  }
  if (Module['calledRun']) {
    runWithFS();
  } else {
    if (!Module['preRun']) Module['preRun'] = [];
    Module["preRun"].push(runWithFS); // FS is not initialized yet, wait for it
  }

})();

// Note: For maximum-speed code, see "Optimizing Code" on the Emscripten wiki, https://github.com/kripken/emscripten/wiki/Optimizing-Code
// Note: Some Emscripten settings may limit the speed of the generated code.
// The Module object: Our interface to the outside world. We import
// and export values on it, and do the work to get that through
// closure compiler if necessary. There are various ways Module can be used:
// 1. Not defined. We create it here
// 2. A function parameter, function(Module) { ..generated code.. }
// 3. pre-run appended it, var Module = {}; ..generated code..
// 4. External script tag defines var Module.
// We need to do an eval in order to handle the closure compiler
// case, where this code here is minified but Module was defined
// elsewhere (e.g. case 4 above). We also need to check if Module
// already exists (e.g. case 3 above).
// Note that if you want to run closure, and also to use Module
// after the generated code, you will need to define   var Module = {};
// before the code. Then that object will be used in the code, and you
// can continue to use Module afterwards as well.
var Module;
if (!Module) Module = eval('(function() { try { return Module || {} } catch(e) { return {} } })()');

// Sometimes an existing Module object exists with properties
// meant to overwrite the default module functionality. Here
// we collect those properties and reapply _after_ we configure
// the current environment's defaults to avoid having to be so
// defensive during initialization.
var moduleOverrides = {};
for (var key in Module) {
  if (Module.hasOwnProperty(key)) {
    moduleOverrides[key] = Module[key];
  }
}

// The environment setup code below is customized to use Module.
// *** Environment setup code ***
var ENVIRONMENT_IS_NODE = typeof process === 'object' && typeof require === 'function';
var ENVIRONMENT_IS_WEB = typeof window === 'object';
var ENVIRONMENT_IS_WORKER = typeof importScripts === 'function';
var ENVIRONMENT_IS_SHELL = !ENVIRONMENT_IS_WEB && !ENVIRONMENT_IS_NODE && !ENVIRONMENT_IS_WORKER;

if (ENVIRONMENT_IS_NODE) {
  // Expose functionality in the same simple way that the shells work
  // Note that we pollute the global namespace here, otherwise we break in node
  if (!Module['print']) Module['print'] = function print(x) {
    process['stdout'].write(x + '\n');
  };
  if (!Module['printErr']) Module['printErr'] = function printErr(x) {
    process['stderr'].write(x + '\n');
  };

  var nodeFS = require('fs');
  var nodePath = require('path');

  Module['read'] = function read(filename, binary) {
    filename = nodePath['normalize'](filename);
    var ret = nodeFS['readFileSync'](filename);
    // The path is absolute if the normalized version is the same as the resolved.
    if (!ret && filename != nodePath['resolve'](filename)) {
      filename = path.join(__dirname, '..', 'src', filename);
      ret = nodeFS['readFileSync'](filename);
    }
    if (ret && !binary) ret = ret.toString();
    return ret;
  };

  Module['readBinary'] = function readBinary(filename) { return Module['read'](filename, true) };

  Module['load'] = function load(f) {
    globalEval(read(f));
  };

  Module['arguments'] = process['argv'].slice(2);

  module['exports'] = Module;
}
else if (ENVIRONMENT_IS_SHELL) {
  if (!Module['print']) Module['print'] = print;
  if (typeof printErr != 'undefined') Module['printErr'] = printErr; // not present in v8 or older sm

  if (typeof read != 'undefined') {
    Module['read'] = read;
  } else {
    Module['read'] = function read() { throw 'no read() available (jsc?)' };
  }

  Module['readBinary'] = function readBinary(f) {
    return read(f, 'binary');
  };

  if (typeof scriptArgs != 'undefined') {
    Module['arguments'] = scriptArgs;
  } else if (typeof arguments != 'undefined') {
    Module['arguments'] = arguments;
  }

  this['Module'] = Module;

  eval("if (typeof gc === 'function' && gc.toString().indexOf('[native code]') > 0) var gc = undefined"); // wipe out the SpiderMonkey shell 'gc' function, which can confuse closure (uses it as a minified name, and it is then initted to a non-falsey value unexpectedly)
}
else if (ENVIRONMENT_IS_WEB || ENVIRONMENT_IS_WORKER) {
  Module['read'] = function read(url) {
    var xhr = new XMLHttpRequest();
    xhr.open('GET', url, false);
    xhr.send(null);
    return xhr.responseText;
  };

  if (typeof arguments != 'undefined') {
    Module['arguments'] = arguments;
  }

  if (typeof console !== 'undefined') {
    if (!Module['print']) Module['print'] = function print(x) {
      console.log(x);
    };
    if (!Module['printErr']) Module['printErr'] = function printErr(x) {
      console.log(x);
    };
  } else {
    // Probably a worker, and without console.log. We can do very little here...
    var TRY_USE_DUMP = false;
    if (!Module['print']) Module['print'] = (TRY_USE_DUMP && (typeof(dump) !== "undefined") ? (function(x) {
      dump(x);
    }) : (function(x) {
      // self.postMessage(x); // enable this if you want stdout to be sent as messages
    }));
  }

  if (ENVIRONMENT_IS_WEB) {
    this['Module'] = Module;
  } else {
    Module['load'] = importScripts;
  }
}
else {
  // Unreachable because SHELL is dependant on the others
  throw 'Unknown runtime environment. Where are we?';
}

function globalEval(x) {
  eval.call(null, x);
}
if (!Module['load'] == 'undefined' && Module['read']) {
  Module['load'] = function load(f) {
    globalEval(Module['read'](f));
  };
}
if (!Module['print']) {
  Module['print'] = function(){};
}
if (!Module['printErr']) {
  Module['printErr'] = Module['print'];
}
if (!Module['arguments']) {
  Module['arguments'] = [];
}
// *** Environment setup code ***

// Closure helpers
Module.print = Module['print'];
Module.printErr = Module['printErr'];

// Callbacks
Module['preRun'] = [];
Module['postRun'] = [];

// Merge back in the overrides
for (var key in moduleOverrides) {
  if (moduleOverrides.hasOwnProperty(key)) {
    Module[key] = moduleOverrides[key];
  }
}



// === Auto-generated preamble library stuff ===

//========================================
// Runtime code shared with compiler
//========================================

var Runtime = {
  stackSave: function () {
    return STACKTOP;
  },
  stackRestore: function (stackTop) {
    STACKTOP = stackTop;
  },
  forceAlign: function (target, quantum) {
    quantum = quantum || 4;
    if (quantum == 1) return target;
    if (isNumber(target) && isNumber(quantum)) {
      return Math.ceil(target/quantum)*quantum;
    } else if (isNumber(quantum) && isPowerOfTwo(quantum)) {
      return '(((' +target + ')+' + (quantum-1) + ')&' + -quantum + ')';
    }
    return 'Math.ceil((' + target + ')/' + quantum + ')*' + quantum;
  },
  isNumberType: function (type) {
    return type in Runtime.INT_TYPES || type in Runtime.FLOAT_TYPES;
  },
  isPointerType: function isPointerType(type) {
  return type[type.length-1] == '*';
},
  isStructType: function isStructType(type) {
  if (isPointerType(type)) return false;
  if (isArrayType(type)) return true;
  if (/<?\{ ?[^}]* ?\}>?/.test(type)) return true; // { i32, i8 } etc. - anonymous struct types
  // See comment in isStructPointerType()
  return type[0] == '%';
},
  INT_TYPES: {"i1":0,"i8":0,"i16":0,"i32":0,"i64":0},
  FLOAT_TYPES: {"float":0,"double":0},
  or64: function (x, y) {
    var l = (x | 0) | (y | 0);
    var h = (Math.round(x / 4294967296) | Math.round(y / 4294967296)) * 4294967296;
    return l + h;
  },
  and64: function (x, y) {
    var l = (x | 0) & (y | 0);
    var h = (Math.round(x / 4294967296) & Math.round(y / 4294967296)) * 4294967296;
    return l + h;
  },
  xor64: function (x, y) {
    var l = (x | 0) ^ (y | 0);
    var h = (Math.round(x / 4294967296) ^ Math.round(y / 4294967296)) * 4294967296;
    return l + h;
  },
  getNativeTypeSize: function (type) {
    switch (type) {
      case 'i1': case 'i8': return 1;
      case 'i16': return 2;
      case 'i32': return 4;
      case 'i64': return 8;
      case 'float': return 4;
      case 'double': return 8;
      default: {
        if (type[type.length-1] === '*') {
          return Runtime.QUANTUM_SIZE; // A pointer
        } else if (type[0] === 'i') {
          var bits = parseInt(type.substr(1));
          assert(bits % 8 === 0);
          return bits/8;
        } else {
          return 0;
        }
      }
    }
  },
  getNativeFieldSize: function (type) {
    return Math.max(Runtime.getNativeTypeSize(type), Runtime.QUANTUM_SIZE);
  },
  dedup: function dedup(items, ident) {
  var seen = {};
  if (ident) {
    return items.filter(function(item) {
      if (seen[item[ident]]) return false;
      seen[item[ident]] = true;
      return true;
    });
  } else {
    return items.filter(function(item) {
      if (seen[item]) return false;
      seen[item] = true;
      return true;
    });
  }
},
  set: function set() {
  var args = typeof arguments[0] === 'object' ? arguments[0] : arguments;
  var ret = {};
  for (var i = 0; i < args.length; i++) {
    ret[args[i]] = 0;
  }
  return ret;
},
  STACK_ALIGN: 8,
  getAlignSize: function (type, size, vararg) {
    // we align i64s and doubles on 64-bit boundaries, unlike x86
    if (vararg) return 8;
    if (!vararg && (type == 'i64' || type == 'double')) return 8;
    if (!type) return Math.min(size, 8); // align structures internally to 64 bits
    return Math.min(size || (type ? Runtime.getNativeFieldSize(type) : 0), Runtime.QUANTUM_SIZE);
  },
  calculateStructAlignment: function calculateStructAlignment(type) {
    type.flatSize = 0;
    type.alignSize = 0;
    var diffs = [];
    var prev = -1;
    var index = 0;
    type.flatIndexes = type.fields.map(function(field) {
      index++;
      var size, alignSize;
      if (Runtime.isNumberType(field) || Runtime.isPointerType(field)) {
        size = Runtime.getNativeTypeSize(field); // pack char; char; in structs, also char[X]s.
        alignSize = Runtime.getAlignSize(field, size);
      } else if (Runtime.isStructType(field)) {
        if (field[1] === '0') {
          // this is [0 x something]. When inside another structure like here, it must be at the end,
          // and it adds no size
          // XXX this happens in java-nbody for example... assert(index === type.fields.length, 'zero-length in the middle!');
          size = 0;
          if (Types.types[field]) {
            alignSize = Runtime.getAlignSize(null, Types.types[field].alignSize);
          } else {
            alignSize = type.alignSize || QUANTUM_SIZE;
          }
        } else {
          size = Types.types[field].flatSize;
          alignSize = Runtime.getAlignSize(null, Types.types[field].alignSize);
        }
      } else if (field[0] == 'b') {
        // bN, large number field, like a [N x i8]
        size = field.substr(1)|0;
        alignSize = 1;
      } else if (field[0] === '<') {
        // vector type
        size = alignSize = Types.types[field].flatSize; // fully aligned
      } else if (field[0] === 'i') {
        // illegal integer field, that could not be legalized because it is an internal structure field
        // it is ok to have such fields, if we just use them as markers of field size and nothing more complex
        size = alignSize = parseInt(field.substr(1))/8;
        assert(size % 1 === 0, 'cannot handle non-byte-size field ' + field);
      } else {
        assert(false, 'invalid type for calculateStructAlignment');
      }
      if (type.packed) alignSize = 1;
      type.alignSize = Math.max(type.alignSize, alignSize);
      var curr = Runtime.alignMemory(type.flatSize, alignSize); // if necessary, place this on aligned memory
      type.flatSize = curr + size;
      if (prev >= 0) {
        diffs.push(curr-prev);
      }
      prev = curr;
      return curr;
    });
    if (type.name_ && type.name_[0] === '[') {
      // arrays have 2 elements, so we get the proper difference. then we scale here. that way we avoid
      // allocating a potentially huge array for [999999 x i8] etc.
      type.flatSize = parseInt(type.name_.substr(1))*type.flatSize/2;
    }
    type.flatSize = Runtime.alignMemory(type.flatSize, type.alignSize);
    if (diffs.length == 0) {
      type.flatFactor = type.flatSize;
    } else if (Runtime.dedup(diffs).length == 1) {
      type.flatFactor = diffs[0];
    }
    type.needsFlattening = (type.flatFactor != 1);
    return type.flatIndexes;
  },
  generateStructInfo: function (struct, typeName, offset) {
    var type, alignment;
    if (typeName) {
      offset = offset || 0;
      type = (typeof Types === 'undefined' ? Runtime.typeInfo : Types.types)[typeName];
      if (!type) return null;
      if (type.fields.length != struct.length) {
        printErr('Number of named fields must match the type for ' + typeName + ': possibly duplicate struct names. Cannot return structInfo');
        return null;
      }
      alignment = type.flatIndexes;
    } else {
      var type = { fields: struct.map(function(item) { return item[0] }) };
      alignment = Runtime.calculateStructAlignment(type);
    }
    var ret = {
      __size__: type.flatSize
    };
    if (typeName) {
      struct.forEach(function(item, i) {
        if (typeof item === 'string') {
          ret[item] = alignment[i] + offset;
        } else {
          // embedded struct
          var key;
          for (var k in item) key = k;
          ret[key] = Runtime.generateStructInfo(item[key], type.fields[i], alignment[i]);
        }
      });
    } else {
      struct.forEach(function(item, i) {
        ret[item[1]] = alignment[i];
      });
    }
    return ret;
  },
  dynCall: function (sig, ptr, args) {
    if (args && args.length) {
      if (!args.splice) args = Array.prototype.slice.call(args);
      args.splice(0, 0, ptr);
      return Module['dynCall_' + sig].apply(null, args);
    } else {
      return Module['dynCall_' + sig].call(null, ptr);
    }
  },
  functionPointers: [],
  addFunction: function (func) {
    for (var i = 0; i < Runtime.functionPointers.length; i++) {
      if (!Runtime.functionPointers[i]) {
        Runtime.functionPointers[i] = func;
        return 2*(1 + i);
      }
    }
    throw 'Finished up all reserved function pointers. Use a higher value for RESERVED_FUNCTION_POINTERS.';
  },
  removeFunction: function (index) {
    Runtime.functionPointers[(index-2)/2] = null;
  },
  getAsmConst: function (code, numArgs) {
    // code is a constant string on the heap, so we can cache these
    if (!Runtime.asmConstCache) Runtime.asmConstCache = {};
    var func = Runtime.asmConstCache[code];
    if (func) return func;
    var args = [];
    for (var i = 0; i < numArgs; i++) {
      args.push(String.fromCharCode(36) + i); // $0, $1 etc
    }
    code = Pointer_stringify(code);
    if (code[0] === '"') {
      // tolerate EM_ASM("..code..") even though EM_ASM(..code..) is correct
      if (code.indexOf('"', 1) === code.length-1) {
        code = code.substr(1, code.length-2);
      } else {
        // something invalid happened, e.g. EM_ASM("..code($0)..", input)
        abort('invalid EM_ASM input |' + code + '|. Please use EM_ASM(..code..) (no quotes) or EM_ASM({ ..code($0).. }, input) (to input values)');
      }
    }
    return Runtime.asmConstCache[code] = eval('(function(' + args.join(',') + '){ ' + code + ' })'); // new Function does not allow upvars in node
  },
  warnOnce: function (text) {
    if (!Runtime.warnOnce.shown) Runtime.warnOnce.shown = {};
    if (!Runtime.warnOnce.shown[text]) {
      Runtime.warnOnce.shown[text] = 1;
      Module.printErr(text);
    }
  },
  funcWrappers: {},
  getFuncWrapper: function (func, sig) {
    assert(sig);
    if (!Runtime.funcWrappers[func]) {
      Runtime.funcWrappers[func] = function dynCall_wrapper() {
        return Runtime.dynCall(sig, func, arguments);
      };
    }
    return Runtime.funcWrappers[func];
  },
  UTF8Processor: function () {
    var buffer = [];
    var needed = 0;
    this.processCChar = function (code) {
      code = code & 0xFF;

      if (buffer.length == 0) {
        if ((code & 0x80) == 0x00) {        // 0xxxxxxx
          return String.fromCharCode(code);
        }
        buffer.push(code);
        if ((code & 0xE0) == 0xC0) {        // 110xxxxx
          needed = 1;
        } else if ((code & 0xF0) == 0xE0) { // 1110xxxx
          needed = 2;
        } else {                            // 11110xxx
          needed = 3;
        }
        return '';
      }

      if (needed) {
        buffer.push(code);
        needed--;
        if (needed > 0) return '';
      }

      var c1 = buffer[0];
      var c2 = buffer[1];
      var c3 = buffer[2];
      var c4 = buffer[3];
      var ret;
      if (buffer.length == 2) {
        ret = String.fromCharCode(((c1 & 0x1F) << 6)  | (c2 & 0x3F));
      } else if (buffer.length == 3) {
        ret = String.fromCharCode(((c1 & 0x0F) << 12) | ((c2 & 0x3F) << 6)  | (c3 & 0x3F));
      } else {
        // http://mathiasbynens.be/notes/javascript-encoding#surrogate-formulae
        var codePoint = ((c1 & 0x07) << 18) | ((c2 & 0x3F) << 12) |
                        ((c3 & 0x3F) << 6)  | (c4 & 0x3F);
        ret = String.fromCharCode(
          Math.floor((codePoint - 0x10000) / 0x400) + 0xD800,
          (codePoint - 0x10000) % 0x400 + 0xDC00);
      }
      buffer.length = 0;
      return ret;
    }
    this.processJSString = function processJSString(string) {
      string = unescape(encodeURIComponent(string));
      var ret = [];
      for (var i = 0; i < string.length; i++) {
        ret.push(string.charCodeAt(i));
      }
      return ret;
    }
  },
  getCompilerSetting: function (name) {
    throw 'You must build with -s RETAIN_COMPILER_SETTINGS=1 for Runtime.getCompilerSetting or emscripten_get_compiler_setting to work';
  },
  stackAlloc: function (size) { var ret = STACKTOP;STACKTOP = (STACKTOP + size)|0;STACKTOP = (((STACKTOP)+7)&-8); return ret; },
  staticAlloc: function (size) { var ret = STATICTOP;STATICTOP = (STATICTOP + size)|0;STATICTOP = (((STATICTOP)+7)&-8); return ret; },
  dynamicAlloc: function (size) { var ret = DYNAMICTOP;DYNAMICTOP = (DYNAMICTOP + size)|0;DYNAMICTOP = (((DYNAMICTOP)+7)&-8); if (DYNAMICTOP >= TOTAL_MEMORY) enlargeMemory();; return ret; },
  alignMemory: function (size,quantum) { var ret = size = Math.ceil((size)/(quantum ? quantum : 8))*(quantum ? quantum : 8); return ret; },
  makeBigInt: function (low,high,unsigned) { var ret = (unsigned ? ((+((low>>>0)))+((+((high>>>0)))*(+4294967296))) : ((+((low>>>0)))+((+((high|0)))*(+4294967296)))); return ret; },
  GLOBAL_BASE: 8,
  QUANTUM_SIZE: 4,
  __dummy__: 0
}


Module['Runtime'] = Runtime;









//========================================
// Runtime essentials
//========================================

var __THREW__ = 0; // Used in checking for thrown exceptions.

var ABORT = false; // whether we are quitting the application. no code should run after this. set in exit() and abort()
var EXITSTATUS = 0;

var undef = 0;
// tempInt is used for 32-bit signed values or smaller. tempBigInt is used
// for 32-bit unsigned values or more than 32 bits. TODO: audit all uses of tempInt
var tempValue, tempInt, tempBigInt, tempInt2, tempBigInt2, tempPair, tempBigIntI, tempBigIntR, tempBigIntS, tempBigIntP, tempBigIntD, tempDouble, tempFloat;
var tempI64, tempI64b;
var tempRet0, tempRet1, tempRet2, tempRet3, tempRet4, tempRet5, tempRet6, tempRet7, tempRet8, tempRet9;

function assert(condition, text) {
  if (!condition) {
    abort('Assertion failed: ' + text);
  }
}

var globalScope = this;

// C calling interface. A convenient way to call C functions (in C files, or
// defined with extern "C").
//
// Note: LLVM optimizations can inline and remove functions, after which you will not be
//       able to call them. Closure can also do so. To avoid that, add your function to
//       the exports using something like
//
//         -s EXPORTED_FUNCTIONS='["_main", "_myfunc"]'
//
// @param ident      The name of the C function (note that C++ functions will be name-mangled - use extern "C")
// @param returnType The return type of the function, one of the JS types 'number', 'string' or 'array' (use 'number' for any C pointer, and
//                   'array' for JavaScript arrays and typed arrays; note that arrays are 8-bit).
// @param argTypes   An array of the types of arguments for the function (if there are no arguments, this can be ommitted). Types are as in returnType,
//                   except that 'array' is not possible (there is no way for us to know the length of the array)
// @param args       An array of the arguments to the function, as native JS values (as in returnType)
//                   Note that string arguments will be stored on the stack (the JS string will become a C string on the stack).
// @return           The return value, as a native JS value (as in returnType)
function ccall(ident, returnType, argTypes, args) {
  return ccallFunc(getCFunc(ident), returnType, argTypes, args);
}
Module["ccall"] = ccall;

// Returns the C function with a specified identifier (for C++, you need to do manual name mangling)
function getCFunc(ident) {
  try {
    var func = Module['_' + ident]; // closure exported function
    if (!func) func = eval('_' + ident); // explicit lookup
  } catch(e) {
  }
  assert(func, 'Cannot call unknown function ' + ident + ' (perhaps LLVM optimizations or closure removed it?)');
  return func;
}

// Internal function that does a C call using a function, not an identifier
function ccallFunc(func, returnType, argTypes, args) {
  var stack = 0;
  function toC(value, type) {
    if (type == 'string') {
      if (value === null || value === undefined || value === 0) return 0; // null string
      value = intArrayFromString(value);
      type = 'array';
    }
    if (type == 'array') {
      if (!stack) stack = Runtime.stackSave();
      var ret = Runtime.stackAlloc(value.length);
      writeArrayToMemory(value, ret);
      return ret;
    }
    return value;
  }
  function fromC(value, type) {
    if (type == 'string') {
      return Pointer_stringify(value);
    }
    assert(type != 'array');
    return value;
  }
  var i = 0;
  var cArgs = args ? args.map(function(arg) {
    return toC(arg, argTypes[i++]);
  }) : [];
  var ret = fromC(func.apply(null, cArgs), returnType);
  if (stack) Runtime.stackRestore(stack);
  return ret;
}

// Returns a native JS wrapper for a C function. This is similar to ccall, but
// returns a function you can call repeatedly in a normal way. For example:
//
//   var my_function = cwrap('my_c_function', 'number', ['number', 'number']);
//   alert(my_function(5, 22));
//   alert(my_function(99, 12));
//
function cwrap(ident, returnType, argTypes) {
  var func = getCFunc(ident);
  return function() {
    return ccallFunc(func, returnType, argTypes, Array.prototype.slice.call(arguments));
  }
}
Module["cwrap"] = cwrap;

// Sets a value in memory in a dynamic way at run-time. Uses the
// type data. This is the same as makeSetValue, except that
// makeSetValue is done at compile-time and generates the needed
// code then, whereas this function picks the right code at
// run-time.
// Note that setValue and getValue only do *aligned* writes and reads!
// Note that ccall uses JS types as for defining types, while setValue and
// getValue need LLVM types ('i8', 'i32') - this is a lower-level operation
function setValue(ptr, value, type, noSafe) {
  type = type || 'i8';
  if (type.charAt(type.length-1) === '*') type = 'i32'; // pointers are 32-bit
    switch(type) {
      case 'i1': HEAP8[(ptr)]=value; break;
      case 'i8': HEAP8[(ptr)]=value; break;
      case 'i16': HEAP16[((ptr)>>1)]=value; break;
      case 'i32': HEAP32[((ptr)>>2)]=value; break;
      case 'i64': (tempI64 = [value>>>0,(tempDouble=value,(+(Math_abs(tempDouble))) >= (+1) ? (tempDouble > (+0) ? ((Math_min((+(Math_floor((tempDouble)/(+4294967296)))), (+4294967295)))|0)>>>0 : (~~((+(Math_ceil((tempDouble - +(((~~(tempDouble)))>>>0))/(+4294967296))))))>>>0) : 0)],HEAP32[((ptr)>>2)]=tempI64[0],HEAP32[(((ptr)+(4))>>2)]=tempI64[1]); break;
      case 'float': HEAPF32[((ptr)>>2)]=value; break;
      case 'double': HEAPF64[((ptr)>>3)]=value; break;
      default: abort('invalid type for setValue: ' + type);
    }
}
Module['setValue'] = setValue;

// Parallel to setValue.
function getValue(ptr, type, noSafe) {
  type = type || 'i8';
  if (type.charAt(type.length-1) === '*') type = 'i32'; // pointers are 32-bit
    switch(type) {
      case 'i1': return HEAP8[(ptr)];
      case 'i8': return HEAP8[(ptr)];
      case 'i16': return HEAP16[((ptr)>>1)];
      case 'i32': return HEAP32[((ptr)>>2)];
      case 'i64': return HEAP32[((ptr)>>2)];
      case 'float': return HEAPF32[((ptr)>>2)];
      case 'double': return HEAPF64[((ptr)>>3)];
      default: abort('invalid type for setValue: ' + type);
    }
  return null;
}
Module['getValue'] = getValue;

var ALLOC_NORMAL = 0; // Tries to use _malloc()
var ALLOC_STACK = 1; // Lives for the duration of the current function call
var ALLOC_STATIC = 2; // Cannot be freed
var ALLOC_DYNAMIC = 3; // Cannot be freed except through sbrk
var ALLOC_NONE = 4; // Do not allocate
Module['ALLOC_NORMAL'] = ALLOC_NORMAL;
Module['ALLOC_STACK'] = ALLOC_STACK;
Module['ALLOC_STATIC'] = ALLOC_STATIC;
Module['ALLOC_DYNAMIC'] = ALLOC_DYNAMIC;
Module['ALLOC_NONE'] = ALLOC_NONE;

// allocate(): This is for internal use. You can use it yourself as well, but the interface
//             is a little tricky (see docs right below). The reason is that it is optimized
//             for multiple syntaxes to save space in generated code. So you should
//             normally not use allocate(), and instead allocate memory using _malloc(),
//             initialize it with setValue(), and so forth.
// @slab: An array of data, or a number. If a number, then the size of the block to allocate,
//        in *bytes* (note that this is sometimes confusing: the next parameter does not
//        affect this!)
// @types: Either an array of types, one for each byte (or 0 if no type at that position),
//         or a single type which is used for the entire block. This only matters if there
//         is initial data - if @slab is a number, then this does not matter at all and is
//         ignored.
// @allocator: How to allocate memory, see ALLOC_*
function allocate(slab, types, allocator, ptr) {
  var zeroinit, size;
  if (typeof slab === 'number') {
    zeroinit = true;
    size = slab;
  } else {
    zeroinit = false;
    size = slab.length;
  }

  var singleType = typeof types === 'string' ? types : null;

  var ret;
  if (allocator == ALLOC_NONE) {
    ret = ptr;
  } else {
    ret = [_malloc, Runtime.stackAlloc, Runtime.staticAlloc, Runtime.dynamicAlloc][allocator === undefined ? ALLOC_STATIC : allocator](Math.max(size, singleType ? 1 : types.length));
  }

  if (zeroinit) {
    var ptr = ret, stop;
    assert((ret & 3) == 0);
    stop = ret + (size & ~3);
    for (; ptr < stop; ptr += 4) {
      HEAP32[((ptr)>>2)]=0;
    }
    stop = ret + size;
    while (ptr < stop) {
      HEAP8[((ptr++)|0)]=0;
    }
    return ret;
  }

  if (singleType === 'i8') {
    if (slab.subarray || slab.slice) {
      HEAPU8.set(slab, ret);
    } else {
      HEAPU8.set(new Uint8Array(slab), ret);
    }
    return ret;
  }

  var i = 0, type, typeSize, previousType;
  while (i < size) {
    var curr = slab[i];

    if (typeof curr === 'function') {
      curr = Runtime.getFunctionIndex(curr);
    }

    type = singleType || types[i];
    if (type === 0) {
      i++;
      continue;
    }

    if (type == 'i64') type = 'i32'; // special case: we have one i32 here, and one i32 later

    setValue(ret+i, curr, type);

    // no need to look up size unless type changes, so cache it
    if (previousType !== type) {
      typeSize = Runtime.getNativeTypeSize(type);
      previousType = type;
    }
    i += typeSize;
  }

  return ret;
}
Module['allocate'] = allocate;

function Pointer_stringify(ptr, /* optional */ length) {
  // TODO: use TextDecoder
  // Find the length, and check for UTF while doing so
  var hasUtf = false;
  var t;
  var i = 0;
  while (1) {
    t = HEAPU8[(((ptr)+(i))|0)];
    if (t >= 128) hasUtf = true;
    else if (t == 0 && !length) break;
    i++;
    if (length && i == length) break;
  }
  if (!length) length = i;

  var ret = '';

  if (!hasUtf) {
    var MAX_CHUNK = 1024; // split up into chunks, because .apply on a huge string can overflow the stack
    var curr;
    while (length > 0) {
      curr = String.fromCharCode.apply(String, HEAPU8.subarray(ptr, ptr + Math.min(length, MAX_CHUNK)));
      ret = ret ? ret + curr : curr;
      ptr += MAX_CHUNK;
      length -= MAX_CHUNK;
    }
    return ret;
  }

  var utf8 = new Runtime.UTF8Processor();
  for (i = 0; i < length; i++) {
    t = HEAPU8[(((ptr)+(i))|0)];
    ret += utf8.processCChar(t);
  }
  return ret;
}
Module['Pointer_stringify'] = Pointer_stringify;

// Given a pointer 'ptr' to a null-terminated UTF16LE-encoded string in the emscripten HEAP, returns
// a copy of that string as a Javascript String object.
function UTF16ToString(ptr) {
  var i = 0;

  var str = '';
  while (1) {
    var codeUnit = HEAP16[(((ptr)+(i*2))>>1)];
    if (codeUnit == 0)
      return str;
    ++i;
    // fromCharCode constructs a character from a UTF-16 code unit, so we can pass the UTF16 string right through.
    str += String.fromCharCode(codeUnit);
  }
}
Module['UTF16ToString'] = UTF16ToString;

// Copies the given Javascript String object 'str' to the emscripten HEAP at address 'outPtr',
// null-terminated and encoded in UTF16LE form. The copy will require at most (str.length*2+1)*2 bytes of space in the HEAP.
function stringToUTF16(str, outPtr) {
  for(var i = 0; i < str.length; ++i) {
    // charCodeAt returns a UTF-16 encoded code unit, so it can be directly written to the HEAP.
    var codeUnit = str.charCodeAt(i); // possibly a lead surrogate
    HEAP16[(((outPtr)+(i*2))>>1)]=codeUnit;
  }
  // Null-terminate the pointer to the HEAP.
  HEAP16[(((outPtr)+(str.length*2))>>1)]=0;
}
Module['stringToUTF16'] = stringToUTF16;

// Given a pointer 'ptr' to a null-terminated UTF32LE-encoded string in the emscripten HEAP, returns
// a copy of that string as a Javascript String object.
function UTF32ToString(ptr) {
  var i = 0;

  var str = '';
  while (1) {
    var utf32 = HEAP32[(((ptr)+(i*4))>>2)];
    if (utf32 == 0)
      return str;
    ++i;
    // Gotcha: fromCharCode constructs a character from a UTF-16 encoded code (pair), not from a Unicode code point! So encode the code point to UTF-16 for constructing.
    if (utf32 >= 0x10000) {
      var ch = utf32 - 0x10000;
      str += String.fromCharCode(0xD800 | (ch >> 10), 0xDC00 | (ch & 0x3FF));
    } else {
      str += String.fromCharCode(utf32);
    }
  }
}
Module['UTF32ToString'] = UTF32ToString;

// Copies the given Javascript String object 'str' to the emscripten HEAP at address 'outPtr',
// null-terminated and encoded in UTF32LE form. The copy will require at most (str.length+1)*4 bytes of space in the HEAP,
// but can use less, since str.length does not return the number of characters in the string, but the number of UTF-16 code units in the string.
function stringToUTF32(str, outPtr) {
  var iChar = 0;
  for(var iCodeUnit = 0; iCodeUnit < str.length; ++iCodeUnit) {
    // Gotcha: charCodeAt returns a 16-bit word that is a UTF-16 encoded code unit, not a Unicode code point of the character! We must decode the string to UTF-32 to the heap.
    var codeUnit = str.charCodeAt(iCodeUnit); // possibly a lead surrogate
    if (codeUnit >= 0xD800 && codeUnit <= 0xDFFF) {
      var trailSurrogate = str.charCodeAt(++iCodeUnit);
      codeUnit = 0x10000 + ((codeUnit & 0x3FF) << 10) | (trailSurrogate & 0x3FF);
    }
    HEAP32[(((outPtr)+(iChar*4))>>2)]=codeUnit;
    ++iChar;
  }
  // Null-terminate the pointer to the HEAP.
  HEAP32[(((outPtr)+(iChar*4))>>2)]=0;
}
Module['stringToUTF32'] = stringToUTF32;

function demangle(func) {
  var i = 3;
  // params, etc.
  var basicTypes = {
    'v': 'void',
    'b': 'bool',
    'c': 'char',
    's': 'short',
    'i': 'int',
    'l': 'long',
    'f': 'float',
    'd': 'double',
    'w': 'wchar_t',
    'a': 'signed char',
    'h': 'unsigned char',
    't': 'unsigned short',
    'j': 'unsigned int',
    'm': 'unsigned long',
    'x': 'long long',
    'y': 'unsigned long long',
    'z': '...'
  };
  var subs = [];
  var first = true;
  function dump(x) {
    //return;
    if (x) Module.print(x);
    Module.print(func);
    var pre = '';
    for (var a = 0; a < i; a++) pre += ' ';
    Module.print (pre + '^');
  }
  function parseNested() {
    i++;
    if (func[i] === 'K') i++; // ignore const
    var parts = [];
    while (func[i] !== 'E') {
      if (func[i] === 'S') { // substitution
        i++;
        var next = func.indexOf('_', i);
        var num = func.substring(i, next) || 0;
        parts.push(subs[num] || '?');
        i = next+1;
        continue;
      }
      if (func[i] === 'C') { // constructor
        parts.push(parts[parts.length-1]);
        i += 2;
        continue;
      }
      var size = parseInt(func.substr(i));
      var pre = size.toString().length;
      if (!size || !pre) { i--; break; } // counter i++ below us
      var curr = func.substr(i + pre, size);
      parts.push(curr);
      subs.push(curr);
      i += pre + size;
    }
    i++; // skip E
    return parts;
  }
  function parse(rawList, limit, allowVoid) { // main parser
    limit = limit || Infinity;
    var ret = '', list = [];
    function flushList() {
      return '(' + list.join(', ') + ')';
    }
    var name;
    if (func[i] === 'N') {
      // namespaced N-E
      name = parseNested().join('::');
      limit--;
      if (limit === 0) return rawList ? [name] : name;
    } else {
      // not namespaced
      if (func[i] === 'K' || (first && func[i] === 'L')) i++; // ignore const and first 'L'
      var size = parseInt(func.substr(i));
      if (size) {
        var pre = size.toString().length;
        name = func.substr(i + pre, size);
        i += pre + size;
      }
    }
    first = false;
    if (func[i] === 'I') {
      i++;
      var iList = parse(true);
      var iRet = parse(true, 1, true);
      ret += iRet[0] + ' ' + name + '<' + iList.join(', ') + '>';
    } else {
      ret = name;
    }
    paramLoop: while (i < func.length && limit-- > 0) {
      //dump('paramLoop');
      var c = func[i++];
      if (c in basicTypes) {
        list.push(basicTypes[c]);
      } else {
        switch (c) {
          case 'P': list.push(parse(true, 1, true)[0] + '*'); break; // pointer
          case 'R': list.push(parse(true, 1, true)[0] + '&'); break; // reference
          case 'L': { // literal
            i++; // skip basic type
            var end = func.indexOf('E', i);
            var size = end - i;
            list.push(func.substr(i, size));
            i += size + 2; // size + 'EE'
            break;
          }
          case 'A': { // array
            var size = parseInt(func.substr(i));
            i += size.toString().length;
            if (func[i] !== '_') throw '?';
            i++; // skip _
            list.push(parse(true, 1, true)[0] + ' [' + size + ']');
            break;
          }
          case 'E': break paramLoop;
          default: ret += '?' + c; break paramLoop;
        }
      }
    }
    if (!allowVoid && list.length === 1 && list[0] === 'void') list = []; // avoid (void)
    return rawList ? list : ret + flushList();
  }
  try {
    // Special-case the entry point, since its name differs from other name mangling.
    if (func == 'Object._main' || func == '_main') {
      return 'main()';
    }
    if (typeof func === 'number') func = Pointer_stringify(func);
    if (func[0] !== '_') return func;
    if (func[1] !== '_') return func; // C function
    if (func[2] !== 'Z') return func;
    switch (func[3]) {
      case 'n': return 'operator new()';
      case 'd': return 'operator delete()';
    }
    return parse();
  } catch(e) {
    return func;
  }
}

function demangleAll(text) {
  return text.replace(/__Z[\w\d_]+/g, function(x) { var y = demangle(x); return x === y ? x : (x + ' [' + y + ']') });
}

function stackTrace() {
  var stack = new Error().stack;
  return stack ? demangleAll(stack) : '(no stack trace available)'; // Stack trace is not available at least on IE10 and Safari 6.
}

// Memory management

var PAGE_SIZE = 4096;
function alignMemoryPage(x) {
  return (x+4095)&-4096;
}

var HEAP;
var HEAP8, HEAPU8, HEAP16, HEAPU16, HEAP32, HEAPU32, HEAPF32, HEAPF64;

var STATIC_BASE = 0, STATICTOP = 0, staticSealed = false; // static area
var STACK_BASE = 0, STACKTOP = 0, STACK_MAX = 0; // stack area
var DYNAMIC_BASE = 0, DYNAMICTOP = 0; // dynamic area handled by sbrk

function enlargeMemory() {
  abort('Cannot enlarge memory arrays. Either (1) compile with -s TOTAL_MEMORY=X with X higher than the current value ' + TOTAL_MEMORY + ', (2) compile with ALLOW_MEMORY_GROWTH which adjusts the size at runtime but prevents some optimizations, or (3) set Module.TOTAL_MEMORY before the program runs.');
}

var TOTAL_STACK = Module['TOTAL_STACK'] || 5242880;
var TOTAL_MEMORY = Module['TOTAL_MEMORY'] || 28000000;
var FAST_MEMORY = Module['FAST_MEMORY'] || 2097152;

var totalMemory = 4096;
while (totalMemory < TOTAL_MEMORY || totalMemory < 2*TOTAL_STACK) {
  if (totalMemory < 16*1024*1024) {
    totalMemory *= 2;
  } else {
    totalMemory += 16*1024*1024
  }
}
if (totalMemory !== TOTAL_MEMORY) {
  Module.printErr('increasing TOTAL_MEMORY to ' + totalMemory + ' to be more reasonable');
  TOTAL_MEMORY = totalMemory;
}

// Initialize the runtime's memory
// check for full engine support (use string 'subarray' to avoid closure compiler confusion)
assert(typeof Int32Array !== 'undefined' && typeof Float64Array !== 'undefined' && !!(new Int32Array(1)['subarray']) && !!(new Int32Array(1)['set']),
       'JS engine does not provide full typed array support');

var buffer = new ArrayBuffer(TOTAL_MEMORY);
HEAP8 = new Int8Array(buffer);
HEAP16 = new Int16Array(buffer);
HEAP32 = new Int32Array(buffer);
HEAPU8 = new Uint8Array(buffer);
HEAPU16 = new Uint16Array(buffer);
HEAPU32 = new Uint32Array(buffer);
HEAPF32 = new Float32Array(buffer);
HEAPF64 = new Float64Array(buffer);

// Endianness check (note: assumes compiler arch was little-endian)
HEAP32[0] = 255;
assert(HEAPU8[0] === 255 && HEAPU8[3] === 0, 'Typed arrays 2 must be run on a little-endian system');

Module['HEAP'] = HEAP;
Module['HEAP8'] = HEAP8;
Module['HEAP16'] = HEAP16;
Module['HEAP32'] = HEAP32;
Module['HEAPU8'] = HEAPU8;
Module['HEAPU16'] = HEAPU16;
Module['HEAPU32'] = HEAPU32;
Module['HEAPF32'] = HEAPF32;
Module['HEAPF64'] = HEAPF64;

function callRuntimeCallbacks(callbacks) {
  while(callbacks.length > 0) {
    var callback = callbacks.shift();
    if (typeof callback == 'function') {
      callback();
      continue;
    }
    var func = callback.func;
    if (typeof func === 'number') {
      if (callback.arg === undefined) {
        Runtime.dynCall('v', func);
      } else {
        Runtime.dynCall('vi', func, [callback.arg]);
      }
    } else {
      func(callback.arg === undefined ? null : callback.arg);
    }
  }
}

var __ATPRERUN__  = []; // functions called before the runtime is initialized
var __ATINIT__    = []; // functions called during startup
var __ATMAIN__    = []; // functions called when main() is to be run
var __ATEXIT__    = []; // functions called during shutdown
var __ATPOSTRUN__ = []; // functions called after the runtime has exited

var runtimeInitialized = false;

function preRun() {
  // compatibility - merge in anything from Module['preRun'] at this time
  if (Module['preRun']) {
    if (typeof Module['preRun'] == 'function') Module['preRun'] = [Module['preRun']];
    while (Module['preRun'].length) {
      addOnPreRun(Module['preRun'].shift());
    }
  }
  callRuntimeCallbacks(__ATPRERUN__);
}

function ensureInitRuntime() {
  if (runtimeInitialized) return;
  runtimeInitialized = true;
  callRuntimeCallbacks(__ATINIT__);
}

function preMain() {
  callRuntimeCallbacks(__ATMAIN__);
}

function exitRuntime() {
  callRuntimeCallbacks(__ATEXIT__);
}

function postRun() {
  // compatibility - merge in anything from Module['postRun'] at this time
  if (Module['postRun']) {
    if (typeof Module['postRun'] == 'function') Module['postRun'] = [Module['postRun']];
    while (Module['postRun'].length) {
      addOnPostRun(Module['postRun'].shift());
    }
  }
  callRuntimeCallbacks(__ATPOSTRUN__);
}

function addOnPreRun(cb) {
  __ATPRERUN__.unshift(cb);
}
Module['addOnPreRun'] = Module.addOnPreRun = addOnPreRun;

function addOnInit(cb) {
  __ATINIT__.unshift(cb);
}
Module['addOnInit'] = Module.addOnInit = addOnInit;

function addOnPreMain(cb) {
  __ATMAIN__.unshift(cb);
}
Module['addOnPreMain'] = Module.addOnPreMain = addOnPreMain;

function addOnExit(cb) {
  __ATEXIT__.unshift(cb);
}
Module['addOnExit'] = Module.addOnExit = addOnExit;

function addOnPostRun(cb) {
  __ATPOSTRUN__.unshift(cb);
}
Module['addOnPostRun'] = Module.addOnPostRun = addOnPostRun;

// Tools

// This processes a JS string into a C-line array of numbers, 0-terminated.
// For LLVM-originating strings, see parser.js:parseLLVMString function
function intArrayFromString(stringy, dontAddNull, length /* optional */) {
  var ret = (new Runtime.UTF8Processor()).processJSString(stringy);
  if (length) {
    ret.length = length;
  }
  if (!dontAddNull) {
    ret.push(0);
  }
  return ret;
}
Module['intArrayFromString'] = intArrayFromString;

function intArrayToString(array) {
  var ret = [];
  for (var i = 0; i < array.length; i++) {
    var chr = array[i];
    if (chr > 0xFF) {
      chr &= 0xFF;
    }
    ret.push(String.fromCharCode(chr));
  }
  return ret.join('');
}
Module['intArrayToString'] = intArrayToString;

// Write a Javascript array to somewhere in the heap
function writeStringToMemory(string, buffer, dontAddNull) {
  var array = intArrayFromString(string, dontAddNull);
  var i = 0;
  while (i < array.length) {
    var chr = array[i];
    HEAP8[(((buffer)+(i))|0)]=chr;
    i = i + 1;
  }
}
Module['writeStringToMemory'] = writeStringToMemory;

function writeArrayToMemory(array, buffer) {
  for (var i = 0; i < array.length; i++) {
    HEAP8[(((buffer)+(i))|0)]=array[i];
  }
}
Module['writeArrayToMemory'] = writeArrayToMemory;

function writeAsciiToMemory(str, buffer, dontAddNull) {
  for (var i = 0; i < str.length; i++) {
    HEAP8[(((buffer)+(i))|0)]=str.charCodeAt(i);
  }
  if (!dontAddNull) HEAP8[(((buffer)+(str.length))|0)]=0;
}
Module['writeAsciiToMemory'] = writeAsciiToMemory;

function unSign(value, bits, ignore) {
  if (value >= 0) {
    return value;
  }
  return bits <= 32 ? 2*Math.abs(1 << (bits-1)) + value // Need some trickery, since if bits == 32, we are right at the limit of the bits JS uses in bitshifts
                    : Math.pow(2, bits)         + value;
}
function reSign(value, bits, ignore) {
  if (value <= 0) {
    return value;
  }
  var half = bits <= 32 ? Math.abs(1 << (bits-1)) // abs is needed if bits == 32
                        : Math.pow(2, bits-1);
  if (value >= half && (bits <= 32 || value > half)) { // for huge values, we can hit the precision limit and always get true here. so don't do that
                                                       // but, in general there is no perfect solution here. With 64-bit ints, we get rounding and errors
                                                       // TODO: In i64 mode 1, resign the two parts separately and safely
    value = -2*half + value; // Cannot bitshift half, as it may be at the limit of the bits JS uses in bitshifts
  }
  return value;
}

// check for imul support, and also for correctness ( https://bugs.webkit.org/show_bug.cgi?id=126345 )
if (!Math['imul'] || Math['imul'](0xffffffff, 5) !== -5) Math['imul'] = function imul(a, b) {
  var ah  = a >>> 16;
  var al = a & 0xffff;
  var bh  = b >>> 16;
  var bl = b & 0xffff;
  return (al*bl + ((ah*bl + al*bh) << 16))|0;
};
Math.imul = Math['imul'];


var Math_abs = Math.abs;
var Math_cos = Math.cos;
var Math_sin = Math.sin;
var Math_tan = Math.tan;
var Math_acos = Math.acos;
var Math_asin = Math.asin;
var Math_atan = Math.atan;
var Math_atan2 = Math.atan2;
var Math_exp = Math.exp;
var Math_log = Math.log;
var Math_sqrt = Math.sqrt;
var Math_ceil = Math.ceil;
var Math_floor = Math.floor;
var Math_pow = Math.pow;
var Math_imul = Math.imul;
var Math_fround = Math.fround;
var Math_min = Math.min;

// A counter of dependencies for calling run(). If we need to
// do asynchronous work before running, increment this and
// decrement it. Incrementing must happen in a place like
// PRE_RUN_ADDITIONS (used by emcc to add file preloading).
// Note that you can add dependencies in preRun, even though
// it happens right before run - run will be postponed until
// the dependencies are met.
var runDependencies = 0;
var runDependencyWatcher = null;
var dependenciesFulfilled = null; // overridden to take different actions when all run dependencies are fulfilled

function addRunDependency(id) {
  runDependencies++;
  if (Module['monitorRunDependencies']) {
    Module['monitorRunDependencies'](runDependencies);
  }
}
Module['addRunDependency'] = addRunDependency;
function removeRunDependency(id) {
  runDependencies--;
  if (Module['monitorRunDependencies']) {
    Module['monitorRunDependencies'](runDependencies);
  }
  if (runDependencies == 0) {
    if (runDependencyWatcher !== null) {
      clearInterval(runDependencyWatcher);
      runDependencyWatcher = null;
    }
    if (dependenciesFulfilled) {
      var callback = dependenciesFulfilled;
      dependenciesFulfilled = null;
      callback(); // can add another dependenciesFulfilled
    }
  }
}
Module['removeRunDependency'] = removeRunDependency;

Module["preloadedImages"] = {}; // maps url to image data
Module["preloadedAudios"] = {}; // maps url to audio data


var memoryInitializer = null;

// === Body ===



STATIC_BASE = 8;

STATICTOP = STATIC_BASE + 275672;


/* global initializers */ __ATINIT__.push({ func: function() { runPostSets() } });





var _stdout;
var _stdout=_stdout=allocate(1, "i32*", ALLOC_STATIC);











































































































































/* memory initializer */ allocate([0,0,0,0,0,0,112,0,64,64,64,64,64,64,191,64,64,64,64,64,64,64,64,64,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,10,0,0,0,19,0,0,0,28,0,0,0,37,0,0,0,46,0,0,0,55,0,0,0,64,0,0,0,73,0,0,0,82,0,0,0,91,0,0,0,99,0,0,0,104,0,0,0,110,0,0,0,114,0,0,0,122,0,0,0,131,0,0,0,140,0,0,0,149,0,0,0,158,0,0,0,167,0,0,0,176,0,0,0,185,0,0,0,194,0,0,0,203,0,0,0,212,0,0,0,220,0,0,0,228,0,0,0,237,0,0,0,244,0,0,0,253,0,0,0,6,1,0,0,15,1,0,0,24,1,0,0,33,1,0,0,42,1,0,0,51,1,0,0,60,1,0,0,69,1,0,0,78,1,0,0,87,1,0,0,96,1,0,0,105,1,0,0,114,1,0,0,123,1,0,0,132,1,0,0,141,1,0,0,150,1,0,0,159,1,0,0,168,1,0,0,177,1,0,0,186,1,0,0,195,1,0,0,204,1,0,0,213,1,0,0,222,1,0,0,231,1,0,0,240,1,0,0,249,1,0,0,2,2,0,0,10,2,0,0,19,2,0,0,28,2,0,0,36,2,0,0,45,2,0,0,52,2,0,0,61,2,0,0,68,2,0,0,77,2,0,0,84,2,0,0,92,2,0,0,100,2,0,0,109,2,0,0,117,2,0,0,124,2,0,0,132,2,0,0,140,2,0,0,147,2,0,0,154,2,0,0,161,2,0,0,168,2,0,0,175,2,0,0,182,2,0,0,189,2,0,0,197,2,0,0,204,2,0,0,211,2,0,0,218,2,0,0,225,2,0,0,232,2,0,0,239,2,0,0,248,2,0,0,1,3,0,0,10,3,0,0,16,3,0,0,8,0,33,8,66,0,128,8,0,5,0,82,148,0,0,0,8,0,5,0,87,213,245,0,0,8,0,5,0,35,232,226,248,128,8,0,5,0,198,68,68,76,96,8,0,5,0,100,168,138,201,160,8,0,5,0,49,132,64,0,0,8,0,5,0,17,16,132,16,64,8,0,5,0,65,4,33,17,0,8,0,5,0,37,93,247,84,128,8,0,5,1,33,62,66,0,0,6,0,4,49,132,64,7,3,248,0,0,0,5,5,99,0,8,1,8,136,136,0,0,8,0,0,100,165,41,73,128,8,0,5,0,35,8,66,16,128,8,0,5,0,116,66,100,67,224,8,0,5,0,248,68,96,135,192,8,0,5,0,148,165,241,8,64,8,0,5,0,252,60,16,135,192,8,0,5,0,50,33,232,197,192,8,0,5,0,248,68,68,66,0,8,0,5,0,116,98,232,197,192,8,0,5,0,116,98,240,137,128,8,0,5,1,99,0,198,0,0,8,0,1,99,0,198,17,0,8,0,0,17,17,4,16,64,7,0,5,2,248,62,0,0,8,0,0,65,4,17,17,0,8,0,5,0,116,66,34,0,128,8,0,5,0,116,111,91,193,224,8,0,5,0,116,99,248,198,32,8,0,5,0,244,99,232,199,192,8,0,5,0,116,97,8,69,192,8,0,5,0,244,99,24,199,192,8,0,5,0,252,33,232,67,224,8,0,5,0,252,33,232,66,0,8,0,5,0,116,97,120,197,224,8,0,5,0,140,99,248,198,32,8,0,5,0,113,8,66,17,192,8,0,5,0,8,66,16,197,192,8,0,5,0,140,169,138,74,32,8,0,5,0,132,33,8,67,224,8,0,5,0,142,235,88,198,32,8,0,5,0,142,107,56,198,32,8,0,5,0,116,99,24,197,192,8,0,5,0,244,99,232,66,0,8,0,5,0,116,99,26,201,160,8,0,5,0,244,99,234,74,32,8,0,5,0,116,96,224,197,192,8,0,5,0,249,8,66,16,128,8,0,5,0,140,99,24,197,192,8,0,5,0,140,99,24,168,128,8,0,5,0,140,99,90,238,32,8,0,5,0,140,84,69,70,32,8,0,5,0,140,98,162,16,128,8,0,5,0,248,68,68,67,224,8,0,5,0,114,16,132,33,192,8,0,5,1,130,8,32,128,0,8,0,0,112,132,33,9,192,8,0,5,0,35,170,66,16,128,8,0,5,1,34,62,130,0,0,8,0,0,99,16,64,0,0,7,0,5,2,96,189,47,128,8,0,0,66,30,148,167,192,7,0,5,2,50,80,131,128,8,0,0,16,157,41,73,224,7,0,5,2,50,92,131,128,8,0,1,25,28,66,16,0,8,0,1,58,82,112,133,192,8,0,0,66,28,148,165,32,8,0,5,1,32,8,66,16,0,7,0,2,16,4,37,16,8,0,1,66,84,197,36,0,8,0,1,97,8,66,24,0,7,0,2,245,107,90,128,7,0,2,114,82,148,128,7,0,2,50,82,147,0,7,0,2,114,82,228,32,7,0,2,116,164,225,12,7,0,2,91,16,132,0,7,0,2,58,12,23,0,8,0,1,35,136,66,136,0,7,0,2,148,165,39,128,7,0,2,140,84,162,0,7,0,2,140,107,85,0,7,0,2,201,136,201,128,7,0,2,74,82,112,140,7,0,2,120,136,143,0,8,0,0,25,8,130,16,96,8,0,5,0,33,8,2,16,128,8,0,5,0,96,132,17,9,128,7,0,5,3,248,66,0,0,8,0,170,170,170,170,160,3,0,0,0,0,0,0,0,0,0,0,0,0,0,9,0,0,0,19,0,0,0,29,0,0,0,39,0,0,0,49,0,0,0,59,0,0,0,67,0,0,0,77,0,0,0,87,0,0,0,97,0,0,0,109,0,0,0,115,0,0,0,121,0,0,0,133,0,0,0,145,0,0,0,155,0,0,0,163,0,0,0,169,0,0,0,173,0,0,0,175,0,0,0,187,0,0,0,199,0,0,0,211,0,0,0,217,0,0,0,229,0,0,0,239,0,0,0,249,0,0,0,1,1,0,0,10,1,0,0,20,1,0,0,26,1,0,0,27,1,0,0,28,1,0,0,38,1,0,0,48,1,0,0,57,1,0,0,66,1,0,0,75,1,0,0,84,1,0,0,94,1,0,0,104,1,0,0,114,1,0,0,123,1,0,0,132,1,0,0,137,1,0,0,143,1,0,0,147,1,0,0,156,1,0,0,166,1,0,0,176,1,0,0,186,1,0,0,196,1,0,0,206,1,0,0,216,1,0,0,226,1,0,0,236,1,0,0,246,1,0,0,0,2,0,0,7,2,0,0,14,2,0,0,23,2,0,0,30,2,0,0,39,2,0,0,49,2,0,0,58,2,0,0,68,2,0,0,78,2,0,0,88,2,0,0,98,2,0,0,108,2,0,0,118,2,0,0,128,2,0,0,138,2,0,0,148,2,0,0,158,2,0,0,168,2,0,0,178,2,0,0,188,2,0,0,198,2,0,0,208,2,0,0,218,2,0,0,228,2,0,0,238,2,0,0,248,2,0,0,2,3,0,0,12,3,0,0,22,3,0,0,32,3,0,0,42,3,0,0,52,3,0,0,62,3,0,0,73,3,0,0,82,3,0,0,93,3,0,0,103,3,0,0,106,3,0,0,116,3,0,0,124,3,0,0,133,3,0,0,141,3,0,0,150,3,0,0,158,3,0,0,167,3,0,0,175,3,0,0,184,3,0,0,193,3,0,0,202,3,0,0,211,3,0,0,220,3,0,0,228,3,0,0,236,3,0,0,244,3,0,0,252,3,0,0,4,4,0,0,12,4,0,0,20,4,0,0,29,4,0,0,37,4,0,0,45,4,0,0,53,4,0,0,61,4,0,0,69,4,0,0,77,4,0,0,87,4,0,0,97,4,0,0,107,4,0,0,114,4,0,0,126,4,0,0,137,4,0,0,148,4,0,0,157,4,0,0,166,4,0,0,177,4,0,0,188,4,0,0,198,4,0,0,209,4,0,0,220,4,0,0,231,4,0,0,240,4,0,0,251,4,0,0,6,5,0,0,17,5,0,0,28,5,0,0,37,5,0,0,47,5,0,0,57,5,0,0,66,5,0,0,76,5,0,0,86,5,0,0,96,5,0,0,106,5,0,0,116,5,0,0,126,5,0,0,136,5,0,0,144,5,0,0,154,5,0,0,164,5,0,0,174,5,0,0,184,5,0,0,194,5,0,0,204,5,0,0,214,5,0,0,224,5,0,0,235,5,0,0,244,5,0,0,253,5,0,0,6,6,0,0,7,6,0,0,8,6,0,0,9,6,0,0,10,6,0,0,11,6,0,0,12,6,0,0,13,6,0,0,14,6,0,0,15,6,0,0,26,6,0,0,37,6,0,0,48,6,0,0,59,6,0,0,70,6,0,0,81,6,0,0,92,6,0,0,103,6,0,0,114,6,0,0,125,6,0,0,126,6,0,0,127,6,0,0,128,6,0,0,129,6,0,0,130,6,0,0,131,6,0,0,132,6,0,0,141,6,0,0,150,6,0,0,159,6,0,0,168,6,0,0,177,6,0,0,186,6,0,0,195,6,0,0,204,6,0,0,213,6,0,0,222,6,0,0,231,6,0,0,240,6,0,0,249,6,0,0,2,7,0,0,11,7,0,0,20,7,0,0,29,7,0,0,38,7,0,0,47,7,0,0,56,7,0,0,66,7,0,0,76,7,0,0,85,7,0,0,90,7,0,0,95,7,0,0,100,7,0,0,105,7,0,0,110,7,0,0,115,7,0,0,120,7,0,0,125,7,0,0,126,7,0,0,135,7,0,0,144,7,0,0,153,7,0,0,163,7,0,0,172,7,0,0,183,7,0,0,192,7,0,0,202,7,0,0,211,7,0,0,219,7,0,0,230,7,0,0,239,7,0,0,248,7,0,0,3,8,0,0,12,8,0,0,21,8,0,0,30,8,0,0,39,8,0,0,48,8,0,0,57,8,0,0,65,8,0,0,76,8,0,0,84,8,0,0,89,8,0,0,94,8,0,0,95,8,0,0,96,8,0,0,97,8,0,0,98,8,0,0,99,8,0,0,3,8,28,62,127,62,28,8,0,2,85,42,85,42,85,42,85,42,0,2,72,72,120,72,72,31,4,4,4,2,124,64,112,64,95,16,28,16,16,2,48,64,64,72,62,17,30,18,17,2,64,64,64,120,31,16,28,16,16,4,24,36,36,24,0,0,0,2,8,8,8,127,8,8,8,127,0,2,68,76,84,100,84,16,16,16,31,2,68,68,68,40,16,31,4,4,4,0,16,16,16,16,16,16,112,0,0,0,0,6,112,16,16,16,16,6,31,16,16,16,16,0,16,16,16,16,16,16,31,0,0,0,0,0,16,16,16,16,16,16,255,16,16,16,16,2,255,0,0,0,0,0,0,0,0,4,255,0,0,0,0,0,0,6,255,0,0,0,0,8,255,0,0,10,255,0,16,16,16,16,16,16,31,16,16,16,16,0,16,16,16,16,16,16,112,16,16,16,16,0,16,16,16,16,16,16,255,0,0,0,0,6,255,16,16,16,16,0,16,16,16,16,16,16,16,16,16,16,16,2,6,24,96,24,6,0,126,0,126,2,96,24,6,24,96,0,126,0,126,4,50,93,20,20,20,38,0,3,1,2,127,8,127,32,64,0,2,6,9,8,31,4,60,70,57,0,6,8,0,0,0,0,11,11,2,16,16,16,16,16,0,0,16,0,2,108,108,36,72,0,0,0,0,0,3,20,20,127,20,127,20,20,0,3,4,62,72,62,9,17,126,16,3,97,98,4,8,16,35,67,0,3,28,34,20,8,21,34,29,0,2,24,24,8,16,0,0,0,0,0,2,8,16,32,32,32,32,16,8,0,2,32,16,8,8,8,8,16,32,0,3,8,42,20,107,20,42,8,0,3,8,8,8,127,8,8,8,0,7,24,24,8,16,6,127,0,0,0,0,8,96,96,0,3,1,2,4,8,16,32,64,0,2,60,66,70,74,82,98,66,60,0,2,16,48,80,16,16,16,16,124,0,2,60,66,2,2,28,32,64,126,0,2,126,4,8,28,2,2,66,60,0,2,8,16,32,72,127,8,8,8,0,2,124,64,64,124,2,2,66,60,0,2,28,32,64,94,97,65,65,62,0,2,127,1,2,4,8,16,32,64,0,2,62,65,65,62,65,65,65,62,0,2,62,65,65,67,61,1,2,60,0,5,48,48,0,48,48,0,5,48,48,0,48,16,32,3,8,16,32,64,32,16,8,0,5,127,0,127,0,0,0,3,16,8,4,2,4,8,16,0,2,62,65,1,6,8,8,0,8,0,3,62,65,73,79,64,65,62,0,2,8,20,34,65,65,127,65,65,0,2,124,66,66,126,65,65,65,126,0,2,62,65,64,64,64,64,65,62,0,2,124,66,65,65,65,65,65,126,0,2,126,64,64,120,64,64,64,127,0,2,127,64,64,120,64,64,64,64,0,2,62,65,64,64,79,73,65,62,0,2,65,65,65,65,127,65,65,65,0,2,62,8,8,8,8,8,8,62,0,2,7,2,2,2,2,2,34,28,0,2,66,68,72,112,72,68,66,65,0,2,64,64,64,64,64,64,64,127,0,2,65,99,85,73,73,65,65,65,0,2,65,97,81,73,69,67,65,65,0,2,62,65,65,65,65,65,65,62,0,2,126,65,65,65,126,64,64,64,0,2,62,65,65,65,73,69,66,61,0,2,124,66,66,66,124,66,65,65,0,2,62,64,64,62,1,1,65,62,0,2,127,8,8,8,8,8,8,8,0,2,65,65,65,65,65,65,65,62,0,2,65,65,65,65,65,34,20,8,0,2,65,65,65,73,73,85,99,65,0,2,65,34,20,8,20,34,65,65,0,2,65,65,34,20,8,8,8,28,0,2,63,2,4,8,16,32,64,127,0,1,31,16,16,16,16,16,16,16,16,31,3,64,32,16,8,4,2,1,0,1,124,4,4,4,4,4,4,4,4,124,2,8,20,34,65,0,0,0,0,0,9,127,0,2,24,24,16,8,0,0,0,0,0,4,28,2,62,66,66,63,0,3,32,32,62,33,33,33,126,0,4,60,66,64,64,64,62,0,3,2,2,62,66,66,66,63,0,4,60,66,66,124,64,62,0,3,12,16,16,124,16,16,16,0,4,62,66,66,70,58,2,60,3,64,64,124,66,66,66,66,0,3,16,0,16,16,16,16,124,0,3,4,0,4,4,4,4,68,56,3,64,68,104,80,72,68,66,0,3,112,16,16,16,16,16,28,0,4,118,73,73,73,73,73,0,4,92,98,66,66,66,66,0,4,60,66,66,66,66,60,0,4,124,66,66,98,92,64,64,4,62,66,66,70,58,2,3,4,92,98,64,64,64,64,0,4,62,64,60,2,2,124,0,3,16,16,124,16,16,20,8,0,4,68,68,68,68,68,62,0,4,65,65,34,34,20,8,0,4,65,65,73,73,85,34,0,4,35,20,8,20,34,65,0,4,66,66,66,70,58,2,60,4,62,4,8,16,32,126,0,2,14,16,16,16,32,16,16,16,14,2,16,16,16,16,0,16,16,16,16,2,112,8,8,8,4,8,8,8,112,5,49,73,70,0,0,0,0,255,0,255,0,255,0,255,0,255,0,255,1,20,0,8,20,34,65,127,65,65,0,1,8,0,8,20,34,65,127,65,65,0,3,15,20,36,71,124,68,71,0,3,12,18,18,38,33,73,70,0,1,20,8,62,65,64,64,64,65,62,0,1,4,8,62,65,64,64,64,65,62,0,2,60,34,33,33,121,33,33,62,0,1,4,8,126,64,64,120,64,64,127,0,1,25,38,0,65,97,81,73,69,67,0,1,34,0,62,65,65,65,65,65,62,0,3,61,66,69,73,81,33,94,0,1,62,64,64,62,65,65,62,1,1,126,1,20,8,62,65,64,62,1,65,62,0,1,34,0,65,65,65,65,65,65,62,0,1,20,8,127,2,4,8,16,32,127,0,3,64,38,9,9,9,38,64,0,2,34,0,28,2,62,66,66,63,0,2,8,0,28,2,62,66,66,63,0,3,102,25,9,62,72,76,51,0,2,16,8,28,2,62,66,66,63,0,2,20,8,60,66,64,64,64,62,0,2,4,8,60,66,64,64,64,62,0,2,2,15,2,62,66,66,66,63,0,2,4,8,60,66,66,124,64,62,0,2,50,76,0,92,98,66,66,66,0,2,36,0,60,66,66,66,66,60,0,4,58,68,74,82,34,92,0,2,32,16,60,66,66,124,64,62,0,2,40,16,60,64,60,2,2,124,0,2,68,0,68,68,68,68,68,62,0,2,20,8,62,4,8,16,32,126,0,2,32,16,0,16,16,16,16,124,0,2,32,16,60,66,66,66,66,60,0,2,32,16,68,68,68,68,68,62,0,2,16,40,0,16,16,16,16,124,0,1,8,20,0,60,66,64,64,64,62,0,3,60,66,64,66,60,2,2,12,3,24,36,36,24,0,0,0,0,3,34,85,34,0,0,0,0,0,11,11,11,11,11,11,11,11,11,1,24,36,36,36,24,0,0,0,0,0,1,4,12,20,4,4,0,0,0,0,0,1,24,36,8,16,60,0,0,0,0,0,1,56,4,24,4,56,0,0,0,0,0,1,16,32,60,8,8,0,0,0,0,0,1,56,32,56,4,56,0,0,0,0,0,1,24,32,56,36,24,0,0,0,0,0,1,60,4,8,16,32,0,0,0,0,0,1,24,36,24,36,24,0,0,0,0,0,1,24,36,28,4,24,0,0,0,0,0,11,11,11,11,11,11,11,3,8,20,20,34,62,65,65,0,3,124,66,68,126,66,66,124,0,3,126,66,64,64,64,64,64,0,3,8,20,20,34,34,65,127,0,3,127,64,64,124,64,64,127,0,3,127,2,4,8,16,32,127,0,3,65,65,65,127,65,65,65,0,3,62,65,65,73,65,65,62,0,3,8,8,8,8,8,8,8,0,3,66,68,72,80,104,68,66,0,3,8,20,20,34,34,65,65,0,3,65,99,85,73,73,73,73,0,3,65,97,81,73,69,67,65,0,3,127,0,0,28,0,0,127,0,3,28,34,65,65,65,34,28,0,3,127,65,65,65,65,65,65,0,3,126,65,65,126,64,64,64,0,3,127,32,16,8,16,32,127,0,3,127,8,8,8,8,8,8,0,3,54,73,8,8,8,8,8,0,2,8,8,62,73,73,73,73,62,8,2,8,8,201,73,73,73,73,62,8,3,62,65,65,65,65,34,99,0,7,24,36,36,36,7,8,24,40,8,7,24,36,8,16,7,56,4,24,4,7,16,32,60,8,7,60,32,56,4,7,24,32,56,36,7,60,4,8,16,11,3,1,49,74,68,74,50,0,0,3,30,33,33,38,65,65,78,64,3,66,69,34,21,8,20,20,8,2,65,62,24,4,62,65,65,62,0,3,28,34,32,48,64,66,60,0,1,7,8,7,28,32,64,64,32,28,2,3,38,89,17,33,34,66,68,4,2,4,74,167,34,34,36,40,16,0,3,8,8,16,16,18,20,8,0,4,19,36,40,48,72,70,0,1,96,16,16,8,20,34,34,65,65,0,3,33,33,33,33,33,34,60,32,3,33,81,17,18,60,80,32,0,1,12,16,31,32,32,62,64,64,62,2,3,28,34,65,65,65,34,28,0,3,126,211,18,18,18,18,227,0,3,12,18,33,33,33,82,76,64,3,31,34,66,66,66,68,56,0,3,63,68,8,8,16,16,32,0,3,33,81,17,34,68,72,48,0,4,38,69,73,73,74,60,16,1,4,4,8,201,73,73,73,73,62,16,4,33,65,65,73,74,52,0,7,24,36,24,36,7,24,36,28,4,11,11,11,11,11,0,255,0,0,0,0,0,0,0,0,0,0,0,73,110,105,99,105,97,108,105,122,97,99,105,106,97,32,83,68,76,32,110,105,32,117,115,112,101,108,97,46,0,0,0,66,114,97,110,106,101,32,115,108,105,107,101,32,82,79,77,45,97,32,40,82,79,77,46,105,109,103,41,32,110,105,32,117,115,112,101,108,111,46,32,74,101,32,115,108,105,107,97,32,118,101,108,105,107,97,32,118,115,97,106,32,50,32,75,66,63,0,0,0,0,0,0,79,100,112,105,114,97,110,106,101,32,115,108,105,107,101,32,82,79,77,45,97,32,40,82,79,77,46,105,109,103,41,32,110,105,32,117,115,112,101,108,111,46,32,66,105,116,105,32,109,111,114,97,32,118,32,105,115,116,101,109,32,105,109,101,110,105,107,117,32,107,111,116,32,112,114,111,103,114,97,109,46,0,0,0,0,0,0,0,114,98,0,0,0,0,0,0,82,79,77,46,105,109,103,0,79,100,112,105,114,97,110,106,101,32,115,108,105,107,101,32,100,105,115,107,97,32,40,84,114,100,105,68,105,115,107,46,105,109,103,41,32,110,105,32,117,115,112,101,108,111,46,32,66,105,116,105,32,109,111,114,97,32,118,32,105,115,116,101,109,32,105,109,101,110,105,107,117,32,107,111,116,32,112,114,111,103,114,97,109,46,0,0,114,43,98,0,0,0,0,0,80,111,115,111,100,97,98,108,106,97,110,106,101,32,100,97,116,111,116,101,107,101,32,122,32,110,97,115,116,97,118,105,116,118,97,109,105,32,40,80,82,65,77,46,114,97,109,41,32,110,105,32,117,115,112,101,108,111,46,0,0,0,0,0,84,114,100,105,68,105,115,107,46,105,109,103,0,0,0,0,85,107,97,122,105,32,122,97,32,101,109,117,108,97,116,111,114,58,10,65,108,116,43,77,32,111,109,111,103,111,196,141,105,47,111,110,101,109,111,103,111,196,141,105,32,109,105,197,161,107,111,44,32,196,141,101,32,112,111,116,114,101,98,117,106,101,116,101,32,118,101,196,141,32,112,114,111,115,116,111,114,97,32,122,97,32,112,114,101,109,105,107,97,110,106,101,46,10,65,108,116,43,80,32,118,107,108,106,117,196,141,105,47,105,122,107,108,106,117,196,141,105,32,110,97,118,105,100,101,122,110,105,32,116,105,115,107,97,108,110,105,107,46,10,65,108,116,43,82,32,114,101,115,101,116,105,114,97,32,101,109,117,108,105,114,97,110,105,32,114,97,196,141,117,110,97,108,110,105,107,46,10,10,78,101,107,97,106,32,122,97,110,105,109,105,118,105,104,32,97,112,108,105,107,97,99,105,106,58,32,86,73,71,82,69,68,44,32,85,82,65,83,69,84,44,32,85,82,65,83,69,84,50,44,32,73,68,82,73,83,44,32,67,71,82,65,70,44,32,77,69,78,85,44,32,77,80,46,10,10,80,111,115,101,98,110,101,32,116,105,112,107,101,58,10,70,49,32,106,101,32,83,69,84,32,85,80,44,32,70,57,32,106,101,32,80,70,49,44,32,70,49,48,32,106,101,32,80,70,50,44,32,70,49,49,32,106,101,32,80,70,51,44,32,70,49,50,32,106,101,32,80,70,52,46,10,10,75,114,97,116,101,107,32,117,118,111,100,32,118,32,111,112,101,114,97,99,105,106,115,107,105,32,115,105,115,116,101,109,32,67,80,47,77,58,10,34,68,73,82,34,32,112,114,105,107,97,197,190,101,32,100,97,116,111,116,101,107,101,46,10,34,68,73,82,83,34,32,112,114,105,107,97,197,190,101,32,100,97,116,111,116,101,107,101,32,115,32,115,105,115,116,101,109,115,107,105,109,32,97,116,114,105,98,117,116,111,109,32,40,116,111,32,106,101,32,118,101,196,141,105,110,97,32,112,114,111,103,114,97,109,111,118,32,110,97,32,117,112,111,114,97,98,110,105,197,161,107,101,109,32,111,98,109,111,196,141,106,117,32,48,59,32,117,112,111,114,97,98,105,116,101,32,34,68,73,82,83,32,42,46,67,79,77,34,44,32,100,97,32,106,105,104,32,118,105,100,105,116,101,41,46,10,34,85,83,69,82,32,110,34,32,40,110,32,111,100,32,48,32,100,111,32,49,53,41,32,122,97,109,101,110,106,97,32,116,114,101,110,117,116,110,111,32,97,107,116,105,118,110,111,32,117,112,111,114,97,98,110,105,197,161,107,111,32,111,98,109,111,196,141,106,101,46,10,34,84,89,80,69,34,32,105,122,112,105,197,161,101,32,118,115,101,98,105,110,111,32,98,101,115,101,100,105,108,110,101,32,100,97,116,111,116,101,107,101,32,110,97,32,122,97,115,108,111,110,46,10,10,79,112,111,109,98,97,58,32,98,114,115,107,97,108,110,105,197,161,107,97,32,118,101,114,122,105,106,97,32,110,101,32,112,111,100,112,105,114,97,32,122,118,111,196,141,110,105,104,32,101,102,101,107,116,111,118,32,110,105,116,105,32,110,97,118,105,100,101,122,110,101,103,97,32,100,105,115,107,101,116,110,101,103,97,32,112,111,103,111,110,97,46,0,0,0,0,0,0,0,80,97,114,116,69,109,0,0,119,98,0,0,0,0,0,0,66,101,115,101,100,105,108,111,44,32,112,111,115,108,97,110,111,32,110,97,32,116,105,115,107,97,108,110,105,107,44,32,98,111,32,105,122,112,105,115,97,110,111,32,116,117,107,97,106,46,32,77,105,197,161,107,101,32,109,101,100,32,116,101,109,32,110,101,32,109,111,114,101,116,101,32,117,112,111,114,97,98,108,106,97,116,105,46,0,0,0,0,0,0,0,0,73,110,105,99,105,97,108,105,122,97,99,105,106,97,32,103,114,97,102,105,107,101,32,110,105,32,117,115,112,101,108,97,46,0,0,0,0,0,0,0,66,114,97,110,106,101,32,122,97,103,111,110,115,107,101,32,115,108,101,100,105,32,105,122,32,115,108,105,107,101,32,116,114,100,101,103,97,32,100,105,115,107,97,32,110,105,32,117,115,112,101,108,111,46,0,0,80,82,65,77,46,114,97,109,0,0,0,0,0,0,0,0,114,98,0,0,0,0,0,0,84,105,115,107,97,110,106,101,32,122,97,107,108,106,117,196,141,101,110,111,46,32,90,100,97,106,32,108,97,104,107,111,32,115,112,101,116,32,117,112,111,114,97,98,108,106,97,116,101,32,109,105,197,161,107,111,46,0,0,0,0,0,0,0,10,0,0,0,0,0,0,0,0,16,16,16,0,0,0,16,0,0,0,0,0,0,0,0,62,4,0,0,241,0,0,0,82,4,0,0,241,0,0,0,63,4,0,0,242,0,0,0,81,4,0,0,242,0,0,0,64,4,0,0,243,0,0,0,80,4,0,0,243,0,0,0,65,4,0,0,244,0,0,0,79,4,0,0,244,0,0,0,74,4,0,0,245,0,0,0,66,4,0,0,246,0,0,0,67,4,0,0,247,0,0,0,68,4,0,0,248,0,0,0,69,4,0,0,249,0,0,0,27,0,0,0,27,0,0,0,8,0,0,0,8,0,0,0,95,4,0,0,225,0,0,0,96,4,0,0,226,0,0,0,97,4,0,0,227,0,0,0,86,4,0,0,228,0,0,0,9,0,0,0,9,0,0,0,92,4,0,0,208,0,0,0,93,4,0,0,209,0,0,0,94,4,0,0,210,0,0,0,87,4,0,0,211,0,0,0,13,0,0,0,13,0,0,0,89,4,0,0,192,0,0,0,90,4,0,0,193,0,0,0,91,4,0,0,194,0,0,0,85,4,0,0,163,0,0,0,96,0,0,0,176,0,0,0,78,4,0,0,10,0,0,0,98,4,0,0,177,0,0,0,99,4,0,0,178,0,0,0,88,4,0,0,195,0,0,0,32,0,0,0,32,0,0,0,50,0,0,0,50,34,255,255,51,0,0,0,51,35,255,229,54,0,0,0,54,39,255,255,55,0,0,0,55,38,255,38,45,0,0,0,45,95,255,31,61,0,0,0,61,43,8,255,73,4,0,0,47,63,255,255,121,0,0,0,122,90,26,25,91,0,0,0,123,91,27,27,93,0,0,0,124,92,28,28,59,0,0,0,126,94,30,30,39,0,0,0,125,93,29,29,75,4,0,0,60,62,255,255,122,0,0,0,121,89,25,25,44,0,0,0,44,59,255,255,46,0,0,0,46,58,255,255,47,0,0,0,96,64,0,0,58,4,0,0,254,254,245,245,49,0,0,0,49,33,255,255,50,0,0,0,50,64,0,0,51,0,0,0,51,35,229,229,52,0,0,0,52,36,255,255,53,0,0,0,53,37,255,255,54,0,0,0,54,94,255,30,55,0,0,0,55,38,255,255,56,0,0,0,56,42,255,255,57,0,0,0,57,40,255,255,48,0,0,0,48,41,255,255,45,0,0,0,45,95,31,31,61,0,0,0,61,43,255,255,73,4,0,0,96,126,255,30,72,4,0,0,224,234,224,224,91,0,0,0,91,123,27,27,93,0,0,0,93,125,29,29,92,0,0,0,212,214,212,214,127,0,0,0,127,0,127,127,59,0,0,0,59,58,255,255,39,0,0,0,39,34,255,255,75,4,0,0,92,124,28,28,44,0,0,0,44,60,255,255,46,0,0,0,46,62,255,255,47,0,0,0,47,63,255,255,0,0,0,0,0,0,0,0,199,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,51,51,15,15,255,51,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,80,180,72,72,168,230,64,64,160,205,168,172,255,255,192,255,0,0,224,255,0,0,192,224,0,0,224,255,0,0], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE);



var tempDoublePtr = Runtime.alignMemory(allocate(12, "i8", ALLOC_STATIC), 8);

assert(tempDoublePtr % 8 == 0);

function copyTempFloat(ptr) { // functions, because inlining this code increases code size too much

  HEAP8[tempDoublePtr] = HEAP8[ptr];

  HEAP8[tempDoublePtr+1] = HEAP8[ptr+1];

  HEAP8[tempDoublePtr+2] = HEAP8[ptr+2];

  HEAP8[tempDoublePtr+3] = HEAP8[ptr+3];

}

function copyTempDouble(ptr) {

  HEAP8[tempDoublePtr] = HEAP8[ptr];

  HEAP8[tempDoublePtr+1] = HEAP8[ptr+1];

  HEAP8[tempDoublePtr+2] = HEAP8[ptr+2];

  HEAP8[tempDoublePtr+3] = HEAP8[ptr+3];

  HEAP8[tempDoublePtr+4] = HEAP8[ptr+4];

  HEAP8[tempDoublePtr+5] = HEAP8[ptr+5];

  HEAP8[tempDoublePtr+6] = HEAP8[ptr+6];

  HEAP8[tempDoublePtr+7] = HEAP8[ptr+7];

}


  
  
  function _emscripten_memcpy_big(dest, src, num) {
      HEAPU8.set(HEAPU8.subarray(src, src+num), dest);
      return dest;
    } 
  Module["_memcpy"] = _memcpy;var _llvm_memcpy_p0i8_p0i8_i32=_memcpy;

  
   
  Module["_memset"] = _memset;var _llvm_memset_p0i8_i32=_memset;

  var _llvm_memset_p0i8_i64=_memset;

  
  
  
  var ERRNO_CODES={EPERM:1,ENOENT:2,ESRCH:3,EINTR:4,EIO:5,ENXIO:6,E2BIG:7,ENOEXEC:8,EBADF:9,ECHILD:10,EAGAIN:11,EWOULDBLOCK:11,ENOMEM:12,EACCES:13,EFAULT:14,ENOTBLK:15,EBUSY:16,EEXIST:17,EXDEV:18,ENODEV:19,ENOTDIR:20,EISDIR:21,EINVAL:22,ENFILE:23,EMFILE:24,ENOTTY:25,ETXTBSY:26,EFBIG:27,ENOSPC:28,ESPIPE:29,EROFS:30,EMLINK:31,EPIPE:32,EDOM:33,ERANGE:34,ENOMSG:42,EIDRM:43,ECHRNG:44,EL2NSYNC:45,EL3HLT:46,EL3RST:47,ELNRNG:48,EUNATCH:49,ENOCSI:50,EL2HLT:51,EDEADLK:35,ENOLCK:37,EBADE:52,EBADR:53,EXFULL:54,ENOANO:55,EBADRQC:56,EBADSLT:57,EDEADLOCK:35,EBFONT:59,ENOSTR:60,ENODATA:61,ETIME:62,ENOSR:63,ENONET:64,ENOPKG:65,EREMOTE:66,ENOLINK:67,EADV:68,ESRMNT:69,ECOMM:70,EPROTO:71,EMULTIHOP:72,EDOTDOT:73,EBADMSG:74,ENOTUNIQ:76,EBADFD:77,EREMCHG:78,ELIBACC:79,ELIBBAD:80,ELIBSCN:81,ELIBMAX:82,ELIBEXEC:83,ENOSYS:38,ENOTEMPTY:39,ENAMETOOLONG:36,ELOOP:40,EOPNOTSUPP:95,EPFNOSUPPORT:96,ECONNRESET:104,ENOBUFS:105,EAFNOSUPPORT:97,EPROTOTYPE:91,ENOTSOCK:88,ENOPROTOOPT:92,ESHUTDOWN:108,ECONNREFUSED:111,EADDRINUSE:98,ECONNABORTED:103,ENETUNREACH:101,ENETDOWN:100,ETIMEDOUT:110,EHOSTDOWN:112,EHOSTUNREACH:113,EINPROGRESS:115,EALREADY:114,EDESTADDRREQ:89,EMSGSIZE:90,EPROTONOSUPPORT:93,ESOCKTNOSUPPORT:94,EADDRNOTAVAIL:99,ENETRESET:102,EISCONN:106,ENOTCONN:107,ETOOMANYREFS:109,EUSERS:87,EDQUOT:122,ESTALE:116,ENOTSUP:95,ENOMEDIUM:123,EILSEQ:84,EOVERFLOW:75,ECANCELED:125,ENOTRECOVERABLE:131,EOWNERDEAD:130,ESTRPIPE:86};
  
  var ERRNO_MESSAGES={0:"Success",1:"Not super-user",2:"No such file or directory",3:"No such process",4:"Interrupted system call",5:"I/O error",6:"No such device or address",7:"Arg list too long",8:"Exec format error",9:"Bad file number",10:"No children",11:"No more processes",12:"Not enough core",13:"Permission denied",14:"Bad address",15:"Block device required",16:"Mount device busy",17:"File exists",18:"Cross-device link",19:"No such device",20:"Not a directory",21:"Is a directory",22:"Invalid argument",23:"Too many open files in system",24:"Too many open files",25:"Not a typewriter",26:"Text file busy",27:"File too large",28:"No space left on device",29:"Illegal seek",30:"Read only file system",31:"Too many links",32:"Broken pipe",33:"Math arg out of domain of func",34:"Math result not representable",35:"File locking deadlock error",36:"File or path name too long",37:"No record locks available",38:"Function not implemented",39:"Directory not empty",40:"Too many symbolic links",42:"No message of desired type",43:"Identifier removed",44:"Channel number out of range",45:"Level 2 not synchronized",46:"Level 3 halted",47:"Level 3 reset",48:"Link number out of range",49:"Protocol driver not attached",50:"No CSI structure available",51:"Level 2 halted",52:"Invalid exchange",53:"Invalid request descriptor",54:"Exchange full",55:"No anode",56:"Invalid request code",57:"Invalid slot",59:"Bad font file fmt",60:"Device not a stream",61:"No data (for no delay io)",62:"Timer expired",63:"Out of streams resources",64:"Machine is not on the network",65:"Package not installed",66:"The object is remote",67:"The link has been severed",68:"Advertise error",69:"Srmount error",70:"Communication error on send",71:"Protocol error",72:"Multihop attempted",73:"Cross mount point (not really error)",74:"Trying to read unreadable message",75:"Value too large for defined data type",76:"Given log. name not unique",77:"f.d. invalid for this operation",78:"Remote address changed",79:"Can   access a needed shared lib",80:"Accessing a corrupted shared lib",81:".lib section in a.out corrupted",82:"Attempting to link in too many libs",83:"Attempting to exec a shared library",84:"Illegal byte sequence",86:"Streams pipe error",87:"Too many users",88:"Socket operation on non-socket",89:"Destination address required",90:"Message too long",91:"Protocol wrong type for socket",92:"Protocol not available",93:"Unknown protocol",94:"Socket type not supported",95:"Not supported",96:"Protocol family not supported",97:"Address family not supported by protocol family",98:"Address already in use",99:"Address not available",100:"Network interface is not configured",101:"Network is unreachable",102:"Connection reset by network",103:"Connection aborted",104:"Connection reset by peer",105:"No buffer space available",106:"Socket is already connected",107:"Socket is not connected",108:"Can't send after socket shutdown",109:"Too many references",110:"Connection timed out",111:"Connection refused",112:"Host is down",113:"Host is unreachable",114:"Socket already connected",115:"Connection already in progress",116:"Stale file handle",122:"Quota exceeded",123:"No medium (in tape drive)",125:"Operation canceled",130:"Previous owner died",131:"State not recoverable"};
  
  
  var ___errno_state=0;function ___setErrNo(value) {
      // For convenient setting and returning of errno.
      HEAP32[((___errno_state)>>2)]=value;
      return value;
    }
  
  var PATH={splitPath:function (filename) {
        var splitPathRe = /^(\/?|)([\s\S]*?)((?:\.{1,2}|[^\/]+?|)(\.[^.\/]*|))(?:[\/]*)$/;
        return splitPathRe.exec(filename).slice(1);
      },normalizeArray:function (parts, allowAboveRoot) {
        // if the path tries to go above the root, `up` ends up > 0
        var up = 0;
        for (var i = parts.length - 1; i >= 0; i--) {
          var last = parts[i];
          if (last === '.') {
            parts.splice(i, 1);
          } else if (last === '..') {
            parts.splice(i, 1);
            up++;
          } else if (up) {
            parts.splice(i, 1);
            up--;
          }
        }
        // if the path is allowed to go above the root, restore leading ..s
        if (allowAboveRoot) {
          for (; up--; up) {
            parts.unshift('..');
          }
        }
        return parts;
      },normalize:function (path) {
        var isAbsolute = path.charAt(0) === '/',
            trailingSlash = path.substr(-1) === '/';
        // Normalize the path
        path = PATH.normalizeArray(path.split('/').filter(function(p) {
          return !!p;
        }), !isAbsolute).join('/');
        if (!path && !isAbsolute) {
          path = '.';
        }
        if (path && trailingSlash) {
          path += '/';
        }
        return (isAbsolute ? '/' : '') + path;
      },dirname:function (path) {
        var result = PATH.splitPath(path),
            root = result[0],
            dir = result[1];
        if (!root && !dir) {
          // No dirname whatsoever
          return '.';
        }
        if (dir) {
          // It has a dirname, strip trailing slash
          dir = dir.substr(0, dir.length - 1);
        }
        return root + dir;
      },basename:function (path) {
        // EMSCRIPTEN return '/'' for '/', not an empty string
        if (path === '/') return '/';
        var lastSlash = path.lastIndexOf('/');
        if (lastSlash === -1) return path;
        return path.substr(lastSlash+1);
      },extname:function (path) {
        return PATH.splitPath(path)[3];
      },join:function () {
        var paths = Array.prototype.slice.call(arguments, 0);
        return PATH.normalize(paths.join('/'));
      },join2:function (l, r) {
        return PATH.normalize(l + '/' + r);
      },resolve:function () {
        var resolvedPath = '',
          resolvedAbsolute = false;
        for (var i = arguments.length - 1; i >= -1 && !resolvedAbsolute; i--) {
          var path = (i >= 0) ? arguments[i] : FS.cwd();
          // Skip empty and invalid entries
          if (typeof path !== 'string') {
            throw new TypeError('Arguments to path.resolve must be strings');
          } else if (!path) {
            continue;
          }
          resolvedPath = path + '/' + resolvedPath;
          resolvedAbsolute = path.charAt(0) === '/';
        }
        // At this point the path should be resolved to a full absolute path, but
        // handle relative paths to be safe (might happen when process.cwd() fails)
        resolvedPath = PATH.normalizeArray(resolvedPath.split('/').filter(function(p) {
          return !!p;
        }), !resolvedAbsolute).join('/');
        return ((resolvedAbsolute ? '/' : '') + resolvedPath) || '.';
      },relative:function (from, to) {
        from = PATH.resolve(from).substr(1);
        to = PATH.resolve(to).substr(1);
        function trim(arr) {
          var start = 0;
          for (; start < arr.length; start++) {
            if (arr[start] !== '') break;
          }
          var end = arr.length - 1;
          for (; end >= 0; end--) {
            if (arr[end] !== '') break;
          }
          if (start > end) return [];
          return arr.slice(start, end - start + 1);
        }
        var fromParts = trim(from.split('/'));
        var toParts = trim(to.split('/'));
        var length = Math.min(fromParts.length, toParts.length);
        var samePartsLength = length;
        for (var i = 0; i < length; i++) {
          if (fromParts[i] !== toParts[i]) {
            samePartsLength = i;
            break;
          }
        }
        var outputParts = [];
        for (var i = samePartsLength; i < fromParts.length; i++) {
          outputParts.push('..');
        }
        outputParts = outputParts.concat(toParts.slice(samePartsLength));
        return outputParts.join('/');
      }};
  
  var TTY={ttys:[],init:function () {
        // https://github.com/kripken/emscripten/pull/1555
        // if (ENVIRONMENT_IS_NODE) {
        //   // currently, FS.init does not distinguish if process.stdin is a file or TTY
        //   // device, it always assumes it's a TTY device. because of this, we're forcing
        //   // process.stdin to UTF8 encoding to at least make stdin reading compatible
        //   // with text files until FS.init can be refactored.
        //   process['stdin']['setEncoding']('utf8');
        // }
      },shutdown:function () {
        // https://github.com/kripken/emscripten/pull/1555
        // if (ENVIRONMENT_IS_NODE) {
        //   // inolen: any idea as to why node -e 'process.stdin.read()' wouldn't exit immediately (with process.stdin being a tty)?
        //   // isaacs: because now it's reading from the stream, you've expressed interest in it, so that read() kicks off a _read() which creates a ReadReq operation
        //   // inolen: I thought read() in that case was a synchronous operation that just grabbed some amount of buffered data if it exists?
        //   // isaacs: it is. but it also triggers a _read() call, which calls readStart() on the handle
        //   // isaacs: do process.stdin.pause() and i'd think it'd probably close the pending call
        //   process['stdin']['pause']();
        // }
      },register:function (dev, ops) {
        TTY.ttys[dev] = { input: [], output: [], ops: ops };
        FS.registerDevice(dev, TTY.stream_ops);
      },stream_ops:{open:function (stream) {
          var tty = TTY.ttys[stream.node.rdev];
          if (!tty) {
            throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
          }
          stream.tty = tty;
          stream.seekable = false;
        },close:function (stream) {
          // flush any pending line data
          if (stream.tty.output.length) {
            stream.tty.ops.put_char(stream.tty, 10);
          }
        },read:function (stream, buffer, offset, length, pos /* ignored */) {
          if (!stream.tty || !stream.tty.ops.get_char) {
            throw new FS.ErrnoError(ERRNO_CODES.ENXIO);
          }
          var bytesRead = 0;
          for (var i = 0; i < length; i++) {
            var result;
            try {
              result = stream.tty.ops.get_char(stream.tty);
            } catch (e) {
              throw new FS.ErrnoError(ERRNO_CODES.EIO);
            }
            if (result === undefined && bytesRead === 0) {
              throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
            }
            if (result === null || result === undefined) break;
            bytesRead++;
            buffer[offset+i] = result;
          }
          if (bytesRead) {
            stream.node.timestamp = Date.now();
          }
          return bytesRead;
        },write:function (stream, buffer, offset, length, pos) {
          if (!stream.tty || !stream.tty.ops.put_char) {
            throw new FS.ErrnoError(ERRNO_CODES.ENXIO);
          }
          for (var i = 0; i < length; i++) {
            try {
              stream.tty.ops.put_char(stream.tty, buffer[offset+i]);
            } catch (e) {
              throw new FS.ErrnoError(ERRNO_CODES.EIO);
            }
          }
          if (length) {
            stream.node.timestamp = Date.now();
          }
          return i;
        }},default_tty_ops:{get_char:function (tty) {
          if (!tty.input.length) {
            var result = null;
            if (ENVIRONMENT_IS_NODE) {
              result = process['stdin']['read']();
              if (!result) {
                if (process['stdin']['_readableState'] && process['stdin']['_readableState']['ended']) {
                  return null;  // EOF
                }
                return undefined;  // no data available
              }
            } else if (typeof window != 'undefined' &&
              typeof window.prompt == 'function') {
              // Browser.
              result = window.prompt('Input: ');  // returns null on cancel
              if (result !== null) {
                result += '\n';
              }
            } else if (typeof readline == 'function') {
              // Command line.
              result = readline();
              if (result !== null) {
                result += '\n';
              }
            }
            if (!result) {
              return null;
            }
            tty.input = intArrayFromString(result, true);
          }
          return tty.input.shift();
        },put_char:function (tty, val) {
          if (val === null || val === 10) {
            Module['print'](tty.output.join(''));
            tty.output = [];
          } else {
            tty.output.push(TTY.utf8.processCChar(val));
          }
        }},default_tty1_ops:{put_char:function (tty, val) {
          if (val === null || val === 10) {
            Module['printErr'](tty.output.join(''));
            tty.output = [];
          } else {
            tty.output.push(TTY.utf8.processCChar(val));
          }
        }}};
  
  var MEMFS={ops_table:null,CONTENT_OWNING:1,CONTENT_FLEXIBLE:2,CONTENT_FIXED:3,mount:function (mount) {
        return MEMFS.createNode(null, '/', 16384 | 511 /* 0777 */, 0);
      },createNode:function (parent, name, mode, dev) {
        if (FS.isBlkdev(mode) || FS.isFIFO(mode)) {
          // no supported
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (!MEMFS.ops_table) {
          MEMFS.ops_table = {
            dir: {
              node: {
                getattr: MEMFS.node_ops.getattr,
                setattr: MEMFS.node_ops.setattr,
                lookup: MEMFS.node_ops.lookup,
                mknod: MEMFS.node_ops.mknod,
                rename: MEMFS.node_ops.rename,
                unlink: MEMFS.node_ops.unlink,
                rmdir: MEMFS.node_ops.rmdir,
                readdir: MEMFS.node_ops.readdir,
                symlink: MEMFS.node_ops.symlink
              },
              stream: {
                llseek: MEMFS.stream_ops.llseek
              }
            },
            file: {
              node: {
                getattr: MEMFS.node_ops.getattr,
                setattr: MEMFS.node_ops.setattr
              },
              stream: {
                llseek: MEMFS.stream_ops.llseek,
                read: MEMFS.stream_ops.read,
                write: MEMFS.stream_ops.write,
                allocate: MEMFS.stream_ops.allocate,
                mmap: MEMFS.stream_ops.mmap
              }
            },
            link: {
              node: {
                getattr: MEMFS.node_ops.getattr,
                setattr: MEMFS.node_ops.setattr,
                readlink: MEMFS.node_ops.readlink
              },
              stream: {}
            },
            chrdev: {
              node: {
                getattr: MEMFS.node_ops.getattr,
                setattr: MEMFS.node_ops.setattr
              },
              stream: FS.chrdev_stream_ops
            },
          };
        }
        var node = FS.createNode(parent, name, mode, dev);
        if (FS.isDir(node.mode)) {
          node.node_ops = MEMFS.ops_table.dir.node;
          node.stream_ops = MEMFS.ops_table.dir.stream;
          node.contents = {};
        } else if (FS.isFile(node.mode)) {
          node.node_ops = MEMFS.ops_table.file.node;
          node.stream_ops = MEMFS.ops_table.file.stream;
          node.contents = [];
          node.contentMode = MEMFS.CONTENT_FLEXIBLE;
        } else if (FS.isLink(node.mode)) {
          node.node_ops = MEMFS.ops_table.link.node;
          node.stream_ops = MEMFS.ops_table.link.stream;
        } else if (FS.isChrdev(node.mode)) {
          node.node_ops = MEMFS.ops_table.chrdev.node;
          node.stream_ops = MEMFS.ops_table.chrdev.stream;
        }
        node.timestamp = Date.now();
        // add the new node to the parent
        if (parent) {
          parent.contents[name] = node;
        }
        return node;
      },ensureFlexible:function (node) {
        if (node.contentMode !== MEMFS.CONTENT_FLEXIBLE) {
          var contents = node.contents;
          node.contents = Array.prototype.slice.call(contents);
          node.contentMode = MEMFS.CONTENT_FLEXIBLE;
        }
      },node_ops:{getattr:function (node) {
          var attr = {};
          // device numbers reuse inode numbers.
          attr.dev = FS.isChrdev(node.mode) ? node.id : 1;
          attr.ino = node.id;
          attr.mode = node.mode;
          attr.nlink = 1;
          attr.uid = 0;
          attr.gid = 0;
          attr.rdev = node.rdev;
          if (FS.isDir(node.mode)) {
            attr.size = 4096;
          } else if (FS.isFile(node.mode)) {
            attr.size = node.contents.length;
          } else if (FS.isLink(node.mode)) {
            attr.size = node.link.length;
          } else {
            attr.size = 0;
          }
          attr.atime = new Date(node.timestamp);
          attr.mtime = new Date(node.timestamp);
          attr.ctime = new Date(node.timestamp);
          // NOTE: In our implementation, st_blocks = Math.ceil(st_size/st_blksize),
          //       but this is not required by the standard.
          attr.blksize = 4096;
          attr.blocks = Math.ceil(attr.size / attr.blksize);
          return attr;
        },setattr:function (node, attr) {
          if (attr.mode !== undefined) {
            node.mode = attr.mode;
          }
          if (attr.timestamp !== undefined) {
            node.timestamp = attr.timestamp;
          }
          if (attr.size !== undefined) {
            MEMFS.ensureFlexible(node);
            var contents = node.contents;
            if (attr.size < contents.length) contents.length = attr.size;
            else while (attr.size > contents.length) contents.push(0);
          }
        },lookup:function (parent, name) {
          throw FS.genericErrors[ERRNO_CODES.ENOENT];
        },mknod:function (parent, name, mode, dev) {
          return MEMFS.createNode(parent, name, mode, dev);
        },rename:function (old_node, new_dir, new_name) {
          // if we're overwriting a directory at new_name, make sure it's empty.
          if (FS.isDir(old_node.mode)) {
            var new_node;
            try {
              new_node = FS.lookupNode(new_dir, new_name);
            } catch (e) {
            }
            if (new_node) {
              for (var i in new_node.contents) {
                throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY);
              }
            }
          }
          // do the internal rewiring
          delete old_node.parent.contents[old_node.name];
          old_node.name = new_name;
          new_dir.contents[new_name] = old_node;
          old_node.parent = new_dir;
        },unlink:function (parent, name) {
          delete parent.contents[name];
        },rmdir:function (parent, name) {
          var node = FS.lookupNode(parent, name);
          for (var i in node.contents) {
            throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY);
          }
          delete parent.contents[name];
        },readdir:function (node) {
          var entries = ['.', '..']
          for (var key in node.contents) {
            if (!node.contents.hasOwnProperty(key)) {
              continue;
            }
            entries.push(key);
          }
          return entries;
        },symlink:function (parent, newname, oldpath) {
          var node = MEMFS.createNode(parent, newname, 511 /* 0777 */ | 40960, 0);
          node.link = oldpath;
          return node;
        },readlink:function (node) {
          if (!FS.isLink(node.mode)) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
          return node.link;
        }},stream_ops:{read:function (stream, buffer, offset, length, position) {
          var contents = stream.node.contents;
          if (position >= contents.length)
            return 0;
          var size = Math.min(contents.length - position, length);
          assert(size >= 0);
          if (size > 8 && contents.subarray) { // non-trivial, and typed array
            buffer.set(contents.subarray(position, position + size), offset);
          } else
          {
            for (var i = 0; i < size; i++) {
              buffer[offset + i] = contents[position + i];
            }
          }
          return size;
        },write:function (stream, buffer, offset, length, position, canOwn) {
          var node = stream.node;
          node.timestamp = Date.now();
          var contents = node.contents;
          if (length && contents.length === 0 && position === 0 && buffer.subarray) {
            // just replace it with the new data
            if (canOwn && offset === 0) {
              node.contents = buffer; // this could be a subarray of Emscripten HEAP, or allocated from some other source.
              node.contentMode = (buffer.buffer === HEAP8.buffer) ? MEMFS.CONTENT_OWNING : MEMFS.CONTENT_FIXED;
            } else {
              node.contents = new Uint8Array(buffer.subarray(offset, offset+length));
              node.contentMode = MEMFS.CONTENT_FIXED;
            }
            return length;
          }
          MEMFS.ensureFlexible(node);
          var contents = node.contents;
          while (contents.length < position) contents.push(0);
          for (var i = 0; i < length; i++) {
            contents[position + i] = buffer[offset + i];
          }
          return length;
        },llseek:function (stream, offset, whence) {
          var position = offset;
          if (whence === 1) {  // SEEK_CUR.
            position += stream.position;
          } else if (whence === 2) {  // SEEK_END.
            if (FS.isFile(stream.node.mode)) {
              position += stream.node.contents.length;
            }
          }
          if (position < 0) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
          stream.ungotten = [];
          stream.position = position;
          return position;
        },allocate:function (stream, offset, length) {
          MEMFS.ensureFlexible(stream.node);
          var contents = stream.node.contents;
          var limit = offset + length;
          while (limit > contents.length) contents.push(0);
        },mmap:function (stream, buffer, offset, length, position, prot, flags) {
          if (!FS.isFile(stream.node.mode)) {
            throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
          }
          var ptr;
          var allocated;
          var contents = stream.node.contents;
          // Only make a new copy when MAP_PRIVATE is specified.
          if ( !(flags & 2) &&
                (contents.buffer === buffer || contents.buffer === buffer.buffer) ) {
            // We can't emulate MAP_SHARED when the file is not backed by the buffer
            // we're mapping to (e.g. the HEAP buffer).
            allocated = false;
            ptr = contents.byteOffset;
          } else {
            // Try to avoid unnecessary slices.
            if (position > 0 || position + length < contents.length) {
              if (contents.subarray) {
                contents = contents.subarray(position, position + length);
              } else {
                contents = Array.prototype.slice.call(contents, position, position + length);
              }
            }
            allocated = true;
            ptr = _malloc(length);
            if (!ptr) {
              throw new FS.ErrnoError(ERRNO_CODES.ENOMEM);
            }
            buffer.set(contents, ptr);
          }
          return { ptr: ptr, allocated: allocated };
        }}};
  
  var IDBFS={dbs:{},indexedDB:function () {
        return window.indexedDB || window.mozIndexedDB || window.webkitIndexedDB || window.msIndexedDB;
      },DB_VERSION:21,DB_STORE_NAME:"FILE_DATA",mount:function (mount) {
        // reuse all of the core MEMFS functionality
        return MEMFS.mount.apply(null, arguments);
      },syncfs:function (mount, populate, callback) {
        IDBFS.getLocalSet(mount, function(err, local) {
          if (err) return callback(err);
  
          IDBFS.getRemoteSet(mount, function(err, remote) {
            if (err) return callback(err);
  
            var src = populate ? remote : local;
            var dst = populate ? local : remote;
  
            IDBFS.reconcile(src, dst, callback);
          });
        });
      },getDB:function (name, callback) {
        // check the cache first
        var db = IDBFS.dbs[name];
        if (db) {
          return callback(null, db);
        }
  
        var req;
        try {
          req = IDBFS.indexedDB().open(name, IDBFS.DB_VERSION);
        } catch (e) {
          return callback(e);
        }
        req.onupgradeneeded = function(e) {
          var db = e.target.result;
          var transaction = e.target.transaction;
  
          var fileStore;
  
          if (db.objectStoreNames.contains(IDBFS.DB_STORE_NAME)) {
            fileStore = transaction.objectStore(IDBFS.DB_STORE_NAME);
          } else {
            fileStore = db.createObjectStore(IDBFS.DB_STORE_NAME);
          }
  
          fileStore.createIndex('timestamp', 'timestamp', { unique: false });
        };
        req.onsuccess = function() {
          db = req.result;
  
          // add to the cache
          IDBFS.dbs[name] = db;
          callback(null, db);
        };
        req.onerror = function() {
          callback(this.error);
        };
      },getLocalSet:function (mount, callback) {
        var entries = {};
  
        function isRealDir(p) {
          return p !== '.' && p !== '..';
        };
        function toAbsolute(root) {
          return function(p) {
            return PATH.join2(root, p);
          }
        };
  
        var check = FS.readdir(mount.mountpoint).filter(isRealDir).map(toAbsolute(mount.mountpoint));
  
        while (check.length) {
          var path = check.pop();
          var stat;
  
          try {
            stat = FS.stat(path);
          } catch (e) {
            return callback(e);
          }
  
          if (FS.isDir(stat.mode)) {
            check.push.apply(check, FS.readdir(path).filter(isRealDir).map(toAbsolute(path)));
          }
  
          entries[path] = { timestamp: stat.mtime };
        }
  
        return callback(null, { type: 'local', entries: entries });
      },getRemoteSet:function (mount, callback) {
        var entries = {};
  
        IDBFS.getDB(mount.mountpoint, function(err, db) {
          if (err) return callback(err);
  
          var transaction = db.transaction([IDBFS.DB_STORE_NAME], 'readonly');
          transaction.onerror = function() { callback(this.error); };
  
          var store = transaction.objectStore(IDBFS.DB_STORE_NAME);
          var index = store.index('timestamp');
  
          index.openKeyCursor().onsuccess = function(event) {
            var cursor = event.target.result;
  
            if (!cursor) {
              return callback(null, { type: 'remote', db: db, entries: entries });
            }
  
            entries[cursor.primaryKey] = { timestamp: cursor.key };
  
            cursor.continue();
          };
        });
      },loadLocalEntry:function (path, callback) {
        var stat, node;
  
        try {
          var lookup = FS.lookupPath(path);
          node = lookup.node;
          stat = FS.stat(path);
        } catch (e) {
          return callback(e);
        }
  
        if (FS.isDir(stat.mode)) {
          return callback(null, { timestamp: stat.mtime, mode: stat.mode });
        } else if (FS.isFile(stat.mode)) {
          return callback(null, { timestamp: stat.mtime, mode: stat.mode, contents: node.contents });
        } else {
          return callback(new Error('node type not supported'));
        }
      },storeLocalEntry:function (path, entry, callback) {
        try {
          if (FS.isDir(entry.mode)) {
            FS.mkdir(path, entry.mode);
          } else if (FS.isFile(entry.mode)) {
            FS.writeFile(path, entry.contents, { encoding: 'binary', canOwn: true });
          } else {
            return callback(new Error('node type not supported'));
          }
  
          FS.utime(path, entry.timestamp, entry.timestamp);
        } catch (e) {
          return callback(e);
        }
  
        callback(null);
      },removeLocalEntry:function (path, callback) {
        try {
          var lookup = FS.lookupPath(path);
          var stat = FS.stat(path);
  
          if (FS.isDir(stat.mode)) {
            FS.rmdir(path);
          } else if (FS.isFile(stat.mode)) {
            FS.unlink(path);
          }
        } catch (e) {
          return callback(e);
        }
  
        callback(null);
      },loadRemoteEntry:function (store, path, callback) {
        var req = store.get(path);
        req.onsuccess = function(event) { callback(null, event.target.result); };
        req.onerror = function() { callback(this.error); };
      },storeRemoteEntry:function (store, path, entry, callback) {
        var req = store.put(entry, path);
        req.onsuccess = function() { callback(null); };
        req.onerror = function() { callback(this.error); };
      },removeRemoteEntry:function (store, path, callback) {
        var req = store.delete(path);
        req.onsuccess = function() { callback(null); };
        req.onerror = function() { callback(this.error); };
      },reconcile:function (src, dst, callback) {
        var total = 0;
  
        var create = [];
        Object.keys(src.entries).forEach(function (key) {
          var e = src.entries[key];
          var e2 = dst.entries[key];
          if (!e2 || e.timestamp > e2.timestamp) {
            create.push(key);
            total++;
          }
        });
  
        var remove = [];
        Object.keys(dst.entries).forEach(function (key) {
          var e = dst.entries[key];
          var e2 = src.entries[key];
          if (!e2) {
            remove.push(key);
            total++;
          }
        });
  
        if (!total) {
          return callback(null);
        }
  
        var errored = false;
        var completed = 0;
        var db = src.type === 'remote' ? src.db : dst.db;
        var transaction = db.transaction([IDBFS.DB_STORE_NAME], 'readwrite');
        var store = transaction.objectStore(IDBFS.DB_STORE_NAME);
  
        function done(err) {
          if (err) {
            if (!done.errored) {
              done.errored = true;
              return callback(err);
            }
            return;
          }
          if (++completed >= total) {
            return callback(null);
          }
        };
  
        transaction.onerror = function() { done(this.error); };
  
        // sort paths in ascending order so directory entries are created
        // before the files inside them
        create.sort().forEach(function (path) {
          if (dst.type === 'local') {
            IDBFS.loadRemoteEntry(store, path, function (err, entry) {
              if (err) return done(err);
              IDBFS.storeLocalEntry(path, entry, done);
            });
          } else {
            IDBFS.loadLocalEntry(path, function (err, entry) {
              if (err) return done(err);
              IDBFS.storeRemoteEntry(store, path, entry, done);
            });
          }
        });
  
        // sort paths in descending order so files are deleted before their
        // parent directories
        remove.sort().reverse().forEach(function(path) {
          if (dst.type === 'local') {
            IDBFS.removeLocalEntry(path, done);
          } else {
            IDBFS.removeRemoteEntry(store, path, done);
          }
        });
      }};
  
  var NODEFS={isWindows:false,staticInit:function () {
        NODEFS.isWindows = !!process.platform.match(/^win/);
      },mount:function (mount) {
        assert(ENVIRONMENT_IS_NODE);
        return NODEFS.createNode(null, '/', NODEFS.getMode(mount.opts.root), 0);
      },createNode:function (parent, name, mode, dev) {
        if (!FS.isDir(mode) && !FS.isFile(mode) && !FS.isLink(mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var node = FS.createNode(parent, name, mode);
        node.node_ops = NODEFS.node_ops;
        node.stream_ops = NODEFS.stream_ops;
        return node;
      },getMode:function (path) {
        var stat;
        try {
          stat = fs.lstatSync(path);
          if (NODEFS.isWindows) {
            // On Windows, directories return permission bits 'rw-rw-rw-', even though they have 'rwxrwxrwx', so 
            // propagate write bits to execute bits.
            stat.mode = stat.mode | ((stat.mode & 146) >> 1);
          }
        } catch (e) {
          if (!e.code) throw e;
          throw new FS.ErrnoError(ERRNO_CODES[e.code]);
        }
        return stat.mode;
      },realPath:function (node) {
        var parts = [];
        while (node.parent !== node) {
          parts.push(node.name);
          node = node.parent;
        }
        parts.push(node.mount.opts.root);
        parts.reverse();
        return PATH.join.apply(null, parts);
      },flagsToPermissionStringMap:{0:"r",1:"r+",2:"r+",64:"r",65:"r+",66:"r+",129:"rx+",193:"rx+",514:"w+",577:"w",578:"w+",705:"wx",706:"wx+",1024:"a",1025:"a",1026:"a+",1089:"a",1090:"a+",1153:"ax",1154:"ax+",1217:"ax",1218:"ax+",4096:"rs",4098:"rs+"},flagsToPermissionString:function (flags) {
        if (flags in NODEFS.flagsToPermissionStringMap) {
          return NODEFS.flagsToPermissionStringMap[flags];
        } else {
          return flags;
        }
      },node_ops:{getattr:function (node) {
          var path = NODEFS.realPath(node);
          var stat;
          try {
            stat = fs.lstatSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
          // node.js v0.10.20 doesn't report blksize and blocks on Windows. Fake them with default blksize of 4096.
          // See http://support.microsoft.com/kb/140365
          if (NODEFS.isWindows && !stat.blksize) {
            stat.blksize = 4096;
          }
          if (NODEFS.isWindows && !stat.blocks) {
            stat.blocks = (stat.size+stat.blksize-1)/stat.blksize|0;
          }
          return {
            dev: stat.dev,
            ino: stat.ino,
            mode: stat.mode,
            nlink: stat.nlink,
            uid: stat.uid,
            gid: stat.gid,
            rdev: stat.rdev,
            size: stat.size,
            atime: stat.atime,
            mtime: stat.mtime,
            ctime: stat.ctime,
            blksize: stat.blksize,
            blocks: stat.blocks
          };
        },setattr:function (node, attr) {
          var path = NODEFS.realPath(node);
          try {
            if (attr.mode !== undefined) {
              fs.chmodSync(path, attr.mode);
              // update the common node structure mode as well
              node.mode = attr.mode;
            }
            if (attr.timestamp !== undefined) {
              var date = new Date(attr.timestamp);
              fs.utimesSync(path, date, date);
            }
            if (attr.size !== undefined) {
              fs.truncateSync(path, attr.size);
            }
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },lookup:function (parent, name) {
          var path = PATH.join2(NODEFS.realPath(parent), name);
          var mode = NODEFS.getMode(path);
          return NODEFS.createNode(parent, name, mode);
        },mknod:function (parent, name, mode, dev) {
          var node = NODEFS.createNode(parent, name, mode, dev);
          // create the backing node for this in the fs root as well
          var path = NODEFS.realPath(node);
          try {
            if (FS.isDir(node.mode)) {
              fs.mkdirSync(path, node.mode);
            } else {
              fs.writeFileSync(path, '', { mode: node.mode });
            }
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
          return node;
        },rename:function (oldNode, newDir, newName) {
          var oldPath = NODEFS.realPath(oldNode);
          var newPath = PATH.join2(NODEFS.realPath(newDir), newName);
          try {
            fs.renameSync(oldPath, newPath);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },unlink:function (parent, name) {
          var path = PATH.join2(NODEFS.realPath(parent), name);
          try {
            fs.unlinkSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },rmdir:function (parent, name) {
          var path = PATH.join2(NODEFS.realPath(parent), name);
          try {
            fs.rmdirSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },readdir:function (node) {
          var path = NODEFS.realPath(node);
          try {
            return fs.readdirSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },symlink:function (parent, newName, oldPath) {
          var newPath = PATH.join2(NODEFS.realPath(parent), newName);
          try {
            fs.symlinkSync(oldPath, newPath);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },readlink:function (node) {
          var path = NODEFS.realPath(node);
          try {
            return fs.readlinkSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        }},stream_ops:{open:function (stream) {
          var path = NODEFS.realPath(stream.node);
          try {
            if (FS.isFile(stream.node.mode)) {
              stream.nfd = fs.openSync(path, NODEFS.flagsToPermissionString(stream.flags));
            }
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },close:function (stream) {
          try {
            if (FS.isFile(stream.node.mode) && stream.nfd) {
              fs.closeSync(stream.nfd);
            }
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },read:function (stream, buffer, offset, length, position) {
          // FIXME this is terrible.
          var nbuffer = new Buffer(length);
          var res;
          try {
            res = fs.readSync(stream.nfd, nbuffer, 0, length, position);
          } catch (e) {
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
          if (res > 0) {
            for (var i = 0; i < res; i++) {
              buffer[offset + i] = nbuffer[i];
            }
          }
          return res;
        },write:function (stream, buffer, offset, length, position) {
          // FIXME this is terrible.
          var nbuffer = new Buffer(buffer.subarray(offset, offset + length));
          var res;
          try {
            res = fs.writeSync(stream.nfd, nbuffer, 0, length, position);
          } catch (e) {
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
          return res;
        },llseek:function (stream, offset, whence) {
          var position = offset;
          if (whence === 1) {  // SEEK_CUR.
            position += stream.position;
          } else if (whence === 2) {  // SEEK_END.
            if (FS.isFile(stream.node.mode)) {
              try {
                var stat = fs.fstatSync(stream.nfd);
                position += stat.size;
              } catch (e) {
                throw new FS.ErrnoError(ERRNO_CODES[e.code]);
              }
            }
          }
  
          if (position < 0) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
  
          stream.position = position;
          return position;
        }}};
  
  var _stdin=allocate(1, "i32*", ALLOC_STATIC);
  
  var _stdout=allocate(1, "i32*", ALLOC_STATIC);
  
  var _stderr=allocate(1, "i32*", ALLOC_STATIC);
  
  function _fflush(stream) {
      // int fflush(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fflush.html
      // we don't currently perform any user-space buffering of data
    }var FS={root:null,mounts:[],devices:[null],streams:[],nextInode:1,nameTable:null,currentPath:"/",initialized:false,ignorePermissions:true,ErrnoError:null,genericErrors:{},handleFSError:function (e) {
        if (!(e instanceof FS.ErrnoError)) throw e + ' : ' + stackTrace();
        return ___setErrNo(e.errno);
      },lookupPath:function (path, opts) {
        path = PATH.resolve(FS.cwd(), path);
        opts = opts || {};
  
        var defaults = {
          follow_mount: true,
          recurse_count: 0
        };
        for (var key in defaults) {
          if (opts[key] === undefined) {
            opts[key] = defaults[key];
          }
        }
  
        if (opts.recurse_count > 8) {  // max recursive lookup of 8
          throw new FS.ErrnoError(ERRNO_CODES.ELOOP);
        }
  
        // split the path
        var parts = PATH.normalizeArray(path.split('/').filter(function(p) {
          return !!p;
        }), false);
  
        // start at the root
        var current = FS.root;
        var current_path = '/';
  
        for (var i = 0; i < parts.length; i++) {
          var islast = (i === parts.length-1);
          if (islast && opts.parent) {
            // stop resolving
            break;
          }
  
          current = FS.lookupNode(current, parts[i]);
          current_path = PATH.join2(current_path, parts[i]);
  
          // jump to the mount's root node if this is a mountpoint
          if (FS.isMountpoint(current)) {
            if (!islast || (islast && opts.follow_mount)) {
              current = current.mounted.root;
            }
          }
  
          // by default, lookupPath will not follow a symlink if it is the final path component.
          // setting opts.follow = true will override this behavior.
          if (!islast || opts.follow) {
            var count = 0;
            while (FS.isLink(current.mode)) {
              var link = FS.readlink(current_path);
              current_path = PATH.resolve(PATH.dirname(current_path), link);
              
              var lookup = FS.lookupPath(current_path, { recurse_count: opts.recurse_count });
              current = lookup.node;
  
              if (count++ > 40) {  // limit max consecutive symlinks to 40 (SYMLOOP_MAX).
                throw new FS.ErrnoError(ERRNO_CODES.ELOOP);
              }
            }
          }
        }
  
        return { path: current_path, node: current };
      },getPath:function (node) {
        var path;
        while (true) {
          if (FS.isRoot(node)) {
            var mount = node.mount.mountpoint;
            if (!path) return mount;
            return mount[mount.length-1] !== '/' ? mount + '/' + path : mount + path;
          }
          path = path ? node.name + '/' + path : node.name;
          node = node.parent;
        }
      },hashName:function (parentid, name) {
        var hash = 0;
  
  
        for (var i = 0; i < name.length; i++) {
          hash = ((hash << 5) - hash + name.charCodeAt(i)) | 0;
        }
        return ((parentid + hash) >>> 0) % FS.nameTable.length;
      },hashAddNode:function (node) {
        var hash = FS.hashName(node.parent.id, node.name);
        node.name_next = FS.nameTable[hash];
        FS.nameTable[hash] = node;
      },hashRemoveNode:function (node) {
        var hash = FS.hashName(node.parent.id, node.name);
        if (FS.nameTable[hash] === node) {
          FS.nameTable[hash] = node.name_next;
        } else {
          var current = FS.nameTable[hash];
          while (current) {
            if (current.name_next === node) {
              current.name_next = node.name_next;
              break;
            }
            current = current.name_next;
          }
        }
      },lookupNode:function (parent, name) {
        var err = FS.mayLookup(parent);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        var hash = FS.hashName(parent.id, name);
        for (var node = FS.nameTable[hash]; node; node = node.name_next) {
          var nodeName = node.name;
          if (node.parent.id === parent.id && nodeName === name) {
            return node;
          }
        }
        // if we failed to find it in the cache, call into the VFS
        return FS.lookup(parent, name);
      },createNode:function (parent, name, mode, rdev) {
        if (!FS.FSNode) {
          FS.FSNode = function(parent, name, mode, rdev) {
            if (!parent) {
              parent = this;  // root node sets parent to itself
            }
            this.parent = parent;
            this.mount = parent.mount;
            this.mounted = null;
            this.id = FS.nextInode++;
            this.name = name;
            this.mode = mode;
            this.node_ops = {};
            this.stream_ops = {};
            this.rdev = rdev;
          };
  
          FS.FSNode.prototype = {};
  
          // compatibility
          var readMode = 292 | 73;
          var writeMode = 146;
  
          // NOTE we must use Object.defineProperties instead of individual calls to
          // Object.defineProperty in order to make closure compiler happy
          Object.defineProperties(FS.FSNode.prototype, {
            read: {
              get: function() { return (this.mode & readMode) === readMode; },
              set: function(val) { val ? this.mode |= readMode : this.mode &= ~readMode; }
            },
            write: {
              get: function() { return (this.mode & writeMode) === writeMode; },
              set: function(val) { val ? this.mode |= writeMode : this.mode &= ~writeMode; }
            },
            isFolder: {
              get: function() { return FS.isDir(this.mode); },
            },
            isDevice: {
              get: function() { return FS.isChrdev(this.mode); },
            },
          });
        }
  
        var node = new FS.FSNode(parent, name, mode, rdev);
  
        FS.hashAddNode(node);
  
        return node;
      },destroyNode:function (node) {
        FS.hashRemoveNode(node);
      },isRoot:function (node) {
        return node === node.parent;
      },isMountpoint:function (node) {
        return !!node.mounted;
      },isFile:function (mode) {
        return (mode & 61440) === 32768;
      },isDir:function (mode) {
        return (mode & 61440) === 16384;
      },isLink:function (mode) {
        return (mode & 61440) === 40960;
      },isChrdev:function (mode) {
        return (mode & 61440) === 8192;
      },isBlkdev:function (mode) {
        return (mode & 61440) === 24576;
      },isFIFO:function (mode) {
        return (mode & 61440) === 4096;
      },isSocket:function (mode) {
        return (mode & 49152) === 49152;
      },flagModes:{"r":0,"rs":1052672,"r+":2,"w":577,"wx":705,"xw":705,"w+":578,"wx+":706,"xw+":706,"a":1089,"ax":1217,"xa":1217,"a+":1090,"ax+":1218,"xa+":1218},modeStringToFlags:function (str) {
        var flags = FS.flagModes[str];
        if (typeof flags === 'undefined') {
          throw new Error('Unknown file open mode: ' + str);
        }
        return flags;
      },flagsToPermissionString:function (flag) {
        var accmode = flag & 2097155;
        var perms = ['r', 'w', 'rw'][accmode];
        if ((flag & 512)) {
          perms += 'w';
        }
        return perms;
      },nodePermissions:function (node, perms) {
        if (FS.ignorePermissions) {
          return 0;
        }
        // return 0 if any user, group or owner bits are set.
        if (perms.indexOf('r') !== -1 && !(node.mode & 292)) {
          return ERRNO_CODES.EACCES;
        } else if (perms.indexOf('w') !== -1 && !(node.mode & 146)) {
          return ERRNO_CODES.EACCES;
        } else if (perms.indexOf('x') !== -1 && !(node.mode & 73)) {
          return ERRNO_CODES.EACCES;
        }
        return 0;
      },mayLookup:function (dir) {
        return FS.nodePermissions(dir, 'x');
      },mayCreate:function (dir, name) {
        try {
          var node = FS.lookupNode(dir, name);
          return ERRNO_CODES.EEXIST;
        } catch (e) {
        }
        return FS.nodePermissions(dir, 'wx');
      },mayDelete:function (dir, name, isdir) {
        var node;
        try {
          node = FS.lookupNode(dir, name);
        } catch (e) {
          return e.errno;
        }
        var err = FS.nodePermissions(dir, 'wx');
        if (err) {
          return err;
        }
        if (isdir) {
          if (!FS.isDir(node.mode)) {
            return ERRNO_CODES.ENOTDIR;
          }
          if (FS.isRoot(node) || FS.getPath(node) === FS.cwd()) {
            return ERRNO_CODES.EBUSY;
          }
        } else {
          if (FS.isDir(node.mode)) {
            return ERRNO_CODES.EISDIR;
          }
        }
        return 0;
      },mayOpen:function (node, flags) {
        if (!node) {
          return ERRNO_CODES.ENOENT;
        }
        if (FS.isLink(node.mode)) {
          return ERRNO_CODES.ELOOP;
        } else if (FS.isDir(node.mode)) {
          if ((flags & 2097155) !== 0 ||  // opening for write
              (flags & 512)) {
            return ERRNO_CODES.EISDIR;
          }
        }
        return FS.nodePermissions(node, FS.flagsToPermissionString(flags));
      },MAX_OPEN_FDS:4096,nextfd:function (fd_start, fd_end) {
        fd_start = fd_start || 0;
        fd_end = fd_end || FS.MAX_OPEN_FDS;
        for (var fd = fd_start; fd <= fd_end; fd++) {
          if (!FS.streams[fd]) {
            return fd;
          }
        }
        throw new FS.ErrnoError(ERRNO_CODES.EMFILE);
      },getStream:function (fd) {
        return FS.streams[fd];
      },createStream:function (stream, fd_start, fd_end) {
        if (!FS.FSStream) {
          FS.FSStream = function(){};
          FS.FSStream.prototype = {};
          // compatibility
          Object.defineProperties(FS.FSStream.prototype, {
            object: {
              get: function() { return this.node; },
              set: function(val) { this.node = val; }
            },
            isRead: {
              get: function() { return (this.flags & 2097155) !== 1; }
            },
            isWrite: {
              get: function() { return (this.flags & 2097155) !== 0; }
            },
            isAppend: {
              get: function() { return (this.flags & 1024); }
            }
          });
        }
        if (stream.__proto__) {
          // reuse the object
          stream.__proto__ = FS.FSStream.prototype;
        } else {
          var newStream = new FS.FSStream();
          for (var p in stream) {
            newStream[p] = stream[p];
          }
          stream = newStream;
        }
        var fd = FS.nextfd(fd_start, fd_end);
        stream.fd = fd;
        FS.streams[fd] = stream;
        return stream;
      },closeStream:function (fd) {
        FS.streams[fd] = null;
      },getStreamFromPtr:function (ptr) {
        return FS.streams[ptr - 1];
      },getPtrForStream:function (stream) {
        return stream ? stream.fd + 1 : 0;
      },chrdev_stream_ops:{open:function (stream) {
          var device = FS.getDevice(stream.node.rdev);
          // override node's stream ops with the device's
          stream.stream_ops = device.stream_ops;
          // forward the open call
          if (stream.stream_ops.open) {
            stream.stream_ops.open(stream);
          }
        },llseek:function () {
          throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
        }},major:function (dev) {
        return ((dev) >> 8);
      },minor:function (dev) {
        return ((dev) & 0xff);
      },makedev:function (ma, mi) {
        return ((ma) << 8 | (mi));
      },registerDevice:function (dev, ops) {
        FS.devices[dev] = { stream_ops: ops };
      },getDevice:function (dev) {
        return FS.devices[dev];
      },getMounts:function (mount) {
        var mounts = [];
        var check = [mount];
  
        while (check.length) {
          var m = check.pop();
  
          mounts.push(m);
  
          check.push.apply(check, m.mounts);
        }
  
        return mounts;
      },syncfs:function (populate, callback) {
        if (typeof(populate) === 'function') {
          callback = populate;
          populate = false;
        }
  
        var mounts = FS.getMounts(FS.root.mount);
        var completed = 0;
  
        function done(err) {
          if (err) {
            if (!done.errored) {
              done.errored = true;
              return callback(err);
            }
            return;
          }
          if (++completed >= mounts.length) {
            callback(null);
          }
        };
  
        // sync all mounts
        mounts.forEach(function (mount) {
          if (!mount.type.syncfs) {
            return done(null);
          }
          mount.type.syncfs(mount, populate, done);
        });
      },mount:function (type, opts, mountpoint) {
        var root = mountpoint === '/';
        var pseudo = !mountpoint;
        var node;
  
        if (root && FS.root) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        } else if (!root && !pseudo) {
          var lookup = FS.lookupPath(mountpoint, { follow_mount: false });
  
          mountpoint = lookup.path;  // use the absolute path
          node = lookup.node;
  
          if (FS.isMountpoint(node)) {
            throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
          }
  
          if (!FS.isDir(node.mode)) {
            throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR);
          }
        }
  
        var mount = {
          type: type,
          opts: opts,
          mountpoint: mountpoint,
          mounts: []
        };
  
        // create a root node for the fs
        var mountRoot = type.mount(mount);
        mountRoot.mount = mount;
        mount.root = mountRoot;
  
        if (root) {
          FS.root = mountRoot;
        } else if (node) {
          // set as a mountpoint
          node.mounted = mount;
  
          // add the new mount to the current mount's children
          if (node.mount) {
            node.mount.mounts.push(mount);
          }
        }
  
        return mountRoot;
      },unmount:function (mountpoint) {
        var lookup = FS.lookupPath(mountpoint, { follow_mount: false });
  
        if (!FS.isMountpoint(lookup.node)) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
  
        // destroy the nodes for this mount, and all its child mounts
        var node = lookup.node;
        var mount = node.mounted;
        var mounts = FS.getMounts(mount);
  
        Object.keys(FS.nameTable).forEach(function (hash) {
          var current = FS.nameTable[hash];
  
          while (current) {
            var next = current.name_next;
  
            if (mounts.indexOf(current.mount) !== -1) {
              FS.destroyNode(current);
            }
  
            current = next;
          }
        });
  
        // no longer a mountpoint
        node.mounted = null;
  
        // remove this mount from the child mounts
        var idx = node.mount.mounts.indexOf(mount);
        assert(idx !== -1);
        node.mount.mounts.splice(idx, 1);
      },lookup:function (parent, name) {
        return parent.node_ops.lookup(parent, name);
      },mknod:function (path, mode, dev) {
        var lookup = FS.lookupPath(path, { parent: true });
        var parent = lookup.node;
        var name = PATH.basename(path);
        var err = FS.mayCreate(parent, name);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        if (!parent.node_ops.mknod) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        return parent.node_ops.mknod(parent, name, mode, dev);
      },create:function (path, mode) {
        mode = mode !== undefined ? mode : 438 /* 0666 */;
        mode &= 4095;
        mode |= 32768;
        return FS.mknod(path, mode, 0);
      },mkdir:function (path, mode) {
        mode = mode !== undefined ? mode : 511 /* 0777 */;
        mode &= 511 | 512;
        mode |= 16384;
        return FS.mknod(path, mode, 0);
      },mkdev:function (path, mode, dev) {
        if (typeof(dev) === 'undefined') {
          dev = mode;
          mode = 438 /* 0666 */;
        }
        mode |= 8192;
        return FS.mknod(path, mode, dev);
      },symlink:function (oldpath, newpath) {
        var lookup = FS.lookupPath(newpath, { parent: true });
        var parent = lookup.node;
        var newname = PATH.basename(newpath);
        var err = FS.mayCreate(parent, newname);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        if (!parent.node_ops.symlink) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        return parent.node_ops.symlink(parent, newname, oldpath);
      },rename:function (old_path, new_path) {
        var old_dirname = PATH.dirname(old_path);
        var new_dirname = PATH.dirname(new_path);
        var old_name = PATH.basename(old_path);
        var new_name = PATH.basename(new_path);
        // parents must exist
        var lookup, old_dir, new_dir;
        try {
          lookup = FS.lookupPath(old_path, { parent: true });
          old_dir = lookup.node;
          lookup = FS.lookupPath(new_path, { parent: true });
          new_dir = lookup.node;
        } catch (e) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        }
        // need to be part of the same mount
        if (old_dir.mount !== new_dir.mount) {
          throw new FS.ErrnoError(ERRNO_CODES.EXDEV);
        }
        // source must exist
        var old_node = FS.lookupNode(old_dir, old_name);
        // old path should not be an ancestor of the new path
        var relative = PATH.relative(old_path, new_dirname);
        if (relative.charAt(0) !== '.') {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        // new path should not be an ancestor of the old path
        relative = PATH.relative(new_path, old_dirname);
        if (relative.charAt(0) !== '.') {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY);
        }
        // see if the new path already exists
        var new_node;
        try {
          new_node = FS.lookupNode(new_dir, new_name);
        } catch (e) {
          // not fatal
        }
        // early out if nothing needs to change
        if (old_node === new_node) {
          return;
        }
        // we'll need to delete the old entry
        var isdir = FS.isDir(old_node.mode);
        var err = FS.mayDelete(old_dir, old_name, isdir);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        // need delete permissions if we'll be overwriting.
        // need create permissions if new doesn't already exist.
        err = new_node ?
          FS.mayDelete(new_dir, new_name, isdir) :
          FS.mayCreate(new_dir, new_name);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        if (!old_dir.node_ops.rename) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (FS.isMountpoint(old_node) || (new_node && FS.isMountpoint(new_node))) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        }
        // if we are going to change the parent, check write permissions
        if (new_dir !== old_dir) {
          err = FS.nodePermissions(old_dir, 'w');
          if (err) {
            throw new FS.ErrnoError(err);
          }
        }
        // remove the node from the lookup hash
        FS.hashRemoveNode(old_node);
        // do the underlying fs rename
        try {
          old_dir.node_ops.rename(old_node, new_dir, new_name);
        } catch (e) {
          throw e;
        } finally {
          // add the node back to the hash (in case node_ops.rename
          // changed its name)
          FS.hashAddNode(old_node);
        }
      },rmdir:function (path) {
        var lookup = FS.lookupPath(path, { parent: true });
        var parent = lookup.node;
        var name = PATH.basename(path);
        var node = FS.lookupNode(parent, name);
        var err = FS.mayDelete(parent, name, true);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        if (!parent.node_ops.rmdir) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (FS.isMountpoint(node)) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        }
        parent.node_ops.rmdir(parent, name);
        FS.destroyNode(node);
      },readdir:function (path) {
        var lookup = FS.lookupPath(path, { follow: true });
        var node = lookup.node;
        if (!node.node_ops.readdir) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR);
        }
        return node.node_ops.readdir(node);
      },unlink:function (path) {
        var lookup = FS.lookupPath(path, { parent: true });
        var parent = lookup.node;
        var name = PATH.basename(path);
        var node = FS.lookupNode(parent, name);
        var err = FS.mayDelete(parent, name, false);
        if (err) {
          // POSIX says unlink should set EPERM, not EISDIR
          if (err === ERRNO_CODES.EISDIR) err = ERRNO_CODES.EPERM;
          throw new FS.ErrnoError(err);
        }
        if (!parent.node_ops.unlink) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (FS.isMountpoint(node)) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        }
        parent.node_ops.unlink(parent, name);
        FS.destroyNode(node);
      },readlink:function (path) {
        var lookup = FS.lookupPath(path);
        var link = lookup.node;
        if (!link.node_ops.readlink) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        return link.node_ops.readlink(link);
      },stat:function (path, dontFollow) {
        var lookup = FS.lookupPath(path, { follow: !dontFollow });
        var node = lookup.node;
        if (!node.node_ops.getattr) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        return node.node_ops.getattr(node);
      },lstat:function (path) {
        return FS.stat(path, true);
      },chmod:function (path, mode, dontFollow) {
        var node;
        if (typeof path === 'string') {
          var lookup = FS.lookupPath(path, { follow: !dontFollow });
          node = lookup.node;
        } else {
          node = path;
        }
        if (!node.node_ops.setattr) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        node.node_ops.setattr(node, {
          mode: (mode & 4095) | (node.mode & ~4095),
          timestamp: Date.now()
        });
      },lchmod:function (path, mode) {
        FS.chmod(path, mode, true);
      },fchmod:function (fd, mode) {
        var stream = FS.getStream(fd);
        if (!stream) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        FS.chmod(stream.node, mode);
      },chown:function (path, uid, gid, dontFollow) {
        var node;
        if (typeof path === 'string') {
          var lookup = FS.lookupPath(path, { follow: !dontFollow });
          node = lookup.node;
        } else {
          node = path;
        }
        if (!node.node_ops.setattr) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        node.node_ops.setattr(node, {
          timestamp: Date.now()
          // we ignore the uid / gid for now
        });
      },lchown:function (path, uid, gid) {
        FS.chown(path, uid, gid, true);
      },fchown:function (fd, uid, gid) {
        var stream = FS.getStream(fd);
        if (!stream) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        FS.chown(stream.node, uid, gid);
      },truncate:function (path, len) {
        if (len < 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var node;
        if (typeof path === 'string') {
          var lookup = FS.lookupPath(path, { follow: true });
          node = lookup.node;
        } else {
          node = path;
        }
        if (!node.node_ops.setattr) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (FS.isDir(node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EISDIR);
        }
        if (!FS.isFile(node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var err = FS.nodePermissions(node, 'w');
        if (err) {
          throw new FS.ErrnoError(err);
        }
        node.node_ops.setattr(node, {
          size: len,
          timestamp: Date.now()
        });
      },ftruncate:function (fd, len) {
        var stream = FS.getStream(fd);
        if (!stream) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if ((stream.flags & 2097155) === 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        FS.truncate(stream.node, len);
      },utime:function (path, atime, mtime) {
        var lookup = FS.lookupPath(path, { follow: true });
        var node = lookup.node;
        node.node_ops.setattr(node, {
          timestamp: Math.max(atime, mtime)
        });
      },open:function (path, flags, mode, fd_start, fd_end) {
        flags = typeof flags === 'string' ? FS.modeStringToFlags(flags) : flags;
        mode = typeof mode === 'undefined' ? 438 /* 0666 */ : mode;
        if ((flags & 64)) {
          mode = (mode & 4095) | 32768;
        } else {
          mode = 0;
        }
        var node;
        if (typeof path === 'object') {
          node = path;
        } else {
          path = PATH.normalize(path);
          try {
            var lookup = FS.lookupPath(path, {
              follow: !(flags & 131072)
            });
            node = lookup.node;
          } catch (e) {
            // ignore
          }
        }
        // perhaps we need to create the node
        if ((flags & 64)) {
          if (node) {
            // if O_CREAT and O_EXCL are set, error out if the node already exists
            if ((flags & 128)) {
              throw new FS.ErrnoError(ERRNO_CODES.EEXIST);
            }
          } else {
            // node doesn't exist, try to create it
            node = FS.mknod(path, mode, 0);
          }
        }
        if (!node) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOENT);
        }
        // can't truncate a device
        if (FS.isChrdev(node.mode)) {
          flags &= ~512;
        }
        // check permissions
        var err = FS.mayOpen(node, flags);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        // do truncation if necessary
        if ((flags & 512)) {
          FS.truncate(node, 0);
        }
        // we've already handled these, don't pass down to the underlying vfs
        flags &= ~(128 | 512);
  
        // register the stream with the filesystem
        var stream = FS.createStream({
          node: node,
          path: FS.getPath(node),  // we want the absolute path to the node
          flags: flags,
          seekable: true,
          position: 0,
          stream_ops: node.stream_ops,
          // used by the file family libc calls (fopen, fwrite, ferror, etc.)
          ungotten: [],
          error: false
        }, fd_start, fd_end);
        // call the new stream's open function
        if (stream.stream_ops.open) {
          stream.stream_ops.open(stream);
        }
        if (Module['logReadFiles'] && !(flags & 1)) {
          if (!FS.readFiles) FS.readFiles = {};
          if (!(path in FS.readFiles)) {
            FS.readFiles[path] = 1;
            Module['printErr']('read file: ' + path);
          }
        }
        return stream;
      },close:function (stream) {
        try {
          if (stream.stream_ops.close) {
            stream.stream_ops.close(stream);
          }
        } catch (e) {
          throw e;
        } finally {
          FS.closeStream(stream.fd);
        }
      },llseek:function (stream, offset, whence) {
        if (!stream.seekable || !stream.stream_ops.llseek) {
          throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
        }
        return stream.stream_ops.llseek(stream, offset, whence);
      },read:function (stream, buffer, offset, length, position) {
        if (length < 0 || position < 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        if ((stream.flags & 2097155) === 1) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if (FS.isDir(stream.node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EISDIR);
        }
        if (!stream.stream_ops.read) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var seeking = true;
        if (typeof position === 'undefined') {
          position = stream.position;
          seeking = false;
        } else if (!stream.seekable) {
          throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
        }
        var bytesRead = stream.stream_ops.read(stream, buffer, offset, length, position);
        if (!seeking) stream.position += bytesRead;
        return bytesRead;
      },write:function (stream, buffer, offset, length, position, canOwn) {
        if (length < 0 || position < 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        if ((stream.flags & 2097155) === 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if (FS.isDir(stream.node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EISDIR);
        }
        if (!stream.stream_ops.write) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var seeking = true;
        if (typeof position === 'undefined') {
          position = stream.position;
          seeking = false;
        } else if (!stream.seekable) {
          throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
        }
        if (stream.flags & 1024) {
          // seek to the end before writing in append mode
          FS.llseek(stream, 0, 2);
        }
        var bytesWritten = stream.stream_ops.write(stream, buffer, offset, length, position, canOwn);
        if (!seeking) stream.position += bytesWritten;
        return bytesWritten;
      },allocate:function (stream, offset, length) {
        if (offset < 0 || length <= 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        if ((stream.flags & 2097155) === 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if (!FS.isFile(stream.node.mode) && !FS.isDir(node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
        }
        if (!stream.stream_ops.allocate) {
          throw new FS.ErrnoError(ERRNO_CODES.EOPNOTSUPP);
        }
        stream.stream_ops.allocate(stream, offset, length);
      },mmap:function (stream, buffer, offset, length, position, prot, flags) {
        // TODO if PROT is PROT_WRITE, make sure we have write access
        if ((stream.flags & 2097155) === 1) {
          throw new FS.ErrnoError(ERRNO_CODES.EACCES);
        }
        if (!stream.stream_ops.mmap) {
          throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
        }
        return stream.stream_ops.mmap(stream, buffer, offset, length, position, prot, flags);
      },ioctl:function (stream, cmd, arg) {
        if (!stream.stream_ops.ioctl) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTTY);
        }
        return stream.stream_ops.ioctl(stream, cmd, arg);
      },readFile:function (path, opts) {
        opts = opts || {};
        opts.flags = opts.flags || 'r';
        opts.encoding = opts.encoding || 'binary';
        if (opts.encoding !== 'utf8' && opts.encoding !== 'binary') {
          throw new Error('Invalid encoding type "' + opts.encoding + '"');
        }
        var ret;
        var stream = FS.open(path, opts.flags);
        var stat = FS.stat(path);
        var length = stat.size;
        var buf = new Uint8Array(length);
        FS.read(stream, buf, 0, length, 0);
        if (opts.encoding === 'utf8') {
          ret = '';
          var utf8 = new Runtime.UTF8Processor();
          for (var i = 0; i < length; i++) {
            ret += utf8.processCChar(buf[i]);
          }
        } else if (opts.encoding === 'binary') {
          ret = buf;
        }
        FS.close(stream);
        return ret;
      },writeFile:function (path, data, opts) {
        opts = opts || {};
        opts.flags = opts.flags || 'w';
        opts.encoding = opts.encoding || 'utf8';
        if (opts.encoding !== 'utf8' && opts.encoding !== 'binary') {
          throw new Error('Invalid encoding type "' + opts.encoding + '"');
        }
        var stream = FS.open(path, opts.flags, opts.mode);
        if (opts.encoding === 'utf8') {
          var utf8 = new Runtime.UTF8Processor();
          var buf = new Uint8Array(utf8.processJSString(data));
          FS.write(stream, buf, 0, buf.length, 0, opts.canOwn);
        } else if (opts.encoding === 'binary') {
          FS.write(stream, data, 0, data.length, 0, opts.canOwn);
        }
        FS.close(stream);
      },cwd:function () {
        return FS.currentPath;
      },chdir:function (path) {
        var lookup = FS.lookupPath(path, { follow: true });
        if (!FS.isDir(lookup.node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR);
        }
        var err = FS.nodePermissions(lookup.node, 'x');
        if (err) {
          throw new FS.ErrnoError(err);
        }
        FS.currentPath = lookup.path;
      },createDefaultDirectories:function () {
        FS.mkdir('/tmp');
      },createDefaultDevices:function () {
        // create /dev
        FS.mkdir('/dev');
        // setup /dev/null
        FS.registerDevice(FS.makedev(1, 3), {
          read: function() { return 0; },
          write: function() { return 0; }
        });
        FS.mkdev('/dev/null', FS.makedev(1, 3));
        // setup /dev/tty and /dev/tty1
        // stderr needs to print output using Module['printErr']
        // so we register a second tty just for it.
        TTY.register(FS.makedev(5, 0), TTY.default_tty_ops);
        TTY.register(FS.makedev(6, 0), TTY.default_tty1_ops);
        FS.mkdev('/dev/tty', FS.makedev(5, 0));
        FS.mkdev('/dev/tty1', FS.makedev(6, 0));
        // we're not going to emulate the actual shm device,
        // just create the tmp dirs that reside in it commonly
        FS.mkdir('/dev/shm');
        FS.mkdir('/dev/shm/tmp');
      },createStandardStreams:function () {
        // TODO deprecate the old functionality of a single
        // input / output callback and that utilizes FS.createDevice
        // and instead require a unique set of stream ops
  
        // by default, we symlink the standard streams to the
        // default tty devices. however, if the standard streams
        // have been overwritten we create a unique device for
        // them instead.
        if (Module['stdin']) {
          FS.createDevice('/dev', 'stdin', Module['stdin']);
        } else {
          FS.symlink('/dev/tty', '/dev/stdin');
        }
        if (Module['stdout']) {
          FS.createDevice('/dev', 'stdout', null, Module['stdout']);
        } else {
          FS.symlink('/dev/tty', '/dev/stdout');
        }
        if (Module['stderr']) {
          FS.createDevice('/dev', 'stderr', null, Module['stderr']);
        } else {
          FS.symlink('/dev/tty1', '/dev/stderr');
        }
  
        // open default streams for the stdin, stdout and stderr devices
        var stdin = FS.open('/dev/stdin', 'r');
        HEAP32[((_stdin)>>2)]=FS.getPtrForStream(stdin);
        assert(stdin.fd === 0, 'invalid handle for stdin (' + stdin.fd + ')');
  
        var stdout = FS.open('/dev/stdout', 'w');
        HEAP32[((_stdout)>>2)]=FS.getPtrForStream(stdout);
        assert(stdout.fd === 1, 'invalid handle for stdout (' + stdout.fd + ')');
  
        var stderr = FS.open('/dev/stderr', 'w');
        HEAP32[((_stderr)>>2)]=FS.getPtrForStream(stderr);
        assert(stderr.fd === 2, 'invalid handle for stderr (' + stderr.fd + ')');
      },ensureErrnoError:function () {
        if (FS.ErrnoError) return;
        FS.ErrnoError = function ErrnoError(errno) {
          this.errno = errno;
          for (var key in ERRNO_CODES) {
            if (ERRNO_CODES[key] === errno) {
              this.code = key;
              break;
            }
          }
          this.message = ERRNO_MESSAGES[errno];
        };
        FS.ErrnoError.prototype = new Error();
        FS.ErrnoError.prototype.constructor = FS.ErrnoError;
        // Some errors may happen quite a bit, to avoid overhead we reuse them (and suffer a lack of stack info)
        [ERRNO_CODES.ENOENT].forEach(function(code) {
          FS.genericErrors[code] = new FS.ErrnoError(code);
          FS.genericErrors[code].stack = '<generic error, no stack>';
        });
      },staticInit:function () {
        FS.ensureErrnoError();
  
        FS.nameTable = new Array(4096);
  
        FS.mount(MEMFS, {}, '/');
  
        FS.createDefaultDirectories();
        FS.createDefaultDevices();
      },init:function (input, output, error) {
        assert(!FS.init.initialized, 'FS.init was previously called. If you want to initialize later with custom parameters, remove any earlier calls (note that one is automatically added to the generated code)');
        FS.init.initialized = true;
  
        FS.ensureErrnoError();
  
        // Allow Module.stdin etc. to provide defaults, if none explicitly passed to us here
        Module['stdin'] = input || Module['stdin'];
        Module['stdout'] = output || Module['stdout'];
        Module['stderr'] = error || Module['stderr'];
  
        FS.createStandardStreams();
      },quit:function () {
        FS.init.initialized = false;
        for (var i = 0; i < FS.streams.length; i++) {
          var stream = FS.streams[i];
          if (!stream) {
            continue;
          }
          FS.close(stream);
        }
      },getMode:function (canRead, canWrite) {
        var mode = 0;
        if (canRead) mode |= 292 | 73;
        if (canWrite) mode |= 146;
        return mode;
      },joinPath:function (parts, forceRelative) {
        var path = PATH.join.apply(null, parts);
        if (forceRelative && path[0] == '/') path = path.substr(1);
        return path;
      },absolutePath:function (relative, base) {
        return PATH.resolve(base, relative);
      },standardizePath:function (path) {
        return PATH.normalize(path);
      },findObject:function (path, dontResolveLastLink) {
        var ret = FS.analyzePath(path, dontResolveLastLink);
        if (ret.exists) {
          return ret.object;
        } else {
          ___setErrNo(ret.error);
          return null;
        }
      },analyzePath:function (path, dontResolveLastLink) {
        // operate from within the context of the symlink's target
        try {
          var lookup = FS.lookupPath(path, { follow: !dontResolveLastLink });
          path = lookup.path;
        } catch (e) {
        }
        var ret = {
          isRoot: false, exists: false, error: 0, name: null, path: null, object: null,
          parentExists: false, parentPath: null, parentObject: null
        };
        try {
          var lookup = FS.lookupPath(path, { parent: true });
          ret.parentExists = true;
          ret.parentPath = lookup.path;
          ret.parentObject = lookup.node;
          ret.name = PATH.basename(path);
          lookup = FS.lookupPath(path, { follow: !dontResolveLastLink });
          ret.exists = true;
          ret.path = lookup.path;
          ret.object = lookup.node;
          ret.name = lookup.node.name;
          ret.isRoot = lookup.path === '/';
        } catch (e) {
          ret.error = e.errno;
        };
        return ret;
      },createFolder:function (parent, name, canRead, canWrite) {
        var path = PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name);
        var mode = FS.getMode(canRead, canWrite);
        return FS.mkdir(path, mode);
      },createPath:function (parent, path, canRead, canWrite) {
        parent = typeof parent === 'string' ? parent : FS.getPath(parent);
        var parts = path.split('/').reverse();
        while (parts.length) {
          var part = parts.pop();
          if (!part) continue;
          var current = PATH.join2(parent, part);
          try {
            FS.mkdir(current);
          } catch (e) {
            // ignore EEXIST
          }
          parent = current;
        }
        return current;
      },createFile:function (parent, name, properties, canRead, canWrite) {
        var path = PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name);
        var mode = FS.getMode(canRead, canWrite);
        return FS.create(path, mode);
      },createDataFile:function (parent, name, data, canRead, canWrite, canOwn) {
        var path = name ? PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name) : parent;
        var mode = FS.getMode(canRead, canWrite);
        var node = FS.create(path, mode);
        if (data) {
          if (typeof data === 'string') {
            var arr = new Array(data.length);
            for (var i = 0, len = data.length; i < len; ++i) arr[i] = data.charCodeAt(i);
            data = arr;
          }
          // make sure we can write to the file
          FS.chmod(node, mode | 146);
          var stream = FS.open(node, 'w');
          FS.write(stream, data, 0, data.length, 0, canOwn);
          FS.close(stream);
          FS.chmod(node, mode);
        }
        return node;
      },createDevice:function (parent, name, input, output) {
        var path = PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name);
        var mode = FS.getMode(!!input, !!output);
        if (!FS.createDevice.major) FS.createDevice.major = 64;
        var dev = FS.makedev(FS.createDevice.major++, 0);
        // Create a fake device that a set of stream ops to emulate
        // the old behavior.
        FS.registerDevice(dev, {
          open: function(stream) {
            stream.seekable = false;
          },
          close: function(stream) {
            // flush any pending line data
            if (output && output.buffer && output.buffer.length) {
              output(10);
            }
          },
          read: function(stream, buffer, offset, length, pos /* ignored */) {
            var bytesRead = 0;
            for (var i = 0; i < length; i++) {
              var result;
              try {
                result = input();
              } catch (e) {
                throw new FS.ErrnoError(ERRNO_CODES.EIO);
              }
              if (result === undefined && bytesRead === 0) {
                throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
              }
              if (result === null || result === undefined) break;
              bytesRead++;
              buffer[offset+i] = result;
            }
            if (bytesRead) {
              stream.node.timestamp = Date.now();
            }
            return bytesRead;
          },
          write: function(stream, buffer, offset, length, pos) {
            for (var i = 0; i < length; i++) {
              try {
                output(buffer[offset+i]);
              } catch (e) {
                throw new FS.ErrnoError(ERRNO_CODES.EIO);
              }
            }
            if (length) {
              stream.node.timestamp = Date.now();
            }
            return i;
          }
        });
        return FS.mkdev(path, mode, dev);
      },createLink:function (parent, name, target, canRead, canWrite) {
        var path = PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name);
        return FS.symlink(target, path);
      },forceLoadFile:function (obj) {
        if (obj.isDevice || obj.isFolder || obj.link || obj.contents) return true;
        var success = true;
        if (typeof XMLHttpRequest !== 'undefined') {
          throw new Error("Lazy loading should have been performed (contents set) in createLazyFile, but it was not. Lazy loading only works in web workers. Use --embed-file or --preload-file in emcc on the main thread.");
        } else if (Module['read']) {
          // Command-line.
          try {
            // WARNING: Can't read binary files in V8's d8 or tracemonkey's js, as
            //          read() will try to parse UTF8.
            obj.contents = intArrayFromString(Module['read'](obj.url), true);
          } catch (e) {
            success = false;
          }
        } else {
          throw new Error('Cannot load without read() or XMLHttpRequest.');
        }
        if (!success) ___setErrNo(ERRNO_CODES.EIO);
        return success;
      },createLazyFile:function (parent, name, url, canRead, canWrite) {
        if (typeof XMLHttpRequest !== 'undefined') {
          if (!ENVIRONMENT_IS_WORKER) throw 'Cannot do synchronous binary XHRs outside webworkers in modern browsers. Use --embed-file or --preload-file in emcc';
          // Lazy chunked Uint8Array (implements get and length from Uint8Array). Actual getting is abstracted away for eventual reuse.
          function LazyUint8Array() {
            this.lengthKnown = false;
            this.chunks = []; // Loaded chunks. Index is the chunk number
          }
          LazyUint8Array.prototype.get = function LazyUint8Array_get(idx) {
            if (idx > this.length-1 || idx < 0) {
              return undefined;
            }
            var chunkOffset = idx % this.chunkSize;
            var chunkNum = Math.floor(idx / this.chunkSize);
            return this.getter(chunkNum)[chunkOffset];
          }
          LazyUint8Array.prototype.setDataGetter = function LazyUint8Array_setDataGetter(getter) {
            this.getter = getter;
          }
          LazyUint8Array.prototype.cacheLength = function LazyUint8Array_cacheLength() {
              // Find length
              var xhr = new XMLHttpRequest();
              xhr.open('HEAD', url, false);
              xhr.send(null);
              if (!(xhr.status >= 200 && xhr.status < 300 || xhr.status === 304)) throw new Error("Couldn't load " + url + ". Status: " + xhr.status);
              var datalength = Number(xhr.getResponseHeader("Content-length"));
              var header;
              var hasByteServing = (header = xhr.getResponseHeader("Accept-Ranges")) && header === "bytes";
              var chunkSize = 1024*1024; // Chunk size in bytes
  
              if (!hasByteServing) chunkSize = datalength;
  
              // Function to get a range from the remote URL.
              var doXHR = (function(from, to) {
                if (from > to) throw new Error("invalid range (" + from + ", " + to + ") or no bytes requested!");
                if (to > datalength-1) throw new Error("only " + datalength + " bytes available! programmer error!");
  
                // TODO: Use mozResponseArrayBuffer, responseStream, etc. if available.
                var xhr = new XMLHttpRequest();
                xhr.open('GET', url, false);
                if (datalength !== chunkSize) xhr.setRequestHeader("Range", "bytes=" + from + "-" + to);
  
                // Some hints to the browser that we want binary data.
                if (typeof Uint8Array != 'undefined') xhr.responseType = 'arraybuffer';
                if (xhr.overrideMimeType) {
                  xhr.overrideMimeType('text/plain; charset=x-user-defined');
                }
  
                xhr.send(null);
                if (!(xhr.status >= 200 && xhr.status < 300 || xhr.status === 304)) throw new Error("Couldn't load " + url + ". Status: " + xhr.status);
                if (xhr.response !== undefined) {
                  return new Uint8Array(xhr.response || []);
                } else {
                  return intArrayFromString(xhr.responseText || '', true);
                }
              });
              var lazyArray = this;
              lazyArray.setDataGetter(function(chunkNum) {
                var start = chunkNum * chunkSize;
                var end = (chunkNum+1) * chunkSize - 1; // including this byte
                end = Math.min(end, datalength-1); // if datalength-1 is selected, this is the last block
                if (typeof(lazyArray.chunks[chunkNum]) === "undefined") {
                  lazyArray.chunks[chunkNum] = doXHR(start, end);
                }
                if (typeof(lazyArray.chunks[chunkNum]) === "undefined") throw new Error("doXHR failed!");
                return lazyArray.chunks[chunkNum];
              });
  
              this._length = datalength;
              this._chunkSize = chunkSize;
              this.lengthKnown = true;
          }
  
          var lazyArray = new LazyUint8Array();
          Object.defineProperty(lazyArray, "length", {
              get: function() {
                  if(!this.lengthKnown) {
                      this.cacheLength();
                  }
                  return this._length;
              }
          });
          Object.defineProperty(lazyArray, "chunkSize", {
              get: function() {
                  if(!this.lengthKnown) {
                      this.cacheLength();
                  }
                  return this._chunkSize;
              }
          });
  
          var properties = { isDevice: false, contents: lazyArray };
        } else {
          var properties = { isDevice: false, url: url };
        }
  
        var node = FS.createFile(parent, name, properties, canRead, canWrite);
        // This is a total hack, but I want to get this lazy file code out of the
        // core of MEMFS. If we want to keep this lazy file concept I feel it should
        // be its own thin LAZYFS proxying calls to MEMFS.
        if (properties.contents) {
          node.contents = properties.contents;
        } else if (properties.url) {
          node.contents = null;
          node.url = properties.url;
        }
        // override each stream op with one that tries to force load the lazy file first
        var stream_ops = {};
        var keys = Object.keys(node.stream_ops);
        keys.forEach(function(key) {
          var fn = node.stream_ops[key];
          stream_ops[key] = function forceLoadLazyFile() {
            if (!FS.forceLoadFile(node)) {
              throw new FS.ErrnoError(ERRNO_CODES.EIO);
            }
            return fn.apply(null, arguments);
          };
        });
        // use a custom read function
        stream_ops.read = function stream_ops_read(stream, buffer, offset, length, position) {
          if (!FS.forceLoadFile(node)) {
            throw new FS.ErrnoError(ERRNO_CODES.EIO);
          }
          var contents = stream.node.contents;
          if (position >= contents.length)
            return 0;
          var size = Math.min(contents.length - position, length);
          assert(size >= 0);
          if (contents.slice) { // normal array
            for (var i = 0; i < size; i++) {
              buffer[offset + i] = contents[position + i];
            }
          } else {
            for (var i = 0; i < size; i++) { // LazyUint8Array from sync binary XHR
              buffer[offset + i] = contents.get(position + i);
            }
          }
          return size;
        };
        node.stream_ops = stream_ops;
        return node;
      },createPreloadedFile:function (parent, name, url, canRead, canWrite, onload, onerror, dontCreateFile, canOwn) {
        Browser.init();
        // TODO we should allow people to just pass in a complete filename instead
        // of parent and name being that we just join them anyways
        var fullname = name ? PATH.resolve(PATH.join2(parent, name)) : parent;
        function processData(byteArray) {
          function finish(byteArray) {
            if (!dontCreateFile) {
              FS.createDataFile(parent, name, byteArray, canRead, canWrite, canOwn);
            }
            if (onload) onload();
            removeRunDependency('cp ' + fullname);
          }
          var handled = false;
          Module['preloadPlugins'].forEach(function(plugin) {
            if (handled) return;
            if (plugin['canHandle'](fullname)) {
              plugin['handle'](byteArray, fullname, finish, function() {
                if (onerror) onerror();
                removeRunDependency('cp ' + fullname);
              });
              handled = true;
            }
          });
          if (!handled) finish(byteArray);
        }
        addRunDependency('cp ' + fullname);
        if (typeof url == 'string') {
          Browser.asyncLoad(url, function(byteArray) {
            processData(byteArray);
          }, onerror);
        } else {
          processData(url);
        }
      },indexedDB:function () {
        return window.indexedDB || window.mozIndexedDB || window.webkitIndexedDB || window.msIndexedDB;
      },DB_NAME:function () {
        return 'EM_FS_' + window.location.pathname;
      },DB_VERSION:20,DB_STORE_NAME:"FILE_DATA",saveFilesToDB:function (paths, onload, onerror) {
        onload = onload || function(){};
        onerror = onerror || function(){};
        var indexedDB = FS.indexedDB();
        try {
          var openRequest = indexedDB.open(FS.DB_NAME(), FS.DB_VERSION);
        } catch (e) {
          return onerror(e);
        }
        openRequest.onupgradeneeded = function openRequest_onupgradeneeded() {
          console.log('creating db');
          var db = openRequest.result;
          db.createObjectStore(FS.DB_STORE_NAME);
        };
        openRequest.onsuccess = function openRequest_onsuccess() {
          var db = openRequest.result;
          var transaction = db.transaction([FS.DB_STORE_NAME], 'readwrite');
          var files = transaction.objectStore(FS.DB_STORE_NAME);
          var ok = 0, fail = 0, total = paths.length;
          function finish() {
            if (fail == 0) onload(); else onerror();
          }
          paths.forEach(function(path) {
            var putRequest = files.put(FS.analyzePath(path).object.contents, path);
            putRequest.onsuccess = function putRequest_onsuccess() { ok++; if (ok + fail == total) finish() };
            putRequest.onerror = function putRequest_onerror() { fail++; if (ok + fail == total) finish() };
          });
          transaction.onerror = onerror;
        };
        openRequest.onerror = onerror;
      },loadFilesFromDB:function (paths, onload, onerror) {
        onload = onload || function(){};
        onerror = onerror || function(){};
        var indexedDB = FS.indexedDB();
        try {
          var openRequest = indexedDB.open(FS.DB_NAME(), FS.DB_VERSION);
        } catch (e) {
          return onerror(e);
        }
        openRequest.onupgradeneeded = onerror; // no database to load from
        openRequest.onsuccess = function openRequest_onsuccess() {
          var db = openRequest.result;
          try {
            var transaction = db.transaction([FS.DB_STORE_NAME], 'readonly');
          } catch(e) {
            onerror(e);
            return;
          }
          var files = transaction.objectStore(FS.DB_STORE_NAME);
          var ok = 0, fail = 0, total = paths.length;
          function finish() {
            if (fail == 0) onload(); else onerror();
          }
          paths.forEach(function(path) {
            var getRequest = files.get(path);
            getRequest.onsuccess = function getRequest_onsuccess() {
              if (FS.analyzePath(path).exists) {
                FS.unlink(path);
              }
              FS.createDataFile(PATH.dirname(path), PATH.basename(path), getRequest.result, true, true, true);
              ok++;
              if (ok + fail == total) finish();
            };
            getRequest.onerror = function getRequest_onerror() { fail++; if (ok + fail == total) finish() };
          });
          transaction.onerror = onerror;
        };
        openRequest.onerror = onerror;
      }};
  
  var Browser={mainLoop:{scheduler:null,method:"",shouldPause:false,paused:false,queue:[],pause:function () {
          Browser.mainLoop.shouldPause = true;
        },resume:function () {
          if (Browser.mainLoop.paused) {
            Browser.mainLoop.paused = false;
            Browser.mainLoop.scheduler();
          }
          Browser.mainLoop.shouldPause = false;
        },updateStatus:function () {
          if (Module['setStatus']) {
            var message = Module['statusMessage'] || 'Please wait...';
            var remaining = Browser.mainLoop.remainingBlockers;
            var expected = Browser.mainLoop.expectedBlockers;
            if (remaining) {
              if (remaining < expected) {
                Module['setStatus'](message + ' (' + (expected - remaining) + '/' + expected + ')');
              } else {
                Module['setStatus'](message);
              }
            } else {
              Module['setStatus']('');
            }
          }
        }},isFullScreen:false,pointerLock:false,moduleContextCreatedCallbacks:[],workers:[],init:function () {
        if (!Module["preloadPlugins"]) Module["preloadPlugins"] = []; // needs to exist even in workers
  
        if (Browser.initted || ENVIRONMENT_IS_WORKER) return;
        Browser.initted = true;
  
        try {
          new Blob();
          Browser.hasBlobConstructor = true;
        } catch(e) {
          Browser.hasBlobConstructor = false;
          console.log("warning: no blob constructor, cannot create blobs with mimetypes");
        }
        Browser.BlobBuilder = typeof MozBlobBuilder != "undefined" ? MozBlobBuilder : (typeof WebKitBlobBuilder != "undefined" ? WebKitBlobBuilder : (!Browser.hasBlobConstructor ? console.log("warning: no BlobBuilder") : null));
        Browser.URLObject = typeof window != "undefined" ? (window.URL ? window.URL : window.webkitURL) : undefined;
        if (!Module.noImageDecoding && typeof Browser.URLObject === 'undefined') {
          console.log("warning: Browser does not support creating object URLs. Built-in browser image decoding will not be available.");
          Module.noImageDecoding = true;
        }
  
        // Support for plugins that can process preloaded files. You can add more of these to
        // your app by creating and appending to Module.preloadPlugins.
        //
        // Each plugin is asked if it can handle a file based on the file's name. If it can,
        // it is given the file's raw data. When it is done, it calls a callback with the file's
        // (possibly modified) data. For example, a plugin might decompress a file, or it
        // might create some side data structure for use later (like an Image element, etc.).
  
        var imagePlugin = {};
        imagePlugin['canHandle'] = function imagePlugin_canHandle(name) {
          return !Module.noImageDecoding && /\.(jpg|jpeg|png|bmp)$/i.test(name);
        };
        imagePlugin['handle'] = function imagePlugin_handle(byteArray, name, onload, onerror) {
          var b = null;
          if (Browser.hasBlobConstructor) {
            try {
              b = new Blob([byteArray], { type: Browser.getMimetype(name) });
              if (b.size !== byteArray.length) { // Safari bug #118630
                // Safari's Blob can only take an ArrayBuffer
                b = new Blob([(new Uint8Array(byteArray)).buffer], { type: Browser.getMimetype(name) });
              }
            } catch(e) {
              Runtime.warnOnce('Blob constructor present but fails: ' + e + '; falling back to blob builder');
            }
          }
          if (!b) {
            var bb = new Browser.BlobBuilder();
            bb.append((new Uint8Array(byteArray)).buffer); // we need to pass a buffer, and must copy the array to get the right data range
            b = bb.getBlob();
          }
          var url = Browser.URLObject.createObjectURL(b);
          var img = new Image();
          img.onload = function img_onload() {
            assert(img.complete, 'Image ' + name + ' could not be decoded');
            var canvas = document.createElement('canvas');
            canvas.width = img.width;
            canvas.height = img.height;
            var ctx = canvas.getContext('2d');
            ctx.drawImage(img, 0, 0);
            Module["preloadedImages"][name] = canvas;
            Browser.URLObject.revokeObjectURL(url);
            if (onload) onload(byteArray);
          };
          img.onerror = function img_onerror(event) {
            console.log('Image ' + url + ' could not be decoded');
            if (onerror) onerror();
          };
          img.src = url;
        };
        Module['preloadPlugins'].push(imagePlugin);
  
        var audioPlugin = {};
        audioPlugin['canHandle'] = function audioPlugin_canHandle(name) {
          return !Module.noAudioDecoding && name.substr(-4) in { '.ogg': 1, '.wav': 1, '.mp3': 1 };
        };
        audioPlugin['handle'] = function audioPlugin_handle(byteArray, name, onload, onerror) {
          var done = false;
          function finish(audio) {
            if (done) return;
            done = true;
            Module["preloadedAudios"][name] = audio;
            if (onload) onload(byteArray);
          }
          function fail() {
            if (done) return;
            done = true;
            Module["preloadedAudios"][name] = new Audio(); // empty shim
            if (onerror) onerror();
          }
          if (Browser.hasBlobConstructor) {
            try {
              var b = new Blob([byteArray], { type: Browser.getMimetype(name) });
            } catch(e) {
              return fail();
            }
            var url = Browser.URLObject.createObjectURL(b); // XXX we never revoke this!
            var audio = new Audio();
            audio.addEventListener('canplaythrough', function() { finish(audio) }, false); // use addEventListener due to chromium bug 124926
            audio.onerror = function audio_onerror(event) {
              if (done) return;
              console.log('warning: browser could not fully decode audio ' + name + ', trying slower base64 approach');
              function encode64(data) {
                var BASE = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/';
                var PAD = '=';
                var ret = '';
                var leftchar = 0;
                var leftbits = 0;
                for (var i = 0; i < data.length; i++) {
                  leftchar = (leftchar << 8) | data[i];
                  leftbits += 8;
                  while (leftbits >= 6) {
                    var curr = (leftchar >> (leftbits-6)) & 0x3f;
                    leftbits -= 6;
                    ret += BASE[curr];
                  }
                }
                if (leftbits == 2) {
                  ret += BASE[(leftchar&3) << 4];
                  ret += PAD + PAD;
                } else if (leftbits == 4) {
                  ret += BASE[(leftchar&0xf) << 2];
                  ret += PAD;
                }
                return ret;
              }
              audio.src = 'data:audio/x-' + name.substr(-3) + ';base64,' + encode64(byteArray);
              finish(audio); // we don't wait for confirmation this worked - but it's worth trying
            };
            audio.src = url;
            // workaround for chrome bug 124926 - we do not always get oncanplaythrough or onerror
            Browser.safeSetTimeout(function() {
              finish(audio); // try to use it even though it is not necessarily ready to play
            }, 10000);
          } else {
            return fail();
          }
        };
        Module['preloadPlugins'].push(audioPlugin);
  
        // Canvas event setup
  
        var canvas = Module['canvas'];
        canvas.requestPointerLock = canvas['requestPointerLock'] ||
                                    canvas['mozRequestPointerLock'] ||
                                    canvas['webkitRequestPointerLock'];
        canvas.exitPointerLock = document['exitPointerLock'] ||
                                 document['mozExitPointerLock'] ||
                                 document['webkitExitPointerLock'] ||
                                 function(){}; // no-op if function does not exist
        canvas.exitPointerLock = canvas.exitPointerLock.bind(document);
  
        function pointerLockChange() {
          Browser.pointerLock = document['pointerLockElement'] === canvas ||
                                document['mozPointerLockElement'] === canvas ||
                                document['webkitPointerLockElement'] === canvas;
        }
  
        document.addEventListener('pointerlockchange', pointerLockChange, false);
        document.addEventListener('mozpointerlockchange', pointerLockChange, false);
        document.addEventListener('webkitpointerlockchange', pointerLockChange, false);
  
        if (Module['elementPointerLock']) {
          canvas.addEventListener("click", function(ev) {
            if (!Browser.pointerLock && canvas.requestPointerLock) {
              canvas.requestPointerLock();
              ev.preventDefault();
            }
          }, false);
        }
      },createContext:function (canvas, useWebGL, setInModule, webGLContextAttributes) {
        var ctx;
        var errorInfo = '?';
        function onContextCreationError(event) {
          errorInfo = event.statusMessage || errorInfo;
        }
        try {
          if (useWebGL) {
            var contextAttributes = {
              antialias: false,
              alpha: false
            };
  
            if (webGLContextAttributes) {
              for (var attribute in webGLContextAttributes) {
                contextAttributes[attribute] = webGLContextAttributes[attribute];
              }
            }
  
  
            canvas.addEventListener('webglcontextcreationerror', onContextCreationError, false);
            try {
              ['experimental-webgl', 'webgl'].some(function(webglId) {
                return ctx = canvas.getContext(webglId, contextAttributes);
              });
            } finally {
              canvas.removeEventListener('webglcontextcreationerror', onContextCreationError, false);
            }
          } else {
            ctx = canvas.getContext('2d');
          }
          if (!ctx) throw ':(';
        } catch (e) {
          Module.print('Could not create canvas: ' + [errorInfo, e]);
          return null;
        }
        if (useWebGL) {
          // Set the background of the WebGL canvas to black
          canvas.style.backgroundColor = "black";
  
          // Warn on context loss
          canvas.addEventListener('webglcontextlost', function(event) {
            alert('WebGL context lost. You will need to reload the page.');
          }, false);
        }
        if (setInModule) {
          GLctx = Module.ctx = ctx;
          Module.useWebGL = useWebGL;
          Browser.moduleContextCreatedCallbacks.forEach(function(callback) { callback() });
          Browser.init();
        }
        return ctx;
      },destroyContext:function (canvas, useWebGL, setInModule) {},fullScreenHandlersInstalled:false,lockPointer:undefined,resizeCanvas:undefined,requestFullScreen:function (lockPointer, resizeCanvas) {
        Browser.lockPointer = lockPointer;
        Browser.resizeCanvas = resizeCanvas;
        if (typeof Browser.lockPointer === 'undefined') Browser.lockPointer = true;
        if (typeof Browser.resizeCanvas === 'undefined') Browser.resizeCanvas = false;
  
        var canvas = Module['canvas'];
        function fullScreenChange() {
          Browser.isFullScreen = false;
          if ((document['webkitFullScreenElement'] || document['webkitFullscreenElement'] ||
               document['mozFullScreenElement'] || document['mozFullscreenElement'] ||
               document['fullScreenElement'] || document['fullscreenElement']) === canvas) {
            canvas.cancelFullScreen = document['cancelFullScreen'] ||
                                      document['mozCancelFullScreen'] ||
                                      document['webkitCancelFullScreen'];
            canvas.cancelFullScreen = canvas.cancelFullScreen.bind(document);
            if (Browser.lockPointer) canvas.requestPointerLock();
            Browser.isFullScreen = true;
            if (Browser.resizeCanvas) Browser.setFullScreenCanvasSize();
          } else if (Browser.resizeCanvas){
            Browser.setWindowedCanvasSize();
          }
          if (Module['onFullScreen']) Module['onFullScreen'](Browser.isFullScreen);
        }
  
        if (!Browser.fullScreenHandlersInstalled) {
          Browser.fullScreenHandlersInstalled = true;
          document.addEventListener('fullscreenchange', fullScreenChange, false);
          document.addEventListener('mozfullscreenchange', fullScreenChange, false);
          document.addEventListener('webkitfullscreenchange', fullScreenChange, false);
        }
  
        canvas.requestFullScreen = canvas['requestFullScreen'] ||
                                   canvas['mozRequestFullScreen'] ||
                                   (canvas['webkitRequestFullScreen'] ? function() { canvas['webkitRequestFullScreen'](Element['ALLOW_KEYBOARD_INPUT']) } : null);
        canvas.requestFullScreen();
      },requestAnimationFrame:function requestAnimationFrame(func) {
        if (typeof window === 'undefined') { // Provide fallback to setTimeout if window is undefined (e.g. in Node.js)
          setTimeout(func, 1000/60);
        } else {
          if (!window.requestAnimationFrame) {
            window.requestAnimationFrame = window['requestAnimationFrame'] ||
                                           window['mozRequestAnimationFrame'] ||
                                           window['webkitRequestAnimationFrame'] ||
                                           window['msRequestAnimationFrame'] ||
                                           window['oRequestAnimationFrame'] ||
                                           window['setTimeout'];
          }
          window.requestAnimationFrame(func);
        }
      },safeCallback:function (func) {
        return function() {
          if (!ABORT) return func.apply(null, arguments);
        };
      },safeRequestAnimationFrame:function (func) {
        return Browser.requestAnimationFrame(function() {
          if (!ABORT) func();
        });
      },safeSetTimeout:function (func, timeout) {
        return setTimeout(function() {
          if (!ABORT) func();
        }, timeout);
      },safeSetInterval:function (func, timeout) {
        return setInterval(function() {
          if (!ABORT) func();
        }, timeout);
      },getMimetype:function (name) {
        return {
          'jpg': 'image/jpeg',
          'jpeg': 'image/jpeg',
          'png': 'image/png',
          'bmp': 'image/bmp',
          'ogg': 'audio/ogg',
          'wav': 'audio/wav',
          'mp3': 'audio/mpeg'
        }[name.substr(name.lastIndexOf('.')+1)];
      },getUserMedia:function (func) {
        if(!window.getUserMedia) {
          window.getUserMedia = navigator['getUserMedia'] ||
                                navigator['mozGetUserMedia'];
        }
        window.getUserMedia(func);
      },getMovementX:function (event) {
        return event['movementX'] ||
               event['mozMovementX'] ||
               event['webkitMovementX'] ||
               0;
      },getMovementY:function (event) {
        return event['movementY'] ||
               event['mozMovementY'] ||
               event['webkitMovementY'] ||
               0;
      },getMouseWheelDelta:function (event) {
        return Math.max(-1, Math.min(1, event.type === 'DOMMouseScroll' ? event.detail : -event.wheelDelta));
      },mouseX:0,mouseY:0,mouseMovementX:0,mouseMovementY:0,calculateMouseEvent:function (event) { // event should be mousemove, mousedown or mouseup
        if (Browser.pointerLock) {
          // When the pointer is locked, calculate the coordinates
          // based on the movement of the mouse.
          // Workaround for Firefox bug 764498
          if (event.type != 'mousemove' &&
              ('mozMovementX' in event)) {
            Browser.mouseMovementX = Browser.mouseMovementY = 0;
          } else {
            Browser.mouseMovementX = Browser.getMovementX(event);
            Browser.mouseMovementY = Browser.getMovementY(event);
          }
          
          // check if SDL is available
          if (typeof SDL != "undefined") {
          	Browser.mouseX = SDL.mouseX + Browser.mouseMovementX;
          	Browser.mouseY = SDL.mouseY + Browser.mouseMovementY;
          } else {
          	// just add the mouse delta to the current absolut mouse position
          	// FIXME: ideally this should be clamped against the canvas size and zero
          	Browser.mouseX += Browser.mouseMovementX;
          	Browser.mouseY += Browser.mouseMovementY;
          }        
        } else {
          // Otherwise, calculate the movement based on the changes
          // in the coordinates.
          var rect = Module["canvas"].getBoundingClientRect();
          var x, y;
          
          // Neither .scrollX or .pageXOffset are defined in a spec, but
          // we prefer .scrollX because it is currently in a spec draft.
          // (see: http://www.w3.org/TR/2013/WD-cssom-view-20131217/)
          var scrollX = ((typeof window.scrollX !== 'undefined') ? window.scrollX : window.pageXOffset);
          var scrollY = ((typeof window.scrollY !== 'undefined') ? window.scrollY : window.pageYOffset);
          if (event.type == 'touchstart' ||
              event.type == 'touchend' ||
              event.type == 'touchmove') {
            var t = event.touches.item(0);
            if (t) {
              x = t.pageX - (scrollX + rect.left);
              y = t.pageY - (scrollY + rect.top);
            } else {
              return;
            }
          } else {
            x = event.pageX - (scrollX + rect.left);
            y = event.pageY - (scrollY + rect.top);
          }
  
          // the canvas might be CSS-scaled compared to its backbuffer;
          // SDL-using content will want mouse coordinates in terms
          // of backbuffer units.
          var cw = Module["canvas"].width;
          var ch = Module["canvas"].height;
          x = x * (cw / rect.width);
          y = y * (ch / rect.height);
  
          Browser.mouseMovementX = x - Browser.mouseX;
          Browser.mouseMovementY = y - Browser.mouseY;
          Browser.mouseX = x;
          Browser.mouseY = y;
        }
      },xhrLoad:function (url, onload, onerror) {
        var xhr = new XMLHttpRequest();
        xhr.open('GET', url, true);
        xhr.responseType = 'arraybuffer';
        xhr.onload = function xhr_onload() {
          if (xhr.status == 200 || (xhr.status == 0 && xhr.response)) { // file URLs can return 0
            onload(xhr.response);
          } else {
            onerror();
          }
        };
        xhr.onerror = onerror;
        xhr.send(null);
      },asyncLoad:function (url, onload, onerror, noRunDep) {
        Browser.xhrLoad(url, function(arrayBuffer) {
          assert(arrayBuffer, 'Loading data file "' + url + '" failed (no arrayBuffer).');
          onload(new Uint8Array(arrayBuffer));
          if (!noRunDep) removeRunDependency('al ' + url);
        }, function(event) {
          if (onerror) {
            onerror();
          } else {
            throw 'Loading data file "' + url + '" failed.';
          }
        });
        if (!noRunDep) addRunDependency('al ' + url);
      },resizeListeners:[],updateResizeListeners:function () {
        var canvas = Module['canvas'];
        Browser.resizeListeners.forEach(function(listener) {
          listener(canvas.width, canvas.height);
        });
      },setCanvasSize:function (width, height, noUpdates) {
        var canvas = Module['canvas'];
        canvas.width = width;
        canvas.height = height;
        if (!noUpdates) Browser.updateResizeListeners();
      },windowedWidth:0,windowedHeight:0,setFullScreenCanvasSize:function () {
        var canvas = Module['canvas'];
        this.windowedWidth = canvas.width;
        this.windowedHeight = canvas.height;
        canvas.width = screen.width;
        canvas.height = screen.height;
        // check if SDL is available   
        if (typeof SDL != "undefined") {
        	var flags = HEAPU32[((SDL.screen+Runtime.QUANTUM_SIZE*0)>>2)];
        	flags = flags | 0x00800000; // set SDL_FULLSCREEN flag
        	HEAP32[((SDL.screen+Runtime.QUANTUM_SIZE*0)>>2)]=flags
        }
        Browser.updateResizeListeners();
      },setWindowedCanvasSize:function () {
        var canvas = Module['canvas'];
        canvas.width = this.windowedWidth;
        canvas.height = this.windowedHeight;
        // check if SDL is available       
        if (typeof SDL != "undefined") {
        	var flags = HEAPU32[((SDL.screen+Runtime.QUANTUM_SIZE*0)>>2)];
        	flags = flags & ~0x00800000; // clear SDL_FULLSCREEN flag
        	HEAP32[((SDL.screen+Runtime.QUANTUM_SIZE*0)>>2)]=flags
        }
        Browser.updateResizeListeners();
      }};var SDL={defaults:{width:320,height:200,copyOnLock:true},version:null,surfaces:{},canvasPool:[],events:[],fonts:[null],audios:[null],rwops:[null],music:{audio:null,volume:1},mixerFrequency:22050,mixerFormat:32784,mixerNumChannels:2,mixerChunkSize:1024,channelMinimumNumber:0,GL:false,glAttributes:{0:3,1:3,2:2,3:0,4:0,5:1,6:16,7:0,8:0,9:0,10:0,11:0,12:0,13:0,14:0,15:1,16:0,17:0,18:0},keyboardState:null,keyboardMap:{},canRequestFullscreen:false,isRequestingFullscreen:false,textInput:false,startTime:null,initFlags:0,buttonState:0,modState:0,DOMButtons:[0,0,0],DOMEventToSDLEvent:{},keyCodes:{16:1249,17:1248,18:1250,33:1099,34:1102,37:1104,38:1106,39:1103,40:1105,46:127,96:1112,97:1113,98:1114,99:1115,100:1116,101:1117,102:1118,103:1119,104:1120,105:1121,112:1082,113:1083,114:1084,115:1085,116:1086,117:1087,118:1088,119:1089,120:1090,121:1091,122:1092,123:1093,173:45,188:44,190:46,191:47,192:96},scanCodes:{8:42,9:43,13:40,27:41,32:44,44:54,46:55,47:56,48:39,49:30,50:31,51:32,52:33,53:34,54:35,55:36,56:37,57:38,59:51,61:46,91:47,92:49,93:48,96:52,97:4,98:5,99:6,100:7,101:8,102:9,103:10,104:11,105:12,106:13,107:14,108:15,109:16,110:17,111:18,112:19,113:20,114:21,115:22,116:23,117:24,118:25,119:26,120:27,121:28,122:29,305:224,308:226},loadRect:function (rect) {
        return {
          x: HEAP32[((rect + 0)>>2)],
          y: HEAP32[((rect + 4)>>2)],
          w: HEAP32[((rect + 8)>>2)],
          h: HEAP32[((rect + 12)>>2)]
        };
      },loadColorToCSSRGB:function (color) {
        var rgba = HEAP32[((color)>>2)];
        return 'rgb(' + (rgba&255) + ',' + ((rgba >> 8)&255) + ',' + ((rgba >> 16)&255) + ')';
      },loadColorToCSSRGBA:function (color) {
        var rgba = HEAP32[((color)>>2)];
        return 'rgba(' + (rgba&255) + ',' + ((rgba >> 8)&255) + ',' + ((rgba >> 16)&255) + ',' + (((rgba >> 24)&255)/255) + ')';
      },translateColorToCSSRGBA:function (rgba) {
        return 'rgba(' + (rgba&0xff) + ',' + (rgba>>8 & 0xff) + ',' + (rgba>>16 & 0xff) + ',' + (rgba>>>24)/0xff + ')';
      },translateRGBAToCSSRGBA:function (r, g, b, a) {
        return 'rgba(' + (r&0xff) + ',' + (g&0xff) + ',' + (b&0xff) + ',' + (a&0xff)/255 + ')';
      },translateRGBAToColor:function (r, g, b, a) {
        return r | g << 8 | b << 16 | a << 24;
      },makeSurface:function (width, height, flags, usePageCanvas, source, rmask, gmask, bmask, amask) {
        flags = flags || 0;
        var is_SDL_HWSURFACE = flags & 0x00000001;
        var is_SDL_HWPALETTE = flags & 0x00200000;
        var is_SDL_OPENGL = flags & 0x04000000;
  
        var surf = _malloc(60);
        var pixelFormat = _malloc(44);
        //surface with SDL_HWPALETTE flag is 8bpp surface (1 byte)
        var bpp = is_SDL_HWPALETTE ? 1 : 4;
        var buffer = 0;
  
        // preemptively initialize this for software surfaces,
        // otherwise it will be lazily initialized inside of SDL_LockSurface
        if (!is_SDL_HWSURFACE && !is_SDL_OPENGL) {
          buffer = _malloc(width * height * 4);
        }
  
        HEAP32[((surf)>>2)]=flags;
        HEAP32[(((surf)+(4))>>2)]=pixelFormat;
        HEAP32[(((surf)+(8))>>2)]=width;
        HEAP32[(((surf)+(12))>>2)]=height;
        HEAP32[(((surf)+(16))>>2)]=width * bpp;  // assuming RGBA or indexed for now,
                                                                                          // since that is what ImageData gives us in browsers
        HEAP32[(((surf)+(20))>>2)]=buffer;
        HEAP32[(((surf)+(36))>>2)]=0;
        HEAP32[(((surf)+(56))>>2)]=1;
  
        HEAP32[((pixelFormat)>>2)]=0 /* XXX missing C define SDL_PIXELFORMAT_RGBA8888 */;
        HEAP32[(((pixelFormat)+(4))>>2)]=0;// TODO
        HEAP8[(((pixelFormat)+(8))|0)]=bpp * 8;
        HEAP8[(((pixelFormat)+(9))|0)]=bpp;
  
        HEAP32[(((pixelFormat)+(12))>>2)]=rmask || 0x000000ff;
        HEAP32[(((pixelFormat)+(16))>>2)]=gmask || 0x0000ff00;
        HEAP32[(((pixelFormat)+(20))>>2)]=bmask || 0x00ff0000;
        HEAP32[(((pixelFormat)+(24))>>2)]=amask || 0xff000000;
  
        // Decide if we want to use WebGL or not
        SDL.GL = SDL.GL || is_SDL_OPENGL;
        var canvas;
        if (!usePageCanvas) {
          if (SDL.canvasPool.length > 0) {
            canvas = SDL.canvasPool.pop();
          } else {
            canvas = document.createElement('canvas');
          }
          canvas.width = width;
          canvas.height = height;
        } else {
          canvas = Module['canvas'];
        }
  
        var webGLContextAttributes = {
          antialias: ((SDL.glAttributes[13 /*SDL_GL_MULTISAMPLEBUFFERS*/] != 0) && (SDL.glAttributes[14 /*SDL_GL_MULTISAMPLESAMPLES*/] > 1)),
          depth: (SDL.glAttributes[6 /*SDL_GL_DEPTH_SIZE*/] > 0),
          stencil: (SDL.glAttributes[7 /*SDL_GL_STENCIL_SIZE*/] > 0)
        };
        
        var ctx = Browser.createContext(canvas, is_SDL_OPENGL, usePageCanvas, webGLContextAttributes);
              
        SDL.surfaces[surf] = {
          width: width,
          height: height,
          canvas: canvas,
          ctx: ctx,
          surf: surf,
          buffer: buffer,
          pixelFormat: pixelFormat,
          alpha: 255,
          flags: flags,
          locked: 0,
          usePageCanvas: usePageCanvas,
          source: source,
  
          isFlagSet: function(flag) {
            return flags & flag;
          }
        };
  
        return surf;
      },copyIndexedColorData:function (surfData, rX, rY, rW, rH) {
        // HWPALETTE works with palette
        // setted by SDL_SetColors
        if (!surfData.colors) {
          return;
        }
        
        var fullWidth  = Module['canvas'].width;
        var fullHeight = Module['canvas'].height;
  
        var startX  = rX || 0;
        var startY  = rY || 0;
        var endX    = (rW || (fullWidth - startX)) + startX;
        var endY    = (rH || (fullHeight - startY)) + startY;
        
        var buffer  = surfData.buffer;
        var data    = surfData.image.data;
        var colors  = surfData.colors;
  
        for (var y = startY; y < endY; ++y) {
          var indexBase = y * fullWidth;
          var colorBase = indexBase * 4;
          for (var x = startX; x < endX; ++x) {
            // HWPALETTE have only 256 colors (not rgba)
            var index = HEAPU8[((buffer + indexBase + x)|0)] * 3;
            var colorOffset = colorBase + x * 4;
  
            data[colorOffset   ] = colors[index   ];
            data[colorOffset +1] = colors[index +1];
            data[colorOffset +2] = colors[index +2];
            //unused: data[colorOffset +3] = color[index +3];
          }
        }
      },freeSurface:function (surf) {
        var refcountPointer = surf + 56;
        var refcount = HEAP32[((refcountPointer)>>2)];
        if (refcount > 1) {
          HEAP32[((refcountPointer)>>2)]=refcount - 1;
          return;
        }
  
        var info = SDL.surfaces[surf];
        if (!info.usePageCanvas && info.canvas) SDL.canvasPool.push(info.canvas);
        if (info.buffer) _free(info.buffer);
        _free(info.pixelFormat);
        _free(surf);
        SDL.surfaces[surf] = null;
      },touchX:0,touchY:0,savedKeydown:null,receiveEvent:function (event) {
        switch(event.type) {
          case 'touchstart':
            event.preventDefault();
            var touch = event.touches[0];
            touchX = touch.pageX;
            touchY = touch.pageY;
            var event = {
              type: 'mousedown',
              button: 0,
              pageX: touchX,
              pageY: touchY
            };
            SDL.DOMButtons[0] = 1;
            SDL.events.push(event);
            break;
          case 'touchmove':
            event.preventDefault();
            var touch = event.touches[0];
            touchX = touch.pageX;
            touchY = touch.pageY;
            event = {
              type: 'mousemove',
              button: 0,
              pageX: touchX,
              pageY: touchY
            };
            SDL.events.push(event);
            break;
          case 'touchend':
            event.preventDefault();
            event = {
              type: 'mouseup',
              button: 0,
              pageX: touchX,
              pageY: touchY
            };
            SDL.DOMButtons[0] = 0;
            SDL.events.push(event);
            break;
          case 'mousemove':
            if (Browser.pointerLock) {
              // workaround for firefox bug 750111
              if ('mozMovementX' in event) {
                event['movementX'] = event['mozMovementX'];
                event['movementY'] = event['mozMovementY'];
              }
              // workaround for Firefox bug 782777
              if (event['movementX'] == 0 && event['movementY'] == 0) {
                // ignore a mousemove event if it doesn't contain any movement info
                // (without pointer lock, we infer movement from pageX/pageY, so this check is unnecessary)
                event.preventDefault();
                return;
              }
            }
            // fall through
          case 'keydown': case 'keyup': case 'keypress': case 'mousedown': case 'mouseup': case 'DOMMouseScroll': case 'mousewheel':
            // If we preventDefault on keydown events, the subsequent keypress events
            // won't fire. However, it's fine (and in some cases necessary) to
            // preventDefault for keys that don't generate a character. Otherwise,
            // preventDefault is the right thing to do in general.
            if (event.type !== 'keydown' || (!SDL.unicode && !SDL.textInput) || (event.keyCode === 8 /* backspace */ || event.keyCode === 9 /* tab */)) {
              event.preventDefault();
            }
  
            if (event.type == 'DOMMouseScroll' || event.type == 'mousewheel') {
              var button = Browser.getMouseWheelDelta(event) > 0 ? 4 : 3;
              var event2 = {
                type: 'mousedown',
                button: button,
                pageX: event.pageX,
                pageY: event.pageY
              };
              SDL.events.push(event2);
              event = {
                type: 'mouseup',
                button: button,
                pageX: event.pageX,
                pageY: event.pageY
              };
            } else if (event.type == 'mousedown') {
              SDL.DOMButtons[event.button] = 1;
            } else if (event.type == 'mouseup') {
              // ignore extra ups, can happen if we leave the canvas while pressing down, then return,
              // since we add a mouseup in that case
              if (!SDL.DOMButtons[event.button]) {
                return;
              }
  
              SDL.DOMButtons[event.button] = 0;
            }
  
            // We can only request fullscreen as the result of user input.
            // Due to this limitation, we toggle a boolean on keydown which
            // SDL_WM_ToggleFullScreen will check and subsequently set another
            // flag indicating for us to request fullscreen on the following
            // keyup. This isn't perfect, but it enables SDL_WM_ToggleFullScreen
            // to work as the result of a keypress (which is an extremely
            // common use case).
            if (event.type === 'keydown') {
              SDL.canRequestFullscreen = true;
            } else if (event.type === 'keyup') {
              if (SDL.isRequestingFullscreen) {
                Module['requestFullScreen'](true, true);
                SDL.isRequestingFullscreen = false;
              }
              SDL.canRequestFullscreen = false;
            }
  
            // SDL expects a unicode character to be passed to its keydown events.
            // Unfortunately, the browser APIs only provide a charCode property on
            // keypress events, so we must backfill in keydown events with their
            // subsequent keypress event's charCode.
            if (event.type === 'keypress' && SDL.savedKeydown) {
              // charCode is read-only
              SDL.savedKeydown.keypressCharCode = event.charCode;
              SDL.savedKeydown = null;
            } else if (event.type === 'keydown') {
              SDL.savedKeydown = event;
            }
  
            // Don't push keypress events unless SDL_StartTextInput has been called.
            if (event.type !== 'keypress' || SDL.textInput) {
              SDL.events.push(event);
            }
            break;
          case 'mouseout':
            // Un-press all pressed mouse buttons, because we might miss the release outside of the canvas
            for (var i = 0; i < 3; i++) {
              if (SDL.DOMButtons[i]) {
                SDL.events.push({
                  type: 'mouseup',
                  button: i,
                  pageX: event.pageX,
                  pageY: event.pageY
                });
                SDL.DOMButtons[i] = 0;
              }
            }
            event.preventDefault();
            break;
          case 'blur':
          case 'visibilitychange': {
            // Un-press all pressed keys: TODO
            for (var code in SDL.keyboardMap) {
              SDL.events.push({
                type: 'keyup',
                keyCode: SDL.keyboardMap[code]
              });
            }
            event.preventDefault();
            break;
          }
          case 'unload':
            if (Browser.mainLoop.runner) {
              SDL.events.push(event);
              // Force-run a main event loop, since otherwise this event will never be caught!
              Browser.mainLoop.runner();
            }
            return;
          case 'resize':
            SDL.events.push(event);
            // manually triggered resize event doesn't have a preventDefault member
            if (event.preventDefault) {
              event.preventDefault();
            }
            break;
        }
        if (SDL.events.length >= 10000) {
          Module.printErr('SDL event queue full, dropping events');
          SDL.events = SDL.events.slice(0, 10000);
        }
        return;
      },handleEvent:function (event) {
        if (event.handled) return;
        event.handled = true;
  
        switch (event.type) {
          case 'keydown': case 'keyup': {
            var down = event.type === 'keydown';
            var code = event.keyCode;
            if (code >= 65 && code <= 90) {
              code += 32; // make lowercase for SDL
            } else {
              code = SDL.keyCodes[event.keyCode] || event.keyCode;
            }
  
            HEAP8[(((SDL.keyboardState)+(code))|0)]=down;
            // TODO: lmeta, rmeta, numlock, capslock, KMOD_MODE, KMOD_RESERVED
            SDL.modState = (HEAP8[(((SDL.keyboardState)+(1248))|0)] ? 0x0040 | 0x0080 : 0) | // KMOD_LCTRL & KMOD_RCTRL
              (HEAP8[(((SDL.keyboardState)+(1249))|0)] ? 0x0001 | 0x0002 : 0) | // KMOD_LSHIFT & KMOD_RSHIFT
              (HEAP8[(((SDL.keyboardState)+(1250))|0)] ? 0x0100 | 0x0200 : 0); // KMOD_LALT & KMOD_RALT
  
            if (down) {
              SDL.keyboardMap[code] = event.keyCode; // save the DOM input, which we can use to unpress it during blur
            } else {
              delete SDL.keyboardMap[code];
            }
  
            break;
          }
          case 'mousedown': case 'mouseup':
            if (event.type == 'mousedown') {
              // SDL_BUTTON(x) is defined as (1 << ((x)-1)).  SDL buttons are 1-3,
              // and DOM buttons are 0-2, so this means that the below formula is
              // correct.
              SDL.buttonState |= 1 << event.button;
            } else if (event.type == 'mouseup') {
              SDL.buttonState &= ~(1 << event.button);
            }
            // fall through
          case 'mousemove': {
            Browser.calculateMouseEvent(event);
            break;
          }
        }
      },makeCEvent:function (event, ptr) {
        if (typeof event === 'number') {
          // This is a pointer to a native C event that was SDL_PushEvent'ed
          _memcpy(ptr, event, 28); // XXX
          return;
        }
  
        SDL.handleEvent(event);
  
        switch (event.type) {
          case 'keydown': case 'keyup': {
            var down = event.type === 'keydown';
            //Module.print('Received key event: ' + event.keyCode);
            var key = event.keyCode;
            if (key >= 65 && key <= 90) {
              key += 32; // make lowercase for SDL
            } else {
              key = SDL.keyCodes[event.keyCode] || event.keyCode;
            }
            var scan;
            if (key >= 1024) {
              scan = key - 1024;
            } else {
              scan = SDL.scanCodes[key] || key;
            }
  
            HEAP32[((ptr)>>2)]=SDL.DOMEventToSDLEvent[event.type];
            HEAP8[(((ptr)+(8))|0)]=down ? 1 : 0;
            HEAP8[(((ptr)+(9))|0)]=0; // TODO
            HEAP32[(((ptr)+(12))>>2)]=scan;
            HEAP32[(((ptr)+(16))>>2)]=key;
            HEAP16[(((ptr)+(20))>>1)]=SDL.modState;
            // some non-character keys (e.g. backspace and tab) won't have keypressCharCode set, fill in with the keyCode.
            HEAP32[(((ptr)+(24))>>2)]=event.keypressCharCode || key;
  
            break;
          }
          case 'keypress': {
            HEAP32[((ptr)>>2)]=SDL.DOMEventToSDLEvent[event.type];
            // Not filling in windowID for now
            var cStr = intArrayFromString(String.fromCharCode(event.charCode));
            for (var i = 0; i < cStr.length; ++i) {
              HEAP8[(((ptr)+(8 + i))|0)]=cStr[i];
            }
            break;
          }
          case 'mousedown': case 'mouseup': case 'mousemove': {
            if (event.type != 'mousemove') {
              var down = event.type === 'mousedown';
              HEAP32[((ptr)>>2)]=SDL.DOMEventToSDLEvent[event.type];
              HEAP8[(((ptr)+(8))|0)]=event.button+1; // DOM buttons are 0-2, SDL 1-3
              HEAP8[(((ptr)+(9))|0)]=down ? 1 : 0;
              HEAP32[(((ptr)+(12))>>2)]=Browser.mouseX;
              HEAP32[(((ptr)+(16))>>2)]=Browser.mouseY;
            } else {
              HEAP32[((ptr)>>2)]=SDL.DOMEventToSDLEvent[event.type];
              HEAP8[(((ptr)+(8))|0)]=SDL.buttonState;
              HEAP32[(((ptr)+(12))>>2)]=Browser.mouseX;
              HEAP32[(((ptr)+(16))>>2)]=Browser.mouseY;
              HEAP32[(((ptr)+(20))>>2)]=Browser.mouseMovementX;
              HEAP32[(((ptr)+(24))>>2)]=Browser.mouseMovementY;
            }
            break;
          }
          case 'unload': {
            HEAP32[((ptr)>>2)]=SDL.DOMEventToSDLEvent[event.type];
            break;
          }
          case 'resize': {
            HEAP32[((ptr)>>2)]=SDL.DOMEventToSDLEvent[event.type];
            HEAP32[(((ptr)+(4))>>2)]=event.w;
            HEAP32[(((ptr)+(8))>>2)]=event.h;
            break;
          }
          case 'joystick_button_up': case 'joystick_button_down': {
            var state = event.type === 'joystick_button_up' ? 0 : 1;
            HEAP32[((ptr)>>2)]=SDL.DOMEventToSDLEvent[event.type];
            HEAP8[(((ptr)+(4))|0)]=event.index;
            HEAP8[(((ptr)+(5))|0)]=event.button;
            HEAP8[(((ptr)+(6))|0)]=state;
            break;
          }
          case 'joystick_axis_motion': {
            HEAP32[((ptr)>>2)]=SDL.DOMEventToSDLEvent[event.type];
            HEAP8[(((ptr)+(4))|0)]=event.index;
            HEAP8[(((ptr)+(5))|0)]=event.axis;
            HEAP32[(((ptr)+(8))>>2)]=SDL.joystickAxisValueConversion(event.value);
            break;
          }
          default: throw 'Unhandled SDL event: ' + event.type;
        }
      },estimateTextWidth:function (fontData, text) {
        var h = fontData.size;
        var fontString = h + 'px ' + fontData.name;
        var tempCtx = SDL.ttfContext;
        tempCtx.save();
        tempCtx.font = fontString;
        var ret = tempCtx.measureText(text).width | 0;
        tempCtx.restore();
        return ret;
      },allocateChannels:function (num) { // called from Mix_AllocateChannels and init
        if (SDL.numChannels && SDL.numChannels >= num && num != 0) return;
        SDL.numChannels = num;
        SDL.channels = [];
        for (var i = 0; i < num; i++) {
          SDL.channels[i] = {
            audio: null,
            volume: 1.0
          };
        }
      },setGetVolume:function (info, volume) {
        if (!info) return 0;
        var ret = info.volume * 128; // MIX_MAX_VOLUME
        if (volume != -1) {
          info.volume = volume / 128;
          if (info.audio) info.audio.volume = info.volume;
        }
        return ret;
      },fillWebAudioBufferFromHeap:function (heapPtr, sizeSamplesPerChannel, dstAudioBuffer) {
        // The input audio data is interleaved across the channels, i.e. [L, R, L, R, L, R, ...] and is either 8-bit or 16-bit as
        // supported by the SDL API. The output audio wave data for Web Audio API must be in planar buffers of [-1,1]-normalized Float32 data,
        // so perform a buffer conversion for the data.
        var numChannels = SDL.audio.channels;
        for(var c = 0; c < numChannels; ++c) {
          var channelData = dstAudioBuffer['getChannelData'](c);
          if (channelData.length != sizeSamplesPerChannel) {
            throw 'Web Audio output buffer length mismatch! Destination size: ' + channelData.length + ' samples vs expected ' + sizeSamplesPerChannel + ' samples!';
          }
          if (SDL.audio.format == 0x8010 /*AUDIO_S16LSB*/) {
            for(var j = 0; j < sizeSamplesPerChannel; ++j) {
              channelData[j] = (HEAP16[(((heapPtr)+((j*numChannels + c)*2))>>1)]) / 0x8000;
            }
          } else if (SDL.audio.format == 0x0008 /*AUDIO_U8*/) {
            for(var j = 0; j < sizeSamplesPerChannel; ++j) {
              var v = (HEAP8[(((heapPtr)+(j*numChannels + c))|0)]);
              channelData[j] = ((v >= 0) ? v-128 : v+128) /128;
            }
          }
        }
      },debugSurface:function (surfData) {
        console.log('dumping surface ' + [surfData.surf, surfData.source, surfData.width, surfData.height]);
        var image = surfData.ctx.getImageData(0, 0, surfData.width, surfData.height);
        var data = image.data;
        var num = Math.min(surfData.width, surfData.height);
        for (var i = 0; i < num; i++) {
          console.log('   diagonal ' + i + ':' + [data[i*surfData.width*4 + i*4 + 0], data[i*surfData.width*4 + i*4 + 1], data[i*surfData.width*4 + i*4 + 2], data[i*surfData.width*4 + i*4 + 3]]);
        }
      },joystickEventState:1,lastJoystickState:{},joystickNamePool:{},recordJoystickState:function (joystick, state) {
        // Standardize button state.
        var buttons = new Array(state.buttons.length);
        for (var i = 0; i < state.buttons.length; i++) {
          buttons[i] = SDL.getJoystickButtonState(state.buttons[i]);
        }
  
        SDL.lastJoystickState[joystick] = {
          buttons: buttons,
          axes: state.axes.slice(0),
          timestamp: state.timestamp,
          index: state.index,
          id: state.id
        };
      },getJoystickButtonState:function (button) {
        if (typeof button === 'object') {
          // Current gamepad API editor's draft (Firefox Nightly)
          // https://dvcs.w3.org/hg/gamepad/raw-file/default/gamepad.html#idl-def-GamepadButton
          return button.pressed;
        } else {
          // Current gamepad API working draft (Firefox / Chrome Stable)
          // http://www.w3.org/TR/2012/WD-gamepad-20120529/#gamepad-interface
          return button > 0;
        }
      },queryJoysticks:function () {
        for (var joystick in SDL.lastJoystickState) {
          var state = SDL.getGamepad(joystick - 1);
          var prevState = SDL.lastJoystickState[joystick];
          // Check only if the timestamp has differed.
          // NOTE: Timestamp is not available in Firefox.
          if (typeof state.timestamp !== 'number' || state.timestamp !== prevState.timestamp) {
            var i;
            for (i = 0; i < state.buttons.length; i++) {
              var buttonState = SDL.getJoystickButtonState(state.buttons[i]);
              // NOTE: The previous state already has a boolean representation of
              //       its button, so no need to standardize its button state here.
              if (buttonState !== prevState.buttons[i]) {
                // Insert button-press event.
                SDL.events.push({
                  type: buttonState ? 'joystick_button_down' : 'joystick_button_up',
                  joystick: joystick,
                  index: joystick - 1,
                  button: i
                });
              }
            }
            for (i = 0; i < state.axes.length; i++) {
              if (state.axes[i] !== prevState.axes[i]) {
                // Insert axes-change event.
                SDL.events.push({
                  type: 'joystick_axis_motion',
                  joystick: joystick,
                  index: joystick - 1,
                  axis: i,
                  value: state.axes[i]
                });
              }
            }
  
            SDL.recordJoystickState(joystick, state);
          }
        }
      },joystickAxisValueConversion:function (value) {
        // Ensures that 0 is 0, 1 is 32767, and -1 is 32768.
        return Math.ceil(((value+1) * 32767.5) - 32768);
      },getGamepads:function () {
        var fcn = navigator.getGamepads || navigator.webkitGamepads || navigator.mozGamepads || navigator.gamepads || navigator.webkitGetGamepads;
        if (fcn !== undefined) {
          // The function must be applied on the navigator object.
          return fcn.apply(navigator);
        } else {
          return [];
        }
      },getGamepad:function (deviceIndex) {
        var gamepads = SDL.getGamepads();
        if (gamepads.length > deviceIndex && deviceIndex >= 0) {
          return gamepads[deviceIndex];
        }
        return null;
      }};function _SDL_Quit() {
      for (var i = 0; i < SDL.numChannels; ++i) {
        if (SDL.channels[i].audio) {
          SDL.channels[i].audio.pause();
        }
      }
      if (SDL.music.audio) {
        SDL.music.audio.pause();
      }
      Module.print('SDL_Quit called (and ignored)');
    }

  
  function __exit(status) {
      // void _exit(int status);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/exit.html
      Module['exit'](status);
    }function _exit(status) {
      __exit(status);
    }

  function _SDL_Init(initFlags) {
      SDL.startTime = Date.now();
      SDL.initFlags = initFlags;
  
      // capture all key events. we just keep down and up, but also capture press to prevent default actions
      if (!Module['doNotCaptureKeyboard']) {
        document.addEventListener("keydown", SDL.receiveEvent);
        document.addEventListener("keyup", SDL.receiveEvent);
        document.addEventListener("keypress", SDL.receiveEvent);
        window.addEventListener("blur", SDL.receiveEvent);
        document.addEventListener("visibilitychange", SDL.receiveEvent);
      }
  
      if (initFlags & 0x200) {
        // SDL_INIT_JOYSTICK
        // Firefox will not give us Joystick data unless we register this NOP
        // callback.
        // https://bugzilla.mozilla.org/show_bug.cgi?id=936104
        addEventListener("gamepadconnected", function() {});
      }
  
      window.addEventListener("unload", SDL.receiveEvent);
      SDL.keyboardState = _malloc(0x10000); // Our SDL needs 512, but 64K is safe for older SDLs
      _memset(SDL.keyboardState, 0, 0x10000);
      // Initialize this structure carefully for closure
      SDL.DOMEventToSDLEvent['keydown'] = 0x300 /* SDL_KEYDOWN */;
      SDL.DOMEventToSDLEvent['keyup'] = 0x301 /* SDL_KEYUP */;
      SDL.DOMEventToSDLEvent['keypress'] = 0x303 /* SDL_TEXTINPUT */;
      SDL.DOMEventToSDLEvent['mousedown'] = 0x401 /* SDL_MOUSEBUTTONDOWN */;
      SDL.DOMEventToSDLEvent['mouseup'] = 0x402 /* SDL_MOUSEBUTTONUP */;
      SDL.DOMEventToSDLEvent['mousemove'] = 0x400 /* SDL_MOUSEMOTION */;
      SDL.DOMEventToSDLEvent['unload'] = 0x100 /* SDL_QUIT */;
      SDL.DOMEventToSDLEvent['resize'] = 0x7001 /* SDL_VIDEORESIZE/SDL_EVENT_COMPAT2 */;
      // These are not technically DOM events; the HTML gamepad API is poll-based.
      // However, we define them here, as the rest of the SDL code assumes that
      // all SDL events originate as DOM events.
      SDL.DOMEventToSDLEvent['joystick_axis_motion'] = 0x600 /* SDL_JOYAXISMOTION */;
      SDL.DOMEventToSDLEvent['joystick_button_down'] = 0x603 /* SDL_JOYBUTTONDOWN */;
      SDL.DOMEventToSDLEvent['joystick_button_up'] = 0x604 /* SDL_JOYBUTTONUP */;
      return 0; // success
    }

  function _SDL_SetVideoMode(width, height, depth, flags) {
      ['mousedown', 'mouseup', 'mousemove', 'DOMMouseScroll', 'mousewheel', 'mouseout'].forEach(function(event) {
        Module['canvas'].addEventListener(event, SDL.receiveEvent, true);
      });
  
      // (0,0) means 'use fullscreen' in native; in Emscripten, use the current canvas size.
      if (width == 0 && height == 0) {
        var canvas = Module['canvas'];
        width = canvas.width;
        height = canvas.height;
      }
  
      Browser.setCanvasSize(width, height, true);
      // Free the old surface first.
      if (SDL.screen) {
        SDL.freeSurface(SDL.screen);
        SDL.screen = null;
      }
      SDL.screen = SDL.makeSurface(width, height, flags, true, 'screen');
      if (!SDL.addedResizeListener) {
        SDL.addedResizeListener = true;
        Browser.resizeListeners.push(function(w, h) {
          SDL.receiveEvent({
            type: 'resize',
            w: w,
            h: h
          });
        });
      }
      return SDL.screen;
    }

  function _SDL_WM_SetCaption(title, icon) {
      title = title && Pointer_stringify(title);
      icon = icon && Pointer_stringify(icon);
    }

  
  
  
  
  
  function _mkport() { throw 'TODO' }var SOCKFS={mount:function (mount) {
        return FS.createNode(null, '/', 16384 | 511 /* 0777 */, 0);
      },createSocket:function (family, type, protocol) {
        var streaming = type == 1;
        if (protocol) {
          assert(streaming == (protocol == 6)); // if SOCK_STREAM, must be tcp
        }
  
        // create our internal socket structure
        var sock = {
          family: family,
          type: type,
          protocol: protocol,
          server: null,
          peers: {},
          pending: [],
          recv_queue: [],
          sock_ops: SOCKFS.websocket_sock_ops
        };
  
        // create the filesystem node to store the socket structure
        var name = SOCKFS.nextname();
        var node = FS.createNode(SOCKFS.root, name, 49152, 0);
        node.sock = sock;
  
        // and the wrapping stream that enables library functions such
        // as read and write to indirectly interact with the socket
        var stream = FS.createStream({
          path: name,
          node: node,
          flags: FS.modeStringToFlags('r+'),
          seekable: false,
          stream_ops: SOCKFS.stream_ops
        });
  
        // map the new stream to the socket structure (sockets have a 1:1
        // relationship with a stream)
        sock.stream = stream;
  
        return sock;
      },getSocket:function (fd) {
        var stream = FS.getStream(fd);
        if (!stream || !FS.isSocket(stream.node.mode)) {
          return null;
        }
        return stream.node.sock;
      },stream_ops:{poll:function (stream) {
          var sock = stream.node.sock;
          return sock.sock_ops.poll(sock);
        },ioctl:function (stream, request, varargs) {
          var sock = stream.node.sock;
          return sock.sock_ops.ioctl(sock, request, varargs);
        },read:function (stream, buffer, offset, length, position /* ignored */) {
          var sock = stream.node.sock;
          var msg = sock.sock_ops.recvmsg(sock, length);
          if (!msg) {
            // socket is closed
            return 0;
          }
          buffer.set(msg.buffer, offset);
          return msg.buffer.length;
        },write:function (stream, buffer, offset, length, position /* ignored */) {
          var sock = stream.node.sock;
          return sock.sock_ops.sendmsg(sock, buffer, offset, length);
        },close:function (stream) {
          var sock = stream.node.sock;
          sock.sock_ops.close(sock);
        }},nextname:function () {
        if (!SOCKFS.nextname.current) {
          SOCKFS.nextname.current = 0;
        }
        return 'socket[' + (SOCKFS.nextname.current++) + ']';
      },websocket_sock_ops:{createPeer:function (sock, addr, port) {
          var ws;
  
          if (typeof addr === 'object') {
            ws = addr;
            addr = null;
            port = null;
          }
  
          if (ws) {
            // for sockets that've already connected (e.g. we're the server)
            // we can inspect the _socket property for the address
            if (ws._socket) {
              addr = ws._socket.remoteAddress;
              port = ws._socket.remotePort;
            }
            // if we're just now initializing a connection to the remote,
            // inspect the url property
            else {
              var result = /ws[s]?:\/\/([^:]+):(\d+)/.exec(ws.url);
              if (!result) {
                throw new Error('WebSocket URL must be in the format ws(s)://address:port');
              }
              addr = result[1];
              port = parseInt(result[2], 10);
            }
          } else {
            // create the actual websocket object and connect
            try {
              var url = 'ws://' + addr + ':' + port;
              // the node ws library API is slightly different than the browser's
              var opts = ENVIRONMENT_IS_NODE ? {headers: {'websocket-protocol': ['binary']}} : ['binary'];
              // If node we use the ws library.
              var WebSocket = ENVIRONMENT_IS_NODE ? require('ws') : window['WebSocket'];
              ws = new WebSocket(url, opts);
              ws.binaryType = 'arraybuffer';
            } catch (e) {
              throw new FS.ErrnoError(ERRNO_CODES.EHOSTUNREACH);
            }
          }
  
  
          var peer = {
            addr: addr,
            port: port,
            socket: ws,
            dgram_send_queue: []
          };
  
          SOCKFS.websocket_sock_ops.addPeer(sock, peer);
          SOCKFS.websocket_sock_ops.handlePeerEvents(sock, peer);
  
          // if this is a bound dgram socket, send the port number first to allow
          // us to override the ephemeral port reported to us by remotePort on the
          // remote end.
          if (sock.type === 2 && typeof sock.sport !== 'undefined') {
            peer.dgram_send_queue.push(new Uint8Array([
                255, 255, 255, 255,
                'p'.charCodeAt(0), 'o'.charCodeAt(0), 'r'.charCodeAt(0), 't'.charCodeAt(0),
                ((sock.sport & 0xff00) >> 8) , (sock.sport & 0xff)
            ]));
          }
  
          return peer;
        },getPeer:function (sock, addr, port) {
          return sock.peers[addr + ':' + port];
        },addPeer:function (sock, peer) {
          sock.peers[peer.addr + ':' + peer.port] = peer;
        },removePeer:function (sock, peer) {
          delete sock.peers[peer.addr + ':' + peer.port];
        },handlePeerEvents:function (sock, peer) {
          var first = true;
  
          var handleOpen = function () {
            try {
              var queued = peer.dgram_send_queue.shift();
              while (queued) {
                peer.socket.send(queued);
                queued = peer.dgram_send_queue.shift();
              }
            } catch (e) {
              // not much we can do here in the way of proper error handling as we've already
              // lied and said this data was sent. shut it down.
              peer.socket.close();
            }
          };
  
          function handleMessage(data) {
            assert(typeof data !== 'string' && data.byteLength !== undefined);  // must receive an ArrayBuffer
            data = new Uint8Array(data);  // make a typed array view on the array buffer
  
  
            // if this is the port message, override the peer's port with it
            var wasfirst = first;
            first = false;
            if (wasfirst &&
                data.length === 10 &&
                data[0] === 255 && data[1] === 255 && data[2] === 255 && data[3] === 255 &&
                data[4] === 'p'.charCodeAt(0) && data[5] === 'o'.charCodeAt(0) && data[6] === 'r'.charCodeAt(0) && data[7] === 't'.charCodeAt(0)) {
              // update the peer's port and it's key in the peer map
              var newport = ((data[8] << 8) | data[9]);
              SOCKFS.websocket_sock_ops.removePeer(sock, peer);
              peer.port = newport;
              SOCKFS.websocket_sock_ops.addPeer(sock, peer);
              return;
            }
  
            sock.recv_queue.push({ addr: peer.addr, port: peer.port, data: data });
          };
  
          if (ENVIRONMENT_IS_NODE) {
            peer.socket.on('open', handleOpen);
            peer.socket.on('message', function(data, flags) {
              if (!flags.binary) {
                return;
              }
              handleMessage((new Uint8Array(data)).buffer);  // copy from node Buffer -> ArrayBuffer
            });
            peer.socket.on('error', function() {
              // don't throw
            });
          } else {
            peer.socket.onopen = handleOpen;
            peer.socket.onmessage = function peer_socket_onmessage(event) {
              handleMessage(event.data);
            };
          }
        },poll:function (sock) {
          if (sock.type === 1 && sock.server) {
            // listen sockets should only say they're available for reading
            // if there are pending clients.
            return sock.pending.length ? (64 | 1) : 0;
          }
  
          var mask = 0;
          var dest = sock.type === 1 ?  // we only care about the socket state for connection-based sockets
            SOCKFS.websocket_sock_ops.getPeer(sock, sock.daddr, sock.dport) :
            null;
  
          if (sock.recv_queue.length ||
              !dest ||  // connection-less sockets are always ready to read
              (dest && dest.socket.readyState === dest.socket.CLOSING) ||
              (dest && dest.socket.readyState === dest.socket.CLOSED)) {  // let recv return 0 once closed
            mask |= (64 | 1);
          }
  
          if (!dest ||  // connection-less sockets are always ready to write
              (dest && dest.socket.readyState === dest.socket.OPEN)) {
            mask |= 4;
          }
  
          if ((dest && dest.socket.readyState === dest.socket.CLOSING) ||
              (dest && dest.socket.readyState === dest.socket.CLOSED)) {
            mask |= 16;
          }
  
          return mask;
        },ioctl:function (sock, request, arg) {
          switch (request) {
            case 21531:
              var bytes = 0;
              if (sock.recv_queue.length) {
                bytes = sock.recv_queue[0].data.length;
              }
              HEAP32[((arg)>>2)]=bytes;
              return 0;
            default:
              return ERRNO_CODES.EINVAL;
          }
        },close:function (sock) {
          // if we've spawned a listen server, close it
          if (sock.server) {
            try {
              sock.server.close();
            } catch (e) {
            }
            sock.server = null;
          }
          // close any peer connections
          var peers = Object.keys(sock.peers);
          for (var i = 0; i < peers.length; i++) {
            var peer = sock.peers[peers[i]];
            try {
              peer.socket.close();
            } catch (e) {
            }
            SOCKFS.websocket_sock_ops.removePeer(sock, peer);
          }
          return 0;
        },bind:function (sock, addr, port) {
          if (typeof sock.saddr !== 'undefined' || typeof sock.sport !== 'undefined') {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);  // already bound
          }
          sock.saddr = addr;
          sock.sport = port || _mkport();
          // in order to emulate dgram sockets, we need to launch a listen server when
          // binding on a connection-less socket
          // note: this is only required on the server side
          if (sock.type === 2) {
            // close the existing server if it exists
            if (sock.server) {
              sock.server.close();
              sock.server = null;
            }
            // swallow error operation not supported error that occurs when binding in the
            // browser where this isn't supported
            try {
              sock.sock_ops.listen(sock, 0);
            } catch (e) {
              if (!(e instanceof FS.ErrnoError)) throw e;
              if (e.errno !== ERRNO_CODES.EOPNOTSUPP) throw e;
            }
          }
        },connect:function (sock, addr, port) {
          if (sock.server) {
            throw new FS.ErrnoError(ERRNO_CODS.EOPNOTSUPP);
          }
  
          // TODO autobind
          // if (!sock.addr && sock.type == 2) {
          // }
  
          // early out if we're already connected / in the middle of connecting
          if (typeof sock.daddr !== 'undefined' && typeof sock.dport !== 'undefined') {
            var dest = SOCKFS.websocket_sock_ops.getPeer(sock, sock.daddr, sock.dport);
            if (dest) {
              if (dest.socket.readyState === dest.socket.CONNECTING) {
                throw new FS.ErrnoError(ERRNO_CODES.EALREADY);
              } else {
                throw new FS.ErrnoError(ERRNO_CODES.EISCONN);
              }
            }
          }
  
          // add the socket to our peer list and set our
          // destination address / port to match
          var peer = SOCKFS.websocket_sock_ops.createPeer(sock, addr, port);
          sock.daddr = peer.addr;
          sock.dport = peer.port;
  
          // always "fail" in non-blocking mode
          throw new FS.ErrnoError(ERRNO_CODES.EINPROGRESS);
        },listen:function (sock, backlog) {
          if (!ENVIRONMENT_IS_NODE) {
            throw new FS.ErrnoError(ERRNO_CODES.EOPNOTSUPP);
          }
          if (sock.server) {
             throw new FS.ErrnoError(ERRNO_CODES.EINVAL);  // already listening
          }
          var WebSocketServer = require('ws').Server;
          var host = sock.saddr;
          sock.server = new WebSocketServer({
            host: host,
            port: sock.sport
            // TODO support backlog
          });
  
          sock.server.on('connection', function(ws) {
            if (sock.type === 1) {
              var newsock = SOCKFS.createSocket(sock.family, sock.type, sock.protocol);
  
              // create a peer on the new socket
              var peer = SOCKFS.websocket_sock_ops.createPeer(newsock, ws);
              newsock.daddr = peer.addr;
              newsock.dport = peer.port;
  
              // push to queue for accept to pick up
              sock.pending.push(newsock);
            } else {
              // create a peer on the listen socket so calling sendto
              // with the listen socket and an address will resolve
              // to the correct client
              SOCKFS.websocket_sock_ops.createPeer(sock, ws);
            }
          });
          sock.server.on('closed', function() {
            sock.server = null;
          });
          sock.server.on('error', function() {
            // don't throw
          });
        },accept:function (listensock) {
          if (!listensock.server) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
          var newsock = listensock.pending.shift();
          newsock.stream.flags = listensock.stream.flags;
          return newsock;
        },getname:function (sock, peer) {
          var addr, port;
          if (peer) {
            if (sock.daddr === undefined || sock.dport === undefined) {
              throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
            }
            addr = sock.daddr;
            port = sock.dport;
          } else {
            // TODO saddr and sport will be set for bind()'d UDP sockets, but what
            // should we be returning for TCP sockets that've been connect()'d?
            addr = sock.saddr || 0;
            port = sock.sport || 0;
          }
          return { addr: addr, port: port };
        },sendmsg:function (sock, buffer, offset, length, addr, port) {
          if (sock.type === 2) {
            // connection-less sockets will honor the message address,
            // and otherwise fall back to the bound destination address
            if (addr === undefined || port === undefined) {
              addr = sock.daddr;
              port = sock.dport;
            }
            // if there was no address to fall back to, error out
            if (addr === undefined || port === undefined) {
              throw new FS.ErrnoError(ERRNO_CODES.EDESTADDRREQ);
            }
          } else {
            // connection-based sockets will only use the bound
            addr = sock.daddr;
            port = sock.dport;
          }
  
          // find the peer for the destination address
          var dest = SOCKFS.websocket_sock_ops.getPeer(sock, addr, port);
  
          // early out if not connected with a connection-based socket
          if (sock.type === 1) {
            if (!dest || dest.socket.readyState === dest.socket.CLOSING || dest.socket.readyState === dest.socket.CLOSED) {
              throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
            } else if (dest.socket.readyState === dest.socket.CONNECTING) {
              throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
            }
          }
  
          // create a copy of the incoming data to send, as the WebSocket API
          // doesn't work entirely with an ArrayBufferView, it'll just send
          // the entire underlying buffer
          var data;
          if (buffer instanceof Array || buffer instanceof ArrayBuffer) {
            data = buffer.slice(offset, offset + length);
          } else {  // ArrayBufferView
            data = buffer.buffer.slice(buffer.byteOffset + offset, buffer.byteOffset + offset + length);
          }
  
          // if we're emulating a connection-less dgram socket and don't have
          // a cached connection, queue the buffer to send upon connect and
          // lie, saying the data was sent now.
          if (sock.type === 2) {
            if (!dest || dest.socket.readyState !== dest.socket.OPEN) {
              // if we're not connected, open a new connection
              if (!dest || dest.socket.readyState === dest.socket.CLOSING || dest.socket.readyState === dest.socket.CLOSED) {
                dest = SOCKFS.websocket_sock_ops.createPeer(sock, addr, port);
              }
              dest.dgram_send_queue.push(data);
              return length;
            }
          }
  
          try {
            // send the actual data
            dest.socket.send(data);
            return length;
          } catch (e) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
        },recvmsg:function (sock, length) {
          // http://pubs.opengroup.org/onlinepubs/7908799/xns/recvmsg.html
          if (sock.type === 1 && sock.server) {
            // tcp servers should not be recv()'ing on the listen socket
            throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
          }
  
          var queued = sock.recv_queue.shift();
          if (!queued) {
            if (sock.type === 1) {
              var dest = SOCKFS.websocket_sock_ops.getPeer(sock, sock.daddr, sock.dport);
  
              if (!dest) {
                // if we have a destination address but are not connected, error out
                throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
              }
              else if (dest.socket.readyState === dest.socket.CLOSING || dest.socket.readyState === dest.socket.CLOSED) {
                // return null if the socket has closed
                return null;
              }
              else {
                // else, our socket is in a valid state but truly has nothing available
                throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
              }
            } else {
              throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
            }
          }
  
          // queued.data will be an ArrayBuffer if it's unadulterated, but if it's
          // requeued TCP data it'll be an ArrayBufferView
          var queuedLength = queued.data.byteLength || queued.data.length;
          var queuedOffset = queued.data.byteOffset || 0;
          var queuedBuffer = queued.data.buffer || queued.data;
          var bytesRead = Math.min(length, queuedLength);
          var res = {
            buffer: new Uint8Array(queuedBuffer, queuedOffset, bytesRead),
            addr: queued.addr,
            port: queued.port
          };
  
  
          // push back any unread data for TCP connections
          if (sock.type === 1 && bytesRead < queuedLength) {
            var bytesRemaining = queuedLength - bytesRead;
            queued.data = new Uint8Array(queuedBuffer, queuedOffset + bytesRead, bytesRemaining);
            sock.recv_queue.unshift(queued);
          }
  
          return res;
        }}};function _send(fd, buf, len, flags) {
      var sock = SOCKFS.getSocket(fd);
      if (!sock) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      // TODO honor flags
      return _write(fd, buf, len);
    }
  
  function _pwrite(fildes, buf, nbyte, offset) {
      // ssize_t pwrite(int fildes, const void *buf, size_t nbyte, off_t offset);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/write.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        var slab = HEAP8;
        return FS.write(stream, slab, buf, nbyte, offset);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _write(fildes, buf, nbyte) {
      // ssize_t write(int fildes, const void *buf, size_t nbyte);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/write.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
  
  
      try {
        var slab = HEAP8;
        return FS.write(stream, slab, buf, nbyte);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }
  
   
  Module["_strlen"] = _strlen;
  
  function _fileno(stream) {
      // int fileno(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fileno.html
      return FS.getStreamFromPtr(stream).fd;
    }function _fputs(s, stream) {
      // int fputs(const char *restrict s, FILE *restrict stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fputs.html
      var fd = _fileno(stream);
      return _write(fd, s, _strlen(s));
    }
  
  function _fputc(c, stream) {
      // int fputc(int c, FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fputc.html
      var chr = unSign(c & 0xFF);
      HEAP8[((_fputc.ret)|0)]=chr;
      var fd = _fileno(stream);
      var ret = _write(fd, _fputc.ret, 1);
      if (ret == -1) {
        var streamObj = FS.getStreamFromPtr(stream);
        if (streamObj) streamObj.error = true;
        return -1;
      } else {
        return chr;
      }
    }function _puts(s) {
      // int puts(const char *s);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/puts.html
      // NOTE: puts() always writes an extra newline.
      var stdout = HEAP32[((_stdout)>>2)];
      var ret = _fputs(s, stdout);
      if (ret < 0) {
        return ret;
      } else {
        var newlineRet = _fputc(10, stdout);
        return (newlineRet < 0) ? -1 : ret + 1;
      }
    }

  function _SDL_MapRGB(fmt, r, g, b) {
      // Canvas screens are always RGBA. We assume the machine is little-endian.
      return r&0xff|(g&0xff)<<8|(b&0xff)<<16|0xff000000;
    }

  
  function _close(fildes) {
      // int close(int fildes);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/close.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        FS.close(stream);
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }
  
  function _fsync(fildes) {
      // int fsync(int fildes);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fsync.html
      var stream = FS.getStream(fildes);
      if (stream) {
        // We write directly to the file system, so there's nothing to do here.
        return 0;
      } else {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
    }function _fclose(stream) {
      // int fclose(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fclose.html
      var fd = _fileno(stream);
      _fsync(fd);
      return _close(fd);
    }

  function _SDL_PollEvent(ptr) {
      if (SDL.initFlags & 0x200 && SDL.joystickEventState) {
        // If SDL_INIT_JOYSTICK was supplied AND the joystick system is configured
        // to automatically query for events, query for joystick events.
        SDL.queryJoysticks();
      }
      if (SDL.events.length === 0) return 0;
      if (ptr) {
        SDL.makeCEvent(SDL.events.shift(), ptr);
      }
      return 1;
    }

  function _emscripten_set_main_loop(func, fps, simulateInfiniteLoop, arg) {
      Module['noExitRuntime'] = true;
  
      Browser.mainLoop.runner = function Browser_mainLoop_runner() {
        if (ABORT) return;
        if (Browser.mainLoop.queue.length > 0) {
          var start = Date.now();
          var blocker = Browser.mainLoop.queue.shift();
          blocker.func(blocker.arg);
          if (Browser.mainLoop.remainingBlockers) {
            var remaining = Browser.mainLoop.remainingBlockers;
            var next = remaining%1 == 0 ? remaining-1 : Math.floor(remaining);
            if (blocker.counted) {
              Browser.mainLoop.remainingBlockers = next;
            } else {
              // not counted, but move the progress along a tiny bit
              next = next + 0.5; // do not steal all the next one's progress
              Browser.mainLoop.remainingBlockers = (8*remaining + next)/9;
            }
          }
          console.log('main loop blocker "' + blocker.name + '" took ' + (Date.now() - start) + ' ms'); //, left: ' + Browser.mainLoop.remainingBlockers);
          Browser.mainLoop.updateStatus();
          setTimeout(Browser.mainLoop.runner, 0);
          return;
        }
        if (Browser.mainLoop.shouldPause) {
          // catch pauses from non-main loop sources
          Browser.mainLoop.paused = true;
          Browser.mainLoop.shouldPause = false;
          return;
        }
  
        // Signal GL rendering layer that processing of a new frame is about to start. This helps it optimize
        // VBO double-buffering and reduce GPU stalls.
  
        if (Browser.mainLoop.method === 'timeout' && Module.ctx) {
          Module.printErr('Looks like you are rendering without using requestAnimationFrame for the main loop. You should use 0 for the frame rate in emscripten_set_main_loop in order to use requestAnimationFrame, as that can greatly improve your frame rates!');
          Browser.mainLoop.method = ''; // just warn once per call to set main loop
        }
  
        if (Module['preMainLoop']) {
          Module['preMainLoop']();
        }
  
        try {
          if (typeof arg !== 'undefined') {
            Runtime.dynCall('vi', func, [arg]);
          } else {
            Runtime.dynCall('v', func);
          }
        } catch (e) {
          if (e instanceof ExitStatus) {
            return;
          } else {
            if (e && typeof e === 'object' && e.stack) Module.printErr('exception thrown: ' + [e, e.stack]);
            throw e;
          }
        }
  
        if (Module['postMainLoop']) {
          Module['postMainLoop']();
        }
  
        if (Browser.mainLoop.shouldPause) {
          // catch pauses from the main loop itself
          Browser.mainLoop.paused = true;
          Browser.mainLoop.shouldPause = false;
          return;
        }
        Browser.mainLoop.scheduler();
      }
      if (fps && fps > 0) {
        Browser.mainLoop.scheduler = function Browser_mainLoop_scheduler() {
          setTimeout(Browser.mainLoop.runner, 1000/fps); // doing this each time means that on exception, we stop
        };
        Browser.mainLoop.method = 'timeout';
      } else {
        Browser.mainLoop.scheduler = function Browser_mainLoop_scheduler() {
          Browser.requestAnimationFrame(Browser.mainLoop.runner);
        };
        Browser.mainLoop.method = 'rAF';
      }
      Browser.mainLoop.scheduler();
  
      if (simulateInfiniteLoop) {
        throw 'SimulateInfiniteLoop';
      }
    }

  
  function _open(path, oflag, varargs) {
      // int open(const char *path, int oflag, ...);
      // http://pubs.opengroup.org/onlinepubs/009695399/functions/open.html
      var mode = HEAP32[((varargs)>>2)];
      path = Pointer_stringify(path);
      try {
        var stream = FS.open(path, oflag, mode);
        return stream.fd;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _fopen(filename, mode) {
      // FILE *fopen(const char *restrict filename, const char *restrict mode);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fopen.html
      var flags;
      mode = Pointer_stringify(mode);
      if (mode[0] == 'r') {
        if (mode.indexOf('+') != -1) {
          flags = 2;
        } else {
          flags = 0;
        }
      } else if (mode[0] == 'w') {
        if (mode.indexOf('+') != -1) {
          flags = 2;
        } else {
          flags = 1;
        }
        flags |= 64;
        flags |= 512;
      } else if (mode[0] == 'a') {
        if (mode.indexOf('+') != -1) {
          flags = 2;
        } else {
          flags = 1;
        }
        flags |= 64;
        flags |= 1024;
      } else {
        ___setErrNo(ERRNO_CODES.EINVAL);
        return 0;
      }
      var fd = _open(filename, flags, allocate([0x1FF, 0, 0, 0], 'i32', ALLOC_STACK));  // All creation permissions.
      return fd === -1 ? 0 : FS.getPtrForStream(FS.getStream(fd));
    }

  
  
  function _recv(fd, buf, len, flags) {
      var sock = SOCKFS.getSocket(fd);
      if (!sock) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      // TODO honor flags
      return _read(fd, buf, len);
    }
  
  function _pread(fildes, buf, nbyte, offset) {
      // ssize_t pread(int fildes, void *buf, size_t nbyte, off_t offset);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/read.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        var slab = HEAP8;
        return FS.read(stream, slab, buf, nbyte, offset);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _read(fildes, buf, nbyte) {
      // ssize_t read(int fildes, void *buf, size_t nbyte);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/read.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
  
  
      try {
        var slab = HEAP8;
        return FS.read(stream, slab, buf, nbyte);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _fread(ptr, size, nitems, stream) {
      // size_t fread(void *restrict ptr, size_t size, size_t nitems, FILE *restrict stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fread.html
      var bytesToRead = nitems * size;
      if (bytesToRead == 0) {
        return 0;
      }
      var bytesRead = 0;
      var streamObj = FS.getStreamFromPtr(stream);
      if (!streamObj) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return 0;
      }
      while (streamObj.ungotten.length && bytesToRead > 0) {
        HEAP8[((ptr++)|0)]=streamObj.ungotten.pop();
        bytesToRead--;
        bytesRead++;
      }
      var err = _read(streamObj.fd, ptr, bytesToRead);
      if (err == -1) {
        if (streamObj) streamObj.error = true;
        return 0;
      }
      bytesRead += err;
      if (bytesRead < bytesToRead) streamObj.eof = true;
      return Math.floor(bytesRead / size);
    }

  
   
  Module["_rand_r"] = _rand_r;
  
  var ___rand_seed=allocate([0x0273459b, 0, 0, 0], "i32", ALLOC_STATIC); 
  Module["_rand"] = _rand;

  function _div(divt, numer, denom) {
      var quot = Math.floor(numer / denom);
      var rem = numer - quot * denom;
      HEAP32[((divt)>>2)]=quot;
      HEAP32[(((divt)+(4))>>2)]=rem;
      return divt;
    }


  function _fgetc(stream) {
      // int fgetc(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fgetc.html
      var streamObj = FS.getStreamFromPtr(stream);
      if (!streamObj) return -1;
      if (streamObj.eof || streamObj.error) return -1;
      var ret = _fread(_fgetc.ret, 1, 1, stream);
      if (ret == 0) {
        return -1;
      } else if (ret == -1) {
        streamObj.error = true;
        return -1;
      } else {
        return HEAPU8[((_fgetc.ret)|0)];
      }
    }

  
  function _lseek(fildes, offset, whence) {
      // off_t lseek(int fildes, off_t offset, int whence);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/lseek.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        return FS.llseek(stream, offset, whence);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _fseek(stream, offset, whence) {
      // int fseek(FILE *stream, long offset, int whence);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fseek.html
      var fd = _fileno(stream);
      var ret = _lseek(fd, offset, whence);
      if (ret == -1) {
        return -1;
      }
      stream = FS.getStreamFromPtr(stream);
      stream.eof = false;
      return 0;
    }

  function _SDL_GetAppState() {
      var state = 0;
  
      if (Browser.pointerLock) {
        state |= 0x01;  // SDL_APPMOUSEFOCUS
      }
      if (document.hasFocus()) {
        state |= 0x02;  // SDL_APPINPUTFOCUS
      }
      state |= 0x04;  // SDL_APPACTIVE
  
      return state;
    }

  function _SDL_FillRect(surf, rect, color) {
      var surfData = SDL.surfaces[surf];
      assert(!surfData.locked); // but we could unlock and re-lock if we must..
      
      if (surfData.isFlagSet(0x00200000 /* SDL_HWPALETTE */)) {
        //in SDL_HWPALETTE color is index (0..255)
        //so we should translate 1 byte value to
        //32 bit canvas
        var index = color * 3;
        color = SDL.translateRGBAToColor(surfData.colors[index], surfData.colors[index +1], surfData.colors[index +2], 255);
      }
  
      var r = rect ? SDL.loadRect(rect) : { x: 0, y: 0, w: surfData.width, h: surfData.height };
      surfData.ctx.save();
      surfData.ctx.fillStyle = SDL.translateColorToCSSRGBA(color);
      surfData.ctx.fillRect(r.x, r.y, r.w, r.h);
      surfData.ctx.restore();
      return 0;
    }

  function _SDL_LockSurface(surf) {
      var surfData = SDL.surfaces[surf];
  
      surfData.locked++;
      if (surfData.locked > 1) return 0;
  
      if (!surfData.buffer) {
        surfData.buffer = _malloc(surfData.width * surfData.height * 4);
        HEAP32[(((surf)+(20))>>2)]=surfData.buffer;
      }
  
      // Mark in C/C++-accessible SDL structure
      // SDL_Surface has the following fields: Uint32 flags, SDL_PixelFormat *format; int w, h; Uint16 pitch; void *pixels; ...
      // So we have fields all of the same size, and 5 of them before us.
      // TODO: Use macros like in library.js
      HEAP32[(((surf)+(20))>>2)]=surfData.buffer;
  
      if (surf == SDL.screen && Module.screenIsReadOnly && surfData.image) return 0;
  
      surfData.image = surfData.ctx.getImageData(0, 0, surfData.width, surfData.height);
      if (surf == SDL.screen) {
        var data = surfData.image.data;
        var num = data.length;
        for (var i = 0; i < num/4; i++) {
          data[i*4+3] = 255; // opacity, as canvases blend alpha
        }
      }
  
      if (SDL.defaults.copyOnLock) {
        // Copy pixel data to somewhere accessible to 'C/C++'
        if (surfData.isFlagSet(0x00200000 /* SDL_HWPALETTE */)) {
          // If this is neaded then
          // we should compact the data from 32bpp to 8bpp index.
          // I think best way to implement this is use
          // additional colorMap hash (color->index).
          // Something like this:
          //
          // var size = surfData.width * surfData.height;
          // var data = '';
          // for (var i = 0; i<size; i++) {
          //   var color = SDL.translateRGBAToColor(
          //     surfData.image.data[i*4   ], 
          //     surfData.image.data[i*4 +1], 
          //     surfData.image.data[i*4 +2], 
          //     255);
          //   var index = surfData.colorMap[color];
          //   HEAP8[(((surfData.buffer)+(i))|0)]=index;
          // }
          throw 'CopyOnLock is not supported for SDL_LockSurface with SDL_HWPALETTE flag set' + new Error().stack;
        } else {
        HEAPU8.set(surfData.image.data, surfData.buffer);
        }
      }
  
      return 0;
    }

  function _SDL_UnlockSurface(surf) {
      assert(!SDL.GL); // in GL mode we do not keep around 2D canvases and contexts
  
      var surfData = SDL.surfaces[surf];
  
      if (!surfData.locked || --surfData.locked > 0) {
        return;
      }
  
      // Copy pixel data to image
      if (surfData.isFlagSet(0x00200000 /* SDL_HWPALETTE */)) {
        SDL.copyIndexedColorData(surfData);
      } else if (!surfData.colors) {
        var data = surfData.image.data;
        var buffer = surfData.buffer;
        assert(buffer % 4 == 0, 'Invalid buffer offset: ' + buffer);
        var src = buffer >> 2;
        var dst = 0;
        var isScreen = surf == SDL.screen;
        var num;
        if (typeof CanvasPixelArray !== 'undefined' && data instanceof CanvasPixelArray) {
          // IE10/IE11: ImageData objects are backed by the deprecated CanvasPixelArray,
          // not UInt8ClampedArray. These don't have buffers, so we need to revert
          // to copying a byte at a time. We do the undefined check because modern
          // browsers do not define CanvasPixelArray anymore.
          num = data.length;
          while (dst < num) {
            var val = HEAP32[src]; // This is optimized. Instead, we could do HEAP32[(((buffer)+(dst))>>2)];
            data[dst  ] = val & 0xff;
            data[dst+1] = (val >> 8) & 0xff;
            data[dst+2] = (val >> 16) & 0xff;
            data[dst+3] = isScreen ? 0xff : ((val >> 24) & 0xff);
            src++;
            dst += 4;
          }
        } else {
          var data32 = new Uint32Array(data.buffer);
          num = data32.length;
          if (isScreen) {
            while (dst < num) {
              // HEAP32[src++] is an optimization. Instead, we could do HEAP32[(((buffer)+(dst))>>2)];
              data32[dst++] = HEAP32[src++] | 0xff000000;
            }
          } else {
            while (dst < num) {
              data32[dst++] = HEAP32[src++];
            }
          }
        }
      } else {
        var width = Module['canvas'].width;
        var height = Module['canvas'].height;
        var s = surfData.buffer;
        var data = surfData.image.data;
        var colors = surfData.colors;
        for (var y = 0; y < height; y++) {
          var base = y*width*4;
          for (var x = 0; x < width; x++) {
            // See comment above about signs
            var val = HEAPU8[((s++)|0)] * 3;
            var start = base + x*4;
            data[start]   = colors[val];
            data[start+1] = colors[val+1];
            data[start+2] = colors[val+2];
          }
          s += width*3;
        }
      }
      // Copy to canvas
      surfData.ctx.putImageData(surfData.image, 0, 0);
      // Note that we save the image, so future writes are fast. But, memory is not yet released
    }

  function _SDL_UpdateRect(surf, x, y, w, h) {
      // We actually do the whole screen in Unlock...
    }

  function _fwrite(ptr, size, nitems, stream) {
      // size_t fwrite(const void *restrict ptr, size_t size, size_t nitems, FILE *restrict stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fwrite.html
      var bytesToWrite = nitems * size;
      if (bytesToWrite == 0) return 0;
      var fd = _fileno(stream);
      var bytesWritten = _write(fd, ptr, bytesToWrite);
      if (bytesWritten == -1) {
        var streamObj = FS.getStreamFromPtr(stream);
        if (streamObj) streamObj.error = true;
        return 0;
      } else {
        return Math.floor(bytesWritten / size);
      }
    }

  function _time(ptr) {
      var ret = Math.floor(Date.now()/1000);
      if (ptr) {
        HEAP32[((ptr)>>2)]=ret;
      }
      return ret;
    }

  
  var ___tm_current=allocate(44, "i8", ALLOC_STATIC);
  
  
  var ___tm_timezone=allocate(intArrayFromString("GMT"), "i8", ALLOC_STATIC);
  
  
  var _tzname=allocate(8, "i32*", ALLOC_STATIC);
  
  var _daylight=allocate(1, "i32*", ALLOC_STATIC);
  
  var _timezone=allocate(1, "i32*", ALLOC_STATIC);function _tzset() {
      // TODO: Use (malleable) environment variables instead of system settings.
      if (_tzset.called) return;
      _tzset.called = true;
  
      HEAP32[((_timezone)>>2)]=-(new Date()).getTimezoneOffset() * 60;
  
      var winter = new Date(2000, 0, 1);
      var summer = new Date(2000, 6, 1);
      HEAP32[((_daylight)>>2)]=Number(winter.getTimezoneOffset() != summer.getTimezoneOffset());
  
      var winterName = 'GMT'; // XXX do not rely on browser timezone info, it is very unpredictable | winter.toString().match(/\(([A-Z]+)\)/)[1];
      var summerName = 'GMT'; // XXX do not rely on browser timezone info, it is very unpredictable | summer.toString().match(/\(([A-Z]+)\)/)[1];
      var winterNamePtr = allocate(intArrayFromString(winterName), 'i8', ALLOC_NORMAL);
      var summerNamePtr = allocate(intArrayFromString(summerName), 'i8', ALLOC_NORMAL);
      HEAP32[((_tzname)>>2)]=winterNamePtr;
      HEAP32[(((_tzname)+(4))>>2)]=summerNamePtr;
    }function _localtime_r(time, tmPtr) {
      _tzset();
      var date = new Date(HEAP32[((time)>>2)]*1000);
      HEAP32[((tmPtr)>>2)]=date.getSeconds();
      HEAP32[(((tmPtr)+(4))>>2)]=date.getMinutes();
      HEAP32[(((tmPtr)+(8))>>2)]=date.getHours();
      HEAP32[(((tmPtr)+(12))>>2)]=date.getDate();
      HEAP32[(((tmPtr)+(16))>>2)]=date.getMonth();
      HEAP32[(((tmPtr)+(20))>>2)]=date.getFullYear()-1900;
      HEAP32[(((tmPtr)+(24))>>2)]=date.getDay();
  
      var start = new Date(date.getFullYear(), 0, 1);
      var yday = Math.floor((date.getTime() - start.getTime()) / (1000 * 60 * 60 * 24));
      HEAP32[(((tmPtr)+(28))>>2)]=yday;
      HEAP32[(((tmPtr)+(36))>>2)]=start.getTimezoneOffset() * 60;
  
      var dst = Number(start.getTimezoneOffset() != date.getTimezoneOffset());
      HEAP32[(((tmPtr)+(32))>>2)]=dst;
  
      HEAP32[(((tmPtr)+(40))>>2)]=___tm_timezone;
  
      return tmPtr;
    }function _localtime(time) {
      return _localtime_r(time, ___tm_current);
    }

  function _llvm_lifetime_start() {}

  function _SDL_WM_ToggleFullScreen(surf) {
      if (Browser.isFullScreen) {
        Module['canvas'].cancelFullScreen();
        return 1;
      } else {
        if (!SDL.canRequestFullscreen) {
          return 0;
        }
        SDL.isRequestingFullscreen = true;
        return 1;
      }
    }

  function _abort() {
      Module['abort']();
    }

  function ___errno_location() {
      return ___errno_state;
    }

  function _sbrk(bytes) {
      // Implement a Linux-like 'memory area' for our 'process'.
      // Changes the size of the memory area by |bytes|; returns the
      // address of the previous top ('break') of the memory area
      // We control the "dynamic" memory - DYNAMIC_BASE to DYNAMICTOP
      var self = _sbrk;
      if (!self.called) {
        DYNAMICTOP = alignMemoryPage(DYNAMICTOP); // make sure we start out aligned
        self.called = true;
        assert(Runtime.dynamicAlloc);
        self.alloc = Runtime.dynamicAlloc;
        Runtime.dynamicAlloc = function() { abort('cannot dynamically allocate, sbrk now has control') };
      }
      var ret = DYNAMICTOP;
      if (bytes != 0) self.alloc(bytes);
      return ret;  // Previous break location.
    }

  function _sysconf(name) {
      // long sysconf(int name);
      // http://pubs.opengroup.org/onlinepubs/009695399/functions/sysconf.html
      switch(name) {
        case 30: return PAGE_SIZE;
        case 132:
        case 133:
        case 12:
        case 137:
        case 138:
        case 15:
        case 235:
        case 16:
        case 17:
        case 18:
        case 19:
        case 20:
        case 149:
        case 13:
        case 10:
        case 236:
        case 153:
        case 9:
        case 21:
        case 22:
        case 159:
        case 154:
        case 14:
        case 77:
        case 78:
        case 139:
        case 80:
        case 81:
        case 79:
        case 82:
        case 68:
        case 67:
        case 164:
        case 11:
        case 29:
        case 47:
        case 48:
        case 95:
        case 52:
        case 51:
        case 46:
          return 200809;
        case 27:
        case 246:
        case 127:
        case 128:
        case 23:
        case 24:
        case 160:
        case 161:
        case 181:
        case 182:
        case 242:
        case 183:
        case 184:
        case 243:
        case 244:
        case 245:
        case 165:
        case 178:
        case 179:
        case 49:
        case 50:
        case 168:
        case 169:
        case 175:
        case 170:
        case 171:
        case 172:
        case 97:
        case 76:
        case 32:
        case 173:
        case 35:
          return -1;
        case 176:
        case 177:
        case 7:
        case 155:
        case 8:
        case 157:
        case 125:
        case 126:
        case 92:
        case 93:
        case 129:
        case 130:
        case 131:
        case 94:
        case 91:
          return 1;
        case 74:
        case 60:
        case 69:
        case 70:
        case 4:
          return 1024;
        case 31:
        case 42:
        case 72:
          return 32;
        case 87:
        case 26:
        case 33:
          return 2147483647;
        case 34:
        case 1:
          return 47839;
        case 38:
        case 36:
          return 99;
        case 43:
        case 37:
          return 2048;
        case 0: return 2097152;
        case 3: return 65536;
        case 28: return 32768;
        case 44: return 32767;
        case 75: return 16384;
        case 39: return 1000;
        case 89: return 700;
        case 71: return 256;
        case 40: return 255;
        case 2: return 100;
        case 180: return 64;
        case 25: return 20;
        case 5: return 16;
        case 6: return 6;
        case 73: return 4;
        case 84: return 1;
      }
      ___setErrNo(ERRNO_CODES.EINVAL);
      return -1;
    }






FS.staticInit();__ATINIT__.unshift({ func: function() { if (!Module["noFSInit"] && !FS.init.initialized) FS.init() } });__ATMAIN__.push({ func: function() { FS.ignorePermissions = false } });__ATEXIT__.push({ func: function() { FS.quit() } });Module["FS_createFolder"] = FS.createFolder;Module["FS_createPath"] = FS.createPath;Module["FS_createDataFile"] = FS.createDataFile;Module["FS_createPreloadedFile"] = FS.createPreloadedFile;Module["FS_createLazyFile"] = FS.createLazyFile;Module["FS_createLink"] = FS.createLink;Module["FS_createDevice"] = FS.createDevice;
___errno_state = Runtime.staticAlloc(4); HEAP32[((___errno_state)>>2)]=0;
__ATINIT__.unshift({ func: function() { TTY.init() } });__ATEXIT__.push({ func: function() { TTY.shutdown() } });TTY.utf8 = new Runtime.UTF8Processor();
if (ENVIRONMENT_IS_NODE) { var fs = require("fs"); NODEFS.staticInit(); }
Module["requestFullScreen"] = function Module_requestFullScreen(lockPointer, resizeCanvas) { Browser.requestFullScreen(lockPointer, resizeCanvas) };
  Module["requestAnimationFrame"] = function Module_requestAnimationFrame(func) { Browser.requestAnimationFrame(func) };
  Module["setCanvasSize"] = function Module_setCanvasSize(width, height, noUpdates) { Browser.setCanvasSize(width, height, noUpdates) };
  Module["pauseMainLoop"] = function Module_pauseMainLoop() { Browser.mainLoop.pause() };
  Module["resumeMainLoop"] = function Module_resumeMainLoop() { Browser.mainLoop.resume() };
  Module["getUserMedia"] = function Module_getUserMedia() { Browser.getUserMedia() }
__ATINIT__.push({ func: function() { SOCKFS.root = FS.mount(SOCKFS, {}, null); } });
_fputc.ret = allocate([0], "i8", ALLOC_STATIC);
_fgetc.ret = allocate([0], "i8", ALLOC_STATIC);
STACK_BASE = STACKTOP = Runtime.alignMemory(STATICTOP);

staticSealed = true; // seal the static portion of memory

STACK_MAX = STACK_BASE + 5242880;

DYNAMIC_BASE = DYNAMICTOP = Runtime.alignMemory(STACK_MAX);

assert(DYNAMIC_BASE < TOTAL_MEMORY, "TOTAL_MEMORY not big enough for stack");


var Math_min = Math.min;
function invoke_viiiii(index,a1,a2,a3,a4,a5) {
  try {
    Module["dynCall_viiiii"](index,a1,a2,a3,a4,a5);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_vi(index,a1) {
  try {
    Module["dynCall_vi"](index,a1);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_ii(index,a1) {
  try {
    return Module["dynCall_ii"](index,a1);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiii(index,a1,a2,a3) {
  try {
    return Module["dynCall_iiii"](index,a1,a2,a3);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_v(index) {
  try {
    Module["dynCall_v"](index);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iii(index,a1,a2) {
  try {
    return Module["dynCall_iii"](index,a1,a2);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiii(index,a1,a2,a3,a4) {
  try {
    Module["dynCall_viiii"](index,a1,a2,a3,a4);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function asmPrintInt(x, y) {
  Module.print('int ' + x + ',' + y);// + ' ' + new Error().stack);
}
function asmPrintFloat(x, y) {
  Module.print('float ' + x + ',' + y);// + ' ' + new Error().stack);
}
// EMSCRIPTEN_START_ASM
var asm=(function(global,env,buffer){"use asm";var a=new global.Int8Array(buffer);var b=new global.Int16Array(buffer);var c=new global.Int32Array(buffer);var d=new global.Uint8Array(buffer);var e=new global.Uint16Array(buffer);var f=new global.Uint32Array(buffer);var g=new global.Float32Array(buffer);var h=new global.Float64Array(buffer);var i=env.STACKTOP|0;var j=env.STACK_MAX|0;var k=env.tempDoublePtr|0;var l=env.ABORT|0;var m=env.___rand_seed|0;var n=env._stdout|0;var o=+env.NaN;var p=+env.Infinity;var q=0;var r=0;var s=0;var t=0;var u=0,v=0,w=0,x=0,y=0.0,z=0,A=0,B=0,C=0.0;var D=0;var E=0;var F=0;var G=0;var H=0;var I=0;var J=0;var K=0;var L=0;var M=0;var N=global.Math.floor;var O=global.Math.abs;var P=global.Math.sqrt;var Q=global.Math.pow;var R=global.Math.cos;var S=global.Math.sin;var T=global.Math.tan;var U=global.Math.acos;var V=global.Math.asin;var W=global.Math.atan;var X=global.Math.atan2;var Y=global.Math.exp;var Z=global.Math.log;var _=global.Math.ceil;var $=global.Math.imul;var aa=env.abort;var ba=env.assert;var ca=env.asmPrintInt;var da=env.asmPrintFloat;var ea=env.min;var fa=env.invoke_viiiii;var ga=env.invoke_vi;var ha=env.invoke_ii;var ia=env.invoke_iiii;var ja=env.invoke_v;var ka=env.invoke_iii;var la=env.invoke_viiii;var ma=env._tzset;var na=env._sysconf;var oa=env._SDL_MapRGB;var pa=env._fgetc;var qa=env._fclose;var ra=env._SDL_WM_ToggleFullScreen;var sa=env._abort;var ta=env._lseek;var ua=env._div;var va=env._pread;var wa=env._close;var xa=env._SDL_SetVideoMode;var ya=env._fopen;var za=env._fflush;var Aa=env._SDL_FillRect;var Ba=env._fputc;var Ca=env._SDL_LockSurface;var Da=env._puts;var Ea=env.___setErrNo;var Fa=env._open;var Ga=env._fseek;var Ha=env._send;var Ia=env._write;var Ja=env._fputs;var Ka=env._mkport;var La=env._exit;var Ma=env._SDL_GetAppState;var Na=env._SDL_UpdateRect;var Oa=env._localtime;var Pa=env._fread;var Qa=env._read;var Ra=env._emscripten_set_main_loop;var Sa=env._time;var Ta=env._localtime_r;var Ua=env._SDL_UnlockSurface;var Va=env._emscripten_memcpy_big;var Wa=env._SDL_WM_SetCaption;var Xa=env._recv;var Ya=env._fileno;var Za=env._pwrite;var _a=env._SDL_PollEvent;var $a=env._fsync;var ab=env._SDL_Init;var bb=env.___errno_location;var cb=env._llvm_lifetime_start;var db=env._SDL_Quit;var eb=env._sbrk;var fb=env._fwrite;var gb=env.__exit;var hb=0.0;
// EMSCRIPTEN_START_FUNCS
function pb(a){a=a|0;var b=0;b=i;i=i+a|0;i=i+7&-8;return b|0}function qb(){return i|0}function rb(a){a=a|0;i=a}function sb(a,b){a=a|0;b=b|0;if((q|0)==0){q=a;r=b}}function tb(b){b=b|0;a[k]=a[b];a[k+1|0]=a[b+1|0];a[k+2|0]=a[b+2|0];a[k+3|0]=a[b+3|0]}function ub(b){b=b|0;a[k]=a[b];a[k+1|0]=a[b+1|0];a[k+2|0]=a[b+2|0];a[k+3|0]=a[b+3|0];a[k+4|0]=a[b+4|0];a[k+5|0]=a[b+5|0];a[k+6|0]=a[b+6|0];a[k+7|0]=a[b+7|0]}function vb(a){a=a|0;D=a}function wb(a){a=a|0;E=a}function xb(a){a=a|0;F=a}function yb(a){a=a|0;G=a}function zb(a){a=a|0;H=a}function Ab(a){a=a|0;I=a}function Bb(a){a=a|0;J=a}function Cb(a){a=a|0;K=a}function Db(a){a=a|0;L=a}function Eb(a){a=a|0;M=a}function Fb(){}function Gb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;if(a[40]|0){h=b;xc(h|0,0,128)|0;h=b+60|0;c[h>>2]=-1;return}else{d=0}do{e=d&255&-88;a[6864+d|0]=e;if((d|0)==0){f=4}else{h=d;f=0;while(1){g=h&1;h=h>>1;if((h|0)==0){break}else{f=g^f}}f=(f|0)!=(g|0)?0:4}a[7120+d|0]=f;a[6608+d|0]=f|e;d=d+1|0;}while((d|0)<256);a[6864]=a[6864]|64;a[6608]=a[6608]|64;a[40]=1;h=b;xc(h|0,0,128)|0;h=b+60|0;c[h>>2]=-1;return}function Hb(b){b=b|0;var c=0,d=0,e=0,f=0,g=0;if(a[40]|0){g=b+72|0;xc(g|0,0,36)|0;return}else{c=0}do{d=c&255&-88;a[6864+c|0]=d;if((c|0)==0){e=4}else{g=c;e=0;while(1){f=g&1;g=g>>1;if((g|0)==0){break}else{e=f^e}}e=(e|0)!=(f|0)?0:4}a[7120+c|0]=e;a[6608+c|0]=e|d;c=c+1|0;}while((c|0)<256);a[6864]=a[6864]|64;a[6608]=a[6608]|64;a[40]=1;g=b+72|0;xc(g|0,0,36)|0;return}function Ib(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;if(!(a[40]|0)){d=0;do{e=d&255&-88;a[6864+d|0]=e;if((d|0)==0){f=4}else{h=d;f=0;while(1){g=h&1;h=h>>1;if((h|0)==0){break}else{f=g^f}}f=(f|0)!=(g|0)?0:4}a[7120+d|0]=f;a[6608+d|0]=f|e;d=d+1|0;}while((d|0)<256);a[6864]=a[6864]|64;a[6608]=a[6608]|64;a[40]=1}c[b+44>>2]=0;c[b+40>>2]=0;a[b+48|0]=0;c[b+52>>2]=0;c[b+64>>2]=0;c[b+56>>2]=0;xc(b|0,0,22)|0;xc(b+28|0,0,10)|0;c[b+24>>2]=b+4;a[b+120|0]=0;return}function Jb(f,g){f=f|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0;r=f+56|0;v=c[r>>2]|0;x=f+60|0;w=(g|0)<0;aa=f+34|0;u=f+32|0;o=f+116|0;q=f+108|0;$=f+30|0;t=f+80|0;s=f+68|0;p=f+72|0;W=f+37|0;I=f+120|0;G=f+6|0;j=G;k=f+64|0;l=f+4|0;m=f+24|0;n=f+52|0;Z=G|0;_=f+20|0;C=f+1|0;T=f+36|0;A=f+28|0;D=f|0;E=f+2|0;L=f+8|0;F=f+76|0;G=G+1|0;N=f;Y=f+28|0;ba=Y;Y=Y+1|0;O=f+2|0;ca=O|0;P=O;O=O+1|0;Q=l+1|0;R=l;da=f+14|0;ea=f+16|0;B=l|0;fa=f+18|0;h=f+92|0;S=f+88|0;M=f+84|0;J=f+44|0;K=f+40|0;U=f+100|0;V=f+96|0;i=f+48|0;X=f+4|0;H=f+104|0;y=f+10|0;z=f+12|0;ha=0;ja=0;ia=0;a:while(1){ka=c[x>>2]|0;if((ka|0)>=0){if((c[r>>2]|0)>=(ka|0)){ga=795;break}}if(!w){if(((c[r>>2]|0)-v|0)>(g|0)){ga=795;break}}b[u>>1]=b[aa>>1]|0;c[o>>2]=0;if((c[q>>2]|0)!=0){break}while(1){la=b[$>>1]|0;b[aa>>1]=la;ka=c[r>>2]|0;ma=c[t>>2]|0;if((ma|0)==0){c[r>>2]=ka+4;ma=la}else{ib[ma&1](f,la,4,0,32);ma=b[$>>1]|0}b[aa>>1]=ma;do{if((c[s>>2]|0)!=0){la=c[r>>2]|0;if((la&1|0)==0){break}c[r>>2]=la+1}}while(0);na=lb[c[p>>2]&7](f,ma,0)|0;la=b[$>>1]|0;b[aa>>1]=la;if((c[q>>2]|0)!=0){ga=18;break a}if((c[o>>2]|0)==0){break}c[r>>2]=ka;c[o>>2]=0}b[aa>>1]=la;ma=la+1&65535;b[$>>1]=ma;pa=a[W]|0;a[W]=pa+1&127|pa&-128;pa=a[I]|0;a[I]=a[j]|0;c[k>>2]=0;c[m>>2]=l;if((c[n>>2]|0)!=0){b[$>>1]=la;continue}do{if((na<<24>>24|0)==(-3|0)|(na<<24>>24|0)==(-35|0)){c[m>>2]=na<<24>>24==-35?y:z;ka=c[t>>2]|0;if((ka|0)==0){c[r>>2]=(c[r>>2]|0)+4}else{ib[ka&1](f,ma,4,1,32);ma=b[$>>1]|0}na=lb[c[p>>2]&7](f,ma,1)|0;ma=(b[$>>1]|0)+1&65535;b[$>>1]=ma;qa=a[W]|0;a[W]=qa+1&127|qa&-128;qa=na&255;if((c[8+(qa>>>5<<2)>>2]&1<<(qa&31)|0)==0){oa=1;ka=0;break}ka=c[t>>2]|0;if((ka|0)==0){c[r>>2]=(c[r>>2]|0)+3}else{ib[ka&1](f,ma,3,2,32)}qa=lb[c[p>>2]&7](f,ma,3)|0;ka=qa&255;ka=qa<<24>>24<0?ka|-256:ka;ma=(b[$>>1]|0)+1&65535;b[$>>1]=ma;b[A>>1]=(e[c[m>>2]>>1]|0)+ka;oa=1}else{oa=0;ka=0}}while(0);la=na&255;if((na<<24>>24|0)==(-19|0)){c[m>>2]=l;ka=c[t>>2]|0;if((ka|0)==0){c[r>>2]=(c[r>>2]|0)+4}else{ib[ka&1](f,ma,4,1,32);ma=b[$>>1]|0}la=lb[c[p>>2]&7](f,ma,1)|0;na=(b[$>>1]|0)+1&65535;b[$>>1]=na;ma=a[W]|0;ma=ma+1&127|ma&-128;a[W]=ma;ka=la&255;switch(ka|0){case 160:case 176:case 168:case 184:{ia=b[B>>1]|0;la=c[t>>2]|0;if((la|0)==0){c[r>>2]=(c[r>>2]|0)+3}else{ib[la&1](f,ia,3,3,32)}ia=lb[c[p>>2]&7](f,ia,3)|0;la=c[t>>2]|0;if((la|0)==0){c[r>>2]=(c[r>>2]|0)+3}else{ib[la&1](f,b[E>>1]|0,3,3,16)}ob[c[F>>2]&7](f,b[E>>1]|0,ia,3);la=c[t>>2]|0;if((la|0)==0){c[r>>2]=(c[r>>2]|0)+2}else{ib[la&1](f,b[E>>1]|0,1,4,0);ib[c[t>>2]&1](f,b[E>>1]|0,1,4,0)}la=(b[D>>1]|0)-1&65535;b[D>>1]=la;ma=(d[G]|0)+(ia&255)|0;ia=ma&255;a[I]=0;a[j]=ma&8|a[j]&193|(la<<16>>16!=0?4:0)|ma<<4&32;if(!((ka&16|0)==0|la<<16>>16==0)){la=c[t>>2]|0;if((la|0)==0){c[r>>2]=(c[r>>2]|0)+5}else{ib[la&1](f,b[E>>1]|0,1,4,0);ib[c[t>>2]&1](f,b[E>>1]|0,1,4,0);ib[c[t>>2]&1](f,b[E>>1]|0,1,4,0);ib[c[t>>2]&1](f,b[E>>1]|0,1,4,0);ib[c[t>>2]&1](f,b[E>>1]|0,1,4,0)}qa=b[$>>1]|0;b[$>>1]=qa-2;b[A>>1]=qa-1}la=b[B>>1]|0;if((ka&8|0)==0){b[B>>1]=la+1;b[E>>1]=(b[E>>1]|0)+1;continue a}else{b[B>>1]=la-1;b[E>>1]=(b[E>>1]|0)-1;continue a}};case 161:case 177:case 169:case 185:{la=(ka&16|0)!=0;do{if(la){if((b[D>>1]|0)==1){ga=55;break}qa=lb[c[p>>2]&7](f,b[B>>1]|0,4)|0;if(qa<<24>>24==(a[G]|0)){ga=55;break}ia=(b[aa>>1]|0)+1&65535}else{ga=55}}while(0);if((ga|0)==55){ga=0;ia=(ka>>>2&2^2)+65535+(e[A>>1]|0)&65535}b[A>>1]=ia;ia=b[B>>1]|0;ma=c[t>>2]|0;if((ma|0)==0){c[r>>2]=(c[r>>2]|0)+3}else{ib[ma&1](f,ia,3,3,32)}ia=lb[c[p>>2]&7](f,ia,3)|0;ma=c[t>>2]|0;if((ma|0)==0){c[r>>2]=(c[r>>2]|0)+5}else{ib[ma&1](f,b[B>>1]|0,1,4,0);ib[c[t>>2]&1](f,b[B>>1]|0,1,4,0);ib[c[t>>2]&1](f,b[B>>1]|0,1,4,0);ib[c[t>>2]&1](f,b[B>>1]|0,1,4,0);ib[c[t>>2]&1](f,b[B>>1]|0,1,4,0)}ma=(b[D>>1]|0)-1&65535;b[D>>1]=ma;a[I]=0;qa=d[G]|0;ia=ia&255;na=(qa&15)-(ia&15)>>31&16;ia=qa-ia|0;ma=(((ia&255|0)==0?64:0)|ia&128|(a[j]&1|(ma<<16>>16!=0?4:0)|na|2))&255;a[j]=ma;if((na|0)==0){ia=ia&255}else{ia=ia+255&255}a[j]=ma|ia&8|ia<<4&32;do{if(la){if(!((ma&68)==4)){break}la=c[t>>2]|0;if((la|0)==0){c[r>>2]=(c[r>>2]|0)+5}else{ib[la&1](f,b[B>>1]|0,1,4,0);ib[c[t>>2]&1](f,b[B>>1]|0,1,4,0);ib[c[t>>2]&1](f,b[B>>1]|0,1,4,0);ib[c[t>>2]&1](f,b[B>>1]|0,1,4,0);ib[c[t>>2]&1](f,b[B>>1]|0,1,4,0)}b[$>>1]=(b[$>>1]|0)-2}}while(0);la=b[B>>1]|0;if((ka&8|0)==0){b[B>>1]=la+1;continue a}else{b[B>>1]=la-1;continue a}};case 163:case 179:case 171:case 187:{a[C]=(a[C]|0)-1;break};case 162:case 178:case 170:case 186:{break};default:{if((ka&192|0)!=64){ka=c[H>>2]|0;if((ka|0)==0){continue a}if((nb[ka&1](f,la)|0)==0){continue a}else{ga=795;break a}}switch(ka&7|0){case 0:{ia=b[D>>1]|0;b[A>>1]=ia+1;la=c[h>>2]|0;if((la|0)==0){c[r>>2]=(c[r>>2]|0)+3}else{ob[la&7](f,ia,1,48);ob[c[h>>2]&7](f,ia,2,16)}ia=lb[c[M>>2]&7](f,ia,0)|0;c[r>>2]=(c[r>>2]|0)+1;a[I]=0;a[j]=a[j]&1|a[6608+(ia&255)|0];switch(ka>>>3&7|0){case 0:{a[C]=ia;continue a};case 1:{a[N]=ia;continue a};case 2:{a[O]=ia;continue a};case 3:{a[P]=ia;continue a};case 4:{a[Q]=ia;continue a};case 5:{a[R]=ia;continue a};case 7:{a[G]=ia;continue a};default:{continue a}}};case 1:{la=b[D>>1]|0;b[A>>1]=la+1;switch(ka>>>3&7|0){case 0:{ia=a[C]|0;break};case 1:{ia=la&255;break};case 2:{ia=a[O]|0;break};case 3:{ia=a[P]|0;break};case 4:{ia=a[Q]|0;break};case 5:{ia=a[R]|0;break};case 7:{ia=a[G]|0;break};default:{ia=0}}ka=c[h>>2]|0;if((ka|0)==0){c[r>>2]=(c[r>>2]|0)+1}else{ob[ka&7](f,la,1,32)}ob[c[S>>2]&7](f,la,ia,0);ka=c[h>>2]|0;if((ka|0)==0){c[r>>2]=(c[r>>2]|0)+3;continue a}else{ob[ka&7](f,la,2,0);c[r>>2]=(c[r>>2]|0)+1;continue a}};case 2:{ja=c[t>>2]|0;if((ja|0)==0){c[r>>2]=(c[r>>2]|0)+7}else{ib[ja&1](f,d[T]<<8|ma&255,1,4,0);ib[c[t>>2]&1](f,d[T]<<8|d[W],1,4,0);ib[c[t>>2]&1](f,d[T]<<8|d[W],1,4,0);ib[c[t>>2]&1](f,d[T]<<8|d[W],1,4,0);ib[c[t>>2]&1](f,d[T]<<8|d[W],1,4,0);ib[c[t>>2]&1](f,d[T]<<8|d[W],1,4,0);ib[c[t>>2]&1](f,d[T]<<8|d[W],1,4,0)}ja=ka>>>4&3;if((ja|0)==1){ja=E}else if((ja|0)==2){ja=B}else if((ja|0)==0){ja=D}else{ja=L}ja=b[ja>>1]|0;oa=b[B>>1]|0;if((ka&8|0)==0){ka=a[G]|0;b[A>>1]=oa+1;la=oa&255;na=ja&255;ma=a[j]&1;qa=la-na-ma|0;a[G]=qa;a[I]=0;ma=(la&15)-(na&15)-ma>>31&16|d[6864+(qa&255)|0]|(qa&65280)>>>0>255>>>0;a[j]=((qa^la)&((oa^ja)&128))>>>5&4|ma|2;oa=(oa&65535)>>>8;la=(ja&65535)>>>8;na=oa&65535;ra=la&65535;ma=ma&1;pa=na-ra-ma|0;a[G]=pa;a[I]=0;la=(d[6864+(pa&255)|0]|(na&15)-(ra&15)-ma>>31&16|(pa&65280)>>>0>255>>>0|((pa^na)&((oa^la)&65535))>>>5&4|2)&255;qa=(pa&65535)<<8|qa&255;a[G]=ka;ka=qa;la=qa<<16>>16!=0?la&-65:la|64}else{ma=ja&65535;na=oa&65535;ra=a[j]&1;la=na+ma+ra|0;b[A>>1]=oa+1;a[I]=0;ka=la&65535;la=(la>>>0>65535>>>0|la>>>8&168|(((na&4095)+(ma&4095)+ra|0)>4095?16:0)|((la&65535|0)==0?64:0)|((la^ma)&(ma^32768^na))>>>13&4)&255}a[j]=la;b[B>>1]=ka;continue a};case 3:{ja=c[t>>2]|0;if((ja|0)==0){c[r>>2]=(c[r>>2]|0)+3}else{ib[ja&1](f,na,3,2,32)}ja=lb[c[p>>2]&7](f,na,3)|0;ma=(b[$>>1]|0)+1&65535;b[$>>1]=ma;la=c[t>>2]|0;if((la|0)==0){c[r>>2]=(c[r>>2]|0)+3}else{ib[la&1](f,ma,3,2,32)}ja=((lb[c[p>>2]&7](f,ma,3)|0)&255)<<8|ja&255;b[$>>1]=(b[$>>1]|0)+1;la=ja+1&65535;b[A>>1]=la;ma=ka>>>4&3;if((ka&8|0)==0){if((ma|0)==0){ka=b[D>>1]|0;ma=c[t>>2]|0;if((ma|0)==0){c[r>>2]=(c[r>>2]|0)+3}else{ib[ma&1](f,ja,3,3,16)}ob[c[F>>2]&7](f,ja,ka&255,3);ma=c[t>>2]|0;if((ma|0)==0){c[r>>2]=(c[r>>2]|0)+3}else{ib[ma&1](f,la,3,3,16)}ob[c[F>>2]&7](f,la,(ka&65535)>>>8&255,3);continue a}else if((ma|0)==1){ka=b[E>>1]|0;ma=c[t>>2]|0;if((ma|0)==0){c[r>>2]=(c[r>>2]|0)+3}else{ib[ma&1](f,ja,3,3,16)}ob[c[F>>2]&7](f,ja,ka&255,3);ma=c[t>>2]|0;if((ma|0)==0){c[r>>2]=(c[r>>2]|0)+3}else{ib[ma&1](f,la,3,3,16)}ob[c[F>>2]&7](f,la,(ka&65535)>>>8&255,3);continue a}else if((ma|0)==2){ka=b[B>>1]|0;ma=c[t>>2]|0;if((ma|0)==0){c[r>>2]=(c[r>>2]|0)+3}else{ib[ma&1](f,ja,3,3,16)}ob[c[F>>2]&7](f,ja,ka&255,3);ma=c[t>>2]|0;if((ma|0)==0){c[r>>2]=(c[r>>2]|0)+3}else{ib[ma&1](f,la,3,3,16)}ob[c[F>>2]&7](f,la,(ka&65535)>>>8&255,3);continue a}else if((ma|0)==3){ka=b[L>>1]|0;ma=c[t>>2]|0;if((ma|0)==0){c[r>>2]=(c[r>>2]|0)+3}else{ib[ma&1](f,ja,3,3,16)}ob[c[F>>2]&7](f,ja,ka&255,3);ma=c[t>>2]|0;if((ma|0)==0){c[r>>2]=(c[r>>2]|0)+3}else{ib[ma&1](f,la,3,3,16)}ob[c[F>>2]&7](f,la,(ka&65535)>>>8&255,3);continue a}else{continue a}}else{if((ma|0)==0){ka=c[t>>2]|0;if((ka|0)==0){c[r>>2]=(c[r>>2]|0)+3}else{ib[ka&1](f,ja,3,3,32)}ka=(lb[c[p>>2]&7](f,ja,3)|0)&255;ma=c[t>>2]|0;if((ma|0)==0){c[r>>2]=(c[r>>2]|0)+3}else{ib[ma&1](f,la,3,3,32)}b[D>>1]=((lb[c[p>>2]&7](f,la,3)|0)&255)<<8|ka;continue a}else if((ma|0)==1){ka=c[t>>2]|0;if((ka|0)==0){c[r>>2]=(c[r>>2]|0)+3}else{ib[ka&1](f,ja,3,3,32)}ka=(lb[c[p>>2]&7](f,ja,3)|0)&255;ma=c[t>>2]|0;if((ma|0)==0){c[r>>2]=(c[r>>2]|0)+3}else{ib[ma&1](f,la,3,3,32)}b[E>>1]=((lb[c[p>>2]&7](f,la,3)|0)&255)<<8|ka;continue a}else if((ma|0)==2){ka=c[t>>2]|0;if((ka|0)==0){c[r>>2]=(c[r>>2]|0)+3}else{ib[ka&1](f,ja,3,3,32)}ka=(lb[c[p>>2]&7](f,ja,3)|0)&255;ma=c[t>>2]|0;if((ma|0)==0){c[r>>2]=(c[r>>2]|0)+3}else{ib[ma&1](f,la,3,3,32)}b[B>>1]=((lb[c[p>>2]&7](f,la,3)|0)&255)<<8|ka;continue a}else if((ma|0)==3){ka=c[t>>2]|0;if((ka|0)==0){c[r>>2]=(c[r>>2]|0)+3}else{ib[ka&1](f,ja,3,3,32)}ka=(lb[c[p>>2]&7](f,ja,3)|0)&255;ma=c[t>>2]|0;if((ma|0)==0){c[r>>2]=(c[r>>2]|0)+3}else{ib[ma&1](f,la,3,3,32)}b[L>>1]=((lb[c[p>>2]&7](f,la,3)|0)&255)<<8|ka;continue a}else{continue a}}};case 4:{ia=a[G]|0;a[j]=a[j]&-2;qa=ia&255;ra=-qa|0;a[G]=ra;a[I]=0;a[j]=d[6864+(ra&255)|0]|(ra&65280)>>>0>255>>>0|-(qa&15)>>31&16|(qa&ra)>>>5&4|2;continue a};case 5:{c[K>>2]=c[J>>2];na=b[L>>1]|0;ma=c[t>>2]|0;if((ma|0)==0){c[r>>2]=(c[r>>2]|0)+3}else{ib[ma&1](f,na,3,3,32)}na=lb[c[p>>2]&7](f,na,3)|0;ma=(b[L>>1]|0)+1&65535;b[L>>1]=ma;oa=c[t>>2]|0;if((oa|0)==0){c[r>>2]=(c[r>>2]|0)+3}else{ib[oa&1](f,ma,3,3,32)}ra=((lb[c[p>>2]&7](f,ma,3)|0)&255)<<8|na&255;b[L>>1]=(b[L>>1]|0)+1;b[$>>1]=ra;b[A>>1]=ra;if((ka&8|0)==0){ka=c[U>>2]|0;if((ka|0)==0){continue a}if((nb[ka&1](f,la)|0)==0){continue a}else{ga=795;break a}}else{ka=c[V>>2]|0;if((ka|0)==0){continue a}if((nb[ka&1](f,la)|0)==0){continue a}else{ga=795;break a}}};case 6:{if((ka|0)==86|(ka|0)==118){a[i]=1;continue a}else if((ka|0)==94|(ka|0)==126){a[i]=2;continue a}else{a[i]=0;continue a}};case 7:{switch(ka|0){case 71:{ka=c[t>>2]|0;if((ka|0)==0){c[r>>2]=(c[r>>2]|0)+1}else{ib[ka&1](f,d[T]<<8|ma&255,1,4,0)}a[T]=a[G]|0;continue a};case 79:{ka=c[t>>2]|0;if((ka|0)==0){c[r>>2]=(c[r>>2]|0)+1}else{ib[ka&1](f,d[T]<<8|ma&255,1,4,0)}a[W]=a[G]|0;continue a};case 87:{ka=a[T]|0;a[G]=ka;c[k>>2]=-1;la=c[t>>2]|0;if((la|0)==0){c[r>>2]=(c[r>>2]|0)+1}else{ib[la&1](f,(ka&255)<<8|ma&255,1,4,0);ka=a[G]|0}a[I]=0;a[j]=a[j]&1|a[6864+(ka&255)|0]|((c[J>>2]|0)!=0?4:0);continue a};case 95:{a[G]=ma;c[k>>2]=-1;ka=c[t>>2]|0;if((ka|0)==0){c[r>>2]=(c[r>>2]|0)+1}else{ib[ka&1](f,d[T]<<8|ma&255,1,4,0);ma=a[G]|0}a[I]=0;a[j]=a[j]&1|a[6864+(ma&255)|0]|((c[J>>2]|0)!=0?4:0);continue a};case 103:{ka=b[X>>1]|0;la=c[t>>2]|0;if((la|0)==0){c[r>>2]=(c[r>>2]|0)+3}else{ib[la&1](f,ka,3,3,32)}ka=lb[c[p>>2]&7](f,ka,3)|0;la=b[X>>1]|0;b[A>>1]=la+1;ma=c[t>>2]|0;do{if((ma|0)==0){la=(c[r>>2]|0)+4|0;c[r>>2]=la;ga=249}else{ib[ma&1](f,la,1,4,0);ib[c[t>>2]&1](f,b[X>>1]|0,1,4,0);ib[c[t>>2]&1](f,b[X>>1]|0,1,4,0);ib[c[t>>2]&1](f,b[X>>1]|0,1,4,0);la=c[t>>2]|0;if((la|0)==0){la=c[r>>2]|0;ga=249;break}else{ib[la&1](f,b[X>>1]|0,3,3,16);break}}}while(0);if((ga|0)==249){ga=0;c[r>>2]=la+3}ob[c[F>>2]&7](f,b[X>>1]|0,a[G]<<4|(ka&255)>>>4,3);ra=a[G]&-16|ka&15;a[G]=ra;a[I]=0;a[j]=a[6608+(ra&255)|0]|a[j]&1;continue a};case 111:{ka=b[X>>1]|0;la=c[t>>2]|0;if((la|0)==0){c[r>>2]=(c[r>>2]|0)+3}else{ib[la&1](f,ka,3,3,32)}ka=lb[c[p>>2]&7](f,ka,3)|0;la=b[X>>1]|0;b[A>>1]=la+1;ma=c[t>>2]|0;do{if((ma|0)==0){la=(c[r>>2]|0)+4|0;c[r>>2]=la;ga=259}else{ib[ma&1](f,la,1,4,0);ib[c[t>>2]&1](f,b[X>>1]|0,1,4,0);ib[c[t>>2]&1](f,b[X>>1]|0,1,4,0);ib[c[t>>2]&1](f,b[X>>1]|0,1,4,0);la=c[t>>2]|0;if((la|0)==0){la=c[r>>2]|0;ga=259;break}else{ib[la&1](f,b[X>>1]|0,3,3,16);break}}}while(0);if((ga|0)==259){ga=0;c[r>>2]=la+3}ob[c[F>>2]&7](f,b[X>>1]|0,a[G]&15|ka<<4,3);ra=a[G]&-16|(ka&255)>>>4;a[G]=ra;a[I]=0;a[j]=a[6608+(ra&255)|0]|a[j]&1;continue a};default:{continue a}}};default:{continue a}}}}ia=ka&8;la=(ia|0)!=0;ia=(ia>>>2^2)-1|0;b[A>>1]=(e[D>>1]|0)+ia;na=c[t>>2]|0;if((na|0)==0){c[r>>2]=(c[r>>2]|0)+1}else{ib[na&1](f,d[T]<<8|ma&255,1,4,0)}ma=(ka&1|0)!=0;do{if(ma){na=b[B>>1]|0;ja=c[t>>2]|0;if((ja|0)==0){c[r>>2]=(c[r>>2]|0)+3}else{ib[ja&1](f,na,3,3,32)}na=lb[c[p>>2]&7](f,na,3)|0;ja=b[D>>1]|0;oa=c[h>>2]|0;if((oa|0)==0){c[r>>2]=(c[r>>2]|0)+1}else{ob[oa&7](f,ja,1,32)}ob[c[S>>2]&7](f,ja,na,0);oa=c[h>>2]|0;if((oa|0)==0){ja=(c[r>>2]|0)+3|0}else{ob[oa&7](f,ja,2,0);ja=(c[r>>2]|0)+1|0}c[r>>2]=ja;oa=(e[B>>1]|0)+ia|0;ja=oa&65535;ia=na;oa=oa+(na&255)&255;na=a[C]|0}else{na=b[D>>1]|0;ia=c[h>>2]|0;if((ia|0)==0){c[r>>2]=(c[r>>2]|0)+3}else{ob[ia&7](f,na,1,48);ob[c[h>>2]&7](f,na,2,16)}ia=lb[c[M>>2]&7](f,na,0)|0;na=c[r>>2]|0;c[r>>2]=na+1;oa=c[t>>2]|0;if((oa|0)==0){c[r>>2]=na+4}else{ib[oa&1](f,b[B>>1]|0,3,3,16)}ob[c[F>>2]&7](f,b[B>>1]|0,ia,3);na=(a[C]|0)-1&255;a[C]=na;oa=(d[N]|0)+(ia&255)|0;if(la){oa=oa+255&255;break}else{oa=oa+1&255;break}}}while(0);a[I]=0;pa=na&255;a[j]=(ia&255)>>>6&2|((oa&255)>>>0<(ia&255)>>>0?17:0)|a[7120+(pa^oa&7)|0]|a[6864+pa|0];if(!((ka&16|0)==0|na<<24>>24==0)){ka=b[(ma?D:B)>>1]|0;ma=c[t>>2]|0;if((ma|0)==0){c[r>>2]=(c[r>>2]|0)+5}else{ib[ma&1](f,ka,1,4,0);ib[c[t>>2]&1](f,ka,1,4,0);ib[c[t>>2]&1](f,ka,1,4,0);ib[c[t>>2]&1](f,ka,1,4,0);ib[c[t>>2]&1](f,ka,1,4,0)}b[$>>1]=(b[$>>1]|0)-2}ka=b[B>>1]|0;if(la){b[B>>1]=ka-1;continue}else{b[B>>1]=ka+1;continue}}else if((na<<24>>24|0)==(-53|0)){la=(oa|0)!=0;na=c[t>>2]|0;oa=(na|0)!=0;if(la){if(oa){ib[na&1](f,ma,3,1,32);ma=b[$>>1]|0}else{c[r>>2]=(c[r>>2]|0)+3}ma=lb[c[p>>2]&7](f,ma,1)|0;na=c[t>>2]|0;if((na|0)==0){c[r>>2]=(c[r>>2]|0)+2}else{ib[na&1](f,b[$>>1]|0,1,4,0);ib[c[t>>2]&1](f,b[$>>1]|0,1,4,0)}b[$>>1]=(b[$>>1]|0)+1}else{if(oa){ib[na&1](f,ma,4,1,32);ma=b[$>>1]|0}else{c[r>>2]=(c[r>>2]|0)+4}ma=lb[c[p>>2]&7](f,ma,1)|0;b[$>>1]=(b[$>>1]|0)+1;ra=a[W]|0;a[W]=ra+1&127|ra&-128}b:do{if(la){ja=(e[c[m>>2]>>1]|0)+ka&65535;ia=c[t>>2]|0;if((ia|0)==0){c[r>>2]=(c[r>>2]|0)+3}else{ib[ia&1](f,ja,3,3,32)}ia=lb[c[p>>2]&7](f,ja,3)|0;na=c[t>>2]|0;if((na|0)==0){c[r>>2]=(c[r>>2]|0)+1;break}else{ib[na&1](f,ja,1,4,0);break}}else{switch(ma&7|0){case 0:{ia=a[C]|0;break b};case 1:{ia=a[N]|0;break b};case 2:{ia=a[O]|0;break b};case 3:{ia=a[P]|0;break b};case 4:{ia=a[Q]|0;break b};case 5:{ia=a[R]|0;break b};case 6:{na=b[B>>1]|0;ia=c[t>>2]|0;if((ia|0)==0){c[r>>2]=(c[r>>2]|0)+3}else{ib[ia&1](f,na,3,3,32)}ia=lb[c[p>>2]&7](f,na,3)|0;na=c[t>>2]|0;if((na|0)==0){c[r>>2]=(c[r>>2]|0)+1;break b}else{ib[na&1](f,b[B>>1]|0,1,3,32);break b}};case 7:{ia=a[G]|0;break b};default:{break b}}}}while(0);ma=ma&255;na=ma>>>3;c:do{switch(na|0){case 0:{ra=(ia&255)>>>7;a[I]=0;ia=(ia&255)<<1|ra&255;a[j]=a[6608+(ia&255)|0]|ra;ia=ia&255;break};case 1:{a[I]=0;ra=(ia&255)>>>1|ia<<7;a[j]=a[6608+(ra&255)|0]|ia&1;ia=ra;break};case 2:{a[I]=0;ra=a[j]&1|(ia&255)<<1;a[j]=a[6608+(ra&255)|0]|(ia&255)>>>7;ia=ra&255;break};case 3:{a[I]=0;ra=d[j]<<7|(ia&255)>>>1;a[j]=a[6608+(ra&255)|0]|ia&1;ia=ra&255;break};case 4:{a[I]=0;ra=ia<<1;a[j]=a[6608+(ra&255)|0]|(ia&255)>>>7;ia=ra;break};case 5:{a[I]=0;ra=(ia&255)>>>1|ia&-128;a[j]=a[6608+(ra&255)|0]|ia&1;ia=ra;break};case 6:{a[I]=0;ra=ia<<1|1;a[j]=a[6608+(ra&255)|0]|(ia&255)>>>7;ia=ra;break};case 7:{a[I]=0;ra=(ia&255)>>>1;a[j]=a[6608+(ra&255)|0]|ia&1;ia=ra;break};default:{oa=ma>>>6;if((oa|0)==1){oa=na&7;if(la){na=0}else{na=(ma&7|0)!=6}a[I]=0;oa=ia&40|(oa<<24>>24==7?ia&-128:0)|((ia&255&1<<(oa&255)|0)!=0?0:68)|a[j]&1|16;a[j]=oa;if(na){break c}a[j]=a[Y]&40|oa&-43;break c}else if((oa|0)==2){ia=ia&255&(1<<(na&7)^255)&255;break c}else if((oa|0)==3){ia=(ia&255|1<<(na&7))&255;break c}else{break c}}}}while(0);if((ma&192|0)==64){continue}ma=ma&7;do{if(la){if((ma|0)==6){break}ga=c[t>>2]|0;if((ga|0)==0){c[r>>2]=(c[r>>2]|0)+3}else{ib[ga&1](f,ja,3,3,16)}ob[c[F>>2]&7](f,ja,ia,3);ga=319}else{ga=319}}while(0);d:do{if((ga|0)==319){ga=0;switch(ma|0){case 0:{a[C]=ia;continue a};case 1:{a[N]=ia;continue a};case 2:{a[O]=ia;continue a};case 3:{a[P]=ia;continue a};case 4:{a[Q]=ia;continue a};case 5:{a[R]=ia;continue a};case 6:{break d};case 7:{a[G]=ia;continue a};default:{continue a}}}}while(0);la=c[t>>2]|0;if((la|0)==0){c[r>>2]=(c[r>>2]|0)+3}else{ib[la&1](f,(e[c[m>>2]>>1]|0)+ka&65535,3,3,16)}ob[c[F>>2]&7](f,(e[c[m>>2]>>1]|0)+ka&65535,ia,3);continue}else{qa=la&192;if((qa|0)==0){switch(la&7|0){case 0:{if((la&48|0)==0){if(na<<24>>24==0){continue a}qa=b[Z>>1]|0;ra=b[_>>1]|0;b[Z>>1]=ra;b[_>>1]=qa;a[I]=ra;continue a}do{if((la&32|0)==0){if((la&8|0)!=0){ha=1;break}ha=c[t>>2]|0;if((ha|0)==0){c[r>>2]=(c[r>>2]|0)+1}else{ib[ha&1](f,d[T]<<8|d[W],1,4,0);ma=b[$>>1]|0}ha=(d[C]|0)+255|0;a[C]=ha;ha=(ha&255|0)!=0|0}else{ha=la>>>3&3;if((ha|0)==0){ha=((d[j]|0)>>>6&1^1)&255;break}else if((ha|0)==1){ha=(d[j]|0)>>>6&1;break}else if((ha|0)==2){ha=(a[j]&1^1)&255;break}else if((ha|0)==3){ha=a[j]&1;break}else{ha=0;break}}}while(0);ka=c[t>>2]|0;if((ka|0)==0){c[r>>2]=(c[r>>2]|0)+3}else{ib[ka&1](f,ma,3,2,32)}la=lb[c[p>>2]&7](f,ma,3)|0;ka=la&255;if((ha|0)==0){b[$>>1]=(b[$>>1]|0)+1;ha=0;continue a}ma=c[t>>2]|0;if((ma|0)==0){c[r>>2]=(c[r>>2]|0)+5}else{ib[ma&1](f,b[$>>1]|0,1,4,0);ib[c[t>>2]&1](f,b[$>>1]|0,1,4,0);ib[c[t>>2]&1](f,b[$>>1]|0,1,4,0);ib[c[t>>2]&1](f,b[$>>1]|0,1,4,0);ib[c[t>>2]&1](f,b[$>>1]|0,1,4,0)}ra=(la<<24>>24<0?ka|65280:ka)+1+(e[$>>1]|0)&65535;b[$>>1]=ra;b[A>>1]=ra;continue a};case 1:{ka=c[t>>2]|0;na=(ka|0)==0;if((la&8|0)!=0){if(na){c[r>>2]=(c[r>>2]|0)+7}else{ib[ka&1](f,d[T]<<8|d[W],1,4,0);ib[c[t>>2]&1](f,d[T]<<8|d[W],1,4,0);ib[c[t>>2]&1](f,d[T]<<8|d[W],1,4,0);ib[c[t>>2]&1](f,d[T]<<8|d[W],1,4,0);ib[c[t>>2]&1](f,d[T]<<8|d[W],1,4,0);ib[c[t>>2]&1](f,d[T]<<8|d[W],1,4,0);ib[c[t>>2]&1](f,d[T]<<8|d[W],1,4,0)}ka=la>>>4&3;if((ka|0)==0){ra=c[m>>2]|0;na=b[ra>>1]|0;pa=e[D>>1]|0;oa=na&65535;qa=oa+pa|0;b[A>>1]=na+1;a[I]=0;a[j]=d[5872+(oa>>>10&2|pa>>>11&1|qa>>>9&4)|0]|a[j]&196|qa>>>0>65535>>>0|qa>>>8&40;b[ra>>1]=qa;continue a}else if((ka|0)==1){ra=c[m>>2]|0;na=b[ra>>1]|0;pa=e[E>>1]|0;oa=na&65535;qa=oa+pa|0;b[A>>1]=na+1;a[I]=0;a[j]=d[5872+(oa>>>10&2|pa>>>11&1|qa>>>9&4)|0]|a[j]&196|qa>>>0>65535>>>0|qa>>>8&40;b[ra>>1]=qa;continue a}else if((ka|0)==2){ra=c[m>>2]|0;oa=b[ra>>1]|0;pa=oa&65535;qa=pa<<1;b[A>>1]=oa+1;a[I]=0;a[j]=a[j]&196|pa>>>7&40|d[5872+(pa>>>10&2|pa>>>11&1|pa>>>8&4)|0]|qa>>>0>65535>>>0;b[ra>>1]=qa;continue a}else if((ka|0)==3){ra=c[m>>2]|0;na=b[ra>>1]|0;pa=e[L>>1]|0;oa=na&65535;qa=oa+pa|0;b[A>>1]=na+1;a[I]=0;a[j]=d[5872+(oa>>>10&2|pa>>>11&1|qa>>>9&4)|0]|a[j]&196|qa>>>0>65535>>>0|qa>>>8&40;b[ra>>1]=qa;continue a}else{continue a}}if(na){c[r>>2]=(c[r>>2]|0)+3}else{ib[ka&1](f,ma,3,2,32)}ka=lb[c[p>>2]&7](f,ma,3)|0;ja=(b[$>>1]|0)+1&65535;b[$>>1]=ja;ma=c[t>>2]|0;if((ma|0)==0){c[r>>2]=(c[r>>2]|0)+3}else{ib[ma&1](f,ja,3,2,32)}ja=((lb[c[p>>2]&7](f,ja,3)|0)&255)<<8|ka&255;b[$>>1]=(b[$>>1]|0)+1;ka=la>>>4&3;if((ka|0)==0){b[D>>1]=ja;continue a}else if((ka|0)==1){b[E>>1]=ja;continue a}else if((ka|0)==2){b[c[m>>2]>>1]=ja;continue a}else if((ka|0)==3){b[L>>1]=ja;continue a}else{continue a}};case 2:{switch(la>>>3&7|0){case 0:{ka=c[t>>2]|0;if((ka|0)==0){c[r>>2]=(c[r>>2]|0)+3}else{ib[ka&1](f,b[D>>1]|0,3,3,16)}ob[c[F>>2]&7](f,b[D>>1]|0,a[G]|0,3);a[ba]=(a[N]|0)+1;a[Y]=a[G]|0;continue a};case 1:{la=b[D>>1]|0;ka=c[t>>2]|0;if((ka|0)==0){c[r>>2]=(c[r>>2]|0)+3}else{ib[ka&1](f,la,3,3,32)}a[G]=lb[c[p>>2]&7](f,la,3)|0;b[A>>1]=(b[D>>1]|0)+1;continue a};case 2:{ka=c[t>>2]|0;if((ka|0)==0){c[r>>2]=(c[r>>2]|0)+3}else{ib[ka&1](f,b[E>>1]|0,3,3,16)}ob[c[F>>2]&7](f,b[ca>>1]|0,a[G]|0,3);a[ba]=(a[P]|0)+1;a[Y]=a[G]|0;continue a};case 3:{la=b[E>>1]|0;ka=c[t>>2]|0;if((ka|0)==0){c[r>>2]=(c[r>>2]|0)+3}else{ib[ka&1](f,la,3,3,32)}a[G]=lb[c[p>>2]&7](f,la,3)|0;b[A>>1]=(b[E>>1]|0)+1;continue a};case 4:{ja=c[t>>2]|0;if((ja|0)==0){c[r>>2]=(c[r>>2]|0)+3}else{ib[ja&1](f,ma,3,2,32)}la=lb[c[p>>2]&7](f,ma,3)|0;ja=(b[$>>1]|0)+1&65535;b[$>>1]=ja;ka=c[t>>2]|0;if((ka|0)==0){c[r>>2]=(c[r>>2]|0)+3}else{ib[ka&1](f,ja,3,2,32)}ja=((lb[c[p>>2]&7](f,ja,3)|0)&255)<<8|la&255;b[$>>1]=(b[$>>1]|0)+1;ka=ja+1&65535;b[A>>1]=ka;la=b[c[m>>2]>>1]|0;ma=c[t>>2]|0;if((ma|0)==0){c[r>>2]=(c[r>>2]|0)+3}else{ib[ma&1](f,ja,3,3,16)}ob[c[F>>2]&7](f,ja,la&255,3);ma=c[t>>2]|0;if((ma|0)==0){c[r>>2]=(c[r>>2]|0)+3}else{ib[ma&1](f,ka,3,3,16)}ob[c[F>>2]&7](f,ka,(la&65535)>>>8&255,3);continue a};case 5:{ja=c[t>>2]|0;if((ja|0)==0){c[r>>2]=(c[r>>2]|0)+3}else{ib[ja&1](f,ma,3,2,32)}ka=lb[c[p>>2]&7](f,ma,3)|0;la=(b[$>>1]|0)+1&65535;b[$>>1]=la;ja=c[t>>2]|0;if((ja|0)==0){c[r>>2]=(c[r>>2]|0)+3}else{ib[ja&1](f,la,3,2,32)}ja=((lb[c[p>>2]&7](f,la,3)|0)&255)<<8|ka&255;b[$>>1]=(b[$>>1]|0)+1;ka=ja+1&65535;b[A>>1]=ka;la=c[t>>2]|0;if((la|0)==0){c[r>>2]=(c[r>>2]|0)+3}else{ib[la&1](f,ja,3,3,32)}la=(lb[c[p>>2]&7](f,ja,3)|0)&255;ma=c[t>>2]|0;if((ma|0)==0){c[r>>2]=(c[r>>2]|0)+3}else{ib[ma&1](f,ka,3,3,32)}ra=((lb[c[p>>2]&7](f,ka,3)|0)&255)<<8|la;b[c[m>>2]>>1]=ra;continue a};case 6:{ja=c[t>>2]|0;if((ja|0)==0){c[r>>2]=(c[r>>2]|0)+3}else{ib[ja&1](f,ma,3,2,32)}ka=lb[c[p>>2]&7](f,ma,3)|0;la=(b[$>>1]|0)+1&65535;b[$>>1]=la;ja=c[t>>2]|0;if((ja|0)==0){c[r>>2]=(c[r>>2]|0)+3}else{ib[ja&1](f,la,3,2,32)}ja=((lb[c[p>>2]&7](f,la,3)|0)&255)<<8|ka&255;b[$>>1]=(b[$>>1]|0)+1;a[ba]=ka+1;la=a[G]|0;a[Y]=la;ka=c[t>>2]|0;if((ka|0)==0){c[r>>2]=(c[r>>2]|0)+3}else{ib[ka&1](f,ja,3,3,16);la=a[G]|0}ob[c[F>>2]&7](f,ja,la,3);continue a};case 7:{ja=c[t>>2]|0;if((ja|0)==0){c[r>>2]=(c[r>>2]|0)+3}else{ib[ja&1](f,ma,3,2,32)}ka=lb[c[p>>2]&7](f,ma,3)|0;la=(b[$>>1]|0)+1&65535;b[$>>1]=la;ja=c[t>>2]|0;if((ja|0)==0){c[r>>2]=(c[r>>2]|0)+3}else{ib[ja&1](f,la,3,2,32)}ja=((lb[c[p>>2]&7](f,la,3)|0)&255)<<8|ka&255;b[$>>1]=(b[$>>1]|0)+1;b[A>>1]=ja+1;ka=c[t>>2]|0;if((ka|0)==0){c[r>>2]=(c[r>>2]|0)+3}else{ib[ka&1](f,ja,3,3,32)}a[G]=lb[c[p>>2]&7](f,ja,3)|0;continue a};default:{continue a}}};case 3:{ka=c[t>>2]|0;if((ka|0)==0){c[r>>2]=(c[r>>2]|0)+2}else{ib[ka&1](f,d[T]<<8|d[W],1,4,0);ib[c[t>>2]&1](f,d[T]<<8|d[W],1,4,0)}ka=la>>>4&3;if((la&8|0)==0){if((ka|0)==0){b[D>>1]=(b[D>>1]|0)+1;continue a}else if((ka|0)==1){b[E>>1]=(b[E>>1]|0)+1;continue a}else if((ka|0)==2){ra=c[m>>2]|0;b[ra>>1]=(b[ra>>1]|0)+1;continue a}else if((ka|0)==3){b[L>>1]=(b[L>>1]|0)+1;continue a}else{continue a}}else{if((ka|0)==0){b[D>>1]=(b[D>>1]|0)-1;continue a}else if((ka|0)==1){b[E>>1]=(b[E>>1]|0)-1;continue a}else if((ka|0)==2){ra=c[m>>2]|0;b[ra>>1]=(b[ra>>1]|0)-1;continue a}else if((ka|0)==3){b[L>>1]=(b[L>>1]|0)-1;continue a}else{continue a}}};case 4:{switch(la>>>3&7|0){case 0:{ra=a[C]|0;a[I]=0;ka=a[j]&1;a[j]=ka;la=(ra&255)+1|0;a[j]=a[6864+(la&255)|0]|(ra<<24>>24==127?4:0)|ka|((la&15|0)!=0?0:16);a[C]=la;continue a};case 1:{ra=a[N]|0;a[I]=0;ka=a[j]&1;a[j]=ka;la=(ra&255)+1|0;a[j]=a[6864+(la&255)|0]|(ra<<24>>24==127?4:0)|ka|((la&15|0)!=0?0:16);a[N]=la;continue a};case 2:{ra=a[O]|0;a[I]=0;ka=a[j]&1;a[j]=ka;la=(ra&255)+1|0;a[j]=a[6864+(la&255)|0]|(ra<<24>>24==127?4:0)|ka|((la&15|0)!=0?0:16);a[O]=la;continue a};case 3:{ra=a[P]|0;a[I]=0;ka=a[j]&1;a[j]=ka;la=(ra&255)+1|0;a[j]=a[6864+(la&255)|0]|(ra<<24>>24==127?4:0)|ka|((la&15|0)!=0?0:16);a[P]=la;continue a};case 4:{la=(c[m>>2]|0)+1|0;ra=a[la]|0;a[I]=0;ma=a[j]&1;a[j]=ma;ka=(ra&255)+1|0;a[j]=a[6864+(ka&255)|0]|(ra<<24>>24==127?4:0)|ma|((ka&15|0)!=0?0:16);a[la]=ka;continue a};case 5:{la=c[m>>2]|0;ra=a[la]|0;a[I]=0;ma=a[j]&1;a[j]=ma;ka=(ra&255)+1|0;a[j]=a[6864+(ka&255)|0]|(ra<<24>>24==127?4:0)|ma|((ka&15|0)!=0?0:16);a[la]=ka;continue a};case 6:{if((oa|0)!=0){ia=ma-1&65535;b[$>>1]=ia;ja=c[t>>2]|0;if((ja|0)==0){c[r>>2]=(c[r>>2]|0)+5}else{ib[ja&1](f,ia,1,4,0);ib[c[t>>2]&1](f,b[$>>1]|0,1,4,0);ib[c[t>>2]&1](f,b[$>>1]|0,1,4,0);ib[c[t>>2]&1](f,b[$>>1]|0,1,4,0);ib[c[t>>2]&1](f,b[$>>1]|0,1,4,0);ia=b[$>>1]|0}b[$>>1]=ia+1}ja=(e[c[m>>2]>>1]|0)+ka&65535;ia=c[t>>2]|0;if((ia|0)==0){c[r>>2]=(c[r>>2]|0)+3}else{ib[ia&1](f,ja,3,3,32)}ia=lb[c[p>>2]&7](f,ja,3)|0;ka=c[t>>2]|0;if((ka|0)==0){c[r>>2]=(c[r>>2]|0)+1;ka=0}else{ib[ka&1](f,ja,1,4,0);ka=c[t>>2]|0}a[I]=0;ma=a[j]&1;a[j]=ma;la=(ia&255)+1|0;a[j]=((la&15|0)!=0?0:16)|(ia<<24>>24==127?4:0)|a[6864+(la&255)|0]|ma;ia=la&255;if((ka|0)==0){c[r>>2]=(c[r>>2]|0)+3}else{ib[ka&1](f,ja,3,3,16)}ob[c[F>>2]&7](f,ja,ia,3);continue a};case 7:{ra=a[G]|0;a[I]=0;ka=a[j]&1;a[j]=ka;la=(ra&255)+1|0;a[j]=a[6864+(la&255)|0]|(ra<<24>>24==127?4:0)|ka|((la&15|0)!=0?0:16);a[G]=la;continue a};default:{continue a}}};case 5:{switch(la>>>3&7|0){case 0:{ra=a[C]|0;a[I]=0;la=a[j]&1;a[j]=la;ma=ra&255;ka=ma+255|0;a[j]=a[6864+(ka&255)|0]|(ra<<24>>24==-128?6:2)|la|((ma&15|0)!=0?0:16);a[C]=ka;continue a};case 1:{ra=a[N]|0;a[I]=0;la=a[j]&1;a[j]=la;ma=ra&255;ka=ma+255|0;a[j]=a[6864+(ka&255)|0]|(ra<<24>>24==-128?6:2)|la|((ma&15|0)!=0?0:16);a[N]=ka;continue a};case 2:{ra=a[O]|0;a[I]=0;la=a[j]&1;a[j]=la;ma=ra&255;ka=ma+255|0;a[j]=a[6864+(ka&255)|0]|(ra<<24>>24==-128?6:2)|la|((ma&15|0)!=0?0:16);a[O]=ka;continue a};case 3:{ra=a[P]|0;a[I]=0;la=a[j]&1;a[j]=la;ma=ra&255;ka=ma+255|0;a[j]=a[6864+(ka&255)|0]|(ra<<24>>24==-128?6:2)|la|((ma&15|0)!=0?0:16);a[P]=ka;continue a};case 4:{la=(c[m>>2]|0)+1|0;ra=a[la]|0;a[I]=0;ma=a[j]&1;a[j]=ma;na=ra&255;ka=na+255|0;a[j]=a[6864+(ka&255)|0]|(ra<<24>>24==-128?6:2)|ma|((na&15|0)!=0?0:16);a[la]=ka;continue a};case 5:{la=c[m>>2]|0;ra=a[la]|0;a[I]=0;ma=a[j]&1;a[j]=ma;na=ra&255;ka=na+255|0;a[j]=a[6864+(ka&255)|0]|(ra<<24>>24==-128?6:2)|ma|((na&15|0)!=0?0:16);a[la]=ka;continue a};case 6:{if((oa|0)!=0){ia=ma-1&65535;b[$>>1]=ia;ja=c[t>>2]|0;if((ja|0)==0){c[r>>2]=(c[r>>2]|0)+5}else{ib[ja&1](f,ia,1,4,0);ib[c[t>>2]&1](f,b[$>>1]|0,1,4,0);ib[c[t>>2]&1](f,b[$>>1]|0,1,4,0);ib[c[t>>2]&1](f,b[$>>1]|0,1,4,0);ib[c[t>>2]&1](f,b[$>>1]|0,1,4,0);ia=b[$>>1]|0}b[$>>1]=ia+1}ja=(e[c[m>>2]>>1]|0)+ka&65535;ia=c[t>>2]|0;if((ia|0)==0){c[r>>2]=(c[r>>2]|0)+3}else{ib[ia&1](f,ja,3,3,32)}ia=lb[c[p>>2]&7](f,ja,3)|0;ka=c[t>>2]|0;if((ka|0)==0){c[r>>2]=(c[r>>2]|0)+1;ka=0}else{ib[ka&1](f,ja,1,4,0);ka=c[t>>2]|0}a[I]=0;ma=a[j]&1;a[j]=ma;ra=ia&255;la=ra+255|0;a[j]=((ra&15|0)!=0?0:16)|(ia<<24>>24==-128?6:2)|a[6864+(la&255)|0]|ma;ia=la&255;if((ka|0)==0){c[r>>2]=(c[r>>2]|0)+3}else{ib[ka&1](f,ja,3,3,16)}ob[c[F>>2]&7](f,ja,ia,3);continue a};case 7:{ra=a[G]|0;a[I]=0;la=a[j]&1;a[j]=la;ma=ra&255;ka=ma+255|0;a[j]=a[6864+(ka&255)|0]|(ra<<24>>24==-128?6:2)|la|((ma&15|0)!=0?0:16);a[G]=ka;continue a};default:{continue a}}};case 6:{ia=c[t>>2]|0;if((ia|0)==0){c[r>>2]=(c[r>>2]|0)+3}else{ib[ia&1](f,ma,3,2,32)}ia=lb[c[p>>2]&7](f,ma,3)|0;ma=b[$>>1]|0;b[$>>1]=ma+1;switch(la>>>3&7|0){case 0:{a[C]=ia;continue a};case 1:{a[N]=ia;continue a};case 2:{a[O]=ia;continue a};case 3:{a[P]=ia;continue a};case 4:{a[(c[m>>2]|0)+1|0]=ia;continue a};case 5:{a[c[m>>2]|0]=ia;continue a};case 6:{if((oa|0)!=0){b[$>>1]=ma;ja=c[t>>2]|0;if((ja|0)==0){c[r>>2]=(c[r>>2]|0)+2}else{ib[ja&1](f,ma,1,4,0);ib[c[t>>2]&1](f,b[$>>1]|0,1,4,0);ma=b[$>>1]|0}b[$>>1]=ma+1}ja=(e[c[m>>2]>>1]|0)+ka&65535;ka=c[t>>2]|0;if((ka|0)==0){c[r>>2]=(c[r>>2]|0)+3}else{ib[ka&1](f,ja,3,3,16)}ob[c[F>>2]&7](f,ja,ia,3);continue a};case 7:{a[G]=ia;continue a};default:{continue a}}};case 7:{switch(la>>>3&7|0){case 0:{qa=a[G]|0;ra=(qa&255)>>>7;qa=qa<<1;a[G]=qa|ra;a[I]=0;a[j]=qa&40|ra|a[j]&-60;continue a};case 1:{ra=a[G]|0;qa=(ra&255)>>>1;a[G]=qa|ra<<7;a[I]=0;a[j]=qa&40|ra&1|a[j]&-60;continue a};case 2:{qa=a[G]|0;pa=qa<<1;ra=a[j]|0;a[G]=ra&1|pa;a[I]=0;a[j]=pa&40|(qa&255)>>>7|ra&-60;continue a};case 3:{qa=a[G]|0;pa=(qa&255)>>>1;ra=a[j]|0;a[G]=ra<<7|pa;a[I]=0;a[j]=pa&40|qa&1|ra&-60;continue a};case 4:{pa=a[j]|0;la=pa&1;oa=a[G]|0;ma=oa&255;if((pa&16)==0){if((ma&14)>>>0>9>>>0){ga=526}else{na=0}}else{ga=526}if((ga|0)==526){ga=0;na=6}ka=(oa&255)>>>0>153>>>0;qa=la<<24>>24!=0|ka?na|96:na;a[j]=pa&-2;na=qa&255;if((pa&2)==0){oa=na+ma|0;pa=oa&255;a[G]=pa;a[I]=0;ma=((((na&6)+(ma&15)|0)>15?16:0)|(oa&65280)>>>0>255>>>0|((oa^ma)&(ma^128))>>>5&4|d[6864+(oa&255)|0])&255}else{ra=ma-na|0;pa=ra&255;a[G]=pa;a[I]=0;ma=((ma&15)-(na&6)>>31&16|(ra&65280)>>>0>255>>>0|((ra^ma)&((qa^oa)&255))>>>5&4|d[6864+(ra&255)|0]|2)&255}a[j]=ma;a[j]=ma&-6|(ka?1:la)|a[7120+(pa&255)|0];continue a};case 5:{ra=~a[G];a[G]=ra;a[j]=ra&40|a[j]&-59|18;a[I]=0;continue a};case 6:{a[j]=a[j]&-60|(a[G]|pa)&40|1;a[I]=0;continue a};case 7:{ra=a[j]|0;ia=ra&1;a[j]=(a[G]|pa)&40|ra&-60|(ia<<24>>24!=0?16:1);a[I]=0;continue a};default:{continue a}}};default:{continue a}}}else if((qa|0)==64){if(na<<24>>24==118){c[n>>2]=1;b[$>>1]=ma-1;continue}la=na&7;na=(na&255)>>>3&7;switch(la&255|0){case 0:{ia=a[C]|0;break};case 1:{ia=a[N]|0;break};case 2:{ia=a[O]|0;break};case 3:{ia=a[P]|0;break};case 4:{if((oa|0)!=0&na<<24>>24==6){ia=l}else{ia=c[m>>2]|0}ia=a[ia+1|0]|0;break};case 5:{if((oa|0)!=0&na<<24>>24==6){ia=l}else{ia=c[m>>2]|0}ia=a[ia]|0;break};case 6:{if((oa|0)!=0){ia=ma-1&65535;b[$>>1]=ia;ja=c[t>>2]|0;if((ja|0)==0){c[r>>2]=(c[r>>2]|0)+5}else{ib[ja&1](f,ia,1,4,0);ib[c[t>>2]&1](f,b[$>>1]|0,1,4,0);ib[c[t>>2]&1](f,b[$>>1]|0,1,4,0);ib[c[t>>2]&1](f,b[$>>1]|0,1,4,0);ib[c[t>>2]&1](f,b[$>>1]|0,1,4,0);ia=b[$>>1]|0}b[$>>1]=ia+1}ia=(e[c[m>>2]>>1]|0)+ka&65535;ja=c[t>>2]|0;if((ja|0)==0){c[r>>2]=(c[r>>2]|0)+3}else{ib[ja&1](f,ia,3,3,32)}ja=ia;ia=lb[c[p>>2]&7](f,ia,3)|0;break};case 7:{ia=a[G]|0;break};default:{}}switch(na&255|0){case 0:{a[C]=ia;continue a};case 1:{a[N]=ia;continue a};case 2:{a[O]=ia;continue a};case 3:{a[P]=ia;continue a};case 4:{if((oa|0)!=0&la<<24>>24==6){a[Q]=ia;continue a}else{a[(c[m>>2]|0)+1|0]=ia;continue a}};case 5:{if((oa|0)!=0&la<<24>>24==6){a[R]=ia;continue a}else{a[c[m>>2]|0]=ia;continue a}};case 6:{if((oa|0)!=0){ja=(b[$>>1]|0)-1&65535;b[$>>1]=ja;la=c[t>>2]|0;if((la|0)==0){c[r>>2]=(c[r>>2]|0)+5}else{ib[la&1](f,ja,1,4,0);ib[c[t>>2]&1](f,b[$>>1]|0,1,4,0);ib[c[t>>2]&1](f,b[$>>1]|0,1,4,0);ib[c[t>>2]&1](f,b[$>>1]|0,1,4,0);ib[c[t>>2]&1](f,b[$>>1]|0,1,4,0);ja=b[$>>1]|0}b[$>>1]=ja+1}ja=(e[c[m>>2]>>1]|0)+ka&65535;ka=c[t>>2]|0;if((ka|0)==0){c[r>>2]=(c[r>>2]|0)+3}else{ib[ka&1](f,ja,3,3,16)}ob[c[F>>2]&7](f,ja,ia,3);continue a};case 7:{a[G]=ia;continue a};default:{continue a}}}else if((qa|0)==128){switch(la&7|0){case 0:{ia=a[C]|0;break};case 1:{ia=a[N]|0;break};case 2:{ia=a[O]|0;break};case 3:{ia=a[P]|0;break};case 4:{ia=a[(c[m>>2]|0)+1|0]|0;break};case 5:{ia=a[c[m>>2]|0]|0;break};case 6:{if((oa|0)!=0){ia=ma-1&65535;b[$>>1]=ia;ja=c[t>>2]|0;if((ja|0)==0){c[r>>2]=(c[r>>2]|0)+5}else{ib[ja&1](f,ia,1,4,0);ib[c[t>>2]&1](f,b[$>>1]|0,1,4,0);ib[c[t>>2]&1](f,b[$>>1]|0,1,4,0);ib[c[t>>2]&1](f,b[$>>1]|0,1,4,0);ib[c[t>>2]&1](f,b[$>>1]|0,1,4,0);ia=b[$>>1]|0}b[$>>1]=ia+1}ia=(e[c[m>>2]>>1]|0)+ka&65535;ja=c[t>>2]|0;if((ja|0)==0){c[r>>2]=(c[r>>2]|0)+3}else{ib[ja&1](f,ia,3,3,32)}ja=ia;ia=lb[c[p>>2]&7](f,ia,3)|0;break};case 7:{ia=a[G]|0;break};default:{}}switch(la>>>3&7|0){case 0:{a[j]=a[j]&-2;la=d[G]|0;ka=ia&255;ma=la+ka|0;a[G]=ma;a[I]=0;a[j]=(ma&65280)>>>0>255>>>0|d[6864+(ma&255)|0]|(((la&15)+(ka&15)|0)>15?16:0)|((ma^la)&(ka^128^la))>>>5&4;continue a};case 1:{la=d[G]|0;ka=ia&255;ra=a[j]&1;ma=la+ka+ra|0;a[G]=ma;a[I]=0;a[j]=(((la&15)+(ka&15)+ra|0)>15?16:0)|d[6864+(ma&255)|0]|(ma&65280)>>>0>255>>>0|((ma^la)&(ka^128^la))>>>5&4;continue a};case 2:{a[j]=a[j]&-2;ra=a[G]|0;qa=ra&255;oa=ia&255;pa=qa-oa|0;a[G]=pa;a[I]=0;a[j]=d[6864+(pa&255)|0]|(pa&65280)>>>0>255>>>0|(qa&15)-(oa&15)>>31&16|((pa^qa)&((ra^ia)&255))>>>5&4|2;continue a};case 3:{ra=a[G]|0;qa=ra&255;na=ia&255;oa=a[j]&1;pa=qa-na-oa|0;a[G]=pa;a[I]=0;a[j]=d[6864+(pa&255)|0]|(qa&15)-(na&15)-oa>>31&16|(pa&65280)>>>0>255>>>0|((pa^qa)&((ra^ia)&255))>>>5&4|2;continue a};case 4:{ra=a[G]&ia;a[G]=ra;a[j]=a[6608+(ra&255)|0]|16;a[I]=0;continue a};case 5:{ra=a[G]^ia;a[G]=ra;a[j]=a[6608+(ra&255)|0]|0;a[I]=0;continue a};case 6:{ra=a[G]|ia;a[G]=ra;a[j]=a[6608+(ra&255)|0]|0;a[I]=0;continue a};case 7:{ka=a[G]|0;na=ka&255;ma=ia&255;la=na-ma|0;a[I]=0;a[j]=ma&40|(ka&255)>>>0<(ia&255)>>>0|la&128|((la&255|0)==0?64:0)|(na&15)-(ma&15)>>31&16|((la^na)&((ka^ia)&255))>>>5&4|2;continue a};default:{continue a}}}else if((qa|0)==192){switch(la&7|0){case 0:{ka=c[t>>2]|0;if((ka|0)==0){c[r>>2]=(c[r>>2]|0)+1}else{ib[ka&1](f,d[T]<<8|d[W],1,4,0)}switch(la>>>3&7|0){case 0:{ha=((d[j]|0)>>>6&1^1)&255;break};case 1:{ha=(d[j]|0)>>>6&1;break};case 2:{ha=(a[j]&1^1)&255;break};case 3:{ha=a[j]&1;break};case 4:{ha=((d[j]|0)>>>2&1^1)&255;break};case 5:{ha=(d[j]|0)>>>2&1;break};case 6:{ha=(d[j]|0)>>>7&255^1;break};case 7:{ha=(d[j]|0)>>>7&255;break};default:{}}if((ha|0)==0){ha=0;continue a}ka=b[L>>1]|0;la=c[t>>2]|0;if((la|0)==0){c[r>>2]=(c[r>>2]|0)+3}else{ib[la&1](f,ka,3,3,32)}ma=lb[c[p>>2]&7](f,ka,3)|0;la=(b[L>>1]|0)+1&65535;b[L>>1]=la;ka=c[t>>2]|0;if((ka|0)==0){c[r>>2]=(c[r>>2]|0)+3}else{ib[ka&1](f,la,3,3,32)}ra=((lb[c[p>>2]&7](f,la,3)|0)&255)<<8|ma&255;b[L>>1]=(b[L>>1]|0)+1;b[$>>1]=ra;b[A>>1]=ra;continue a};case 1:{if((la&8|0)==0){ja=b[L>>1]|0;ka=c[t>>2]|0;if((ka|0)==0){c[r>>2]=(c[r>>2]|0)+3}else{ib[ka&1](f,ja,3,3,32)}ka=lb[c[p>>2]&7](f,ja,3)|0;ma=(b[L>>1]|0)+1&65535;b[L>>1]=ma;ja=c[t>>2]|0;if((ja|0)==0){c[r>>2]=(c[r>>2]|0)+3}else{ib[ja&1](f,ma,3,3,32)}ja=((lb[c[p>>2]&7](f,ma,3)|0)&255)<<8|ka&255;b[L>>1]=(b[L>>1]|0)+1;la=la>>>4&3;if((la|0)==0){b[D>>1]=ja;continue a}else if((la|0)==1){b[E>>1]=ja;continue a}else if((la|0)==2){b[c[m>>2]>>1]=ja;continue a}else if((la|0)==3){b[Z>>1]=ja;a[I]=ka;continue a}else{continue a}}ka=la>>>4&3;if((ka|0)==0){ka=b[L>>1]|0;la=c[t>>2]|0;if((la|0)==0){c[r>>2]=(c[r>>2]|0)+3}else{ib[la&1](f,ka,3,3,32)}ma=lb[c[p>>2]&7](f,ka,3)|0;la=(b[L>>1]|0)+1&65535;b[L>>1]=la;ka=c[t>>2]|0;if((ka|0)==0){c[r>>2]=(c[r>>2]|0)+3}else{ib[ka&1](f,la,3,3,32)}ra=((lb[c[p>>2]&7](f,la,3)|0)&255)<<8|ma&255;b[L>>1]=(b[L>>1]|0)+1;b[$>>1]=ra;b[A>>1]=ra;continue a}else if((ka|0)==1){ra=b[D>>1]|0;b[D>>1]=b[da>>1]|0;b[da>>1]=ra;ra=b[E>>1]|0;b[E>>1]=b[ea>>1]|0;b[ea>>1]=ra;ra=b[B>>1]|0;b[B>>1]=b[fa>>1]|0;b[fa>>1]=ra;continue a}else if((ka|0)==2){b[$>>1]=b[c[m>>2]>>1]|0;continue a}else if((ka|0)==3){ka=c[t>>2]|0;if((ka|0)==0){c[r>>2]=(c[r>>2]|0)+2}else{ib[ka&1](f,d[T]<<8|d[W],1,4,0);ib[c[t>>2]&1](f,d[T]<<8|d[W],1,4,0)}b[L>>1]=b[c[m>>2]>>1]|0;continue a}else{continue a}};case 2:{switch(la>>>3&7|0){case 0:{ha=((d[j]|0)>>>6&1^1)&255;break};case 1:{ha=(d[j]|0)>>>6&1;break};case 2:{ha=(a[j]&1^1)&255;break};case 3:{ha=a[j]&1;break};case 4:{ha=((d[j]|0)>>>2&1^1)&255;break};case 5:{ha=(d[j]|0)>>>2&1;break};case 6:{ha=(d[j]|0)>>>7&255^1;break};case 7:{ha=(d[j]|0)>>>7&255;break};default:{}}ka=c[t>>2]|0;if((ka|0)==0){c[r>>2]=(c[r>>2]|0)+3}else{ib[ka&1](f,ma,3,2,32)}la=lb[c[p>>2]&7](f,ma,3)|0;ma=(b[$>>1]|0)+1&65535;b[$>>1]=ma;ka=c[t>>2]|0;if((ka|0)==0){c[r>>2]=(c[r>>2]|0)+3}else{ib[ka&1](f,ma,3,2,32)}ka=((lb[c[p>>2]&7](f,ma,3)|0)&255)<<8|la&255;b[$>>1]=(b[$>>1]|0)+1;b[A>>1]=ka;if((ha|0)==0){ha=0;continue a}b[$>>1]=ka;continue a};case 3:{switch(la>>>3&7|0){case 0:{ka=c[t>>2]|0;if((ka|0)==0){c[r>>2]=(c[r>>2]|0)+3}else{ib[ka&1](f,ma,3,2,32)}ma=lb[c[p>>2]&7](f,ma,3)|0;la=(b[$>>1]|0)+1&65535;b[$>>1]=la;ka=c[t>>2]|0;if((ka|0)==0){c[r>>2]=(c[r>>2]|0)+3}else{ib[ka&1](f,la,3,2,32)}ra=((lb[c[p>>2]&7](f,la,3)|0)&255)<<8|ma&255;b[$>>1]=ra;b[A>>1]=ra;continue a};case 2:{ja=c[t>>2]|0;if((ja|0)==0){c[r>>2]=(c[r>>2]|0)+3}else{ib[ja&1](f,ma,3,2,32)}ja=lb[c[p>>2]&7](f,ma,3)|0;b[$>>1]=(b[$>>1]|0)+1;a[ba]=ja+1;ka=a[G]|0;a[Y]=ka;ja=(ka&255)<<8|ja&255;la=c[h>>2]|0;if((la|0)==0){c[r>>2]=(c[r>>2]|0)+1}else{ob[la&7](f,ja,1,32)}ob[c[S>>2]&7](f,ja,ka,0);ka=c[h>>2]|0;if((ka|0)==0){c[r>>2]=(c[r>>2]|0)+3;continue a}else{ob[ka&7](f,ja,2,0);c[r>>2]=(c[r>>2]|0)+1;continue a}};case 3:{ja=d[G]<<8;ka=c[t>>2]|0;if((ka|0)==0){c[r>>2]=(c[r>>2]|0)+3}else{ib[ka&1](f,ma,3,2,32)}ja=(lb[c[p>>2]&7](f,ma,3)|0)&255|ja;b[$>>1]=(b[$>>1]|0)+1;b[A>>1]=ja+1;ka=c[h>>2]|0;if((ka|0)==0){c[r>>2]=(c[r>>2]|0)+3}else{ob[ka&7](f,ja,1,48);ob[c[h>>2]&7](f,ja,2,16)}ra=lb[c[M>>2]&7](f,ja,0)|0;c[r>>2]=(c[r>>2]|0)+1;a[G]=ra;continue a};case 4:{ka=b[L>>1]|0;ja=c[t>>2]|0;if((ja|0)==0){c[r>>2]=(c[r>>2]|0)+3}else{ib[ja&1](f,ka,3,3,32)}ja=(lb[c[p>>2]&7](f,ka,3)|0)&255;la=ka+1&65535;ka=c[t>>2]|0;if((ka|0)==0){c[r>>2]=(c[r>>2]|0)+3}else{ib[ka&1](f,la,3,3,32)}ja=((lb[c[p>>2]&7](f,la,3)|0)&255)<<8|ja;ka=c[t>>2]|0;do{if((ka|0)==0){c[r>>2]=(c[r>>2]|0)+1;la=b[c[m>>2]>>1]|0;ma=b[L>>1]|0;na=(la&65535)>>>8&255;la=la&255;ga=702}else{ib[ka&1](f,(b[L>>1]|0)+1&65535,1,4,0);ka=c[t>>2]|0;ma=b[L>>1]|0;la=b[c[m>>2]>>1]|0;if((ka|0)==0){na=(la&65535)>>>8&255;la=la&255;ga=702;break}na=ma+1&65535;ib[ka&1](f,na,3,3,16);ka=na;na=(la&65535)>>>8&255;la=la&255}}while(0);if((ga|0)==702){ga=0;c[r>>2]=(c[r>>2]|0)+3;ka=ma+1&65535}ob[c[F>>2]&7](f,ka,na,3);ka=c[t>>2]|0;if((ka|0)==0){c[r>>2]=(c[r>>2]|0)+3}else{ib[ka&1](f,ma,3,3,16)}ob[c[F>>2]&7](f,ma,la,3);ka=c[t>>2]|0;if((ka|0)==0){c[r>>2]=(c[r>>2]|0)+2}else{ib[ka&1](f,b[L>>1]|0,1,4,0);ib[c[t>>2]&1](f,b[L>>1]|0,1,4,0)}b[c[m>>2]>>1]=ja;b[A>>1]=ja;continue a};case 5:{ja=b[E>>1]|0;b[E>>1]=b[B>>1]|0;b[B>>1]=ja;continue a};case 6:{c[J>>2]=0;c[K>>2]=0;continue a};case 7:{c[J>>2]=1;c[K>>2]=1;c[k>>2]=1;continue a};default:{continue a}}};case 4:{switch(la>>>3&7|0){case 0:{ha=((d[j]|0)>>>6&1^1)&255;break};case 1:{ha=(d[j]|0)>>>6&1;break};case 2:{ha=(a[j]&1^1)&255;break};case 3:{ha=a[j]&1;break};case 4:{ha=((d[j]|0)>>>2&1^1)&255;break};case 5:{ha=(d[j]|0)>>>2&1;break};case 6:{ha=(d[j]|0)>>>7&255^1;break};case 7:{ha=(d[j]|0)>>>7&255;break};default:{}}ka=c[t>>2]|0;if((ka|0)==0){c[r>>2]=(c[r>>2]|0)+3}else{ib[ka&1](f,ma,3,2,32)}la=lb[c[p>>2]&7](f,ma,3)|0;ma=(b[$>>1]|0)+1&65535;b[$>>1]=ma;ka=c[t>>2]|0;if((ka|0)==0){c[r>>2]=(c[r>>2]|0)+3}else{ib[ka&1](f,ma,3,2,32)}ka=((lb[c[p>>2]&7](f,ma,3)|0)&255)<<8|la&255;if((ha|0)==0){b[$>>1]=(b[$>>1]|0)+1;b[A>>1]=ka;ha=0;continue a}la=c[t>>2]|0;do{if((la|0)==0){c[r>>2]=(c[r>>2]|0)+ha;ma=(b[$>>1]|0)+1&65535;b[$>>1]=ma;b[A>>1]=ka;la=(b[L>>1]|0)-1&65535;b[L>>1]=la;ka=ma&255;ma=(ma&65535)>>>8&255;ga=737}else{do{if((ha|0)>0){ma=ha-1|0;ib[la&1](f,b[$>>1]|0,1,4,0);if((ma|0)<=0){break}do{ma=ma-1|0;ib[c[t>>2]&1](f,b[$>>1]|0,1,4,0);}while((ma|0)>0)}}while(0);ma=(b[$>>1]|0)+1&65535;b[$>>1]=ma;b[A>>1]=ka;na=c[t>>2]|0;ka=ma&255;ma=(ma&65535)>>>8&255;la=(b[L>>1]|0)-1&65535;b[L>>1]=la;if((na|0)==0){ga=737;break}ib[na&1](f,la,3,3,16);la=b[L>>1]|0}}while(0);if((ga|0)==737){ga=0;c[r>>2]=(c[r>>2]|0)+3}ob[c[F>>2]&7](f,la,ma,3);ma=(b[L>>1]|0)-1&65535;b[L>>1]=ma;la=c[t>>2]|0;if((la|0)==0){c[r>>2]=(c[r>>2]|0)+3}else{ib[la&1](f,ma,3,3,16);ma=b[L>>1]|0}ob[c[F>>2]&7](f,ma,ka,3);b[$>>1]=b[A>>1]|0;continue a};case 5:{if((la&8|0)==0){ja=c[t>>2]|0;if((ja|0)==0){c[r>>2]=(c[r>>2]|0)+1}else{ib[ja&1](f,d[T]<<8|d[W],1,4,0)}ja=la>>>4&3;if((ja|0)==1){ja=E}else if((ja|0)==2){ja=c[m>>2]|0}else if((ja|0)==0){ja=D}else{ja=Z}ja=b[ja>>1]|0;la=(b[L>>1]|0)-1&65535;b[L>>1]=la;ka=c[t>>2]|0;if((ka|0)==0){c[r>>2]=(c[r>>2]|0)+3}else{ib[ka&1](f,la,3,3,16);la=b[L>>1]|0}ob[c[F>>2]&7](f,la,(ja&65535)>>>8&255,3);la=(b[L>>1]|0)-1&65535;b[L>>1]=la;ka=c[t>>2]|0;if((ka|0)==0){c[r>>2]=(c[r>>2]|0)+3}else{ib[ka&1](f,la,3,3,16);la=b[L>>1]|0}ob[c[F>>2]&7](f,la,ja&255,3);continue a}if((la&48|0)!=0){continue a}ja=c[t>>2]|0;if((ja|0)==0){c[r>>2]=(c[r>>2]|0)+3}else{ib[ja&1](f,ma,3,2,32)}ka=lb[c[p>>2]&7](f,ma,3)|0;la=(b[$>>1]|0)+1&65535;b[$>>1]=la;ja=c[t>>2]|0;if((ja|0)==0){c[r>>2]=(c[r>>2]|0)+3}else{ib[ja&1](f,la,3,2,32)}ja=((lb[c[p>>2]&7](f,la,3)|0)&255)<<8|ka&255;ka=c[t>>2]|0;if((ka|0)==0){c[r>>2]=(c[r>>2]|0)+1;ma=0}else{ib[ka&1](f,b[$>>1]|0,1,4,0);ma=c[t>>2]|0}ka=(b[$>>1]|0)+1&65535;b[$>>1]=ka;b[A>>1]=ja;la=(b[L>>1]|0)-1&65535;b[L>>1]=la;if((ma|0)==0){c[r>>2]=(c[r>>2]|0)+3}else{ib[ma&1](f,la,3,3,16);la=b[L>>1]|0}ob[c[F>>2]&7](f,la,(ka&65535)>>>8&255,3);ma=(b[L>>1]|0)-1&65535;b[L>>1]=ma;la=c[t>>2]|0;if((la|0)==0){c[r>>2]=(c[r>>2]|0)+3}else{ib[la&1](f,ma,3,3,16);ma=b[L>>1]|0}ob[c[F>>2]&7](f,ma,ka&255,3);b[$>>1]=ja;continue a};case 6:{ia=c[t>>2]|0;if((ia|0)==0){c[r>>2]=(c[r>>2]|0)+3}else{ib[ia&1](f,ma,3,2,32)}ia=lb[c[p>>2]&7](f,ma,3)|0;b[$>>1]=(b[$>>1]|0)+1;switch(la>>>3&7|0){case 0:{a[j]=a[j]&-2;la=d[G]|0;ka=ia&255;ma=la+ka|0;a[G]=ma;a[I]=0;a[j]=(ma&65280)>>>0>255>>>0|d[6864+(ma&255)|0]|(((la&15)+(ka&15)|0)>15?16:0)|((ma^la)&(ka^128^la))>>>5&4;continue a};case 1:{la=d[G]|0;ka=ia&255;ra=a[j]&1;ma=la+ka+ra|0;a[G]=ma;a[I]=0;a[j]=(((la&15)+(ka&15)+ra|0)>15?16:0)|d[6864+(ma&255)|0]|(ma&65280)>>>0>255>>>0|((ma^la)&(ka^128^la))>>>5&4;continue a};case 2:{a[j]=a[j]&-2;ra=a[G]|0;qa=ra&255;oa=ia&255;pa=qa-oa|0;a[G]=pa;a[I]=0;a[j]=d[6864+(pa&255)|0]|(pa&65280)>>>0>255>>>0|(qa&15)-(oa&15)>>31&16|((pa^qa)&((ra^ia)&255))>>>5&4|2;continue a};case 3:{ra=a[G]|0;qa=ra&255;na=ia&255;oa=a[j]&1;pa=qa-na-oa|0;a[G]=pa;a[I]=0;a[j]=d[6864+(pa&255)|0]|(qa&15)-(na&15)-oa>>31&16|(pa&65280)>>>0>255>>>0|((pa^qa)&((ra^ia)&255))>>>5&4|2;continue a};case 4:{ra=a[G]&ia;a[G]=ra;a[j]=a[6608+(ra&255)|0]|16;a[I]=0;continue a};case 5:{ra=a[G]^ia;a[G]=ra;a[j]=a[6608+(ra&255)|0]|0;a[I]=0;continue a};case 6:{ra=a[G]|ia;a[G]=ra;a[j]=a[6608+(ra&255)|0]|0;a[I]=0;continue a};case 7:{na=a[G]|0;ka=na&255;la=ia&255;ma=ka-la|0;a[I]=0;a[j]=la&40|(na&255)>>>0<(ia&255)>>>0|ma&128|((ma&255|0)==0?64:0)|(ka&15)-(la&15)>>31&16|((ma^ka)&((na^ia)&255))>>>5&4|2;continue a};default:{continue a}}};case 7:{ka=c[t>>2]|0;do{if((ka|0)==0){c[r>>2]=(c[r>>2]|0)+1;la=(b[L>>1]|0)-1&65535;b[L>>1]=la;ka=ma&255;ma=(ma&65535)>>>8&255;ga=790}else{ib[ka&1](f,d[T]<<8|d[W],1,4,0);ma=b[$>>1]|0;oa=c[t>>2]|0;ka=ma&255;ma=(ma&65535)>>>8&255;la=(b[L>>1]|0)-1&65535;b[L>>1]=la;if((oa|0)==0){ga=790;break}ib[oa&1](f,la,3,3,16);la=b[L>>1]|0}}while(0);if((ga|0)==790){ga=0;c[r>>2]=(c[r>>2]|0)+3}ob[c[F>>2]&7](f,la,ma,3);la=(b[L>>1]|0)-1&65535;b[L>>1]=la;ma=c[t>>2]|0;if((ma|0)==0){c[r>>2]=(c[r>>2]|0)+3}else{ib[ma&1](f,la,3,3,16);la=b[L>>1]|0}ob[c[F>>2]&7](f,la,ka,3);ra=na&56;b[$>>1]=ra;b[A>>1]=ra;continue a};default:{continue a}}}else{continue}}}if((ga|0)==18){c[r>>2]=ka;c[o>>2]=0}else if((ga|0)==795){ra=c[r>>2]|0;ra=ra-v|0;return ra|0}c[f+112>>2]=1;c[q>>2]=0;ra=c[r>>2]|0;ra=ra-v|0;return ra|0}function Kb(e,f){e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=e+56|0;g=c[h>>2]|0;n=e+6|0;m=a[n]|0;k=e+120|0;a[k]=m;l=e+64|0;j=c[l>>2]|0;do{if((j|0)<0){c[l>>2]=0;a[n]=m&-5;a[k]=0}else{if((j|0)==0){break}else{e=0}return e|0}}while(0);j=e+40|0;if((c[j>>2]|0)==0){p=0;return p|0}k=e+52|0;if((c[k>>2]|0)!=0){c[k>>2]=0;p=e+30|0;b[p>>1]=(b[p>>1]|0)+1}c[e+44>>2]=0;c[j>>2]=0;k=e+48|0;j=a[k]&3;a[k]=j;j=j&255;if((j|0)==3){a[k]=0;i=9}else if((j|0)==0){i=9}else if((j|0)==1){l=g;i=10}else if((j|0)==2){j=e+37|0;l=a[j]|0;a[j]=l+1&127|l&-128;c[h>>2]=g+7;j=e+30|0;l=b[j>>1]|0;m=e+8|0;n=(b[m>>1]|0)-1&65535;b[m>>1]=n;k=e+80|0;o=c[k>>2]|0;if((o|0)==0){c[h>>2]=g+10;o=n}else{ib[o&1](e,n,3,3,16);o=b[m>>1]|0}n=e+76|0;ob[c[n>>2]&7](e,o,(l&65535)>>>8&255,3);p=(b[m>>1]|0)-1&65535;b[m>>1]=p;o=c[k>>2]|0;if((o|0)==0){c[h>>2]=(c[h>>2]|0)+3}else{ib[o&1](e,p,3,3,16);p=b[m>>1]|0}ob[c[n>>2]&7](e,p,l&255,3);m=(d[e+36|0]|0)<<8|f&255;f=c[k>>2]|0;if((f|0)==0){c[h>>2]=(c[h>>2]|0)+3}else{ib[f&1](e,m,3,3,32)}f=e+72|0;l=(lb[c[f>>2]&7](e,m,3)|0)&255;m=m+1&65535;k=c[k>>2]|0;if((k|0)==0){c[h>>2]=(c[h>>2]|0)+3}else{ib[k&1](e,m,3,3,32)}p=((lb[c[f>>2]&7](e,m,3)|0)&255)<<8|l;b[j>>1]=p;b[e+28>>1]=p}if((i|0)==9){l=g+6|0;c[h>>2]=l;i=10}if((i|0)==10){i=e+37|0;f=a[i]|0;a[i]=f+1&127|f&-128;c[h>>2]=l+7;i=e+30|0;f=b[i>>1]|0;j=e+8|0;n=(b[j>>1]|0)-1&65535;b[j>>1]=n;k=e+80|0;m=c[k>>2]|0;if((m|0)==0){c[h>>2]=l+10}else{ib[m&1](e,n,3,3,16);n=b[j>>1]|0}l=e+76|0;ob[c[l>>2]&7](e,n,(f&65535)>>>8&255,3);m=(b[j>>1]|0)-1&65535;b[j>>1]=m;k=c[k>>2]|0;if((k|0)==0){c[h>>2]=(c[h>>2]|0)+3}else{ib[k&1](e,m,3,3,16);m=b[j>>1]|0}ob[c[l>>2]&7](e,m,f&255,3);b[i>>1]=56;b[e+28>>1]=56}p=(c[h>>2]|0)-g|0;return p|0}function Lb(){ac();db();La(0)}function Mb(a){a=a|0;Da(a|0)|0;return}function Nb(a){a=a|0;Da(a|0)|0;Lb()}function Ob(a){a=a|0;Da(a|0)|0;return}function Pb(b,d){b=b|0;d=d|0;if((ab(33)|0)!=0){Nb(4416);return 0}d=xa(((a[8056]|0)!=0?1056:1024)|0,572,8,0)|0;c[1970]=d;if((d|0)==0){Nb(5680);return 0}else{Wa(5568,5568);Da(4800)|0;dc();return 0}return 0}function Qb(c){c=c|0;switch(c&255|0){case 56:{c=a[267424]|0;break};case 57:{c=a[267416]|32;break};case 60:{c=b[133732]&255;break};case 61:{c=(e[133732]|0)>>>8&255;break};case 62:{c=b[133704]&255;break};case 63:{c=(e[133704]|0)>>>8&255;break};default:{}}return c|0}function Rb(){var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;y=a[267360]|0;e=(y<<24>>24>>7&52)+80&255;h=a[267446]|0;i=(h&255)>>>4;h=h&15;g=a[267447]&15;f=(g&255)>>>0>10>>>0;g=f?510:(g&255)<<1;k=(((h&255)>>>0<(i&255)>>>0?10:h&255)-(i&255)&65535)+1&65535;h=k<<16>>16==0;j=(i&255)<<1;k=(k&65535)<<1;i=0;l=0;while(1){q=(b[133704]|0)+((l&255)<<1)&65535;m=y<<24>>24<0;if((a[8056]|0)==0){r=m?0:32}else{r=m?0:48}m=i<<16>>16;o=m+g|0;p=m+j|0;n=1;q=d[267480+(q+1&65535&4095)|0]<<8|d[267480+(q&4095)|0];w=0;while(1){v=q&4095;t=271584+v|0;u=d[t]|0;x=u>>>4;u=a[6576+(x^1^(u&1^1|(a[267376]^1)&255))|0]|0;z=a[6560+x|0]|0;if(!((y&16)==0)){s=-64-u&255;u=-64-z&255;z=(u&255)>>>0>192>>>0?0:u;u=(s&255)>>>0>192>>>0?0:s}do{if(y<<24>>24<0){if((a[8056]|0)!=0){s=8;break}s=(w&3|0)!=0?8:7}else{s=12}}while(0);if((x|0)!=0){x=s&65535;B=c[1970]|0;D=c[B+20>>2]|0;E=c[B+8>>2]|0;B=oa(c[B+4>>2]|0,0,z|0,0)|0;E=D+(($(E,m)|0)+(r<<16>>16)<<2)|0;D=(c[1970]|0)+8|0;A=s&255;y=A<<24>>24==0;C=(A-1&255)+1|0;z=21;while(1){if(!y){F=E;G=A;while(1){G=G-1&255;c[F>>2]=B;if(G<<24>>24==0){break}else{F=F+4|0}}E=E+(C<<2)|0}if((z|0)==0){break}else{E=E+((c[D>>2]|0)-x<<2)|0;z=z-1|0}}y=a[267360]|0}do{if((y&8)==0){F=(q&65535)>>>14&255;E=(w&1|0)!=0;A=c[1232+(d[267480+v|0]<<2)>>2]|0;D=A+2257|0;B=a[2256+A|0]|0;w=c[1970]|0;v=r<<16>>16;J=(c[w+20>>2]|0)+(($(c[w+8>>2]|0,m)|0)+v<<2)|0;w=oa(c[w+4>>2]|0,0,u|0,0)|0;x=F<<24>>24!=0;do{if(x){z=E?4:0;y=E?7:3;C=F&2;H=C<<24>>24==0?11:6;if(!(F<<24>>24==3)){E=0;F=B;break}if((B&255)>>>0>5>>>0){E=0;F=B-5&255;break}else{E=0;F=0;D=2256+(A+6-(B&255))|0;break}}else{H=11;y=7;z=0;F=B;C=0}}while(0);C=C<<24>>24==0;A=128>>>((z&255)>>>0)&255;B=(z&255)>>>0>(y&255)>>>0;while(1){G=F<<24>>24!=0;if(!G){L=(a[267360]|0)<0;a:do{if(!B){if(x){K=z;I=A}else{K=z;I=A;while(1){L=L?0:K&1;b:do{if((K&255)>>>0<7>>>0){M=J;N=L;while(1){do{if(!((a[D]&I)<<24>>24==0)){O=(c[1970]|0)+8|0;c[M+(c[O>>2]<<2)>>2]=w;c[M>>2]=w;if((a[267360]&1)==0){break}c[M+((c[O>>2]|0)+1<<2)>>2]=w;c[M+4>>2]=w}}while(0);if(N<<24>>24==0){break b}M=M+4|0;N=N-1&255}}else{N=J;M=L;while(1){if(!((a[D]&I)<<24>>24==0)){c[N+(c[(c[1970]|0)+8>>2]<<2)>>2]=w;c[N>>2]=w}if(M<<24>>24==0){break b}N=N+4|0;M=M-1&255}}}while(0);J=J+((L&255)+1<<2)|0;K=K+1&255;L=(a[267360]|0)<0;if((K&255)>>>0>(y&255)>>>0){break a}else{I=(I&255)>>>1}}}while(1){if(L){L=1}else{L=K<<1&2|1}c:do{if((K&255)>>>0<7>>>0){O=J;N=L;while(1){do{if(!((a[D]&I)<<24>>24==0)){M=(c[1970]|0)+8|0;c[O+(c[M>>2]<<2)>>2]=w;c[O>>2]=w;if((a[267360]&1)==0){break}c[O+((c[M>>2]|0)+1<<2)>>2]=w;c[O+4>>2]=w}}while(0);if(N<<24>>24==0){break c}O=O+4|0;N=N-1&255}}else{M=J;N=L;while(1){if(!((a[D]&I)<<24>>24==0)){c[M+(c[(c[1970]|0)+8>>2]<<2)>>2]=w;c[M>>2]=w}if(N<<24>>24==0){break c}M=M+4|0;N=N-1&255}}}while(0);J=J+((L&255)+1<<2)|0;K=K+1&255;L=(a[267360]|0)<0;if((K&255)>>>0>(y&255)>>>0){break}else{I=(I&255)>>>1}}}}while(0);J=J+((L?-8:-12)<<2)|0}K=c[1970]|0;I=c[K+8>>2]|0;if(C|E){H=H-1&255;F=G?F-1&255:0;D=G?D:D+1|0}if(H<<24>>24==0){break}else{J=J+(I<<1<<2)|0;E=E^1}}if(q<<16>>16!=(b[133732]|0)|(a[267456]|0)==0|(a[136120]|0)==0){if((a[t]&2)==0|f){break}w=s&65535;y=c[K+20>>2]|0;t=oa(c[K+4>>2]|0,0,u|0,0)|0;z=($(I,o)|0)+v|0;B=(c[1970]|0)+8|0;u=s&255;v=u<<24>>24==0;A=(u-1&255)+1|0;if(v){break}else{x=y+(z<<2)|0;C=u}while(1){C=C-1&255;c[x>>2]=t;if(C<<24>>24==0){break}else{x=x+4|0}}if(v){break}v=y+(z+A+((c[B>>2]|0)-w)<<2)|0;while(1){u=u-1&255;c[v>>2]=t;if(u<<24>>24==0){break}else{v=v+4|0}}}else{t=s&65535;w=c[K+20>>2]|0;u=oa(c[K+4>>2]|0,0,u|0,0)|0;if(h){break}A=w+(($(I,p)|0)+v<<2)|0;x=(c[1970]|0)+8|0;w=s&255;v=w<<24>>24==0;y=(w-1&255)+1|0;z=k;while(1){z=z-1|0;if(!v){B=A;C=w;while(1){C=C-1&255;c[B>>2]=u;if(C<<24>>24==0){break}else{B=B+4|0}}A=A+(y<<2)|0}if((z|0)==0){break}else{A=A+((c[x>>2]|0)-t<<2)|0}}}}}while(0);if(!((n&255)>>>0<(e&255)>>>0)){break}w=n&255;n=n+1&255;q=q+1&65535;r=s+r&65535;y=a[267360]|0}l=l+1&255;if(!((l&255)>>>0<26>>>0)){break}i=i+22&65535;y=a[267360]|0}return}function Sb(){a[267456]=0;b[133732]=0;xc(267440|0,0|0,15|0)|0;xc(267480|0,32|0,4096|0)|0;xc(271584|0,0|0,4096|0)|0;a[267424]=0;a[267416]=0;a[136120]=0;a[267376]=0;return}function Tb(){var b=0,c=0;b=a[267447]|0;do{if((b&32)==0){a[136120]=1}else{c=(a[6544]|0)-1&255;a[6544]=c;if(!(c<<24>>24==0)){break}a[7872]=1;a[136120]=a[136120]^1;a[6544]=((b&255)>>>1&8^8)+8}}while(0);c=(a[6552]|0)-1&255;a[6552]=c;if(c<<24>>24==0){a[7872]=1;a[267376]=a[267376]^1;a[6552]=(a[267444]>>7)+64&255&-32}if((a[267424]&16)==0){c=0;return c|0}a[267416]=a[267416]|16;c=1;return c|0}function Ub(c,e){c=c|0;e=e|0;var f=0,g=0,h=0,i=0;switch(c&255|0){case 52:{a[267472]=e;return};case 53:{a[271576]=e;return};case 56:{c=a[267432]|0;if((c&255)>>>0<15>>>0){a[267432]=c+1;a[267440+(c&255)|0]=e}a[7872]=1;return};case 57:{c=e&255;do{if((e<<24>>24|0)==(-94|0)){i=((d[267451]|0)<<8|(d[267450]|0))&4095;a[267480+i|0]=a[267472]|0;a[271584+i|0]=a[271576]|0;a[7872]=1;return}else if((e<<24>>24|0)==(-86|0)|(e<<24>>24|0)==(-85|0)){i=b[133732]&4095;a[267480+i|0]=a[267472]|0;a[271584+i|0]=a[271576]|0;a[7872]=1}else if((e<<24>>24|0)==(-69|0)){c=(d[267451]|0)<<8&16128|(d[267450]|0);f=a[267472]|0;g=a[271576]|0;h=b[133732]|0;while(1){i=h+1&65535;h=h&4095;a[267480+h|0]=f;a[271584+h|0]=g;if(i<<16>>16==c<<16>>16){break}else{h=i}}b[133732]=c;a[7872]=1}else{if((c&96|0)==96){a[267424]=a[267424]|e&31;break}if((c&64|0)!=0){a[267416]=a[267416]&((e|-32)^31);break}if((c&128|0)!=0){a[267424]=a[267424]&((e|-32)^31);break}c=c&240;if((c|0)==16){a[267432]=e&15;break}else if((c|0)==48){a[267456]=e&1;break}else{break}}}while(0);if(!((e<<24>>24|0)==(-87|0)|(e<<24>>24|0)==(-85|0))){return}b[133732]=(b[133732]|0)+1;a[7872]=1;return};case 60:{b[133732]=b[133732]&-256|e&255;a[7872]=1;return};case 61:{b[133732]=b[133732]&255|(e&255)<<8&16128;a[7872]=1;return};case 62:{b[133704]=b[133704]&-256|e&255;a[7872]=1;return};case 63:{b[133704]=b[133704]&255|(e&255)<<8;a[7872]=1;return};default:{return}}}function Vb(c){c=c|0;var d=0,f=0;f=a[267240]|0;switch(c&255|0){case 32:{a[267240]=0;c=0;d=3;break};case 47:{c=f;d=3;break};case 33:{f=a[267280]|0;break};case 34:{f=a[267272]|0;break};case 35:{f=a[267288]|0;break};case 37:{f=a[267264]|0;break};case 39:{f=a[267256]|0;break};case 40:{f=(e[68080]|0)>>>8&255;break};case 41:{f=b[68080]&255;break};case 42:{f=(e[68076]|0)>>>8&255;break};case 43:{f=b[68076]&255;break};case 48:{f=a[136144]|0;break};case 36:case 38:case 45:case 46:{f=-1;break};default:{f=0}}if((d|0)==3){f=((e[68080]|0)>>>0<1024>>>0&(e[68076]|0)>>>0<512>>>0?5:13)|f;a[267240]=c&-3}return f|0}function Wb(b){b=b|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;g=d[136144]|0;h=g&1;if((a[267248+h|0]|0)!=0){return}if((a[267280]&4)!=0|b<<24>>24==0){return}f=c[1970]|0;i=c[f+20>>2]|0;f=c[f+8>>2]|0;n=((a[8056]|0)!=0?-16:0)+(f*30|0)|0;e=i+(n<<2)|0;j=i+(($(f<<1,d[136136]|0)|0)+n<<2)|0;f=i+(n+(f<<9)<<2)|0;g=(g&8|0)==0;if(g){k=168936+(h<<16)|0;h=8192}else{k=136168+(h<<16)|0;h=16384}b=b&255;while(1){do{if((h&31|0)==0){j=(a[8056]|0)==0?j:j+128|0;if(!g){break}j=j+(c[(c[1970]|0)+8>>2]<<2)|0}}while(0);i=k+4|0;k=c[k>>2]|0;if((k|0)!=0){if(g){n=1;l=j;while(1){if((n&k|0)!=0){m=((c[l>>2]|0)>>>8)+b|0;m=oa(c[(c[1970]|0)+4>>2]|0,0,((m&255)>>>0<b>>>0?-1:m&255)|0,0)|0;c[l>>2]=m;c[l+(c[(c[1970]|0)+8>>2]<<2)>>2]=m}n=n<<1;if((n|0)==0){break}else{l=l+4|0}}}else{n=1;l=j;while(1){if((n&k|0)!=0){m=((c[l>>2]|0)>>>8)+b|0;c[l>>2]=oa(c[(c[1970]|0)+4>>2]|0,0,((m&255)>>>0<b>>>0?-1:m&255)|0,0)|0}n=n<<1;if((n|0)==0){break}else{l=l+4|0}}}}j=j+128|0;if(!(j>>>0<f>>>0)){if((a[136144]|0)<0){e=20;break}else{j=e}}h=h-1|0;if((h|0)==0){e=20;break}else{k=i}}if((e|0)==20){return}}function Xb(){a[267280]=0;a[267296]=0;a[136144]=0;a[136136]=0;xc(136168|0,0|0,65536|0)|0;a[267248]=1;a[7872]=1;return}function Yb(){a[267240]=a[267240]|2;return(a[267280]&32)!=0|0}function Zb(e,f){e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;switch(e&255|0){case 32:{i=f&255;if((f&255)>>>0>31>>>0&f<<24>>24>-1){_b(f);return}switch(i|0){case 0:{a[267280]=a[267280]|2;return};case 1:{a[267280]=a[267280]&-3;return};case 2:{a[267280]=a[267280]|1;return};case 3:{a[267280]=a[267280]&-2;return};case 7:{a[267280]=0;a[267272]=0;a[267288]=17;a[267264]=0;a[267256]=0;g=10;break};case 4:case 6:{g=10;break};case 5:case 13:{g=11;break};case 14:{break};case 10:case 11:{_b(f);return};case 12:{r=a[267280]|0;s=a[136144]&1;xc(136168+(s<<16)|0,r<<6<<24>>24>>7|0,65536)|0;a[267248+s|0]=(r&255)>>>1&1^1;a[7872]=1;return};case 15:{g=b[68080]|0;e=b[68076]|0;if((g&65535)>>>0<1024>>>0&(e&65535)>>>0<512>>>0){g=(c[136168+((d[267296]|0)<<16)+((((((a[136144]&8)!=0?511:255)&((d[136136]|0)+e&65535)&65535)<<5|(g&992)>>>5)^16352)<<2)>>2]&1<<(g&31)|0)!=0?0:-128}else{g=-128}a[136128]=g;return};default:{k=a[267264]|0;h=k&255;j=a[267256]|0;e=j&255;do{if((i&248|0)==24){h=(k&255)>>>0>(j&255)>>>0?h:e;e=h}else{if((i&128|0)==0){break}e=(f&255)>>>3&3;h=(f&255)>>>5&3}}while(0);switch(i&7|0){case 0:{e=0;break};case 2:{h=0;break};case 3:{h=-h&65535;break};case 4:{e=-e&65535;h=0;break};case 5:{e=-e&65535;break};case 6:{e=0;h=-h&65535;break};case 7:{e=-e&65535;h=-h&65535;break};default:{}}j=d[267280]|0;if((j&1|0)!=0){q=b[68080]|0;p=b[68076]|0;i=q+h&65535;f=p+e&65535;j=(j&2|0)!=0;k=(i<<16>>16)-(q<<16>>16)|0;k=(k|0)>-1?k:-k|0;l=(f<<16>>16)-(p<<16>>16)|0;o=(l|0)>-1?l:-l|0;m=q<<16>>16<i<<16>>16?1:-1;n=p<<16>>16<f<<16>>16?1:-1;b[133676]=1;b[133672]=b[6528+((a[267272]&3)<<1)>>1]|0;l=-o|0;r=k-o|0;a:while(1){if(p<<16>>16==f<<16>>16){do{$b(q,f,j);if(q<<16>>16==i<<16>>16){break a}s=r<<1;if((s|0)>(l|0)){q=q+m&65535;r=r-o|0}if(q<<16>>16==i<<16>>16){g=40;break a}}while((s|0)>=(k|0))}else{s=q;while(1){$b(s,p,j);q=r<<1;if((q|0)>(l|0)){s=s+m&65535;r=r-o|0}if((q|0)<(k|0)){q=s;break}}}p=p+n&65535;r=r+k|0}if((g|0)==40){$b(i,f,j)}a[267248+(d[267296]|0)|0]=0;a[7872]=1}b[68080]=(b[68080]|0)+h;b[68076]=(b[68076]|0)+e;return}}do{if((g|0)==10){s=a[136144]&1;xc(136168+(s<<16)|0,0,65536)|0;a[267248+s|0]=1;a[7872]=1;if(!(f<<24>>24==4)){g=11;break}return}}while(0);do{if((g|0)==11){b[68080]=0;if(!(f<<24>>24==13)){break}return}}while(0);b[68076]=0;return};case 33:{a[267280]=f&127;return};case 34:{a[267272]=f&15;return};case 35:{a[267288]=f;return};case 37:{a[267264]=f;return};case 39:{a[267256]=f;return};case 40:{b[68080]=b[68080]&255|(f&255)<<8&3840;return};case 41:{b[68080]=b[68080]&3840|f&255;return};case 42:{b[68076]=b[68076]&255|(f&255)<<8&3840;return};case 43:{b[68076]=b[68076]&3840|f&255;return};case 48:{a[136144]=f;a[267296]=(f&255)>>>1&1;return};case 54:{a[136136]=f;a[7872]=1;return};default:{return}}}function _b(e){e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;f=d[267296]|0;a[267248+f|0]=0;a[7872]=1;g=d[267288]|0;h=(g&65535)>>>4;h=h<<16>>16==0?16:h;g=g&15;g=g<<16>>16==0?16:g;if(e<<24>>24==11){e=b[68080]|0;if(!((a[267272]&8)==0)){s=g&255;i=b[68076]|0;h=(h&65535)<<2;j=h&255;l=a[267280]|0;k=(l&2)!=0;if(!(s<<24>>24==0|j<<24>>24==0)){l=(l&255)>>>3&1;m=l<<24>>24==0;l=l<<24>>24!=0;n=d[136136]|0;p=a[136144]|0;o=(p&8)!=0?511:255;r=(p&4)==0;p=(-(h&252)&65535|1)+(j-1&255)&65535;q=i;g=e+(g*-3&65535)&65535;u=s<<2;while(1){t=(q&65535)>>>0>511>>>0;e=(o&(n+q&65535)&65535)<<5^16352;w=j;v=g;while(1){w=w-1&255;s=v+1&65535;do{if(!((t|(v&65535)>>>0>1023>>>0)&m)){x=136168+(f<<16)+(e+(((l?v&992:v)&65535)>>>5)<<2)|0;v=1<<(v&31);if(!r){if(!k){break}c[x>>2]=c[x>>2]^v;break}if(k){c[x>>2]=c[x>>2]|v;break}else{c[x>>2]=c[x>>2]&~v;break}}}while(0);if(w<<24>>24==0){break}else{v=s}}u=u-1&255;if(u<<24>>24==0){break}else{q=q+1&65535;g=p+g&65535}}}b[68076]=(i&65535)+h;return}h=(h&65535)<<2;i=h&255;r=g&255;j=a[267280]|0;g=(j&2)!=0;if(!(r<<24>>24==0|i<<24>>24==0)){k=(j&255)>>>3&1;l=k<<24>>24==0;k=k<<24>>24!=0;j=d[136136]|0;n=a[136144]|0;m=(n&8)!=0?511:255;q=(n&4)==0;n=(-(h&252)&65535|1)+(i-1&255)&65535;p=b[68076]|0;o=e;r=r<<2;while(1){r=r-1&255;s=(m&(j+p&65535)&65535)<<5^16352;if((p&65535)>>>0>511>>>0){v=i;w=o;while(1){v=v-1&255;t=w+1&65535;do{if(!l){u=136168+(f<<16)+((s|(w&992)>>>5)<<2)|0;w=1<<(w&31);if(!q){if(!g){break}c[u>>2]=c[u>>2]^w;break}if(g){c[u>>2]=c[u>>2]|w;break}else{c[u>>2]=c[u>>2]&~w;break}}}while(0);if(v<<24>>24==0){break}else{w=t}}}else{u=i;w=o;while(1){u=u-1&255;t=w+1&65535;do{if(!((w&65535)>>>0>1023>>>0&l)){v=136168+(f<<16)+(s+(((k?w&992:w)&65535)>>>5)<<2)|0;w=1<<(w&31);if(!q){if(!g){break}c[v>>2]=c[v>>2]^w;break}if(g){c[v>>2]=c[v>>2]|w;break}else{c[v>>2]=c[v>>2]&~w;break}}}while(0);if(u<<24>>24==0){break}else{w=t}}}if(r<<24>>24==0){break}else{p=p+1&65535;o=n+o&65535}}}b[68080]=(e&65535)+h;return}e=c[48+((e&255)-32<<2)>>2]|0;H=a[432+e|0]|0;a:do{if((H&255)>>>0<8>>>0){E=e+434|0;t=a[e+433|0]|0;e=a[267272]|0;i=e&255;j=(i&8|0)==0;if(j){J=b[68080]|0;if((i&4|0)!=0){J=J+(h*7&65535)&65535}G=(b[68076]|0)+($(7-(H&255)&65535,g)|0)&65535}else{G=b[68076]|0;if((i&4|0)!=0){G=G+(h*7&65535)&65535}J=(b[68080]|0)-($(7-(H&255)&65535,g)|0)&65535}s=(h&65535)*5|0;l=h&255;m=g&255;n=m<<24>>24==0|l<<24>>24==0;k=(1-h&65535)+(l-1&255)&65535;o=(1-g&65535)+(m-1&255)&65535;q=a[267280]|0;r=a[136136]|0;p=a[136144]|0;I=0;while(1){v=(e&8)==0;w=v?h:0;y=v?0:h;x=(i&4|0)==0;C=(q&2)!=0;u=(q&255)>>>3&1;B=u<<24>>24==0;u=u<<24>>24!=0;D=r&255;z=(p&8)!=0?511:255;A=(p&4)==0;F=-128;do{do{if(!((t&F)<<24>>24==0)){if(v){if(n){break}else{K=G;L=J;P=m}while(1){N=(K&65535)>>>0>511>>>0;O=(z&(D+K&65535)&65535)<<5^16352;R=l;Q=L;while(1){R=R-1&255;M=Q+1&65535;do{if(!((N|(Q&65535)>>>0>1023>>>0)&B)){S=136168+(f<<16)+(O+(((u?Q&992:Q)&65535)>>>5)<<2)|0;Q=1<<(Q&31);if(!A){if(!C){break}c[S>>2]=c[S>>2]^Q;break}if(C){c[S>>2]=c[S>>2]|Q;break}else{c[S>>2]=c[S>>2]&~Q;break}}}while(0);if(R<<24>>24==0){break}else{Q=M}}P=P-1&255;if(P<<24>>24==0){break}else{K=K+1&65535;L=k+L&65535}}}else{if(n){break}else{L=G;K=J;M=l}while(1){N=(L&65535)>>>0>511>>>0;O=(z&(D+L&65535)&65535)<<5^16352;S=m;Q=K;while(1){S=S-1&255;P=Q+1&65535;do{if(!((N|(Q&65535)>>>0>1023>>>0)&B)){R=136168+(f<<16)+(O+(((u?Q&992:Q)&65535)>>>5)<<2)|0;Q=1<<(Q&31);if(!A){if(!C){break}c[R>>2]=c[R>>2]^Q;break}if(C){c[R>>2]=c[R>>2]|Q;break}else{c[R>>2]=c[R>>2]&~Q;break}}}while(0);if(S<<24>>24==0){break}else{Q=P}}M=M-1&255;if(M<<24>>24==0){break}else{L=L+1&65535;K=o+K&65535}}}}}while(0);J=w+J&65535;G=y+G&65535;I=I+1&255;do{if(I<<24>>24==5){H=H+1&255;if(H<<24>>24==8){break a}if(v){G=G-g&65535;J=(J&65535)-s&65535}else{G=(G&65535)-s&65535;J=J+g&65535}if(x){I=0;break}if(j){J=J-h&65535;I=0;break}else{G=G-h&65535;I=0;break}}}while(0);F=(F&255)>>>1;}while(!(F<<24>>24==0));t=a[E]|0;E=E+1|0}}else{e=a[267272]|0}}while(0);f=(h*5&65535)+2&65535;if((e&8)==0){b[68080]=(b[68080]|0)+f;return}else{b[68076]=(b[68076]|0)+f;return}}function $b(e,f,g){e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0;h=b[133676]|0;do{if(!((h&b[133672])<<16>>16==0)){j=(d[267280]|0)>>>3&1;if(((f&65535)>>>0>511>>>0|(e&65535)>>>0>1023>>>0)&j<<24>>24==0){break}i=a[136144]|0;f=136168+((d[267296]|0)<<16)+(((((i&8)!=0?511:255)&((d[136136]|0)+f&65535)&65535)<<5^16352)+(((j<<24>>24!=0?e&992:e)&65535)>>>5)<<2)|0;e=1<<(e&31);if(!((i&4)==0)){if(!g){break}c[f>>2]=c[f>>2]^e;break}if(g){c[f>>2]=c[f>>2]|e;break}else{c[f>>2]=c[f>>2]&~e;break}}}while(0);g=h<<1;b[133676]=g<<16>>16==0?1:g;return}function ac(){var a=0;a=c[2008]|0;if((a|0)!=0){qa(a|0)|0}a=c[2010]|0;if((a|0)==0){mc();return}qa(a|0)|0;mc();return}function bc(){var d=0,e=0,f=0;d=i;i=i+48|0;e=d|0;a:do{if((_a(e|0)|0)!=0){switch(c[e>>2]|0){case 769:{a[8048]=0;break a};case 768:{f=e;if((b[f+20>>1]&768)==0){if(!(rc(f+12|0)|0)){break a}Kb(7896,-100)|0;break a}e=c[e+16>>2]|0;if((e|0)==109){a[8024]=a[8024]^1;break a}else if((e|0)==112){if((c[2010]|0)==0){c[2010]=c[n>>2];Da(5584)|0;break a}else{Da(5864)|0;c[2010]=0;Mb(5800);break a}}else if((e|0)==114){cc();break a}else{break a}};case 1024:case 1026:case 1025:{if((a[8024]|0)==0){break a}oc(e);break a};default:{break a}}}}while(0);e=a[267304]|0;if(!(e<<24>>24==-6)){a[267304]=e+1}do{if((a[7872]|0)!=0){if(((Ma()|0)&4)==0){break}f=c[1970]|0;Aa(f|0,0,oa(c[f+4>>2]|0,0,((a[267360]&16)!=0?-64:0)|0,0)|0)|0;Ca(c[1970]|0)|0;Rb();e=a[267304]|0;Wb((e&255)>>>0<58>>>0?0:e-58&255);Ua(c[1970]|0);Na(c[1970]|0,0,0,0,0);a[7872]=0}}while(0);if(qc()|0){Kb(7896,-100)|0}if(!(Tb()|0)){Yb()|0;Jb(7896,8e4)|0;i=d;return}Kb(7896,-114)|0;Yb()|0;Jb(7896,8e4)|0;i=d;return}function cc(){var b=0,d=0;do{if((c[2008]|0)==0){d=ya(4784,4712)|0;c[2008]=d;if((d|0)!=0){break}Nb(4624)}}while(0);Ib(7896);xc(73608,0,62464)|0;xc(11144,0,62464)|0;a[267384]=0;a[6536]=0;b=ya(4616,4608)|0;if((b|0)==0){Nb(4520)}d=Pa(73608,1,8192,b|0)|0;if(d>>>0<2048>>>0){Nb(4448)}xc(73608+d|0,126,8192-d|0)|0;qa(b|0)|0;wc(11144,73608,8192)|0;a[6504]=1;Sb();Xb();sc();a[267360]=0;a[7872]=1;return}function dc(){c[1650]=0;c[1648]=2;Gb(7896);Hb(7896);c[1992]=4;c[1993]=4;c[1995]=2;c[1996]=2;c[2008]=0;cc();lc();Ra(2,50,1);a[267304]=0;return}function ec(b){b=b|0;var c=0;c=b&65535;do{if((b&65535)>>>0<62464>>>0){if((a[267384]|0)==0){b=73608+c|0;break}else{b=11144+c|0;break}}else{b=8072+(c-62464)|0}}while(0);return a[b]|0}function fc(e,f,g){e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0;e=i;i=i+8|0;h=e|0;a:do{if((g|0)==0){if(a[6504]|0){h=f&65535;if((h|0)==1156){g=-17;i=e;return g|0}else if((h|0)==1547){f=c[2008]|0;b[133656]=0;b[133660]=0;do{if((f|0)!=0){b[3256]=0;if((Ga(f|0,0,0)|0)!=0){break}if((Pa(130952,5120,1,f|0)|0)==0){break}if((Pa(8072,2816,1,f|0)|0)==0){break}a[11144]=-61;a[11145]=3;a[11146]=-6;b[133696]=2816;b[133700]=653;a[267336]=0;g=-55;i=e;return g|0}}while(0);Ob(5720);g=((Ac()|0)&1|0)!=0;b[3963]=g?1750:1927;g=0;i=e;return g|0}else if((h|0)==768){g=-55;i=e;return g|0}else{j=36;break}}if((f<<16>>16|0)==(-1536|0)){b[133696]=-1536;b[133700]=-3066;a[6536]=1;h=64e3;j=40;break}else if((f<<16>>16|0)==(-831|0)){j=13}do{if((j|0)==13){j=b[3952]|0;g=j&65535;do{if((j&65535)>>>0<62464>>>0){if((a[267384]|0)==0){g=73608+g|0;break}else{g=11144+g|0;break}}else{g=8072+(g-62464)|0}}while(0);g=d[g]|0;k=j+1&65535;j=k&65535;do{if((k&65535)>>>0<62464>>>0){if((a[267384]|0)==0){j=73608+j|0;break}else{j=11144+j|0;break}}else{j=8072+(j-62464)|0}}while(0);if((d[j]<<8|g)<<16>>16==-21931){f=-57}else{break}i=e;return f|0}}while(0);j=b[133696]|0;if((j&65535)>>>0>(f&65535)>>>0){j=36;break}ua(h|0,f-j&65535|0,3);j=c[h>>2]|0;if(!((c[h+4>>2]|0)==0&(j|0)<38)){j=36;break}switch(j|0){case 8:{b[133656]=0;j=36;break a};case 9:{if((a[7896]|0)!=1){j=36;break a}b[3950]=0;k=-55;i=e;return k|0};case 10:{b[133656]=b[3948]|0;j=36;break a};case 11:{b[133660]=(b[3948]|0)-1;j=36;break a};case 12:{b[133664]=b[3948]|0;j=36;break a};case 13:{a[7903]=jc(0)|0;k=-55;i=e;return k|0};case 14:{a[7903]=jc(1)|0;k=-55;i=e;return k|0};case 28:{a[267336]=(a[7903]|0)!=0|0;j=36;break a};default:{j=36;break a}}}else{j=36}}while(0);do{if((j|0)==36){h=f&65535;if(!((f&65535)>>>0<62464>>>0)){j=40;break}if((a[267384]|0)==0){f=73608+h|0;break}else{f=11144+h|0;break}}}while(0);if((j|0)==40){f=8072+(h-62464)|0}k=a[f]|0;i=e;return k|0}function gc(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;if(!((c&65535)>>>0>8191>>>0|a[6504]^1)){return}b=c&65535;do{if((c&65535)>>>0<62464>>>0){if((a[267384]|0)==0){c=73608+b|0;break}else{c=11144+b|0;break}}else{c=8072+(b-62464)|0}}while(0);a[c]=d;return}function hc(b,c,e){b=b|0;c=c|0;e=e|0;b=c&255;e=c&255;c=e&65535;a:do{if((c&242|0)==16){b=(c&1|0)!=0?0:7}else{if((e-32&65535)>>>0<17>>>0){b=Vb(b)|0;break}switch(e<<16>>16){case 50:{b=a[267360]|0;break a};case 53:{b=63;break a};case 54:{b=((Ac()|0)&17|(d[136128]|0)|78)&255;break a};case 49:case 51:case 52:case 55:{b=-1;break a};default:{if((e-52&65535)>>>0<12>>>0){b=Qb(b)|0;break a}if((e-128&65535)>>>0<8>>>0){if(!(a[6504]|0)){break a}a[6504]=0;xc(73608,0,8192)|0;xc(11147,0,8189)|0;break a}if((e-136&65535)>>>0<8>>>0){a[267384]=0;break a}if((e-144&65535)>>>0<8>>>0){a[267384]=1;break a}if((e-152&65535)>>>0<8>>>0){b=b&-2;break a}if((e-160&65535)>>>0<32>>>0){b=kc(b)|0;break a}if((e-192&65535)>>>0<8>>>0){b=63;break a}if((e-216&65535)>>>0<16>>>0){b=pc(b)|0;break a}if(!(e<<16>>16==240)){break a}b=((Ac()|0)<<6&64^192)&255;break a}}}}while(0);return b|0}function ic(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;b=c&255;c=c&255;if((c-32&65535)>>>0<17>>>0|c<<16>>16==54){Zb(b,d);return}if(c<<16>>16==50){a[267360]=d;a[7872]=1;return}if((c-52&65535)>>>0<12>>>0){Ub(b,d);return}if((c-128&65535)>>>0<8>>>0){if(!(a[6504]|0)){return}a[6504]=0;xc(73608|0,0|0,8192|0)|0;xc(11147|0,0|0,8189|0)|0;return}if((c-136&65535)>>>0<8>>>0){a[267384]=0;return}if((c-144&65535)>>>0<8>>>0){a[267384]=1;return}if((c-160&65535)>>>0<32>>>0){nc(b,d);return}if(!((c-216&65535)>>>0<16>>>0)){return}tc(b,d);return}function jc(f){f=f|0;var g=0,h=0,i=0,j=0,k=0;g=c[2008]|0;if((g|0)==0){k=1;return k|0}k=a[6536]|0;i=k?32:64;h=b[133656]|0;if((h&65535)>>>0>1223>>>0){k=1;return k|0}j=e[133660]|0;if(!(j>>>0<i>>>0)){k=1;return k|0}b[3256]=h;j=j+($(h&65535,i)|0)|0;if((Ga(g|0,$(j,k?256:128)|0,0)|0)!=0){k=1;return k|0}h=a[267384]|0;a[267384]=a[267336]|0;j=a[6536]|0?256:128;i=b[133664]|0;a:do{if(f){while(1){f=i&65535;do{if((i&65535)>>>0<62464>>>0){if((a[267384]|0)==0){f=73608+f|0;break}else{f=11144+f|0;break}}else{f=8072+(f-62464)|0}}while(0);if((Ba(d[f]|0,g|0)|0)==-1){g=1;break a}j=j-1|0;if((j|0)==0){g=0;break}else{i=i+1&65535}}}else{f=j;while(1){j=pa(g|0)|0;if((j|0)==-1){g=1;break a}j=j&255;k=i&65535;do{if((i&65535)>>>0<62464>>>0){if((a[267384]|0)==0){k=73608+k|0;break}else{k=11144+k|0;break}}else{k=8072+(k-62464)|0}}while(0);a[k]=j;f=f-1|0;if((f|0)==0){g=0;break}else{i=i+1&65535}}}}while(0);a[267384]=h;k=g;return k|0}function kc(b){b=b|0;var d=0,e=0,f=0;d=i;i=i+8|0;f=d|0;e=b&255;switch(e|0){case 168:{f=-16;i=d;return f|0};case 171:case 172:case 173:case 174:case 175:{f=a[136080+(e-171)|0]|0;i=d;return f|0};case 176:{f=8;i=d;return f|0};case 165:case 180:{f=1;i=d;return f|0};default:{if(!((b+96&255)>>>0<10>>>0)){f=-1;i=d;return f|0}c[f>>2]=Sa(0)|0;f=Oa(f|0)|0;switch(e|0){case 162:{e=c[f>>2]|0;break};case 163:{e=c[f+4>>2]|0;break};case 164:{e=c[f+8>>2]|0;break};case 166:{e=c[f+12>>2]|0;break};case 167:{e=(c[f+16>>2]|0)+1|0;break};case 169:{e=c[f+20>>2]|0;break};case 160:case 161:{f=0;i=d;return f|0};default:{e=0}}if(b<<24>>24==-87){f=(e|0)>78?e+27|0:105;e=f-(((f-e|0)>>>0)%28|0)|0}b=~e;f=e+28+((b|0)>-100?b:-100)|0;f=((f>>>0)%28|0)-f+e|0;f=(((f|0)/10|0)<<4|((f|0)%10|0))&255;i=d;return f|0}}return 0}function lc(){var b=0,c=0;b=ya(5776,5792)|0;do{if((b|0)!=0){c=(Pa(136080,5,1,b|0)|0)==0;a[136082]=a[136082]&15;qa(b|0)|0;if(c){break}return}}while(0);a[136080]=8;a[136081]=81;a[136082]=7;a[136083]=2;a[136084]=-41;return}function mc(){var b=0,c=0;if(!(a[6520]|0)){return}b=ya(5776,5576)|0;do{if((b|0)!=0){c=(fb(136080,5,1,b|0)|0)==0;qa(b|0)|0;if(c){break}return}}while(0);Ob(4720);return}function nc(b,c){b=b|0;c=c|0;if(!((b+85&255)>>>0<5>>>0)){return}a[136080+((b&255)-171)|0]=b<<24>>24==-83?c&15:c;a[6520]=1;return}function oc(f){f=f|0;var g=0;if((a[136104]|0)!=65){return}g=c[f>>2]|0;if((g|0)==1026|(g|0)==1025){g=f;f=d[f+8|0]|0;if((f|0)==2){f=8}else if((f|0)==3){f=4}else if((f|0)==1){f=16}else{f=0}if((a[g+9|0]|0)==1){a[136112]=d[136112]|f;return}else{a[136112]=d[136112]&(f^255);return}}else if((g|0)==1024){b[68048]=(e[68048]|0)+(c[f+20>>2]|0);b[68044]=(e[68044]|0)-(c[f+24>>2]|0);return}else{return}}function pc(f){f=f|0;f=f&255;a:do{if((f|0)==216){a[5880]=0;f=a[7888]|0}else if((f|0)==217){f=a[5880]&1|4}else if((f|0)==218){f=a[136104]|0;a[136104]=f+1;switch(f&255|0){case 1:{f=79;break a};case 2:{f=71;break a};case 3:{f=73;break a};case 60:{f=a[136112]|0;break a};case 61:{f=b[68048]&63;break a};case 62:{f=(e[68048]|0)>>>6&63;break a};case 63:{f=b[68044]&63;break a};case 64:{f=(e[68044]|0)>>>6&63;b[68048]=0;b[68044]=0;break a};case 0:{f=76;break a};default:{a[136104]=65;f=0;break a}}}else if((f|0)==219){if((c[2010]|0)!=0){f=4;break}f=(d[136104]|0)>>>0<65>>>0|4}else{f=0}}while(0);return f|0}function qc(){var b=0;if((a[136072]|0)==0|(a[8048]|0)==0){b=0;return b|0}b=(a[267368]|0)-1&255;a[267368]=b;if(!(b<<24>>24==0)){b=0;return b|0}a[267368]=3;a[5880]=1;b=1;return b|0}function rc(b){b=b|0;var d=0,f=0,g=0,h=0,i=0;f=c[b+4>>2]|0;b=e[b+8>>1]|0;do{if((f|0)==1112|(f|0)==13){if((b&768|0)==0){break}ra(c[1970]|0)|0;i=0;return i|0}}while(0);a:do{if((a[8064]|0)==0){g=-3}else{h=17;g=6168;while(1){if((h|0)==0){g=-3;break a}if((c[g>>2]|0)==(f|0)){break}else{h=h-1|0;g=g+8|0}}i=(b&3|0)!=0;h=(b&192|0)==0;if(!(h|i^1)){g=a[g+7|0]|0;break}if(i){g=a[g+5|0]|0;break}if(h){g=a[g+4|0]|0;break}else{g=a[g+6|0]|0;break}}}while(0);h=g<<24>>24==-3;b:do{if(h&(f-97|0)>>>0<26>>>0){if((b&192|0)!=0){f=f+160&255;d=35;break}if((b&8195|0)==0){f=f&255;d=35;break}else{f=f+224&255;d=35;break}}else{do{if(h){h=25;g=6304;while(1){if((h|0)==0){b=0;break}if((c[g>>2]|0)==(f|0)){d=23;break}else{h=h-1|0;g=g+8|0}}if((d|0)==23){h=(b&3|0)!=0;b=(b&192|0)==0;do{if(b|h^1){if(h){b=g+5|0;break}if(b){b=g+4|0;break}else{b=g+6|0;break}}else{b=g+7|0}}while(0);g=a[b]|0;if(g<<24>>24==-3){b=0}else{break}}while(1){if(!(b>>>0<35>>>0)){f=0;d=37;break}if((c[5888+(b<<3)>>2]|0)==(f|0)){d=33;break}else{b=b+1|0}}if((d|0)==33){f=a[5892+(b<<3)|0]|0;d=35;break b}else if((d|0)==37){return f|0}}}while(0);f=g;b=g<<24>>24!=-3}}while(0);do{if((d|0)==35){if(f<<24>>24==-3){f=0}else{b=1;break}return f|0}}while(0);a[7888]=f;a[267368]=23;a[8048]=1;a[5880]=1;i=b;return i|0}function sc(){a[8048]=0;a[136072]=1;a[8064]=0;c[2010]=0;a[8024]=1;return}function tc(d,e){d=d|0;e=e|0;d=d&255;if((d|0)==216){if(!((e&87)==87)){return}a[8064]=(e&255)>>>7;a[136072]=(e&255)>>>5&1^1;return}else if((d|0)==218){d=c[2010]|0;e=e&255;if((d|0)!=0){Ba(e|0,d|0)|0;return}if((e|0)==99){a[136104]=0;a[136112]=0;b[68048]=0;b[68044]=0;return}else if((e|0)==80){a[136104]=60;return}else{return}}else{return}}function uc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;do{if(a>>>0<245>>>0){if(a>>>0<11>>>0){a=16}else{a=a+11&-8}f=a>>>3;d=c[1850]|0;e=d>>>(f>>>0);if((e&3|0)!=0){h=(e&1^1)+f|0;b=h<<1;e=7440+(b<<2)|0;b=7440+(b+2<<2)|0;g=c[b>>2]|0;f=g+8|0;a=c[f>>2]|0;do{if((e|0)==(a|0)){c[1850]=d&~(1<<h)}else{if(a>>>0<(c[1854]|0)>>>0){sa();return 0}d=a+12|0;if((c[d>>2]|0)==(g|0)){c[d>>2]=e;c[b>>2]=a;break}else{sa();return 0}}}while(0);r=h<<3;c[g+4>>2]=r|3;r=g+(r|4)|0;c[r>>2]=c[r>>2]|1;r=f;return r|0}if(!(a>>>0>(c[1852]|0)>>>0)){break}if((e|0)!=0){i=2<<f;i=e<<f&(i|-i);i=(i&-i)-1|0;b=i>>>12&16;i=i>>>(b>>>0);h=i>>>5&8;i=i>>>(h>>>0);e=i>>>2&4;i=i>>>(e>>>0);g=i>>>1&2;i=i>>>(g>>>0);f=i>>>1&1;f=(h|b|e|g|f)+(i>>>(f>>>0))|0;i=f<<1;g=7440+(i<<2)|0;i=7440+(i+2<<2)|0;e=c[i>>2]|0;b=e+8|0;h=c[b>>2]|0;do{if((g|0)==(h|0)){c[1850]=d&~(1<<f)}else{if(h>>>0<(c[1854]|0)>>>0){sa();return 0}d=h+12|0;if((c[d>>2]|0)==(e|0)){c[d>>2]=g;c[i>>2]=h;break}else{sa();return 0}}}while(0);f=f<<3;d=f-a|0;c[e+4>>2]=a|3;r=e;e=r+a|0;c[r+(a|4)>>2]=d|1;c[r+f>>2]=d;f=c[1852]|0;if((f|0)!=0){a=c[1855]|0;g=f>>>3;h=g<<1;f=7440+(h<<2)|0;i=c[1850]|0;g=1<<g;do{if((i&g|0)==0){c[1850]=i|g;g=f;h=7440+(h+2<<2)|0}else{h=7440+(h+2<<2)|0;g=c[h>>2]|0;if(!(g>>>0<(c[1854]|0)>>>0)){break}sa();return 0}}while(0);c[h>>2]=a;c[g+12>>2]=a;c[a+8>>2]=g;c[a+12>>2]=f}c[1852]=d;c[1855]=e;r=b;return r|0}d=c[1851]|0;if((d|0)==0){break}f=(d&-d)-1|0;q=f>>>12&16;f=f>>>(q>>>0);p=f>>>5&8;f=f>>>(p>>>0);r=f>>>2&4;f=f>>>(r>>>0);d=f>>>1&2;f=f>>>(d>>>0);e=f>>>1&1;e=c[7704+((p|q|r|d|e)+(f>>>(e>>>0))<<2)>>2]|0;f=e;d=e;e=(c[e+4>>2]&-8)-a|0;while(1){h=c[f+16>>2]|0;if((h|0)==0){h=c[f+20>>2]|0;if((h|0)==0){break}}i=(c[h+4>>2]&-8)-a|0;g=i>>>0<e>>>0;f=h;d=g?h:d;e=g?i:e}g=d;i=c[1854]|0;if(g>>>0<i>>>0){sa();return 0}r=g+a|0;f=r;if(!(g>>>0<r>>>0)){sa();return 0}h=c[d+24>>2]|0;j=c[d+12>>2]|0;do{if((j|0)==(d|0)){k=d+20|0;j=c[k>>2]|0;if((j|0)==0){k=d+16|0;j=c[k>>2]|0;if((j|0)==0){j=0;break}}while(1){l=j+20|0;m=c[l>>2]|0;if((m|0)!=0){j=m;k=l;continue}m=j+16|0;l=c[m>>2]|0;if((l|0)==0){break}else{j=l;k=m}}if(k>>>0<i>>>0){sa();return 0}else{c[k>>2]=0;break}}else{k=c[d+8>>2]|0;if(k>>>0<i>>>0){sa();return 0}l=k+12|0;if((c[l>>2]|0)!=(d|0)){sa();return 0}i=j+8|0;if((c[i>>2]|0)==(d|0)){c[l>>2]=j;c[i>>2]=k;break}else{sa();return 0}}}while(0);a:do{if((h|0)!=0){k=c[d+28>>2]|0;i=7704+(k<<2)|0;do{if((d|0)==(c[i>>2]|0)){c[i>>2]=j;if((j|0)!=0){break}c[1851]=c[1851]&~(1<<k);break a}else{if(h>>>0<(c[1854]|0)>>>0){sa();return 0}i=h+16|0;if((c[i>>2]|0)==(d|0)){c[i>>2]=j}else{c[h+20>>2]=j}if((j|0)==0){break a}}}while(0);if(j>>>0<(c[1854]|0)>>>0){sa();return 0}c[j+24>>2]=h;h=c[d+16>>2]|0;do{if((h|0)!=0){if(h>>>0<(c[1854]|0)>>>0){sa();return 0}else{c[j+16>>2]=h;c[h+24>>2]=j;break}}}while(0);h=c[d+20>>2]|0;if((h|0)==0){break}if(h>>>0<(c[1854]|0)>>>0){sa();return 0}else{c[j+20>>2]=h;c[h+24>>2]=j;break}}}while(0);if(e>>>0<16>>>0){r=e+a|0;c[d+4>>2]=r|3;r=g+(r+4)|0;c[r>>2]=c[r>>2]|1}else{c[d+4>>2]=a|3;c[g+(a|4)>>2]=e|1;c[g+(e+a)>>2]=e;h=c[1852]|0;if((h|0)!=0){g=c[1855]|0;k=h>>>3;i=k<<1;h=7440+(i<<2)|0;j=c[1850]|0;k=1<<k;do{if((j&k|0)==0){c[1850]=j|k;j=h;i=7440+(i+2<<2)|0}else{i=7440+(i+2<<2)|0;j=c[i>>2]|0;if(!(j>>>0<(c[1854]|0)>>>0)){break}sa();return 0}}while(0);c[i>>2]=g;c[j+12>>2]=g;c[g+8>>2]=j;c[g+12>>2]=h}c[1852]=e;c[1855]=f}d=d+8|0;if((d|0)==0){break}return d|0}else{if(a>>>0>4294967231>>>0){a=-1;break}d=a+11|0;a=d&-8;e=c[1851]|0;if((e|0)==0){break}f=-a|0;d=d>>>8;do{if((d|0)==0){g=0}else{if(a>>>0>16777215>>>0){g=31;break}q=(d+1048320|0)>>>16&8;r=d<<q;p=(r+520192|0)>>>16&4;r=r<<p;g=(r+245760|0)>>>16&2;g=14-(p|q|g)+(r<<g>>>15)|0;g=a>>>((g+7|0)>>>0)&1|g<<1}}while(0);h=c[7704+(g<<2)>>2]|0;b:do{if((h|0)==0){d=0;j=0}else{if((g|0)==31){i=0}else{i=25-(g>>>1)|0}d=0;i=a<<i;j=0;while(1){l=c[h+4>>2]&-8;k=l-a|0;if(k>>>0<f>>>0){if((l|0)==(a|0)){d=h;f=k;j=h;break b}else{d=h;f=k}}k=c[h+20>>2]|0;h=c[h+16+(i>>>31<<2)>>2]|0;j=(k|0)==0|(k|0)==(h|0)?j:k;if((h|0)==0){break}else{i=i<<1}}}}while(0);if((j|0)==0&(d|0)==0){r=2<<g;e=e&(r|-r);if((e|0)==0){break}r=(e&-e)-1|0;o=r>>>12&16;r=r>>>(o>>>0);n=r>>>5&8;r=r>>>(n>>>0);p=r>>>2&4;r=r>>>(p>>>0);q=r>>>1&2;r=r>>>(q>>>0);j=r>>>1&1;j=c[7704+((n|o|p|q|j)+(r>>>(j>>>0))<<2)>>2]|0}if((j|0)!=0){while(1){g=(c[j+4>>2]&-8)-a|0;e=g>>>0<f>>>0;f=e?g:f;d=e?j:d;e=c[j+16>>2]|0;if((e|0)!=0){j=e;continue}j=c[j+20>>2]|0;if((j|0)==0){break}}}if((d|0)==0){break}if(!(f>>>0<((c[1852]|0)-a|0)>>>0)){break}e=d;j=c[1854]|0;if(e>>>0<j>>>0){sa();return 0}h=e+a|0;g=h;if(!(e>>>0<h>>>0)){sa();return 0}i=c[d+24>>2]|0;k=c[d+12>>2]|0;do{if((k|0)==(d|0)){l=d+20|0;k=c[l>>2]|0;if((k|0)==0){l=d+16|0;k=c[l>>2]|0;if((k|0)==0){k=0;break}}while(1){m=k+20|0;n=c[m>>2]|0;if((n|0)!=0){k=n;l=m;continue}m=k+16|0;n=c[m>>2]|0;if((n|0)==0){break}else{k=n;l=m}}if(l>>>0<j>>>0){sa();return 0}else{c[l>>2]=0;break}}else{l=c[d+8>>2]|0;if(l>>>0<j>>>0){sa();return 0}j=l+12|0;if((c[j>>2]|0)!=(d|0)){sa();return 0}m=k+8|0;if((c[m>>2]|0)==(d|0)){c[j>>2]=k;c[m>>2]=l;break}else{sa();return 0}}}while(0);c:do{if((i|0)!=0){l=c[d+28>>2]|0;j=7704+(l<<2)|0;do{if((d|0)==(c[j>>2]|0)){c[j>>2]=k;if((k|0)!=0){break}c[1851]=c[1851]&~(1<<l);break c}else{if(i>>>0<(c[1854]|0)>>>0){sa();return 0}j=i+16|0;if((c[j>>2]|0)==(d|0)){c[j>>2]=k}else{c[i+20>>2]=k}if((k|0)==0){break c}}}while(0);if(k>>>0<(c[1854]|0)>>>0){sa();return 0}c[k+24>>2]=i;i=c[d+16>>2]|0;do{if((i|0)!=0){if(i>>>0<(c[1854]|0)>>>0){sa();return 0}else{c[k+16>>2]=i;c[i+24>>2]=k;break}}}while(0);i=c[d+20>>2]|0;if((i|0)==0){break}if(i>>>0<(c[1854]|0)>>>0){sa();return 0}else{c[k+20>>2]=i;c[i+24>>2]=k;break}}}while(0);do{if(f>>>0<16>>>0){r=f+a|0;c[d+4>>2]=r|3;r=e+(r+4)|0;c[r>>2]=c[r>>2]|1}else{c[d+4>>2]=a|3;c[e+(a|4)>>2]=f|1;c[e+(f+a)>>2]=f;i=f>>>3;if(f>>>0<256>>>0){h=i<<1;f=7440+(h<<2)|0;j=c[1850]|0;i=1<<i;do{if((j&i|0)==0){c[1850]=j|i;i=f;h=7440+(h+2<<2)|0}else{h=7440+(h+2<<2)|0;i=c[h>>2]|0;if(!(i>>>0<(c[1854]|0)>>>0)){break}sa();return 0}}while(0);c[h>>2]=g;c[i+12>>2]=g;c[e+(a+8)>>2]=i;c[e+(a+12)>>2]=f;break}g=f>>>8;do{if((g|0)==0){k=0}else{if(f>>>0>16777215>>>0){k=31;break}q=(g+1048320|0)>>>16&8;r=g<<q;p=(r+520192|0)>>>16&4;r=r<<p;k=(r+245760|0)>>>16&2;k=14-(p|q|k)+(r<<k>>>15)|0;k=f>>>((k+7|0)>>>0)&1|k<<1}}while(0);g=7704+(k<<2)|0;c[e+(a+28)>>2]=k;c[e+(a+20)>>2]=0;c[e+(a+16)>>2]=0;j=c[1851]|0;i=1<<k;if((j&i|0)==0){c[1851]=j|i;c[g>>2]=h;c[e+(a+24)>>2]=g;c[e+(a+12)>>2]=h;c[e+(a+8)>>2]=h;break}if((k|0)==31){i=0}else{i=25-(k>>>1)|0}i=f<<i;g=c[g>>2]|0;while(1){if((c[g+4>>2]&-8|0)==(f|0)){break}j=g+16+(i>>>31<<2)|0;k=c[j>>2]|0;if((k|0)==0){b=151;break}else{i=i<<1;g=k}}if((b|0)==151){if(j>>>0<(c[1854]|0)>>>0){sa();return 0}else{c[j>>2]=h;c[e+(a+24)>>2]=g;c[e+(a+12)>>2]=h;c[e+(a+8)>>2]=h;break}}i=g+8|0;j=c[i>>2]|0;f=c[1854]|0;if(g>>>0<f>>>0){sa();return 0}if(j>>>0<f>>>0){sa();return 0}else{c[j+12>>2]=h;c[i>>2]=h;c[e+(a+8)>>2]=j;c[e+(a+12)>>2]=g;c[e+(a+24)>>2]=0;break}}}while(0);d=d+8|0;if((d|0)==0){break}return d|0}}while(0);d=c[1852]|0;if(!(a>>>0>d>>>0)){b=d-a|0;e=c[1855]|0;if(b>>>0>15>>>0){r=e;c[1855]=r+a;c[1852]=b;c[r+(a+4)>>2]=b|1;c[r+d>>2]=b;c[e+4>>2]=a|3}else{c[1852]=0;c[1855]=0;c[e+4>>2]=d|3;r=e+(d+4)|0;c[r>>2]=c[r>>2]|1}r=e+8|0;return r|0}d=c[1853]|0;if(a>>>0<d>>>0){p=d-a|0;c[1853]=p;r=c[1856]|0;q=r;c[1856]=q+a;c[q+(a+4)>>2]=p|1;c[r+4>>2]=a|3;r=r+8|0;return r|0}do{if((c[1844]|0)==0){d=na(30)|0;if((d-1&d|0)==0){c[1846]=d;c[1845]=d;c[1847]=-1;c[1848]=-1;c[1849]=0;c[1961]=0;c[1844]=(Sa(0)|0)&-16^1431655768;break}else{sa();return 0}}}while(0);h=a+48|0;e=c[1846]|0;g=a+47|0;d=e+g|0;e=-e|0;f=d&e;if(!(f>>>0>a>>>0)){r=0;return r|0}i=c[1960]|0;do{if((i|0)!=0){q=c[1958]|0;r=q+f|0;if(r>>>0<=q>>>0|r>>>0>i>>>0){d=0}else{break}return d|0}}while(0);d:do{if((c[1961]&4|0)==0){i=c[1856]|0;e:do{if((i|0)==0){b=181}else{m=7848;while(1){l=m|0;j=c[l>>2]|0;if(!(j>>>0>i>>>0)){k=m+4|0;if((j+(c[k>>2]|0)|0)>>>0>i>>>0){break}}m=c[m+8>>2]|0;if((m|0)==0){b=181;break e}}if((m|0)==0){b=181;break}i=d-(c[1853]|0)&e;if(!(i>>>0<2147483647>>>0)){e=0;break}j=eb(i|0)|0;b=(j|0)==((c[l>>2]|0)+(c[k>>2]|0)|0);d=b?j:-1;e=b?i:0;b=190}}while(0);do{if((b|0)==181){d=eb(0)|0;if((d|0)==-1){e=0;break}i=d;j=c[1845]|0;e=j-1|0;if((e&i|0)==0){i=f}else{i=f-i+(e+i&-j)|0}j=c[1958]|0;e=j+i|0;if(!(i>>>0>a>>>0&i>>>0<2147483647>>>0)){e=0;break}k=c[1960]|0;if((k|0)!=0){if(e>>>0<=j>>>0|e>>>0>k>>>0){e=0;break}}j=eb(i|0)|0;b=(j|0)==(d|0);d=b?d:-1;e=b?i:0;b=190}}while(0);f:do{if((b|0)==190){b=-i|0;if(!((d|0)==-1)){b=201;break d}do{if((j|0)!=-1&i>>>0<2147483647>>>0&i>>>0<h>>>0){d=c[1846]|0;d=g-i+d&-d;if(!(d>>>0<2147483647>>>0)){break}if((eb(d|0)|0)==-1){eb(b|0)|0;break f}else{i=d+i|0;break}}}while(0);if(!((j|0)==-1)){e=i;d=j;b=201;break d}}}while(0);c[1961]=c[1961]|4;b=198}else{e=0;b=198}}while(0);do{if((b|0)==198){if(!(f>>>0<2147483647>>>0)){break}d=eb(f|0)|0;f=eb(0)|0;if(!((f|0)!=-1&(d|0)!=-1&d>>>0<f>>>0)){break}f=f-d|0;g=f>>>0>(a+40|0)>>>0;d=g?d:-1;if(!((d|0)==-1)){e=g?f:e;b=201}}}while(0);do{if((b|0)==201){f=(c[1958]|0)+e|0;c[1958]=f;if(f>>>0>(c[1959]|0)>>>0){c[1959]=f}f=c[1856]|0;g:do{if((f|0)==0){r=c[1854]|0;if((r|0)==0|d>>>0<r>>>0){c[1854]=d}c[1962]=d;c[1963]=e;c[1965]=0;c[1859]=c[1844];c[1858]=-1;b=0;do{r=b<<1;q=7440+(r<<2)|0;c[7440+(r+3<<2)>>2]=q;c[7440+(r+2<<2)>>2]=q;b=b+1|0;}while(b>>>0<32>>>0);b=d+8|0;if((b&7|0)==0){b=0}else{b=-b&7}r=e-40-b|0;c[1856]=d+b;c[1853]=r;c[d+(b+4)>>2]=r|1;c[d+(e-36)>>2]=40;c[1857]=c[1848]}else{g=7848;do{h=c[g>>2]|0;i=g+4|0;j=c[i>>2]|0;if((d|0)==(h+j|0)){b=213;break}g=c[g+8>>2]|0;}while((g|0)!=0);do{if((b|0)==213){if((c[g+12>>2]&8|0)!=0){break}g=f;if(!(g>>>0>=h>>>0&g>>>0<d>>>0)){break}c[i>>2]=j+e;b=(c[1853]|0)+e|0;d=f+8|0;if((d&7|0)==0){d=0}else{d=-d&7}r=b-d|0;c[1856]=g+d;c[1853]=r;c[g+(d+4)>>2]=r|1;c[g+(b+4)>>2]=40;c[1857]=c[1848];break g}}while(0);if(d>>>0<(c[1854]|0)>>>0){c[1854]=d}g=d+e|0;i=7848;do{h=i|0;if((c[h>>2]|0)==(g|0)){b=223;break}i=c[i+8>>2]|0;}while((i|0)!=0);do{if((b|0)==223){if((c[i+12>>2]&8|0)!=0){break}c[h>>2]=d;f=i+4|0;c[f>>2]=(c[f>>2]|0)+e;f=d+8|0;if((f&7|0)==0){f=0}else{f=-f&7}g=d+(e+8)|0;if((g&7|0)==0){k=0}else{k=-g&7}n=d+(k+e)|0;m=n;g=f+a|0;i=d+g|0;h=i;j=n-(d+f)-a|0;c[d+(f+4)>>2]=a|3;do{if((m|0)==(c[1856]|0)){r=(c[1853]|0)+j|0;c[1853]=r;c[1856]=h;c[d+(g+4)>>2]=r|1}else{if((m|0)==(c[1855]|0)){r=(c[1852]|0)+j|0;c[1852]=r;c[1855]=h;c[d+(g+4)>>2]=r|1;c[d+(r+g)>>2]=r;break}l=e+4|0;p=c[d+(l+k)>>2]|0;if((p&3|0)==1){a=p&-8;o=p>>>3;h:do{if(p>>>0<256>>>0){l=c[d+((k|8)+e)>>2]|0;n=c[d+(e+12+k)>>2]|0;p=7440+(o<<1<<2)|0;do{if((l|0)!=(p|0)){if(l>>>0<(c[1854]|0)>>>0){sa();return 0}if((c[l+12>>2]|0)==(m|0)){break}sa();return 0}}while(0);if((n|0)==(l|0)){c[1850]=c[1850]&~(1<<o);break}do{if((n|0)==(p|0)){o=n+8|0}else{if(n>>>0<(c[1854]|0)>>>0){sa();return 0}o=n+8|0;if((c[o>>2]|0)==(m|0)){break}sa();return 0}}while(0);c[l+12>>2]=n;c[o>>2]=l}else{m=c[d+((k|24)+e)>>2]|0;o=c[d+(e+12+k)>>2]|0;do{if((o|0)==(n|0)){q=k|16;p=d+(l+q)|0;o=c[p>>2]|0;if((o|0)==0){p=d+(q+e)|0;o=c[p>>2]|0;if((o|0)==0){o=0;break}}while(1){q=o+20|0;r=c[q>>2]|0;if((r|0)!=0){o=r;p=q;continue}q=o+16|0;r=c[q>>2]|0;if((r|0)==0){break}else{o=r;p=q}}if(p>>>0<(c[1854]|0)>>>0){sa();return 0}else{c[p>>2]=0;break}}else{q=c[d+((k|8)+e)>>2]|0;if(q>>>0<(c[1854]|0)>>>0){sa();return 0}r=q+12|0;if((c[r>>2]|0)!=(n|0)){sa();return 0}p=o+8|0;if((c[p>>2]|0)==(n|0)){c[r>>2]=o;c[p>>2]=q;break}else{sa();return 0}}}while(0);if((m|0)==0){break}p=c[d+(e+28+k)>>2]|0;q=7704+(p<<2)|0;do{if((n|0)==(c[q>>2]|0)){c[q>>2]=o;if((o|0)!=0){break}c[1851]=c[1851]&~(1<<p);break h}else{if(m>>>0<(c[1854]|0)>>>0){sa();return 0}p=m+16|0;if((c[p>>2]|0)==(n|0)){c[p>>2]=o}else{c[m+20>>2]=o}if((o|0)==0){break h}}}while(0);if(o>>>0<(c[1854]|0)>>>0){sa();return 0}c[o+24>>2]=m;n=k|16;m=c[d+(n+e)>>2]|0;do{if((m|0)!=0){if(m>>>0<(c[1854]|0)>>>0){sa();return 0}else{c[o+16>>2]=m;c[m+24>>2]=o;break}}}while(0);l=c[d+(l+n)>>2]|0;if((l|0)==0){break}if(l>>>0<(c[1854]|0)>>>0){sa();return 0}else{c[o+20>>2]=l;c[l+24>>2]=o;break}}}while(0);m=d+((a|k)+e)|0;j=a+j|0}a=m+4|0;c[a>>2]=c[a>>2]&-2;c[d+(g+4)>>2]=j|1;c[d+(j+g)>>2]=j;a=j>>>3;if(j>>>0<256>>>0){e=a<<1;b=7440+(e<<2)|0;i=c[1850]|0;a=1<<a;do{if((i&a|0)==0){c[1850]=i|a;a=b;e=7440+(e+2<<2)|0}else{e=7440+(e+2<<2)|0;a=c[e>>2]|0;if(!(a>>>0<(c[1854]|0)>>>0)){break}sa();return 0}}while(0);c[e>>2]=h;c[a+12>>2]=h;c[d+(g+8)>>2]=a;c[d+(g+12)>>2]=b;break}a=j>>>8;do{if((a|0)==0){e=0}else{if(j>>>0>16777215>>>0){e=31;break}q=(a+1048320|0)>>>16&8;r=a<<q;p=(r+520192|0)>>>16&4;r=r<<p;e=(r+245760|0)>>>16&2;e=14-(p|q|e)+(r<<e>>>15)|0;e=j>>>((e+7|0)>>>0)&1|e<<1}}while(0);a=7704+(e<<2)|0;c[d+(g+28)>>2]=e;c[d+(g+20)>>2]=0;c[d+(g+16)>>2]=0;h=c[1851]|0;k=1<<e;if((h&k|0)==0){c[1851]=h|k;c[a>>2]=i;c[d+(g+24)>>2]=a;c[d+(g+12)>>2]=i;c[d+(g+8)>>2]=i;break}if((e|0)==31){e=0}else{e=25-(e>>>1)|0}e=j<<e;a=c[a>>2]|0;while(1){if((c[a+4>>2]&-8|0)==(j|0)){break}k=a+16+(e>>>31<<2)|0;h=c[k>>2]|0;if((h|0)==0){b=296;break}else{e=e<<1;a=h}}if((b|0)==296){if(k>>>0<(c[1854]|0)>>>0){sa();return 0}else{c[k>>2]=i;c[d+(g+24)>>2]=a;c[d+(g+12)>>2]=i;c[d+(g+8)>>2]=i;break}}b=a+8|0;e=c[b>>2]|0;h=c[1854]|0;if(a>>>0<h>>>0){sa();return 0}if(e>>>0<h>>>0){sa();return 0}else{c[e+12>>2]=i;c[b>>2]=i;c[d+(g+8)>>2]=e;c[d+(g+12)>>2]=a;c[d+(g+24)>>2]=0;break}}}while(0);r=d+(f|8)|0;return r|0}}while(0);g=f;k=7848;while(1){j=c[k>>2]|0;if(!(j>>>0>g>>>0)){i=c[k+4>>2]|0;h=j+i|0;if(h>>>0>g>>>0){break}}k=c[k+8>>2]|0}k=j+(i-39)|0;if((k&7|0)==0){k=0}else{k=-k&7}i=j+(i-47+k)|0;i=i>>>0<(f+16|0)>>>0?g:i;j=i+8|0;k=d+8|0;if((k&7|0)==0){k=0}else{k=-k&7}r=e-40-k|0;c[1856]=d+k;c[1853]=r;c[d+(k+4)>>2]=r|1;c[d+(e-36)>>2]=40;c[1857]=c[1848];c[i+4>>2]=27;c[j>>2]=c[1962];c[j+4>>2]=c[1963];c[j+8>>2]=c[1964];c[j+12>>2]=c[1965];c[1962]=d;c[1963]=e;c[1965]=0;c[1964]=j;d=i+28|0;c[d>>2]=7;if((i+32|0)>>>0<h>>>0){while(1){e=d+4|0;c[e>>2]=7;if((d+8|0)>>>0<h>>>0){d=e}else{break}}}if((i|0)==(g|0)){break}e=i-f|0;r=g+(e+4)|0;c[r>>2]=c[r>>2]&-2;c[f+4>>2]=e|1;c[g+e>>2]=e;g=e>>>3;if(e>>>0<256>>>0){d=g<<1;b=7440+(d<<2)|0;e=c[1850]|0;g=1<<g;do{if((e&g|0)==0){c[1850]=e|g;e=b;d=7440+(d+2<<2)|0}else{d=7440+(d+2<<2)|0;e=c[d>>2]|0;if(!(e>>>0<(c[1854]|0)>>>0)){break}sa();return 0}}while(0);c[d>>2]=f;c[e+12>>2]=f;c[f+8>>2]=e;c[f+12>>2]=b;break}d=f;g=e>>>8;do{if((g|0)==0){i=0}else{if(e>>>0>16777215>>>0){i=31;break}q=(g+1048320|0)>>>16&8;r=g<<q;p=(r+520192|0)>>>16&4;r=r<<p;i=(r+245760|0)>>>16&2;i=14-(p|q|i)+(r<<i>>>15)|0;i=e>>>((i+7|0)>>>0)&1|i<<1}}while(0);g=7704+(i<<2)|0;c[f+28>>2]=i;c[f+20>>2]=0;c[f+16>>2]=0;j=c[1851]|0;h=1<<i;if((j&h|0)==0){c[1851]=j|h;c[g>>2]=d;c[f+24>>2]=g;c[f+12>>2]=f;c[f+8>>2]=f;break}if((i|0)==31){h=0}else{h=25-(i>>>1)|0}h=e<<h;g=c[g>>2]|0;while(1){if((c[g+4>>2]&-8|0)==(e|0)){break}j=g+16+(h>>>31<<2)|0;i=c[j>>2]|0;if((i|0)==0){b=331;break}else{h=h<<1;g=i}}if((b|0)==331){if(j>>>0<(c[1854]|0)>>>0){sa();return 0}else{c[j>>2]=d;c[f+24>>2]=g;c[f+12>>2]=f;c[f+8>>2]=f;break}}h=g+8|0;e=c[h>>2]|0;b=c[1854]|0;if(g>>>0<b>>>0){sa();return 0}if(e>>>0<b>>>0){sa();return 0}else{c[e+12>>2]=d;c[h>>2]=d;c[f+8>>2]=e;c[f+12>>2]=g;c[f+24>>2]=0;break}}}while(0);b=c[1853]|0;if(!(b>>>0>a>>>0)){break}p=b-a|0;c[1853]=p;r=c[1856]|0;q=r;c[1856]=q+a;c[q+(a+4)>>2]=p|1;c[r+4>>2]=a|3;r=r+8|0;return r|0}}while(0);c[(bb()|0)>>2]=12;r=0;return r|0}function vc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;if((a|0)==0){return}p=a-8|0;s=p;q=c[1854]|0;if(p>>>0<q>>>0){sa()}n=c[a-4>>2]|0;m=n&3;if((m|0)==1){sa()}h=n&-8;k=a+(h-8)|0;j=k;a:do{if((n&1|0)==0){u=c[p>>2]|0;if((m|0)==0){return}p=-8-u|0;s=a+p|0;m=s;n=u+h|0;if(s>>>0<q>>>0){sa()}if((m|0)==(c[1855]|0)){b=a+(h-4)|0;if((c[b>>2]&3|0)!=3){b=m;l=n;break}c[1852]=n;c[b>>2]=c[b>>2]&-2;c[a+(p+4)>>2]=n|1;c[k>>2]=n;return}t=u>>>3;if(u>>>0<256>>>0){b=c[a+(p+8)>>2]|0;l=c[a+(p+12)>>2]|0;o=7440+(t<<1<<2)|0;do{if((b|0)!=(o|0)){if(b>>>0<q>>>0){sa()}if((c[b+12>>2]|0)==(m|0)){break}sa()}}while(0);if((l|0)==(b|0)){c[1850]=c[1850]&~(1<<t);b=m;l=n;break}do{if((l|0)==(o|0)){r=l+8|0}else{if(l>>>0<q>>>0){sa()}o=l+8|0;if((c[o>>2]|0)==(m|0)){r=o;break}sa()}}while(0);c[b+12>>2]=l;c[r>>2]=b;b=m;l=n;break}r=c[a+(p+24)>>2]|0;u=c[a+(p+12)>>2]|0;do{if((u|0)==(s|0)){u=a+(p+20)|0;t=c[u>>2]|0;if((t|0)==0){u=a+(p+16)|0;t=c[u>>2]|0;if((t|0)==0){o=0;break}}while(1){w=t+20|0;v=c[w>>2]|0;if((v|0)!=0){t=v;u=w;continue}v=t+16|0;w=c[v>>2]|0;if((w|0)==0){break}else{t=w;u=v}}if(u>>>0<q>>>0){sa()}else{c[u>>2]=0;o=t;break}}else{t=c[a+(p+8)>>2]|0;if(t>>>0<q>>>0){sa()}q=t+12|0;if((c[q>>2]|0)!=(s|0)){sa()}v=u+8|0;if((c[v>>2]|0)==(s|0)){c[q>>2]=u;c[v>>2]=t;o=u;break}else{sa()}}}while(0);if((r|0)==0){b=m;l=n;break}q=c[a+(p+28)>>2]|0;t=7704+(q<<2)|0;do{if((s|0)==(c[t>>2]|0)){c[t>>2]=o;if((o|0)!=0){break}c[1851]=c[1851]&~(1<<q);b=m;l=n;break a}else{if(r>>>0<(c[1854]|0)>>>0){sa()}q=r+16|0;if((c[q>>2]|0)==(s|0)){c[q>>2]=o}else{c[r+20>>2]=o}if((o|0)==0){b=m;l=n;break a}}}while(0);if(o>>>0<(c[1854]|0)>>>0){sa()}c[o+24>>2]=r;q=c[a+(p+16)>>2]|0;do{if((q|0)!=0){if(q>>>0<(c[1854]|0)>>>0){sa()}else{c[o+16>>2]=q;c[q+24>>2]=o;break}}}while(0);p=c[a+(p+20)>>2]|0;if((p|0)==0){b=m;l=n;break}if(p>>>0<(c[1854]|0)>>>0){sa()}else{c[o+20>>2]=p;c[p+24>>2]=o;b=m;l=n;break}}else{b=s;l=h}}while(0);m=b;if(!(m>>>0<k>>>0)){sa()}n=a+(h-4)|0;o=c[n>>2]|0;if((o&1|0)==0){sa()}do{if((o&2|0)==0){if((j|0)==(c[1856]|0)){w=(c[1853]|0)+l|0;c[1853]=w;c[1856]=b;c[b+4>>2]=w|1;if((b|0)!=(c[1855]|0)){return}c[1855]=0;c[1852]=0;return}if((j|0)==(c[1855]|0)){w=(c[1852]|0)+l|0;c[1852]=w;c[1855]=b;c[b+4>>2]=w|1;c[m+w>>2]=w;return}l=(o&-8)+l|0;n=o>>>3;b:do{if(o>>>0<256>>>0){g=c[a+h>>2]|0;h=c[a+(h|4)>>2]|0;a=7440+(n<<1<<2)|0;do{if((g|0)!=(a|0)){if(g>>>0<(c[1854]|0)>>>0){sa()}if((c[g+12>>2]|0)==(j|0)){break}sa()}}while(0);if((h|0)==(g|0)){c[1850]=c[1850]&~(1<<n);break}do{if((h|0)==(a|0)){i=h+8|0}else{if(h>>>0<(c[1854]|0)>>>0){sa()}a=h+8|0;if((c[a>>2]|0)==(j|0)){i=a;break}sa()}}while(0);c[g+12>>2]=h;c[i>>2]=g}else{i=c[a+(h+16)>>2]|0;n=c[a+(h|4)>>2]|0;do{if((n|0)==(k|0)){n=a+(h+12)|0;j=c[n>>2]|0;if((j|0)==0){n=a+(h+8)|0;j=c[n>>2]|0;if((j|0)==0){g=0;break}}while(1){p=j+20|0;o=c[p>>2]|0;if((o|0)!=0){j=o;n=p;continue}o=j+16|0;p=c[o>>2]|0;if((p|0)==0){break}else{j=p;n=o}}if(n>>>0<(c[1854]|0)>>>0){sa()}else{c[n>>2]=0;g=j;break}}else{o=c[a+h>>2]|0;if(o>>>0<(c[1854]|0)>>>0){sa()}p=o+12|0;if((c[p>>2]|0)!=(k|0)){sa()}j=n+8|0;if((c[j>>2]|0)==(k|0)){c[p>>2]=n;c[j>>2]=o;g=n;break}else{sa()}}}while(0);if((i|0)==0){break}n=c[a+(h+20)>>2]|0;j=7704+(n<<2)|0;do{if((k|0)==(c[j>>2]|0)){c[j>>2]=g;if((g|0)!=0){break}c[1851]=c[1851]&~(1<<n);break b}else{if(i>>>0<(c[1854]|0)>>>0){sa()}j=i+16|0;if((c[j>>2]|0)==(k|0)){c[j>>2]=g}else{c[i+20>>2]=g}if((g|0)==0){break b}}}while(0);if(g>>>0<(c[1854]|0)>>>0){sa()}c[g+24>>2]=i;i=c[a+(h+8)>>2]|0;do{if((i|0)!=0){if(i>>>0<(c[1854]|0)>>>0){sa()}else{c[g+16>>2]=i;c[i+24>>2]=g;break}}}while(0);h=c[a+(h+12)>>2]|0;if((h|0)==0){break}if(h>>>0<(c[1854]|0)>>>0){sa()}else{c[g+20>>2]=h;c[h+24>>2]=g;break}}}while(0);c[b+4>>2]=l|1;c[m+l>>2]=l;if((b|0)!=(c[1855]|0)){break}c[1852]=l;return}else{c[n>>2]=o&-2;c[b+4>>2]=l|1;c[m+l>>2]=l}}while(0);g=l>>>3;if(l>>>0<256>>>0){a=g<<1;d=7440+(a<<2)|0;h=c[1850]|0;g=1<<g;do{if((h&g|0)==0){c[1850]=h|g;f=d;e=7440+(a+2<<2)|0}else{h=7440+(a+2<<2)|0;g=c[h>>2]|0;if(!(g>>>0<(c[1854]|0)>>>0)){f=g;e=h;break}sa()}}while(0);c[e>>2]=b;c[f+12>>2]=b;c[b+8>>2]=f;c[b+12>>2]=d;return}e=b;f=l>>>8;do{if((f|0)==0){a=0}else{if(l>>>0>16777215>>>0){a=31;break}v=(f+1048320|0)>>>16&8;w=f<<v;u=(w+520192|0)>>>16&4;w=w<<u;a=(w+245760|0)>>>16&2;a=14-(u|v|a)+(w<<a>>>15)|0;a=l>>>((a+7|0)>>>0)&1|a<<1}}while(0);f=7704+(a<<2)|0;c[b+28>>2]=a;c[b+20>>2]=0;c[b+16>>2]=0;h=c[1851]|0;g=1<<a;do{if((h&g|0)==0){c[1851]=h|g;c[f>>2]=e;c[b+24>>2]=f;c[b+12>>2]=b;c[b+8>>2]=b}else{if((a|0)==31){g=0}else{g=25-(a>>>1)|0}g=l<<g;f=c[f>>2]|0;while(1){if((c[f+4>>2]&-8|0)==(l|0)){break}h=f+16+(g>>>31<<2)|0;a=c[h>>2]|0;if((a|0)==0){d=129;break}else{g=g<<1;f=a}}if((d|0)==129){if(h>>>0<(c[1854]|0)>>>0){sa()}else{c[h>>2]=e;c[b+24>>2]=f;c[b+12>>2]=b;c[b+8>>2]=b;break}}h=f+8|0;g=c[h>>2]|0;d=c[1854]|0;if(f>>>0<d>>>0){sa()}if(g>>>0<d>>>0){sa()}else{c[g+12>>2]=e;c[h>>2]=e;c[b+8>>2]=g;c[b+12>>2]=f;c[b+24>>2]=0;break}}}while(0);w=(c[1858]|0)-1|0;c[1858]=w;if((w|0)==0){b=7856}else{return}while(1){b=c[b>>2]|0;if((b|0)==0){break}else{b=b+8|0}}c[1858]=-1;return}function wc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;if((e|0)>=4096)return Va(b|0,d|0,e|0)|0;f=b|0;if((b&3)==(d&3)){while(b&3){if((e|0)==0)return f|0;a[b]=a[d]|0;b=b+1|0;d=d+1|0;e=e-1|0}while((e|0)>=4){c[b>>2]=c[d>>2];b=b+4|0;d=d+4|0;e=e-4|0}}while((e|0)>0){a[b]=a[d]|0;b=b+1|0;d=d+1|0;e=e-1|0}return f|0}function xc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;f=b+e|0;if((e|0)>=20){d=d&255;i=b&3;h=d|d<<8|d<<16|d<<24;g=f&~3;if(i){i=b+4-i|0;while((b|0)<(i|0)){a[b]=d;b=b+1|0}}while((b|0)<(g|0)){c[b>>2]=h;b=b+4|0}}while((b|0)<(f|0)){a[b]=d;b=b+1|0}return b-e|0}function yc(b){b=b|0;var c=0;c=b;while(a[c]|0){c=c+1|0}return c-b|0}function zc(a){a=a|0;var b=0;b=($(c[a>>2]|0,31010991)|0)+1735287159&2147483647;c[a>>2]=b;return b|0}function Ac(){return zc(m)|0}function Bc(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;ib[a&1](b|0,c|0,d|0,e|0,f|0)}function Cc(a,b){a=a|0;b=b|0;jb[a&1](b|0)}function Dc(a,b){a=a|0;b=b|0;return kb[a&3](b|0)|0}function Ec(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return lb[a&7](b|0,c|0,d|0)|0}function Fc(a){a=a|0;mb[a&3]()}function Gc(a,b,c){a=a|0;b=b|0;c=c|0;return nb[a&1](b|0,c|0)|0}function Hc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ob[a&7](b|0,c|0,d|0,e|0)}function Ic(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;aa(0)}function Jc(a){a=a|0;aa(1)}function Kc(a){a=a|0;aa(2);return 0}function Lc(a,b,c){a=a|0;b=b|0;c=c|0;aa(3);return 0}function Mc(){aa(4)}function Nc(a,b){a=a|0;b=b|0;aa(5);return 0}function Oc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;aa(6)}




// EMSCRIPTEN_END_FUNCS
var ib=[Ic,Ic];var jb=[Jc,Jc];var kb=[Kc,Kc,ec,Kc];var lb=[Lc,Lc,hc,Lc,fc,Lc,Lc,Lc];var mb=[Mc,Mc,bc,Mc];var nb=[Nc,Nc];var ob=[Oc,Oc,ic,Oc,gc,Oc,Oc,Oc];return{_strlen:yc,_free:vc,_main:Pb,_rand_r:zc,_memset:xc,_malloc:uc,_memcpy:wc,_rand:Ac,runPostSets:Fb,stackAlloc:pb,stackSave:qb,stackRestore:rb,setThrew:sb,setTempRet0:vb,setTempRet1:wb,setTempRet2:xb,setTempRet3:yb,setTempRet4:zb,setTempRet5:Ab,setTempRet6:Bb,setTempRet7:Cb,setTempRet8:Db,setTempRet9:Eb,dynCall_viiiii:Bc,dynCall_vi:Cc,dynCall_ii:Dc,dynCall_iiii:Ec,dynCall_v:Fc,dynCall_iii:Gc,dynCall_viiii:Hc}})


// EMSCRIPTEN_END_ASM
({ "Math": Math, "Int8Array": Int8Array, "Int16Array": Int16Array, "Int32Array": Int32Array, "Uint8Array": Uint8Array, "Uint16Array": Uint16Array, "Uint32Array": Uint32Array, "Float32Array": Float32Array, "Float64Array": Float64Array }, { "abort": abort, "assert": assert, "asmPrintInt": asmPrintInt, "asmPrintFloat": asmPrintFloat, "min": Math_min, "invoke_viiiii": invoke_viiiii, "invoke_vi": invoke_vi, "invoke_ii": invoke_ii, "invoke_iiii": invoke_iiii, "invoke_v": invoke_v, "invoke_iii": invoke_iii, "invoke_viiii": invoke_viiii, "_tzset": _tzset, "_sysconf": _sysconf, "_SDL_MapRGB": _SDL_MapRGB, "_fgetc": _fgetc, "_fclose": _fclose, "_SDL_WM_ToggleFullScreen": _SDL_WM_ToggleFullScreen, "_abort": _abort, "_lseek": _lseek, "_div": _div, "_pread": _pread, "_close": _close, "_SDL_SetVideoMode": _SDL_SetVideoMode, "_fopen": _fopen, "_fflush": _fflush, "_SDL_FillRect": _SDL_FillRect, "_fputc": _fputc, "_SDL_LockSurface": _SDL_LockSurface, "_puts": _puts, "___setErrNo": ___setErrNo, "_open": _open, "_fseek": _fseek, "_send": _send, "_write": _write, "_fputs": _fputs, "_mkport": _mkport, "_exit": _exit, "_SDL_GetAppState": _SDL_GetAppState, "_SDL_UpdateRect": _SDL_UpdateRect, "_localtime": _localtime, "_fread": _fread, "_read": _read, "_emscripten_set_main_loop": _emscripten_set_main_loop, "_time": _time, "_localtime_r": _localtime_r, "_SDL_UnlockSurface": _SDL_UnlockSurface, "_emscripten_memcpy_big": _emscripten_memcpy_big, "_SDL_WM_SetCaption": _SDL_WM_SetCaption, "_recv": _recv, "_fileno": _fileno, "_pwrite": _pwrite, "_SDL_PollEvent": _SDL_PollEvent, "_fsync": _fsync, "_SDL_Init": _SDL_Init, "___errno_location": ___errno_location, "_llvm_lifetime_start": _llvm_lifetime_start, "_SDL_Quit": _SDL_Quit, "_sbrk": _sbrk, "_fwrite": _fwrite, "__exit": __exit, "STACKTOP": STACKTOP, "STACK_MAX": STACK_MAX, "tempDoublePtr": tempDoublePtr, "ABORT": ABORT, "___rand_seed": ___rand_seed, "NaN": NaN, "Infinity": Infinity, "_stdout": _stdout }, buffer);
var _strlen = Module["_strlen"] = asm["_strlen"];
var _free = Module["_free"] = asm["_free"];
var _main = Module["_main"] = asm["_main"];
var _rand_r = Module["_rand_r"] = asm["_rand_r"];
var _memset = Module["_memset"] = asm["_memset"];
var _malloc = Module["_malloc"] = asm["_malloc"];
var _memcpy = Module["_memcpy"] = asm["_memcpy"];
var _rand = Module["_rand"] = asm["_rand"];
var runPostSets = Module["runPostSets"] = asm["runPostSets"];
var dynCall_viiiii = Module["dynCall_viiiii"] = asm["dynCall_viiiii"];
var dynCall_vi = Module["dynCall_vi"] = asm["dynCall_vi"];
var dynCall_ii = Module["dynCall_ii"] = asm["dynCall_ii"];
var dynCall_iiii = Module["dynCall_iiii"] = asm["dynCall_iiii"];
var dynCall_v = Module["dynCall_v"] = asm["dynCall_v"];
var dynCall_iii = Module["dynCall_iii"] = asm["dynCall_iii"];
var dynCall_viiii = Module["dynCall_viiii"] = asm["dynCall_viiii"];

Runtime.stackAlloc = function(size) { return asm['stackAlloc'](size) };
Runtime.stackSave = function() { return asm['stackSave']() };
Runtime.stackRestore = function(top) { asm['stackRestore'](top) };

// Warning: printing of i64 values may be slightly rounded! No deep i64 math used, so precise i64 code not included
var i64Math = null;

// === Auto-generated postamble setup entry stuff ===

if (memoryInitializer) {
  if (ENVIRONMENT_IS_NODE || ENVIRONMENT_IS_SHELL) {
    var data = Module['readBinary'](memoryInitializer);
    HEAPU8.set(data, STATIC_BASE);
  } else {
    addRunDependency('memory initializer');
    Browser.asyncLoad(memoryInitializer, function(data) {
      HEAPU8.set(data, STATIC_BASE);
      removeRunDependency('memory initializer');
    }, function(data) {
      throw 'could not load memory initializer ' + memoryInitializer;
    });
  }
}

function ExitStatus(status) {
  this.name = "ExitStatus";
  this.message = "Program terminated with exit(" + status + ")";
  this.status = status;
};
ExitStatus.prototype = new Error();
ExitStatus.prototype.constructor = ExitStatus;

var initialStackTop;
var preloadStartTime = null;
var calledMain = false;

dependenciesFulfilled = function runCaller() {
  // If run has never been called, and we should call run (INVOKE_RUN is true, and Module.noInitialRun is not false)
  if (!Module['calledRun'] && shouldRunNow) run();
  if (!Module['calledRun']) dependenciesFulfilled = runCaller; // try this again later, after new deps are fulfilled
}

Module['callMain'] = Module.callMain = function callMain(args) {
  assert(runDependencies == 0, 'cannot call main when async dependencies remain! (listen on __ATMAIN__)');
  assert(__ATPRERUN__.length == 0, 'cannot call main when preRun functions remain to be called');

  args = args || [];

  if (ENVIRONMENT_IS_WEB && preloadStartTime !== null) {
    Module.printErr('preload time: ' + (Date.now() - preloadStartTime) + ' ms');
  }

  ensureInitRuntime();

  var argc = args.length+1;
  function pad() {
    for (var i = 0; i < 4-1; i++) {
      argv.push(0);
    }
  }
  var argv = [allocate(intArrayFromString("/bin/this.program"), 'i8', ALLOC_NORMAL) ];
  pad();
  for (var i = 0; i < argc-1; i = i + 1) {
    argv.push(allocate(intArrayFromString(args[i]), 'i8', ALLOC_NORMAL));
    pad();
  }
  argv.push(0);
  argv = allocate(argv, 'i32', ALLOC_NORMAL);

  initialStackTop = STACKTOP;

  try {

    var ret = Module['_main'](argc, argv, 0);


    // if we're not running an evented main loop, it's time to exit
    if (!Module['noExitRuntime']) {
      exit(ret);
    }
  }
  catch(e) {
    if (e instanceof ExitStatus) {
      // exit() throws this once it's done to make sure execution
      // has been stopped completely
      return;
    } else if (e == 'SimulateInfiniteLoop') {
      // running an evented main loop, don't immediately exit
      Module['noExitRuntime'] = true;
      return;
    } else {
      if (e && typeof e === 'object' && e.stack) Module.printErr('exception thrown: ' + [e, e.stack]);
      throw e;
    }
  } finally {
    calledMain = true;
  }
}




function run(args) {
  args = args || Module['arguments'];

  if (preloadStartTime === null) preloadStartTime = Date.now();

  if (runDependencies > 0) {
    Module.printErr('run() called, but dependencies remain, so not running');
    return;
  }

  preRun();

  if (runDependencies > 0) return; // a preRun added a dependency, run will be called later
  if (Module['calledRun']) return; // run may have just been called through dependencies being fulfilled just in this very frame

  function doRun() {
    if (Module['calledRun']) return; // run may have just been called while the async setStatus time below was happening
    Module['calledRun'] = true;

    ensureInitRuntime();

    preMain();

    if (Module['_main'] && shouldRunNow) {
      Module['callMain'](args);
    }

    postRun();
  }

  if (Module['setStatus']) {
    Module['setStatus']('Running...');
    setTimeout(function() {
      setTimeout(function() {
        Module['setStatus']('');
      }, 1);
      if (!ABORT) doRun();
    }, 1);
  } else {
    doRun();
  }
}
Module['run'] = Module.run = run;

function exit(status) {
  ABORT = true;
  EXITSTATUS = status;
  STACKTOP = initialStackTop;

  // exit the runtime
  exitRuntime();

  // TODO We should handle this differently based on environment.
  // In the browser, the best we can do is throw an exception
  // to halt execution, but in node we could process.exit and
  // I'd imagine SM shell would have something equivalent.
  // This would let us set a proper exit status (which
  // would be great for checking test exit statuses).
  // https://github.com/kripken/emscripten/issues/1371

  // throw an exception to halt the current execution
  throw new ExitStatus(status);
}
Module['exit'] = Module.exit = exit;

function abort(text) {
  if (text) {
    Module.print(text);
    Module.printErr(text);
  }

  ABORT = true;
  EXITSTATUS = 1;

  throw 'abort() at ' + stackTrace();
}
Module['abort'] = Module.abort = abort;

// {{PRE_RUN_ADDITIONS}}

if (Module['preInit']) {
  if (typeof Module['preInit'] == 'function') Module['preInit'] = [Module['preInit']];
  while (Module['preInit'].length > 0) {
    Module['preInit'].pop()();
  }
}

// shouldRunNow refers to calling main(), not run().
var shouldRunNow = true;
if (Module['noInitialRun']) {
  shouldRunNow = false;
}


run();

// {{POST_RUN_ADDITIONS}}






// {{MODULE_ADDITIONS}}






